/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager_$type } from "./IAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { enumGetBox, typeCast, Point_$type, markType, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior_$type } from "./ConsolidatedItemHitTestBehavior";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { Rect } from "igniteui-react-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { NumericYAxis } from "./NumericYAxis";
import { ScalerParams } from "./ScalerParams";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { CollisionAvoider } from "./CollisionAvoider";
import { NonCollisionAvoider } from "./NonCollisionAvoider";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
/**
 * @hidden
 */
export let AnchoredCategorySeries = /*@__PURE__*/ (() => {
    class AnchoredCategorySeries extends CategorySeries {
        constructor() {
            super();
            this.s8 = null;
            this.tc = false;
            this.ta = null;
            this.s5 = null;
            this.tg = null;
            this.rh = new CategoryFramePreparer(1, this, this.rl, this, this, this.rl.cr);
        }
        get s9() {
            if (this.s8 == null) {
                this.s8 = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, () => this.cl.n);
            }
            return this.s8;
        }
        getHostReferenceValue() {
            return this.f4();
        }
        ip() {
            return AnchoredCategorySeries.$$p[2];
        }
        bv() {
            let a = new AnchoredCategorySeriesView(this);
            return a;
        }
        lo(a) {
            super.lo(a);
            this.s4 = a;
        }
        hn(a, b) {
            let c = this.jf(b);
            if (c == AnchoredCategorySeries.$$p[2]) {
                return this.ho(a, b, this.tk);
            }
            return super.hn(a, b);
        }
        get valueColumn() {
            return this.ta;
        }
        set valueColumn(a) {
            if (this.ta != a) {
                let b = this.ta;
                this.ta = a;
                if (!this.tc) {
                    this.raisePropertyChanged("ValueColumn", b, this.ta);
                }
            }
        }
        get t2() {
            return this.c(AnchoredCategorySeries.tr);
        }
        set t2(a) {
            this.h(AnchoredCategorySeries.tr, a);
        }
        ej(a) {
            let b = new Rect(0, 0, 0, 1, 1);
            let c = this.fetchXAxis();
            let d = this.fetchYAxis();
            let e = this.pi(this.by);
            let f = c != null ? this.rh.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
            return this.s9.c$a(this, this.valueColumn, c, d, f, a);
        }
        s1(a, b, c) {
            if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.ck;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.ci.item(g);
            }
            return d;
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            if (this.s4.c3 && this.s4.c2.g$b(a, b, c, d)) {
                this.l7(false);
                this.le();
            }
            switch (b) {
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.valueColumn);
                        this.valueColumn = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.valueColumn = this.cf(this.tk);
                    }
                    let e = typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (e != null && !e.cy()) {
                        this.s4.cr.g(this.gk);
                        this.l7(false);
                    }
                    break;
                case AnchoredCategorySeries.$$p[2]:
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.valueColumn);
                        this.valueColumn = this.cf(this.tk);
                    }
                    this.tg = this.tk;
                    break;
                case "ValueColumn":
                    if (this.s4.c3) {
                        this.s4.c2.g$i();
                    }
                    let f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (f != null && !f.cy()) {
                        this.s4.cr.g(this.gk);
                        this.l7(false);
                    }
                    this.tq();
                    this.mq();
                    break;
                case "TrendLineBrush":
                    this.mk();
                    break;
                case "ErrorBarSettings":
                    this.l7(false);
                    break;
                case "TrendLineType":
                    this.le();
                    break;
                case AnchoredCategorySeries.$$p[1]:
                    this.l7(false);
                    break;
            }
        }
        ap(a) {
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            if (a == this.fetchYAxis()) {
                return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
            }
            return null;
        }
        kr(a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.s4.cr.g(this.gk);
                    break;
            }
            if (this.s4.c3) {
                this.s4.c2.g$e(a, b, c, d);
            }
            this.tq();
            this.mq();
        }
        sb() {
            return this.td(this.rl);
        }
        td(a) {
            let b = 0;
            let c = a.bv;
            let d = a.bu;
            let e = this.getEffectiveViewport1(a);
            let f = typeCast(NumericYAxis.$, this.fetchYAxis());
            if (!c.isEmpty && !d.isEmpty && f != null) {
                let g = new ScalerParams(0, c, d, f.cf, e);
                if (f.cm) {
                    g.b = this.f4();
                }
                b = f.ef(f.ln, g);
            }
            return b;
        }
        tp(a, b, c) {
            let d = this.td(c);
            if (a.count > 0) {
                let e = d;
                a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
                a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
            }
        }
        s2(a, b, c, d) {
            return this.s3(a, b, c, d, false);
        }
        s3(a, b, c, d, e) {
            return CategorySeries.q6(a, b, c, d, e);
        }
        e5(a, b, c) {
            let d = super.e5(a, b, c);
            let e = c;
            if (this.valueColumn == null || this.valueColumn.count == 0 || e.cr.d < 1) {
                d = false;
            }
            return d;
        }
        ko(a, b) {
            super.ko(a, b);
            let c = b;
            c.cx();
            if (c.c3) {
                c.c2.g$d();
            }
        }
        sr(a, b) {
            super.sr(a, b);
            this.ri(b).d(a, b);
        }
        su(a, b) {
            super.su(a, b);
            let c = typeCast(AnchoredCategorySeriesView.$, b);
            c.b3 = true;
            if (c.c3) {
                c.c2.g$g(a.p);
            }
            if (this.p2()) {
                CategoryMarkerManager.e(this, a.m, b.cu, this.p4);
                this.so(b, a);
                b.cm();
            }
            this.tm(a, b);
        }
        l6(a, b, c, d, e) {
            super.l6(a, b, c, d, e);
            let f = this.a5.a$h.item(d);
            let g = f;
            g.cr.g(this.gk);
            f.a1(c);
            if (this.cu(g)) {
                return;
            }
            if (this.s5 == null) {
                this.s5 = new CategoryFrame(3);
            }
            this.s5.u();
            this.sr(this.s5, g);
            this.su(this.s5, g);
        }
        tm(a, b) {
        }
        mk() {
            super.mk();
            if (this.hc < 0) {
                return;
            }
            this.s4.c7();
            if (this.trendLineBrush != null) {
                this.s4.c5();
            }
            else {
                this.s4.c4();
            }
        }
        hq(a, b) {
            if (this.s4.c3 && a == this.s4.c2.g$j) {
                return null;
            }
            return super.hq(a, b);
        }
        get currentCategoryMode() {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.rb()));
        }
        get scaler() {
            return typeCast(ICategoryScaler_$type, this.rb());
        }
        get yScaler() {
            return typeCast(IScaler_$type, this.rw());
        }
        get bucketizer() {
            return this.s4.cr;
        }
        get currentMode2Index() {
            return this.sf();
        }
        provideCollisionDetector() {
            if (this.s6 == 1) {
                return new CollisionAvoider();
            }
            return NonCollisionAvoider.b;
        }
        get trendlinePreparer() {
            return this.s4.c3 ? this.s4.c2 : null;
        }
        ky(a) {
            super.ky(a);
            if (this.s4.c3) {
                this.a7.exportTrendlineData(this, a, this.s4.c2.g$j);
            }
        }
        hk(a) {
            let b = this.fetchXAxis();
            let c = this.fetchYAxis();
            return this.s9.c$b(this, a, this.sc(this.by), this.valueColumn, b, c, this.s7 == 1, (d) => super.hk(d));
        }
        get mayContainUnknowns() {
            return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
        }
        f4() {
            return Series.f5(this.valueColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
        }
        get_tf() {
            return 0;
        }
        get tf() {
            return this.get_tf();
        }
        aq(a) {
            if (a.isEmpty && this.cb != null) {
                a = this.cb.r0;
            }
            if (this.valueColumn == null) {
                return null;
            }
            let b = this.pg(this.by);
            let c = this.rb();
            let d = new ScalerParams(0, a, this.cb.sf, c.cf, this.getEffectiveViewport());
            let e = (c.ei(b.left, d));
            let f = (c.ei(b.right, d));
            if (c.cf) {
                let g = e;
                e = f;
                f = g;
            }
            e -= this.tf;
            f += this.tf;
            let h = null;
            if (c.ck) {
                h = c;
                e = h.i$f(e);
                f = h.i$f(f);
            }
            else {
                e = Math.floor(e);
                f = Math.ceil(f);
            }
            if (isNaN_(e) || isNaN_(f)) {
                return null;
            }
            e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
            f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
            let i = 1.7976931348623157E+308;
            let j = -1.7976931348623157E+308;
            if (truncate(e) <= truncate(f)) {
                for (let k = truncate(e); k <= truncate(f); k++) {
                    let l = k;
                    if (h != null) {
                        l = h.i$b._inner[k];
                    }
                    let m = this.valueColumn.item(l);
                    if (this.valueColumn.mayContainUnknowns) {
                        if (isInfinity(m) || isNaN_(m)) {
                            continue;
                        }
                    }
                    i = Math.min(i, m);
                    j = Math.max(j, m);
                }
            }
            let n = new AxisRange(i, j);
            n = this.ao(n, this.rw(), a);
            return n;
        }
        tq() {
            this.fu = this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(this.valueColumn.count - 1);
        }
        get useHighMarkerFidelity() {
            return this.r7;
        }
    }
    AnchoredCategorySeries.$t = /*@__PURE__*/ markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
    AnchoredCategorySeries.tr = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    AnchoredCategorySeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:s7:ts', [ConsolidatedItemHitTestBehavior_$type, /*@__PURE__*/ enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'MarkerCollisionAvoidance:s6:tt', [CategorySeriesMarkerCollisionAvoidance_$type, /*@__PURE__*/ enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberPath:tk:t1', [2, null], 'TrendLineType::tz', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::ty', [1, 1.5], 'TrendLinePeriod::tx', [1, 7], 'TrendLineBrush::tu', [Brush.$, null], 'TrendLineZIndex:te:t0', [1, 1001], 'TrendLineDashArray:t3:tv', [DoubleCollection.$], 'TrendLineDashCap:t4:tw', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredCategorySeries;
})();
/**
 * @hidden
 */
export let AnchoredCategoryBucketCalculator = /*@__PURE__*/ (() => {
    class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
        constructor(a) {
            super(a);
            this.i = null;
            this.h = null;
            this.j = 0;
            this.i = a;
        }
        getBucketWithoutUnknowns(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = 1.7976931348623157E+308;
            let h = -1.7976931348623157E+308;
            let i = true;
            for (let j = d; j <= e; ++j) {
                let k = b[j];
                g = g < k ? g : k;
                h = h > k ? h : k;
                i = false;
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        getBucket(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = 0;
            let h = 0;
            let i = true;
            for (let j = d; j <= e; ++j) {
                let k = b[j];
                if (!i) {
                    if (!isNaN_(k)) {
                        g = g < k ? g : k;
                        h = h > k ? h : k;
                    }
                }
                else {
                    if (!isNaN_(k)) {
                        g = k;
                        h = k;
                        i = false;
                    }
                }
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        cacheValues() {
            this.j = this.i.c0.valueColumn.count;
            this.h = this.i.c0.valueColumn.asArray();
        }
        unCacheValues() {
            this.h = null;
        }
    }
    AnchoredCategoryBucketCalculator.$t = /*@__PURE__*/ markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
    return AnchoredCategoryBucketCalculator;
})();
/**
 * @hidden
 */
export let AnchoredCategorySeriesView = /*@__PURE__*/ (() => {
    class AnchoredCategorySeriesView extends CategorySeriesView {
        constructor(a) {
            super(a);
            this.c0 = null;
            this.c1 = null;
            this.c0 = a;
        }
        get c2() {
            if (this.c1 == null) {
                this.c1 = CategoryTrendLineManagerFactory.a(this.c1, this.e.ar(), this.e.my, this.e, this.e.cl);
            }
            return this.c1;
        }
        set c2(a) {
            this.c1 = a;
        }
        get c3() {
            return this.c1 != null;
        }
        c7() {
            this.c0.t2 = null;
        }
        c5() {
            this.c0.t2 = this.c0.trendLineBrush;
        }
        c4() {
            this.c0.t2 = this.c0.oo;
        }
        cs() {
            return new AnchoredCategoryBucketCalculator(this);
        }
        c6() {
            this.cr.cacheValues();
        }
        c8() {
            this.cr.unCacheValues();
        }
        c9(a) {
            let b = this.cu.item(a);
            return this.cp(b);
        }
        a5(a, b) {
            if (a.d) {
                if (this.c0.trendLineType != 0 && !b) {
                    let c = this.c2.g$j;
                    c.ac = this.c0.trendLineThickness;
                    c._stroke = this.c0.t2;
                    c.ai = this.c0.t3;
                    c.ad = this.c0.t4;
                    a.u(c);
                }
            }
            super.a5(a, b);
        }
        getDefaultTooltipTemplate() {
            return this.c0.s9.c$c(this.e, this.c0.tk);
        }
    }
    AnchoredCategorySeriesView.$t = /*@__PURE__*/ markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
    return AnchoredCategorySeriesView;
})();
