/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { markType, Point_$type, enumGetBox, typeCast, runOn, markDep } from "igniteui-react-core";
import { isNaN_, intDivide, isInfinity } from "igniteui-react-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { RadialFrame } from "./RadialFrame";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { RadialBaseView } from "./RadialBaseView";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-react-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let AnchoredRadialBucketCalculator = /*@__PURE__*/ (() => {
    class AnchoredRadialBucketCalculator extends RadialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = this.f.cw.sr;
            let c = Math.min(a * this.b, b.count - 1);
            let d = Math.min(c + this.b - 1, b.count - 1);
            let e = NaN;
            let f = NaN;
            for (let g = c; g <= d; ++g) {
                let h = b.item(g);
                if (!isNaN_(e)) {
                    if (!isNaN_(h)) {
                        e = Math.min(e, h);
                        f = Math.max(f, h);
                    }
                }
                else {
                    e = h;
                    f = h;
                }
            }
            if (!isNaN_(e)) {
                return [0.5 * (c + d), e, f];
            }
            return [0.5 * (c + d), NaN, NaN];
        }
    }
    AnchoredRadialBucketCalculator.$t = /*@__PURE__*/ markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
})();
/**
 * @hidden
 */
export let AnchoredRadialSeries = /*@__PURE__*/ (() => {
    class AnchoredRadialSeries extends RadialBase {
        constructor() {
            super();
            this.sm = null;
            this.sq = null;
            this.tn = { $type: Point_$type, x: 0, y: 0 };
            this.so = null;
            this.sn = null;
            this.so = new RadialFrame(3);
            this.sm = new CategoryLineRasterizer();
        }
        bv() {
            return new AnchoredRadialSeriesView(this);
        }
        kl() {
            super.kl();
            this.q8 = null;
            this.rf = null;
        }
        hn(a, b) {
            let c = this.jf(b);
            if (c == AnchoredRadialSeries.$$p[0]) {
                return this.ho(a, b, this.s3);
            }
            return super.hn(a, b);
        }
        lo(a) {
            super.lo(a);
            this.sl = a;
        }
        g9(a, b) {
            return this.ha(a, b, this.q8, null, this.sr);
        }
        g7(a, b) {
            return this.g8(a, b, this.q8, null, this.sr);
        }
        fw(a, b, c, d, e) {
            if (this.sr == null) {
                return Number.POSITIVE_INFINITY;
            }
            return this.fx(a, b, this.q8, d, e, this.sr.count, null);
        }
        ga(a, b, c) {
            let d = this.getEffectiveViewport1(this.by);
            let e = this.sw(this.q8, this.by.bv, this.by.bu, d);
            let f = new ScalerParams(0, this.by.bv, this.by.bu, this.q8.cf, d);
            f.c = this.cb.sf;
            return this.gc(this.sr, a, this.q8, f, e, null, b, c);
        }
        pb(a, b, c) {
            if (this.rf == null || this.q8 == null || this.by == null || this.by.bv.isEmpty || this.by.bu.isEmpty) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let d = this.getEffectiveViewport1(this.by);
            let e = new ScalerParams(0, this.by.bv, this.by.bu, this.rf.cf, d);
            e.c = this.getEffectiveViewport1(this.by);
            let f = this.ga(a, b, c);
            f = this.rf.ef(f, e);
            let g = this.rg.c(a);
            if (!b && this.q8 != null) {
                let h = this.g9(a, c);
                let i = this.g7(a, c);
                let j = this.sw(this.q8, this.by.bv, this.by.bu, d);
                let k = new ScalerParams(0, this.by.bv, this.by.bu, this.q8.cf, d);
                k.c = this.cb.sf;
                let l = this.fw(a, h, this.q8, k, j);
                let m = this.fw(a, i, this.q8, k, j);
                if (m <= l) {
                    g = this.q8.ef(i, k) + j;
                }
                else {
                    g = this.q8.ef(h, k) + j;
                }
            }
            let n = this.rg.d(g, f, this.by.bv, this.by.bu);
            let o = this.rg.e(g, f, this.by.bv, this.by.bu);
            return { $type: Point_$type, x: n, y: o };
        }
        get sr() {
            return this.sq;
        }
        set sr(a) {
            if (this.sq != a) {
                let b = this.sq;
                this.sq = a;
                this.raisePropertyChanged("ValueColumn", b, this.sq);
            }
        }
        get tj() {
            return this.c(AnchoredRadialSeries.ta);
        }
        set tj(a) {
            this.h(AnchoredRadialSeries.ta, a);
        }
        ap(a) {
            if (a != null && a == this.q8 && this.sr != null && this.sr.count > 0) {
                return new AxisRange(0, this.sr.count - 1);
            }
            if (a != null && a == this.rf && this.sr != null && this.sr.count > 0) {
                return new AxisRange(this.sr.minimum, this.sr.maximum);
            }
            return null;
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            if (this.sl.cx.g$b(a, b, c, d)) {
                this.l7(false);
                this.le();
            }
            let e = typeCast(NumericAxisBase.$, this.rf);
            switch (b) {
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) !== null) {
                        c.deregisterColumn(this.sr);
                        this.sr = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) !== null) {
                        this.sr = this.cf(this.s3);
                        this.sl.cs.e(this.gk);
                    }
                    if (e != null && !e.cy()) {
                        this.sl.cs.e(this.gk);
                        this.l7(false);
                    }
                    break;
                case AnchoredRadialSeries.$$p[0]:
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.sr);
                        this.sr = this.cf(this.s3);
                    }
                    break;
                case "ValueColumn":
                    if (e != null && !e.cy()) {
                        this.sl.cs.e(this.gk);
                        this.l7(false);
                    }
                    break;
                case "TrendLineBrush":
                    this.mk();
                    break;
                case "TrendLineType":
                    this.le();
                    break;
            }
        }
        kr(a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.sl.cs.e(this.gk);
                    break;
            }
            this.sl.cx.g$e(a, b, c, d);
            switch (a) {
                case 4:
                    if (this.rf != null && !this.rf.cy()) {
                        this.l7(true);
                    }
                    break;
                case 1:
                    if (this.rf != null && !this.rf.cy()) {
                        this.l7(true);
                    }
                    break;
                case 0:
                    if (this.rf != null && !this.rf.cy()) {
                        this.l7(true);
                    }
                    break;
                case 2:
                    if (this.s3 != null && this.sl.cs.b > 0 && this.rf != null && !this.rf.cy()) {
                        this.l7(true);
                    }
                    break;
                case 3:
                    if (d == this.s3) {
                        if (this.rf != null && !this.rf.cy()) {
                            this.l7(true);
                        }
                    }
                    break;
            }
        }
        e5(a, b, c) {
            let d = super.e5(a, b, c);
            let e = c;
            if (this.ci == null || this.ci.count == 0 || this.q8 == null || this.sr == null || this.q8.k9 == 0 || this.rf == null || isInfinity(this.rf.ld) || isInfinity(this.rf.lc) || e.cs.b < 1) {
                d = false;
            }
            return d;
        }
        getOffsetValue() {
            return this.sw(this.q8, this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by));
        }
        getCategoryWidth() {
            return this.q8.getCategorySize(this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by));
        }
        get_su() {
            return false;
        }
        get su() {
            return this.get_su();
        }
        sw(a, b, c, d) {
            let e = 0;
            let f = this.preferredCategoryMode(a);
            if (f == 0 && a.categoryMode != 0) {
                f = 1;
            }
            switch (f) {
                case 0:
                    e = 0;
                    break;
                case 1:
                    e = 0.5 * a.getCategorySize(b, c, d);
                    break;
                case 2:
                    e = a.getGroupCenter(this.r2(), b, c, d);
                    break;
            }
            if (a.cf) {
                e = -e;
            }
            return e;
        }
        sa(a, b) {
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.q8;
            let g = this.rf;
            let h = g.ld;
            let i = g.lc;
            a.f.clear();
            a.m.clear();
            a.p.clear();
            let j = this.p2();
            let k = 0;
            let l = b;
            let m = new CollisionAvoider();
            let n = 0;
            let o = b.cs.d;
            n = this.sw(f, c, d, e);
            l.cx.i = this.rf.mu;
            l.cx.h = this.rf.mt;
            l.cx.j = (p, q) => this.sx(p, q, c, d);
            l.cx.k = (p, q) => this.sy(p, q, c, d);
            let p = ((() => {
                let $ret = new Clipper(0, d, false);
                $ret.i = a.p;
                return $ret;
            })());
            let q = ((() => {
                let $ret = new TrendResolutionParams();
                $ret.c = b.cs.b;
                $ret.d = b.cs.c;
                $ret.e = o;
                $ret.a = n;
                $ret.b = this.gk;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })());
            l.cx.l(a.p, this.sp, this.sr, this.s0, (r) => this.q8.getScaledAngle(r), (r) => this.rf.m0(r), q, p);
            let r = true;
            if (this.sv(b)) {
                o--;
            }
            for (let s = b.cs.c; s <= o; ++s) {
                let t = s;
                if (t * b.cs.b >= this.q8.k9) {
                    t -= intDivide((this.q8.k9), b.cs.b);
                }
                let u = b.cs.getBucket(t);
                if (!isNaN_(u[0])) {
                    u[0] = f.getScaledAngle(u[0]) + n;
                    if (u[1] < h || u[1] > i) {
                        continue;
                    }
                    u[1] = g.m0(u[1]);
                    if (b.cs.b > 1) {
                        if (u[2] < h || u[2] > i) {
                            continue;
                        }
                        u[2] = g.m0(u[2]);
                    }
                    else {
                        u[2] = u[1];
                    }
                    if ((isNaN_(u[1]) || isNaN_(u[2])) && r && this.su && this.st()) {
                        o++;
                    }
                    else {
                        r = false;
                    }
                    a.f.add(u);
                    if (j) {
                        let v = Math.min(t * b.cs.b, this.ci.count - 1);
                        let w = this.rg.d(u[0], u[1], c, d);
                        let x = this.rg.e(u[0], u[1], c, d);
                        let y = new Rect(0, w - 5, x - 5, 11, 11);
                        if (!isNaN_(w) && !isNaN_(x) && !isInfinity(w) && !isInfinity(x) && m.tryAdd(y)) {
                            a.m.add({ $type: Point_$type, x: w, y: x });
                            let z = b.ct.item(k);
                            z.al = t;
                            z.ak = v;
                            z.content.item = this.ci.item(v);
                            ++k;
                        }
                    }
                }
                else {
                    if (r && this.su && this.st()) {
                        o++;
                    }
                }
            }
            b.ct.count = k;
            return;
        }
        sx(a, b, c, d) {
            return this.rg.d(a, b, c, d);
        }
        sy(a, b, c, d) {
            return this.rg.e(a, b, c, d);
        }
        sv(a) {
            let b = a;
            return !this.su && b.cs.c == 0 && b.cs.d == this.q8.k9;
        }
        sk(a, b, c) {
            let d = null;
            let e = c.bv;
            let f = c.bu;
            if (b > -1 && !e.isEmpty && !f.isEmpty) {
                let g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
                let h = f.bottom + 10;
                let i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
                let j = f.top - 10;
                d = new Clipper(1, g, h, i, j, false);
            }
            return d;
        }
        s9(a, b, c, d, e) {
            if (a.count > 0 && d.count > 0) {
                if (!e || this.ss()) {
                    a.add(this.tn);
                    a.add(a._inner[0]);
                    d.add(this.tn);
                    d.add(d._inner[0]);
                }
            }
        }
        st() {
            return !this.ss();
        }
        ss() {
            let a = this.by.bv;
            return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
        }
        ko(a, b) {
            super.ko(a, b);
            let c = b;
            if (a) {
                c.ct.clear();
            }
            c.cx.g$d();
        }
        sd(a, b) {
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.pg(b);
            let g = b;
            g.cx.g$g(a.p);
            CategoryMarkerManager.e(this, a.m, g.ct, this.p4);
            this.s6(b, a);
            g.cm();
            this.s5(d, c, e, f, g);
        }
        sj(a, b, c) {
            if (b < a || a < 0 || a > this.sr.count || b < 0 || b > this.sr.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.ck;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.ci.item(g);
            }
            return d;
        }
        s7(a, b, c, d, e, f) {
            let g = this.bk != 1;
            this.rm.a1(this.rm.d, d.ck, a, b, c, d, e, f, true);
            this.rm.aa(this.fl);
            let h = this.rm.av;
            let i = null;
            let j = this.ci;
            let k = null;
            if (g && this.cb != null) {
                i = this.cb.a3.getHighlightingInfo(this, j, h.o, h.n, true);
                if (this.cb.a3.isCrossSeriesHighlight(this)) {
                    k = this.cb.a3.getHighlightingInfo(this, j, h.o, h.n, true);
                }
                h.b = i;
            }
            h.f = f;
            this.sb(h);
            this.rm.y(this, i, f, g, h.m, this.cb.a3.totalHighlightingProgress);
        }
        s8(a, b, c, d, e, f) {
            let g = this.bk != 1;
            this.rm.a1(this.rm.b, d.ck, a, b, c, d, e, f, false);
            this.rm.ab(this.fl);
            let h = this.rm.aw;
            let i = null;
            let j = this.ci;
            if (g && this.cb != null) {
                i = this.cb.a3.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = f;
            this.sc(h);
            this.rm.z(this, i, f, g, b < 0);
        }
        s6(a, b) {
            a.b3 = true;
            this.rm.az(this, this.rx(), runOn(this, this.q5), this.r0(a), this.r1(a));
            let c = this.rm.d;
            let d = c != null;
            let e = this.q8;
            if (e == null) {
                return;
            }
            let f = this.getEffectiveViewport1(a);
            let g = new ScalerParams(0, a.bv, a.bu, e.cf, f);
            let h = this.ci == null ? 0 : this.ci.count;
            let i = a;
            let j = b.f;
            let k = i.cs.c;
            let l = i.cs.d;
            let m = i.cs.b;
            let n = k * m;
            for (let o = 0; o < a.ct.count; o++) {
                let p = a.ct.item(o);
                let q = p.content;
                if (d) {
                    let r = p.al;
                    this.s7(j, r, h, e, g, a.q);
                }
                this.rm.ac(p, q);
            }
        }
        s5(a, b, c, d, e) {
            e.cy(a, b, c, d);
        }
        mk() {
            super.mk();
            if (this.hc < 0) {
                return;
            }
            this.sl.cz();
        }
        hq(a, b) {
            if (a == this.sl.cx.g$j) {
                return null;
            }
            return super.hq(a, b);
        }
        ej(a) {
            let b = this.by.bv;
            b = b.copy();
            let c = this.by.bu;
            let d = !b.isEmpty && !c.isEmpty && this.ci != null ? this.ci.indexOf(a) : -1;
            if (this.q8 == null || this.sr == null || this.rf == null) {
                return false;
            }
            if (d < 0 || d > this.sr.count - 1) {
                return false;
            }
            let e = this.q8.getScaledAngle(d);
            let f = this.rf.m0(this.sr.item(d));
            if (isNaN_(f)) {
                f = (this.rf.mt + this.rf.mu) / 2;
            }
            let g = 0.5 + (Math.cos(e) * f);
            let h = 0.5 + (Math.sin(e) * f);
            if (!isNaN_(g)) {
                if (g < b.left + 0.1 * b.width) {
                    g = g + 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
                if (g > b.right - 0.1 * b.width) {
                    g = g - 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
            }
            if (!isNaN_(h)) {
                if (h < b.top + 0.1 * b.height) {
                    h = h + 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
                if (h > b.bottom - 0.1 * b.height) {
                    h = h - 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
            }
            if (this.b6 != null) {
                this.b6.au(this.cb, b, true);
            }
            return d >= 0;
        }
        l9(a, b) {
            super.l9(a, b);
            if (!this.ev) {
                this.by.a2(b);
                return;
            }
            this.by.a2(b);
            let c = typeCast(AnchoredRadialSeriesView.$, this.bx);
            c.cs.e(this.gk);
            if (this.cu(this.bx)) {
                return;
            }
            if (!this.ep) {
                this.so = new RadialFrame(3);
                this.sa(this.so, c);
            }
            this.ep = false;
            this.sd(this.so, c);
            this.ev = false;
        }
        l6(a, b, c, d, e) {
            super.l6(a, b, c, d, e);
            let f = this.a5.a$h.item(d);
            let g = f;
            g.cs.e(this.gk);
            f.a1(c);
            if (this.cu(g)) {
                return;
            }
            if (this.sn == null) {
                this.sn = new RadialFrame(3);
            }
            this.sn.u();
            this.sa(this.sn, g);
            this.sd(this.sn, g);
        }
        ky(a) {
            super.ky(a);
            this.a7.exportTrendlineData(this, a, this.sl.cx.g$j);
        }
    }
    AnchoredRadialSeries.$t = /*@__PURE__*/ markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.ta = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    AnchoredRadialSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberPath:s3:ti', [2, null], 'TrendLineType:sp:tg', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:sz:tf', [1, 1.5], 'TrendLinePeriod:s0:te', [1, 7], 'TrendLineZIndex:s1:th', [1, 1], 'TrendLineBrush:tk:tb', [Brush.$, null], 'TrendLineDashArray:tl:tc', [DoubleCollection.$], 'TrendLineDashCap:tm:td', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
})();
/**
 * @hidden
 */
export let AnchoredRadialSeriesView = /*@__PURE__*/ (() => {
    class AnchoredRadialSeriesView extends RadialBaseView {
        constructor(a) {
            super(a);
            this.cw = null;
            this.cx = null;
            this.cs = new AnchoredRadialBucketCalculator(this);
            this.cw = a;
            this.cx = new RadialTrendLineManager();
        }
        cy(a, b, c, d) {
        }
        cz() {
            this.cw.tj = null;
            if (this.cw.tk != null) {
                this.cw.tj = this.cw.tk;
            }
            else {
                this.cw.tj = this.cw.oo;
            }
        }
        a5(a, b) {
            if (a.d) {
                if (!b) {
                }
                if (this.cw.sp != 0 && !b) {
                    let c = this.cx.g$j;
                    c.ac = this.cw.sz;
                    c._stroke = this.cw.tj;
                    c.ai = this.cw.tl;
                    c.ad = this.cw.tm;
                    a.u(c);
                }
            }
            super.a5(a, b);
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'>";
            if (this.cw.q8.fw != null) {
                a += "<span>${item." + this.cw.q8.fw + "}</span><br/>";
            }
            a += "<span";
            let b = this.e.a5.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.cw.hs + ": </span><span class='ui-priority-primary'>" + "${item." + this.cw.s3 + "}</span></div>";
            return a;
        }
    }
    AnchoredRadialSeriesView.$t = /*@__PURE__*/ markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
})();
