/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-react-core";
import { Point_$type, Boolean_$type, runOn, delegateRemove, typeCast, delegateCombine, fromEnum, fromEn, markType, markDep } from "igniteui-react-core";
import { SeriesView } from "./SeriesView";
import { XamDataChart } from "./XamDataChart";
import { Tuple$2 } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let AnnotationLayer = /*@__PURE__*/ (() => {
    class AnnotationLayer extends Series {
        constructor() {
            super();
            this.qu = null;
            this.pt = null;
            this.ps = null;
            this.pu = null;
            this.qs = { $type: Point_$type, x: NaN, y: NaN };
            this.pv = false;
            this.qu = { $type: Point_$type, x: NaN, y: NaN };
        }
        bv() {
            return new AnnotationLayerView(this);
        }
        lo(a) {
            super.lo(a);
            this.pr = a;
        }
        pz(a) {
            if (a == null) {
                return false;
            }
            if (a.c8) {
                return false;
            }
            if (a.ef) {
                return false;
            }
            if (a == this) {
                return false;
            }
            return a.e5(a.by.bu, a.by.bv, a.by);
        }
        get_df() {
            return this.pw;
        }
        bp() {
            if (this.bq == 0) {
                return 1;
            }
            else {
                return super.bp();
            }
        }
        get_du() {
            return this.p1 || this.p2;
        }
        get_isUsableInLegend() {
            return this.p2;
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    let e = c;
                    let f = d;
                    if (e != null) {
                        this.ql(e.series);
                        let g = e.series;
                        g.collectionChanged = delegateRemove(g.collectionChanged, runOn(this, this.qi));
                        if (typeCast(XamDataChart.$, e) !== null) {
                            let h = e;
                            this.qk(h.axes);
                            let i = h.axes;
                            i.collectionChanged = delegateRemove(i.collectionChanged, runOn(this, this.p8));
                        }
                    }
                    if (f != null) {
                        this.qg(f.series);
                        let j = f.series;
                        j.collectionChanged = delegateCombine(j.collectionChanged, runOn(this, this.qi));
                        if (typeCast(XamDataChart.$, f) !== null) {
                            let k = f;
                            this.qf(k.axes);
                            let l = k.axes;
                            l.collectionChanged = delegateCombine(l.collectionChanged, runOn(this, this.p8));
                        }
                    }
                    break;
                case AnnotationLayer.$$p[3]:
                case AnnotationLayer.$$p[2]:
                    if (this.du) {
                        if (this.hc == -1) {
                            this.hc = XamDataChart.ue(this);
                        }
                    }
                    else {
                        this.hc = -1;
                        this.oo = null;
                        this.or = null;
                    }
                    if (this.cb != null) {
                        this.cb.mb();
                    }
                    this.l7(true);
                    break;
                case "TransitionProgress":
                    this.pu.c(this.gq, this.pt, this.ps);
                    if (this.cu(this.by)) {
                        return;
                    }
                    if (this.gq == 1) {
                        this.qh(this.ps, this.by);
                    }
                    else {
                        this.qh(this.pu, this.by);
                    }
                    if (this.cb != null) {
                        this.cb.nd(this);
                    }
                    break;
                case AnnotationLayer.$$p[1]:
                    if (this.cb != null) {
                        this.cb.l9();
                    }
                    break;
                case AnnotationLayer.$$p[0]:
                    this.qu = this.qt;
                    this.li(this.qt);
                    break;
                case "ShouldRenderAsOverlay":
                    if (this.cb != null) {
                        this.by.ak(this.cb);
                        this.by.ag(this.cb);
                    }
                    break;
            }
        }
        ql(a) {
            for (let b of fromEnum(a)) {
                if (!(b == this)) {
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qj));
                }
            }
            this.l7(true);
        }
        qk(a) {
            for (let b of fromEnum(a)) {
                b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.p9));
            }
            this.l7(true);
        }
        qg(a) {
            for (let b of fromEnum(a)) {
                if (!(b == this)) {
                    b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.qj));
                }
            }
            this.l7(true);
        }
        qf(a) {
            for (let b of fromEnum(a)) {
                b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.p9));
            }
            this.l7(true);
        }
        px(a) {
            if (a == null) {
                return false;
            }
            return true;
        }
        p9(a, b) {
            if (this.px(a)) {
                this.qb(a, b.animate);
            }
        }
        py(a) {
            if (a == null) {
                return false;
            }
            if (a.c8) {
                return false;
            }
            return true;
        }
        qj(a, b) {
            if (this.py(a)) {
                this.qc(a, b.animate);
            }
        }
        qb(a, b) {
        }
        qc(a, b) {
        }
        qi(a, b) {
            this.qd(b);
        }
        p8(a, b) {
            this.qa(b);
        }
        qq() {
            if (this.oo != null) {
                return this.oo;
            }
            return this.os;
        }
        qr() {
            if (this.or != null) {
                return this.or;
            }
            return this.ox;
        }
        qa(a) {
            if (a.oldItems != null) {
                for (let b of fromEn(a.oldItems)) {
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.p9));
                }
            }
            if (a.newItems != null) {
                for (let c of fromEn(a.newItems)) {
                    c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.p9));
                }
            }
            this.l7(true);
        }
        qd(a) {
            if (a.oldItems != null) {
                for (let b of fromEn(a.oldItems)) {
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qj));
                }
            }
            if (a.newItems != null) {
                for (let c of fromEn(a.newItems)) {
                    c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.qj));
                }
            }
            this.l7(true);
        }
        mu(a, b) {
            this.l7(false);
        }
        mt(a, b) {
            this.l7(true);
        }
        l8(a) {
            super.l8(a);
            if (this.cu(this.by)) {
                return;
            }
            if (this.ek(a) && !this.eo) {
                let b = this.pt;
                if (this.cs()) {
                    if (this.cc.g) {
                        this.cc.t();
                    }
                    this.pt = this.pu;
                    this.pu = b;
                }
                else {
                    this.pt = this.ps;
                    this.ps = b;
                }
                this.qe(this.ps, this.by);
                this.mf();
            }
            else {
                if (!this.eo) {
                    this.qe(this.ps, this.by);
                }
                this.qh(this.ps, this.by);
            }
        }
        get_c8() {
            return true;
        }
        qe(a, b) {
        }
        qh(a, b) {
            this.pr.b1();
        }
        p7(a) {
            let b = { $type: Point_$type, x: this.qs.x, y: this.qs.y };
            if (a.isVertical) {
                if (isNaN_(this.qs.y)) {
                    return new Tuple$2(Boolean_$type, Point_$type, false, b);
                }
                if (isNaN_(this.qs.x)) {
                    b.x = 0;
                    return new Tuple$2(Boolean_$type, Point_$type, true, b);
                }
            }
            else {
                if (isNaN_(this.qs.x)) {
                    return new Tuple$2(Boolean_$type, Point_$type, false, b);
                }
                if (isNaN_(this.qs.y)) {
                    b.y = 0;
                    return new Tuple$2(Boolean_$type, Point_$type, true, b);
                }
            }
            return new Tuple$2(Boolean_$type, Point_$type, true, b);
        }
        li(a) {
            super.li(a);
            if (isNaN_(this.qu.x) && isNaN_(this.qu.y)) {
                if (isNaN_(a.x) && isNaN_(a.y)) {
                    this.pr.b0();
                    return;
                }
                else {
                    this.pr.b2();
                    this.qs = a;
                }
            }
            else {
                this.pr.b2();
                this.qs = this.qu;
            }
            this.l7(true);
        }
        e5(a, b, c) {
            let d = super.e5(a, b, c);
            if (!this.by.t()) {
                d = false;
                return d;
            }
            return d;
        }
        get_e1() {
            return this.p0;
        }
        get p0() {
            return this.pv;
        }
        set p0(a) {
            let b = this.pv;
            this.pv = a;
            this.raisePropertyChanged("ShouldRenderAsOverlay", b, this.pv);
        }
    }
    AnnotationLayer.$t = /*@__PURE__*/ markType(AnnotationLayer, 'AnnotationLayer', Series.$);
    AnnotationLayer.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, AnnotationLayer, 'raisePropertyChanged', ['CursorPosition:qt:qm', [Point_$type, { $type: Point_$type, x: NaN, y: NaN }], 'IsDefaultCrosshairDisabled:pw:qn', [0, true], 'UseIndex:p1:qo', [0, false], 'UseLegend:p2:qp', [0, false]]);
    return AnnotationLayer;
})();
/**
 * @hidden
 */
export let AnnotationLayerView = /*@__PURE__*/ (() => {
    class AnnotationLayerView extends SeriesView {
        constructor(a) {
            super(a);
            this.bx = null;
            this.by = false;
            this.bz = -1;
            this.bx = a;
        }
        b3() {
            if (this.by) {
                this.by = false;
                this.bz = -1;
                this.bx.qs = { $type: Point_$type, x: NaN, y: NaN };
                this.bx.l7(true);
            }
        }
        b0() {
            this.by = true;
            if (this.e.gz != null) {
                this.e.gz.setTimeout(runOn(this, this.b3), 300);
            }
            else {
                this.bz = window.setTimeout(runOn(this, this.b3), 300);
            }
        }
        b2() {
            if (this.by == true) {
                this.by = false;
                if (this.bz != -1) {
                    window.clearTimeout(this.bz);
                    this.bz = -1;
                }
            }
        }
        b1() {
            this.aq();
        }
    }
    AnnotationLayerView.$t = /*@__PURE__*/ markType(AnnotationLayerView, 'AnnotationLayerView', SeriesView.$);
    return AnnotationLayerView;
})();
