/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Number_$type, typeCast, runOn, markType, markDep, getEnumerator, Point_$type, fromEnum } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { Series } from "./Series";
import { SafeEnumerable } from "./SafeEnumerable";
import { TrendCalculators } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { Flattener } from "igniteui-react-core";
/**
 * @hidden
 */
export let BollingerBandsOverlay = /*@__PURE__*/ (() => {
    class BollingerBandsOverlay extends FinancialOverlay {
        constructor() {
            super();
            this.th = 0;
            this.ti = 0;
            this.tf = new List$1(Number_$type, 0);
            this.tg = new List$1(Number_$type, 0);
            this.ab = BollingerBandsOverlay.$;
            this.p3 = new CategoryFrame(4);
            this.p5 = new CategoryFrame(4);
            this.p1 = new CategoryFrame(4);
        }
        lt(a, b, c, d) {
            if (this.ri().contains(b)) {
                this.s9 = false;
            }
            super.lt(a, b, c, d);
            switch (b) {
                case BollingerBandsOverlay.$$p[1]:
                    this.s9 = false;
                    this.l7(false);
                    break;
                case BollingerBandsOverlay.$$p[0]:
                    this.l7(false);
                    break;
            }
        }
        ta() {
            this.tf.clear();
            this.tg.clear();
            let a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.rh), this.tk));
            let b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.rh), this.tk));
            this.ti = 1.7976931348623157E+308;
            this.th = -1.7976931348623157E+308;
            let c = true;
            let d = true;
            let e = this.tj;
            while (c || d) {
                if (a.moveNext()) {
                    this.tf.add(a.current);
                }
                else {
                    c = false;
                }
                if (b.moveNext()) {
                    this.tg.add(b.current);
                }
                else {
                    d = false;
                }
                if (c && d) {
                    this.ti = Math.min(this.ti, a.current - b.current * e);
                    this.th = Math.max(this.th, a.current + b.current * e);
                }
            }
            return true;
        }
        ap(a) {
            if (this.tf == null || this.tg == null || a == null || this.ci == null || a != this.ql) {
                return null;
            }
            let b = new AxisRange(this.ti, this.th);
            return b;
        }
        sq(a, b) {
            super.sq(a, b);
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.pz;
            let g = this.ql;
            let h = new ScalerParams(0, c, d, f.cf, e);
            let i = new ScalerParams(0, c, d, g.cf, e);
            a.f.clear();
            a.m.clear();
            a.p.clear();
            let j = typeCast(ISortingAxis_$type, this.pz);
            if (j != null && j.i$b.count != this.ci.count) {
                return;
            }
            let k = 0;
            k = this.rq(c, d, e);
            if (!this.s9) {
                this.s9 = this.ta();
                if (this.ql != null) {
                    this.ql.cz(true);
                }
            }
            i.b = this.f4();
            let l = this.pz.ei(2, h) - this.pz.ei(1, h);
            for (let m = b.bx.c; m <= b.bx.d; ++m) {
                let n;
                if (j == null) {
                    n = b.bx.getBucket(m);
                }
                else {
                    let o = j.i$b._inner[m];
                    let p = j.i$d(o);
                    let q = this.tf._inner[m];
                    let r = this.tg._inner[m];
                    let s = q;
                    let t = r;
                    let u = p;
                    let v = 1;
                    while (m < b.bx.d) {
                        o = j.i$b._inner[m + 1];
                        u = j.i$d(o);
                        if (u - p > l) {
                            break;
                        }
                        m++;
                        s += this.tf._inner[m];
                        t += this.tg._inner[m];
                        v++;
                    }
                    s /= v;
                    t /= v;
                    let w = s - t * this.tj;
                    let x = s;
                    let y = s + t * this.tj;
                    let z = NaN;
                    if (!isNaN_(p)) {
                        z = this.pz.ef(p, h);
                    }
                    n = [z, w, x, y];
                }
                let aa = Math.max(1, l);
                if (!isNaN_(n[0]) && m * aa >= this.tb) {
                    if (this.pz != null && typeCast(ISortingAxis_$type, this.pz) !== null) {
                        n[0] = n[0] + k;
                    }
                    else {
                        n[0] = f.ef(n[0], h) + k;
                    }
                    n[1] = g.ef(n[1], i);
                    n[2] = g.ef(n[2], i);
                    n[3] = g.ef(n[3], i);
                    a.f.add(n);
                }
            }
        }
        ko(a, b) {
            super.ko(a, b);
            let c = b;
            if (c != null) {
                c.b4();
            }
        }
        ga(a, b, c) {
            if (this.tf == null) {
                return super.ga(a, b, c);
            }
            let d = this.getEffectiveViewport1(this.by);
            let e = this.rq(this.by.bv, this.by.bu, d);
            let f = new ScalerParams(0, this.by.bv, this.by.bu, this.pz.cf, d);
            f.c = this.cb.sf;
            return this.gc(this.tf, a, this.pz, f, e, runOn(this, this.rp), b, c);
        }
        g9(a, b) {
            if (this.tf == null) {
                return super.g9(a, b);
            }
            return this.ha(a, b, this.pz, runOn(this, this.rp), this.tf);
        }
        g7(a, b) {
            if (this.tf == null) {
                return super.g7(a, b);
            }
            return this.g8(a, b, this.pz, runOn(this, this.rp), this.tf);
        }
        e5(a, b, c) {
            let d = super.e5(a, b, c);
            if (!this.q8(this.ri())) {
                d = false;
            }
            return d;
        }
        ss(a, b) {
            super.ss(a, b);
            let c = typeCast(BollingerBandsOverlayView.$, b);
            let d = this.getEffectiveViewport1(b);
            if (b.b0(a)) {
                c.b4();
                let e = a.f.count;
                let f = (g) => a.f._inner[g][0];
                let g = (h) => a.f._inner[e - 1 - h][0];
                let h = (i) => a.f._inner[i][1];
                let i = (j) => a.f._inner[j][2];
                let j = (k) => a.f._inner[e - 1 - k][3];
                c.b5(e, f, g, h, i, j);
                b.b2(a);
            }
            this.p8.a0(this, this.q7(), runOn(this, this.pr), this.rw(b), this.ry(b));
            let k = false;
            let l = this.p8.b;
            let m = a.f;
            let n = this.ci.count;
            if (l != null) {
                k = true;
            }
            if (k) {
                let o = new ScalerParams(0, b.bv, b.bu, this.pz.cf, d);
                this.sp(m, -1, n, this.pz, o, b.q);
            }
            let p = c.cc;
            let q = c.cd;
            let r = c.ce;
            let s = c.b7;
            this.p8.ad(q, true, false, true, true);
            this.p8.an = null;
            this.p8.am = null;
            this.p8.ad(p, true, false, false, true);
            this.p8.ad(r, true, false, false, true);
            this.p8.ad(s, false, true, false, false);
            s._opacity = this.p8.j * this.fk;
        }
        bv() {
            return new BollingerBandsOverlayView(this);
        }
        lo(a) {
            super.lo(a);
            this.te = typeCast(BollingerBandsOverlayView.$, a);
        }
        rz() {
            return 3;
        }
        f4() {
            return Series.f5(this.tf, null);
        }
    }
    BollingerBandsOverlay.$t = /*@__PURE__*/ markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
    BollingerBandsOverlay.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:tj:tn', [1, 2], 'Period:tk:to', [1, 14]]);
    return BollingerBandsOverlay;
})();
/**
 * @hidden
 */
export let BollingerBandsBucketCalculator = /*@__PURE__*/ (() => {
    class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = a * this.b;
            let c = Math.min(b + this.b - 1, this.a.bz.ci.count - 1);
            if (b <= c) {
                let d = this.f.b3.tj;
                let e = 0;
                let f = 0;
                let g = 0;
                for (let h = b; h <= c; ++h) {
                    if (!isNaN_(this.f.b3.tf._inner[h]) && !isNaN_(this.f.b3.tg._inner[h])) {
                        e += this.f.b3.tf._inner[h];
                        f += this.f.b3.tg._inner[h];
                        ++g;
                    }
                }
                if (g > 0) {
                    e = e / g;
                    f = f / g;
                    return [0.5 * (b + c), e - f * d, e, e + f * d];
                }
            }
            return [NaN, NaN, NaN, NaN];
        }
    }
    BollingerBandsBucketCalculator.$t = /*@__PURE__*/ markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
    return BollingerBandsBucketCalculator;
})();
/**
 * @hidden
 */
export let BollingerBandsOverlayView = /*@__PURE__*/ (() => {
    class BollingerBandsOverlayView extends FinancialSeriesView {
        constructor(a) {
            super(a);
            this.b3 = null;
            this.b8 = new Polygon();
            this.cf = new Polyline();
            this.cg = new Polyline();
            this.ch = new Polyline();
            this.b6 = new Polygon();
            this.b9 = new Polyline();
            this.ca = new Polyline();
            this.cb = new Polyline();
            this.b3 = a;
        }
        as() {
            super.as();
            if (!this.q) {
            }
        }
        by() {
            return new BollingerBandsBucketCalculator(this);
        }
        b5(a, b, c, d, e, f) {
            for (let g of fromEnum(Flattener.d(a, b, d, this.e.gk))) {
                this.b8.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
                this.cf.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
            }
            for (let h of fromEnum(Flattener.d(a, b, e, this.e.gk))) {
                this.cg.ak.add({ $type: Point_$type, x: b(h), y: e(h) });
            }
            for (let i of fromEnum(Flattener.d(a, c, f, this.e.gk))) {
                this.b8.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
                this.ch.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
            }
            this.aq();
        }
        b4() {
            this.b8.ak.clear();
            this.cf.ak.clear();
            this.cg.ak.clear();
            this.ch.ak.clear();
            this.aq();
        }
        get b7() {
            return this.b8;
        }
        get cc() {
            return this.cf;
        }
        get cd() {
            return this.cg;
        }
        get ce() {
            return this.ch;
        }
        bc() {
            super.bc();
            this.b6.ak = this.b8.ak;
            this.b9.ak = this.cf.ak;
            this.ca.ak = this.cg.ak;
            this.cb.ak = this.ch.ak;
            let a = this.bo();
            this.b6._fill = a;
            this.b6._opacity = 1;
            this.b9._stroke = a;
            this.b9.ac = this.e.fn + 3;
            this.ca._stroke = a;
            this.ca.ac = this.e.fn + 3;
            this.cb._stroke = a;
            this.cb.ac = this.e.fn + 3;
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d) {
                if (b) {
                    a.t(this.b6);
                    a.u(this.b9);
                    a.u(this.ca);
                    a.u(this.cb);
                }
                else {
                    a.t(this.b8);
                    a.u(this.cf);
                    a.u(this.cg);
                    a.u(this.ch);
                }
            }
        }
        al(a) {
            super.al(a);
            this.e.a7.exportPolygonData(a, this.b8, "FillShape", ["Fill"]);
            this.e.a7.exportPolylineData(a, this.cf, "BottomLine", ["Lower", "Main"]);
            this.e.a7.exportPolylineData(a, this.cg, "CentralLine", ["Central"]);
            this.e.a7.exportPolylineData(a, this.ch, "TopLine", ["Upper"]);
        }
    }
    BollingerBandsOverlayView.$t = /*@__PURE__*/ markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
    return BollingerBandsOverlayView;
})();
