/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-react-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { List$1 } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-react-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-react-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-react-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-react-core";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-react-core";
import { IChartScaleLegend_$type } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_, isInfinity, logBase } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
export let BubbleSeries = /*@__PURE__*/ (() => {
    class BubbleSeries extends ScatterBase {
        constructor() {
            super();
            this.vt = null;
            this.vs = null;
            this.us = null;
            this.uk = null;
            this.uj = null;
            this.ui = null;
            this.ab = BubbleSeries.$;
            this.rq = new ScatterFrame();
            this.rs = new ScatterFrame();
            this.ro = new ScatterFrame();
        }
        get_c1() {
            return true;
        }
        bv() {
            return new BubbleSeriesView(this);
        }
        lo(a) {
            super.lo(a);
            this.ug = a;
        }
        gl() {
            return 0.7;
        }
        pu() {
            if (this.pt == 0) {
                return 2;
            }
            return super.pu();
        }
        isAttachedTo(a) {
            return this.a0 == a;
        }
        c0() {
            return true;
        }
        k0(a) {
            super.k0(a);
            if (this.un != null && this.us != null && this.us.count > 0) {
                for (let b = 0; b < this.us.count; b++) {
                    a(this.us._inner[b]);
                }
            }
        }
        get um() {
            return this.uo;
        }
        vr(a) {
            let b = typeCast(CustomPaletteBrushScale.$, this.uf);
            let c = typeCast(ValueBrushScale.$, this.uf);
            let d = this.uf;
            if (b != null && this.ci != null) {
                return b.getBrush1(a, this.ci.count);
            }
            else if (c != null) {
                return c.getBrushByIndex(a, this.ul);
            }
            else if (d != null) {
                return d.getBrush(a);
            }
            return null;
        }
        get legendReady() {
            return this.uo != null && this.uo.count != 0;
        }
        get minScaleText() {
            let a = this.ue(this.uh).b;
            return (Math.round(a * 1000) / 1000).toString();
        }
        get maxScaleText() {
            let a = this.ue(this.uh).a;
            return (Math.round(a * 1000) / 1000).toString();
        }
        forScaleColors(a) {
            for (let b = 0; b < this.uo.count; b++) {
                if (this.uf == null || !this.uf.isReady) {
                    return false;
                }
                let c = NaN;
                if (this.ul != null) {
                    c = (this.ul.item(b) - this.ul.minimum) / (this.ul.maximum - this.ul.minimum);
                }
                let d = (this.uo.item(b) - this.uo.minimum) / (this.uo.maximum - this.uo.minimum);
                if (isNaN_(c)) {
                    c = 0;
                }
                if (isNaN_(d)) {
                    d = c;
                }
                let e = this.q0;
                let f = this.vr(b);
                let g = f != null ? f : e;
                a(g, d);
            }
            return true;
        }
        hn(a, b) {
            let c = this.jf(b);
            if (c == BubbleSeries.$$p[3]) {
                return this.ho(a, b, this.u3);
            }
            if (c == BubbleSeries.$$p[7]) {
                return this.ho(a, b, this.u9);
            }
            if (c == ScatterBase.$$p[8]) {
                return this.ho(a, b, this.sx);
            }
            if (c == ScatterBase.$$p[10]) {
                return this.ho(a, b, this.s1);
            }
            if (c == BubbleSeries.$$p[0]) {
                return this.ho(a, b, this.uy);
            }
            return super.hn(a, b);
        }
        get uo() {
            return this.uk;
        }
        set uo(a) {
            if (this.uk != a) {
                let b = this.uo;
                this.uk = a;
                this.raisePropertyChanged("RadiusColumn", b, this.uo);
            }
        }
        get un() {
            return this.uj;
        }
        set un(a) {
            if (this.uj != a) {
                let b = this.un;
                this.uj = a;
                this.raisePropertyChanged("LabelColumn", b, this.un);
            }
        }
        get ul() {
            return this.ui;
        }
        set ul(a) {
            if (this.ui != a) {
                let b = this.ul;
                this.ui = a;
                this.raisePropertyChanged("FillColumn", b, this.ul);
            }
        }
        s4(a, b, c, d, e) {
            if (c <= this.sl) {
                b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
            }
            let f = this.sl;
            let g = this.ci;
            let h;
            let i;
            let j = this.getEffectiveViewport1(a);
            let k = new ScalerParams(0, d, e, this.rk.d, j);
            let l = new ScalerParams(0, d, e, this.rk.e, j);
            let m = false;
            let n = 0;
            if (this.cb != null) {
                if (this.cb.ex()) {
                    let o = this.cb.km(d, k);
                    m = o.c;
                    n = o.d;
                }
            }
            for (let p = 0; p < c; p++) {
                h = this.r0.item(p);
                i = this.r1.item(p);
                let q = { $type: Point_$type, x: this.rk.a.ef(h, k), y: this.rk.b.ef(i, l) };
                if (m) {
                    if (q.x < e.left || q.x > e.right) {
                        if (q.x + n >= e.left && q.x + n <= e.right) {
                            q = { $type: Point_$type, x: q.x + n, y: i };
                        }
                    }
                }
                if (!isInfinity(q.x) && !isInfinity(q.y)) {
                    let r = g.item(p);
                    if (c <= f) {
                        if (!b.g.containsKey(r)) {
                            let s = { $type: Point_$type, x: h, y: i };
                            b.g.addItem(r, ((() => {
                                let $ret = new OwnedPoint();
                                $ret.a = r;
                                $ret.b = s;
                                $ret.c = q;
                                return $ret;
                            })()));
                        }
                    }
                }
            }
        }
        tc(a, b) {
            let c = typeCast(BubbleSeriesView.$, b);
            let d = c.cv;
            d.m = this.uo;
            super.tc(a, b);
            let e = Math.min(this.r0 != null ? this.r0.count : 0, this.r1 != null ? this.r1.count : 0);
            if (e < 1) {
                return;
            }
            c.dh();
            c.di();
        }
        ve() {
            if (this.cb == null) {
                return;
            }
            if (this.a0 == null) {
                return;
            }
            if (this.a0.isItemwise) {
                let a = this.a0;
                this.a0.clearLegendItemsForSeries(this);
                this.vd();
                a.renderItemwiseContent(this);
            }
            if (this.a0.isScale) {
                let b = this.a0;
                b.restoreOriginalState();
                b.initializeLegend(this);
            }
        }
        static ut(a, b, c, d, e) {
            if (e <= a || isNaN_(e) || isInfinity(e)) {
                return c;
            }
            if (e >= b) {
                return d;
            }
            let f = c + ((d - c) / (b - a)) * (e - a);
            return f;
        }
        static uu(a, b, c, d, logBase_, e) {
            let f = logBase(e, logBase_);
            let g = logBase(a, logBase_);
            let h = logBase(b, logBase_);
            return BubbleSeries.ut(g, h, c, d, f);
        }
        e5(a, b, c) {
            let d = super.e5(a, b, c);
            if (this.uo == null || this.ci == null || this.uo.count == 0 || this.ci.count != this.uo.count) {
                d = false;
            }
            return d;
        }
        r9(a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.sx == a || this.s1 == a || this.u9 == a) {
                return true;
            }
            return false;
        }
        vd() {
            let a = typeCast(IChartLegend_$type, this.a0);
            if (a == null || this.ci == null) {
                return;
            }
            this.us = new List$1(UIElement.$, 0);
            let b = typeCast(CustomPaletteBrushScale.$, this.uf);
            let c = typeCast(ValueBrushScale.$, this.uf);
            let d = this.uf;
            let e = this.ud();
            let f = e.b;
            let g = e.a;
            let h = this.ci;
            for (let i = 0; i < h.count; i++) {
                let j = null;
                if (c != null && this.ul != null) {
                    let k = this.ul.item(i);
                    j = c.getBrushByRange(k, f, g);
                }
                else if (b != null) {
                    j = b.getBrush1(i, h.count);
                }
                else if (d != null) {
                    j = d.getBrush(i);
                }
                let l = new ContentControl();
                let m = this.un != null && this.un.item(i) != null ? this.un.item(i).toString() : "";
                l.content = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this;
                    $ret.item = h.item(i);
                    $ret.itemBrush = j;
                    $ret.itemLabel = m;
                    return $ret;
                })());
                let n = this.m0;
                if (n == null) {
                    n = this.by.bl(this.b3);
                }
                l.ah = n;
                this.us.add(l);
            }
        }
        kr(a, b, c, d) {
            super.kr(a, b, c, d);
            if (this.uh != null) {
                this.uh.aa();
            }
            if (this.uf != null) {
                this.uf.x();
            }
            this.ve();
        }
        k7() {
            super.k7();
            this.ve();
        }
        ld() {
            super.ld();
            this.ve();
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    if (this.uh != null) {
                        this.uh.aa();
                    }
                    if (this.uf != null) {
                        this.uf.x();
                    }
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.uo);
                        c.deregisterColumn(this.ul);
                        c.deregisterColumn(this.un);
                        this.uo = null;
                        this.ul = null;
                        this.un = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.uo = this.cf(this.u9);
                        if (!stringIsNullOrEmpty(this.uy)) {
                            this.ul = this.cf(this.uy);
                        }
                        this.un = this.ch(this.u3);
                    }
                    this.l7(false);
                    this.ve();
                    break;
                case BubbleSeries.$$p[7]:
                    if (this.uh != null) {
                        this.uh.aa();
                    }
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.uo);
                        this.uo = this.cf(this.u9);
                        this.ve();
                    }
                    break;
                case "RadiusColumn":
                    if (this.uh != null) {
                        this.uh.aa();
                    }
                    this.rl.cx.g$i();
                    this.l7(false);
                    this.lf();
                    break;
                case BubbleSeries.$$p[8]:
                    if (c != null) {
                        c.l.remove(this);
                        c.aa();
                    }
                    if (d != null) {
                        d.l.add(this);
                        d.aa();
                    }
                    this.l7(false);
                    this.le();
                    break;
                case BubbleSeries.$$p[9]:
                    this.l7(false);
                    this.le();
                    break;
                case "DiscreteLegendItemTemplate":
                    this.ve();
                    break;
                case BubbleSeries.$$p[1]:
                    if (c != null) {
                        c.o.remove(this);
                        c.x();
                    }
                    if (d != null) {
                        d.o.add(this);
                        d.x();
                    }
                    this.l7(false);
                    this.ve();
                    this.le();
                    break;
                case BubbleSeries.$$p[2]:
                case BubbleSeries.$$p[6]:
                case BubbleSeries.$$p[5]:
                case BubbleSeries.$$p[4]:
                    this.l7(false);
                    this.ve();
                    this.le();
                    break;
                case "FillColumn":
                    this.l7(false);
                    this.le();
                    break;
                case BubbleSeries.$$p[0]:
                    if (this.uf != null) {
                        this.uf.x();
                    }
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.ul);
                        this.ul = this.cf(this.uy);
                        this.ve();
                    }
                    break;
                case BubbleSeries.$$p[3]:
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.un);
                        this.un = this.ch(this.u3);
                        this.ve();
                    }
                    break;
                case "ActualLegend":
                    let e = typeCast(IChartLegend_$type, c);
                    if (e != null && e.isItemwise) {
                        let f = typeCast(IChartItemLegend_$type, e);
                        f.clearLegendItemsForSeries(this);
                    }
                    if (e != null && e.isScale) {
                        let g = typeCast(IChartScaleLegend_$type, e);
                        let h = true;
                        let i = null;
                        if (this.cb != null) {
                            for (let j of fromEnum(this.cb.series)) {
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        if (h) {
                            g.restoreOriginalState();
                        }
                        else {
                            g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                        }
                    }
                    this.ve();
                    break;
                case "SeriesViewer":
                    this.ve();
                    break;
            }
        }
        updateSizeScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.uo != null) {
                a.b = this.uo.minimum;
                a.a = this.uo.maximum;
            }
            if (this.uh != null) {
                this.uh.ab(a.b, a.a);
            }
        }
        updateFillScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.ul != null) {
                a.b = this.ul.minimum;
                a.a = this.ul.maximum;
            }
            if (this.uf != null) {
                this.uf.z(a.b, a.a);
            }
        }
        ue(a) {
            let b = new ActualRange();
            b.b = NaN;
            b.a = NaN;
            if (this.uo != null) {
                b.b = this.uo.minimum;
                b.a = this.uo.maximum;
            }
            if (a != null) {
                a.x();
                if (this.ur) {
                    b.b = a.globalMinimum;
                    b.a = a.globalMaximum;
                }
            }
            return b;
        }
        ud() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.ul != null) {
                a.b = this.ul.minimum;
                a.a = this.ul.maximum;
            }
            let b = typeCast(ValueBrushScale.$, this.uf);
            if (b != null) {
                b.s();
                if (this.up && this.uf.o.count > 1) {
                    a.b = b.q;
                    a.a = b.p;
                }
            }
            return a;
        }
        vg(a, b, c, d) {
            let e = c.width;
            if (!this.by.bu.isEmpty) {
                e = this.by.bu.width;
            }
            else if (this.cb != null && !this.cb.sf.isEmpty) {
                e = this.cb.sf.width;
            }
            let f = DeviceUtils.c(e);
            let g = this.uh || ((() => {
                let $ret = new SizeScale();
                $ret.minimumValue = f / 10;
                $ret.maximumValue = f / 5;
                return $ret;
            })());
            if (g != null) {
                let h = g.minimumValue;
                let i = g.maximumValue;
                let j = g.logarithmBase;
                let k = this.ue(g);
                let l = k.b;
                let m = k.a;
                if (g.isLogarithmic) {
                    for (let n = 0; n < b.count; n++) {
                        b._inner[n] = BubbleSeries.uu(l, m, h, i, j, b._inner[n]);
                    }
                }
                else {
                    for (let o = 0; o < b.count; o++) {
                        b._inner[o] = BubbleSeries.ut(l, m, h, i, b._inner[o]);
                    }
                }
            }
            let p = 1;
            p = DeviceUtils.d();
            let q = this.uh == null;
            if (d) {
                let r = c.width / e;
                for (let s = 0; s < b.count; s++) {
                    if (q) {
                        b._inner[s] = b._inner[s] / p;
                    }
                    b._inner[s] = b._inner[s] * r;
                }
            }
            for (let t = 0; t < a.count; t++) {
                let u = a._inner[t];
                if (q && !d) {
                    u.width = Math.max(0, b._inner[t] / p);
                    u.height = Math.max(0, b._inner[t] / p);
                }
                else {
                    u.width = Math.max(0, b._inner[t]);
                    u.height = Math.max(0, b._inner[t]);
                }
            }
        }
        vf(a) {
            let b = typeCast(BubbleSeriesView.$, this.bx);
            this.ug.b3 = false;
            if (b != null) {
                b.b3 = false;
            }
            let c = typeCast(CustomPaletteBrushScale.$, this.uf);
            let d = typeCast(ValueBrushScale.$, this.uf);
            let e = this.uf;
            let f = this.ud();
            let g = f.b;
            let h = f.a;
            let i = this.uf == null || !this.uf.isReady || (d != null && this.uy == null);
            if (i) {
                this.ug.dg();
                if (b != null) {
                    b.dg();
                }
                return;
            }
            this.ug.b3 = true;
            if (b != null) {
                b.b3 = true;
            }
            let j = a.count;
            let k = this.ci;
            for (let l = 0; l < j; l++) {
                let m = a._inner[l];
                let n = typeCast(DataContext.$, m.content);
                if (n != null) {
                    let o = null;
                    let p = k.indexOf(n.item);
                    if (c != null) {
                        o = c.getBrush1(p, k.count);
                    }
                    else if (d != null && this.ul != null) {
                        let q = this.ul.item(p);
                        o = d.getBrushByRange(q, g, h);
                    }
                    else if (e != null) {
                        o = e.getBrush(p);
                    }
                    else {
                        if (this.q2 == null) {
                            o = this.q0;
                        }
                        else {
                            o = this.q2;
                        }
                    }
                    let r = null;
                    if (this.q3 == null) {
                        r = this.q1;
                    }
                    else {
                        r = this.q3;
                    }
                    if (this.uq && o != null) {
                        r = o;
                    }
                    if (r != null && !isNaN_(this.uw)) {
                        r = BrushUtil.l(r, this.uw);
                    }
                    if (o != null && !isNaN_(this.uv)) {
                        o = BrushUtil.l(o, this.uv);
                    }
                    n.itemBrush = o;
                    n.actualItemBrush = o;
                    n.outline = r;
                }
            }
        }
        get actualMarkerBrush() {
            return this.q0;
        }
    }
    BubbleSeries.$t = /*@__PURE__*/ markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberPath:uy:vh', [2], 'FillScale:uf:vi', [BrushScale.$], 'FillScaleUseGlobalValues:up:vj', [0, false], 'LabelMemberPath:u3:vk', [2], 'MarkerBrushBrightness:uv:vl', [1, NaN], 'MarkerOutlineBrightness:uw:vm', [1, NaN], 'MarkerOutlineUsesFillScale:uq:vn', [0, false], 'RadiusMemberPath:u9:vo', [2, null], 'RadiusScale:uh:vp', [SizeScale.$], 'RadiusScaleUseGlobalValues:ur:vq', [0, false]]);
    return BubbleSeries;
})();
/**
 * @hidden
 */
export let CustomPaletteBrushScale = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScale extends BrushScale {
        constructor() {
            super();
        }
        getBrush1(a, b) {
            if (this.brushes == null || this.brushes.count == 0) {
                return null;
            }
            if (this.brushSelectionMode == 0) {
                return super.getBrush(a % this.brushes.count);
            }
            let c = BubbleSeries.ut(0, b - 1, 0, this.brushes.count - 1, a);
            return this.ab(c);
        }
        get_isReady() {
            return this.brushes != null && this.brushes.count > 0;
        }
    }
    CustomPaletteBrushScale.$t = /*@__PURE__*/ markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, /*@__PURE__*/ enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
})();
/**
 * @hidden
 */
export let BubbleSeriesView = /*@__PURE__*/ (() => {
    class BubbleSeriesView extends ScatterBaseView {
        constructor(a) {
            super(a);
            this.df = null;
            this.df = a;
            this.cx = new ScatterTrendLineManager();
        }
        as() {
            super.as();
            if (!this.q) {
                this.b1.p0 = Defaults.e;
            }
        }
        cu() {
            return new BubbleMarkerManager((a) => this.cy.item(a), (a) => this.cw.rk.c.item(a), runOn(this, this.c9), runOn(this, this.cr), runOn(this, this.cz));
        }
        dh() {
            let a = this.cv;
            this.df.vg(a.n, a.o, this.bu, this == this.e.bx);
            this.aq();
        }
        di() {
            let a = this.cv;
            this.df.vf(a.n);
        }
        dg() {
            let a = this.cv;
            for (let b of fromEnum(a.n)) {
                let c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a5.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.df.hs + "</span><br/><span>" + "(${item." + this.df.sx + "}, ${item." + this.df.s1 + "})</span>";
            if (!stringIsNullOrEmpty(this.df.u9)) {
                a += "<span>, Radius: ${item." + this.df.u9 + "}</span>";
            }
            a += "</div>";
            return a;
        }
    }
    BubbleSeriesView.$t = /*@__PURE__*/ markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
})();
