/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { XYChart } from "./XYChart";
import { typeCast, runOn, delegateCombine, enumGetBox, markType, TypeRegistrar, getInstanceType } from "igniteui-react-core";
import { CategoryChartType_$type } from "./CategoryChartType";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { TransitionInSpeedType_$type } from "./TransitionInSpeedType";
import { CategoryXAxis } from "./CategoryXAxis";
import { List$1 } from "igniteui-react-core";
import { DataSeriesType_$type } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { IDataSeriesAdapterRule_$type } from "igniteui-react-core";
import { SimpleCategorySeriesRule } from "igniteui-react-core";
import { SubCollectionsRule } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { Series } from "./Series";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { ArrayExtension } from "igniteui-react-core";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { CategoryChartMockDataGenerator } from "./CategoryChartMockDataGenerator";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let CategoryChart = /*@__PURE__*/ (() => {
    class CategoryChart extends XYChart {
        constructor() {
            super();
            this.uk = 1000;
            this.tj = null;
            this.s3 = 9;
            this.s5 = 1;
            this.tn = false;
            this.s7 = 0;
            this.th = 0;
            this.tx = 0;
            this.ty = 0;
            this.tw = 0;
            this.tz = 0;
            this.t0 = NaN;
            this.tp = false;
            this.ul = 10;
            this.t2 = NaN;
            this.t1 = NaN;
            this.t3 = 0;
            this.sz = null;
            this.s0 = null;
            this.to = true;
            this.tl = false;
            this.tm = false;
            this.tv = null;
            this.i7();
        }
        jp() {
            super.jp();
            if (this.dataChart == null) {
                return;
            }
            let a = this.dataChart.cm.j.e();
            this.s1 = a.d;
            this.s2 = a.e;
            if (this.sb == null) {
                this.sb = a.k;
            }
            if (this.si == null) {
                this.si = a.k;
            }
            this.oa = 0;
            this.sj = AxisDefaults.h;
            this.sm = null;
            this.sf = AxisDefaults.g;
            this.sc = null;
            this.nt = AxisDefaults.f;
            this.sg = AxisDefaults.j;
            this.nu = AxisDefaults.e;
            this.cf = true;
            this.cg = false;
            this.aa = 0;
            this.ec = Defaults.j;
            this.lk = Defaults.ae;
            this.lf = Defaults.af;
            this.lg = Defaults.ag;
        }
        jr(a, b) {
            super.jr(a, b);
            a.he = this.um;
            a.ce = this.tk;
        }
        kb(a, b, c) {
            super.kb(a, b, c);
            switch (a) {
                case "TransitionInDuration":
                    this.je((d) => d.he = this.um);
                    break;
                case "TransitionInEasingFunction":
                    this.je((d) => d.ce = this.tk);
                    break;
            }
        }
        get um() {
            return this.uk;
        }
        set um(a) {
            let b = this.um;
            if (a != b) {
                this.uk = a;
                this.ka("TransitionInDuration", b, this.um);
            }
        }
        get tk() {
            return this.tj;
        }
        set tk(a) {
            let b = this.tk;
            if (a != b) {
                this.tj = a;
                this.ka("TransitionInEasingFunction", b, this.tk);
            }
        }
        up() {
            let cvd_ = this.fg();
            cvd_.scaleByViewport();
            return (cvd_.serialize());
        }
        jk(a) {
            super.jk(a);
            a.dj = this.cb;
        }
        jq(a, b) {
            super.jq(a, b);
            let c = typeCast(HorizontalAnchoredCategorySeries.$, a);
            if (c == null) {
                return;
            }
            c.s6 = this.s6;
            c.r3 = this.ts;
            c.rn = this.s8;
            c.b8 = this.ti;
            c.trendLineBrush = ArrayExtension.getModulus$1(Brush.$, this.t, b);
            c.trendLineType = this.bm;
            c.trendLineThickness = this.ex;
            c.p0 = this.a3(a, b);
            if (a.dz) {
                a.mc(ArrayExtension.getModulus$1(Brush.$, this.s1, b), ArrayExtension.getModulus$1(Brush.$, this.s2, b));
            }
        }
        s9() {
            return new CategoryXAxis();
        }
        td() {
            return new NumericYAxis();
        }
        i4() {
            this.xAxis = this.s9();
            this.xAxis.name = "xAxis";
            let a = this.xAxis;
            a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.vd));
            this.yAxis = this.td();
            this.yAxis.name = "yAxis";
            let b = this.yAxis;
            b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.ve));
            if (this.xAxis.ay == null) {
                this.xAxis.ay = new AxisLabelSettings();
            }
            if (this.yAxis.ay == null) {
                this.yAxis.ay = new AxisLabelSettings();
            }
        }
        rb(a) {
            super.rb(a);
            a.kv = this.tt;
        }
        get_ai() {
            return 0;
        }
        get ai() {
            return this.get_ai();
        }
        get s4() {
            return this.s3;
        }
        set s4(a) {
            if (a != this.s3) {
                let b = this.s4;
                this.s3 = a;
                this.ka("ChartType", enumGetBox(CategoryChartType_$type, b), enumGetBox(CategoryChartType_$type, this.s4));
            }
        }
        get s6() {
            return this.s5;
        }
        set s6(a) {
            let b = this.s6;
            if (a != b) {
                this.s5 = a;
                this.ka("MarkerCollisionAvoidance", enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, b), enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, this.s6));
            }
        }
        get ts() {
            return this.tn;
        }
        set ts(a) {
            let b = this.ts;
            if (a != b) {
                this.tn = a;
                this.ka("IsTransitionInEnabled", b, this.ts);
            }
        }
        get s8() {
            return this.s7;
        }
        set s8(a) {
            let b = this.s8;
            if (a != b) {
                this.s7 = a;
                this.ka("TransitionInMode", enumGetBox(CategoryTransitionInMode_$type, b), enumGetBox(CategoryTransitionInMode_$type, this.s8));
            }
        }
        get ti() {
            return this.th;
        }
        set ti(a) {
            let b = this.ti;
            if (a != b) {
                this.th = a;
                this.ka("TransitionInSpeedType", enumGetBox(TransitionInSpeedType_$type, b), enumGetBox(TransitionInSpeedType_$type, this.ti));
            }
        }
        get ub() {
            return this.tx;
        }
        set ub(a) {
            let b = this.ub;
            if (a != b) {
                this.tx = a;
                this.ka("XAxisInterval", b, this.ub);
            }
        }
        get uc() {
            return this.ty;
        }
        set uc(a) {
            let b = this.uc;
            if (a != b) {
                this.ty = a;
                this.ka("XAxisMinorInterval", b, this.uc);
            }
        }
        get ua() {
            return this.tw;
        }
        set ua(a) {
            let b = this.ua;
            if (a != b) {
                this.tw = a;
                this.ka("XAxisGap", b, this.ua);
            }
        }
        get ud() {
            return this.tz;
        }
        set ud(a) {
            let b = this.ud;
            if (a != b) {
                this.tz = a;
                this.ka("XAxisOverlap", b, this.ud);
            }
        }
        get ug() {
            return this.t0;
        }
        set ug(a) {
            let b = this.ug;
            if (a != b) {
                this.t0 = a;
                this.ka("YAxisInterval", b, this.ug);
            }
        }
        get tu() {
            return this.tp;
        }
        set tu(a) {
            let b = this.tu;
            if (a != b) {
                this.tp = a;
                this.ka("YAxisIsLogarithmic", b, this.tu);
            }
        }
        get un() {
            return this.ul;
        }
        set un(a) {
            let b = this.un;
            if (a != b) {
                this.ul = a;
                this.ka("YAxisLogarithmBase", b, this.un);
            }
        }
        get ui() {
            return this.t2;
        }
        set ui(a) {
            let b = this.ui;
            if (a != b) {
                this.t2 = a;
                this.ka("YAxisMinimumValue", b, this.ui);
            }
        }
        get uh() {
            return this.t1;
        }
        set uh(a) {
            let b = this.uh;
            if (a != b) {
                this.t1 = a;
                this.ka("YAxisMaximumValue", b, this.uh);
            }
        }
        get uj() {
            return this.t3;
        }
        set uj(a) {
            let b = this.uj;
            if (a != b) {
                this.t3 = a;
                this.ka("YAxisMinorInterval", b, this.uj);
            }
        }
        get t9() {
            return this.xAxis.mq;
        }
        get t8() {
            return this.xAxis.mp;
        }
        t5() {
            return this.t9;
        }
        t7() {
            return this.uf;
        }
        t4() {
            return this.t8;
        }
        t6() {
            return this.ue;
        }
        get uf() {
            return this.yAxis.ld;
        }
        get ue() {
            return this.yAxis.lc;
        }
        get s1() {
            return this.sz;
        }
        set s1(a) {
            let b = this.s1;
            if (a != b) {
                this.sz = a;
                this.ka("NegativeBrushes", b, this.s1);
            }
        }
        get s2() {
            return this.s0;
        }
        set s2(a) {
            let b = this.s2;
            if (a != b) {
                this.s0 = a;
                this.ka("NegativeOutlines", b, this.s2);
            }
        }
        get tt() {
            return this.to;
        }
        set tt(a) {
            let b = this.tt;
            if (a != b) {
                this.to = a;
                this.ka("YAxisAbbreviateLargeNumbers", b, this.tt);
            }
        }
        get tq() {
            return this.tl;
        }
        set tq(a) {
            let b = this.tq;
            if (a != b) {
                this.tl = a;
                this.ka("IsCategoryHighlightingEnabled", b, this.tq);
            }
        }
        get tr() {
            return this.tm;
        }
        set tr(a) {
            let b = this.tr;
            if (a != b) {
                this.tm = a;
                this.ka("IsItemHighlightingEnabled", b, this.tr);
            }
        }
        get_c7() {
            let a = new List$1(DataSeriesType_$type, 0);
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                a.add(2);
            }
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                a.add(1);
            }
            if (TypeRegistrar.isRegistered("LineSeries")) {
                a.add(0);
            }
            if (TypeRegistrar.isRegistered("PointSeries")) {
                a.add(10);
            }
            if (TypeRegistrar.isRegistered("SplineSeries")) {
                a.add(6);
            }
            if (TypeRegistrar.isRegistered("SplineAreaSeries")) {
                a.add(7);
            }
            if (TypeRegistrar.isRegistered("StepAreaSeries")) {
                a.add(5);
            }
            if (TypeRegistrar.isRegistered("StepLineSeries")) {
                a.add(4);
            }
            if (TypeRegistrar.isRegistered("WaterfallSeries")) {
                a.add(8);
            }
            return a;
        }
        get c7() {
            return this.get_c7();
        }
        dg() {
            if (this.tv == null) {
                this.tv = CategoryChartMockDataGenerator.a();
            }
            return this.tv;
        }
        vd(a, b) {
            switch (b.propertyName) {
                case "ActualMinimum":
                    this.kh("XAxisActualMinimum");
                    break;
                case "ActualMaximum":
                    this.kh("XAxisActualMaximum");
                    break;
            }
        }
        ve(a, b) {
            switch (b.propertyName) {
                case "ActualMinimumValue":
                    this.kh("YAxisActualMinimum");
                    break;
                case "ActualMaximumValue":
                    this.kh("YAxisActualMaximum");
                    break;
            }
        }
        kt() {
            super.kt();
            this.xAxis.fw = this.ok == null ? XYChart.ow(this.xAxis, this.ac.dataSeries) : this.ok;
            this.xAxis.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        }
        get xAxis() {
            return this._xAxis;
        }
        set xAxis(a) {
            this._xAxis = a;
        }
        get yAxis() {
            return this._yAxis;
        }
        set yAxis(a) {
            this._yAxis = a;
        }
        tc(a, b) {
            switch (a) {
                case 2: return this.bc(1);
                case 3: return this.bc(10);
                case 0: return this.bc(0);
                case 1: return this.bc(2);
                case 6: return this.bc(6);
                case 7: return this.bc(7);
                case 4: return this.bc(4);
                case 5: return this.bc(5);
                case 8: return this.bc(8);
                case 9: return this.tb(b);
                default: return this.bc(1);
            }
        }
        tb(a) {
            return this.bc(a);
        }
        ab(a) {
            switch (this.s4) {
                case 1: return 2;
                case 0: return 0;
                case 3: return 10;
                case 6: return 6;
                case 7: return 7;
                case 5: return 5;
                case 4: return 4;
                case 8: return 8;
                case 9: return a.suggestedSeries;
                default:
                case 2: return 1;
            }
        }
        bb(a, b) {
            let c = this.tc(this.s4, a.suggestedSeries);
            c.tk = a.findMatchingHint(0).path;
            c.xAxis = this.xAxis;
            c.yAxis = this.yAxis;
            return c;
        }
        kr(a) {
            if (a.suggestedSecondaryAxis == 2) {
                this.yAxis.k2 = true;
                this.yAxis.lp = 10;
            }
        }
        ku() {
            this.yAxis.k2 = this.tu;
            this.yAxis.lp = this.un;
        }
        get_c6() {
            return ((() => {
                let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
                $ret.add(new SimpleCategorySeriesRule());
                $ret.add(new SubCollectionsRule());
                return $ret;
            })());
        }
        get c6() {
            return this.get_c6();
        }
        i2(a, b) {
            let c = typeCast(HorizontalAnchoredCategorySeries.$, a);
            if (c != null) {
                c.s6 = this.s6;
                c.p0 = this.a3(a, b);
            }
        }
        vb(a) {
            this.vc((b, c) => a(b));
        }
        vc(a) {
            if (this.dataChart == null) {
                return;
            }
            for (let b = 0; b < this.dataChart.series.count; b++) {
                let c = typeCast(HorizontalAnchoredCategorySeries.$, this.dataChart.series._inner[b]);
                if (c == null) {
                    continue;
                }
                a(c, b);
            }
        }
        l2() {
            return this.xAxis;
        }
        l3() {
            return this.yAxis;
        }
        tf() {
            return this.bc(30);
        }
        tg() {
            return this.bc(31);
        }
        c3(a, b) {
            let c = super.c3(a, b);
            if (c != null) {
                let d = new List$1(Series.$, 0);
                if (this.tl) {
                    d.add(this.tf());
                }
                if (this.tm) {
                    d.add(this.tg());
                }
                for (let e = 0; e < d.count; e++) {
                    let f = d._inner[e];
                    f.name = a + getInstanceType(f).typeName;
                    c.add(f);
                }
            }
            return c;
        }
        ky(a, b, c) {
            super.ky(a, b, c);
            if (this.ac.dataSeries.count > 0) {
                if (stringIsNullOrEmpty(this.gd)) {
                    this.ak.setXMemberPath(a, c.getMemberPathFor(16));
                }
                if (stringIsNullOrEmpty(this.gf)) {
                    this.ak.setYMemberPath(a, c.getMemberPathFor(0));
                }
                if (stringIsNullOrEmpty(this.f9)) {
                    this.ak.setLabelMemberPath(a, c.getMemberPathFor(0));
                }
                if (stringIsNullOrEmpty(this.f6)) {
                    this.ak.setContentMemberPath(a, c.getMemberPathFor(0));
                }
            }
        }
        cm() {
            if (this.aa == 4 || this.aa == 3) {
                return true;
            }
            else if (this.aa == 0) {
                if (this.s4 == 2 || this.s4 == 8) {
                    return false;
                }
                else if (this.s4 == 9 && this.ac != null && this.ac.dataSeries != null && this.ac.dataSeries.count > 0) {
                    let a = this.ac.dataSeries._inner[0].suggestedSeries;
                    if (a == 1 || a == 8) {
                        return false;
                    }
                }
                return true;
            }
            return false;
        }
        ka(a, b, c) {
            super.ka(a, b, c);
            switch (a) {
                case "ChartType":
                    this.kt();
                    break;
                case "MarkerCollisionAvoidance":
                    this.vb((d) => d.s6 = this.s6);
                    break;
                case "IsTransitionInEnabled":
                    this.vb((d) => d.r3 = this.ts);
                    break;
                case "TransitionInMode":
                    this.vb((d) => d.rn = this.s8);
                    break;
                case "TransitionInSpeedType":
                    this.vb((d) => d.b8 = this.ti);
                    break;
                case "XAxisInterval":
                    this.xAxis.ml = this.ub;
                    break;
                case "XAxisMinorInterval":
                    this.xAxis.mm = this.uc;
                    break;
                case "XAxisGap":
                    this.xAxis.kv = this.ua;
                    break;
                case "XAxisOverlap":
                    this.xAxis.k4 = this.ud;
                    break;
                case "YAxisInterval":
                    this.yAxis.lh = this.ug;
                    break;
                case "YAxisIsLogarithmic":
                    this.yAxis.k2 = this.tu;
                    break;
                case "YAxisLogarithmBase":
                    this.yAxis.lp = this.un;
                    break;
                case "YAxisMinimumValue":
                    this.yAxis.ll = this.ui;
                    break;
                case "YAxisMaximumValue":
                    this.yAxis.lk = this.uh;
                    break;
                case "YAxisMinorInterval":
                    this.yAxis.lm = this.uj;
                    break;
                case "NegativeBrushes":
                case "NegativeOutlines":
                    this.vc((d, e) => {
                        if (d.dz) {
                            d.mc(ArrayExtension.getModulus$1(Brush.$, this.s1, e), ArrayExtension.getModulus$1(Brush.$, this.s2, e));
                        }
                    });
                    break;
                case "YAxisAbbreviateLargeNumbers":
                    this.ri((d) => d.kv = this.tt);
                    break;
                case "IsCategoryHighlightingEnabled":
                case "IsItemHighlightingEnabled":
                    this.kt();
                    break;
            }
        }
    }
    CategoryChart.$t = /*@__PURE__*/ markType(CategoryChart, 'CategoryChart', XYChart.$);
    return CategoryChart;
})();
