/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { TimeAxisBase } from "./TimeAxisBase";
import { TimeAxisDisplayType_$type } from "./TimeAxisDisplayType";
import { DependencyProperty } from "igniteui-react-core";
import { Base, enumGetBox, Number_$type, typeGetValue, typeCast, markType, markDep } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { NumericYAxis } from "./NumericYAxis";
import { LinearNumericSnapper } from "./LinearNumericSnapper";
import { LabelPosition } from "./LabelPosition";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-react-core";
import { dateMinValue, dateFromTicks } from "igniteui-react-core";
import { timeSpanFromMilliseconds } from "igniteui-react-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
export let CategoryDateTimeXAxis = /*@__PURE__*/ (() => {
    class CategoryDateTimeXAxis extends TimeAxisBase {
        constructor() {
            super();
            this.nn = 0;
            this.no = 0;
            this.ab = CategoryDateTimeXAxis.$;
            this.actualMinimumValue = (new Date());
            this.actualMaximumValue = (new Date());
        }
        get_cb() {
            return this.ni == 0;
        }
        a3() {
            return new CategoryDateTimeXAxisView(this);
        }
        hn(a) {
            super.hn(a);
            this.nh = a;
        }
        get np() {
            return this.nn;
        }
        set np(a) {
            if (this.np != a) {
                let b = this.nn;
                this.nn = a;
                this.hx("ActualInterval", b, this.np);
            }
        }
        er() {
            return this.np;
        }
        get nt() {
            return typeGetValue(this.c(CategoryDateTimeXAxis.n4));
        }
        set nt(a) {
            this.h(CategoryDateTimeXAxis.n4, a);
        }
        get nq() {
            return this.no;
        }
        set nq(a) {
            if (this.nq != a) {
                let b = this.no;
                this.no = a;
                this.hx("ActualMinorInterval", b, this.nq);
            }
        }
        c4(a, b, c) {
            let d = super.c4(a, b, c);
            if (!d) {
                return false;
            }
            return +(this.actualMinimumValue) != +(this.actualMaximumValue);
        }
        d0() {
            return this.np;
        }
        h4(a) {
            super.h4(a);
            let b = this.bh != null ? this.bh.r0 : Rect.empty;
            let c = !b.isEmpty ? this.j7 : Rect.empty;
            let d = this.j2();
            let e = this.j1();
            let f = new ScalerParams(0, b, c, this.cf, d);
            if (this.mb == null && !this.mh() && !this.mi()) {
                return;
            }
            if (!b.isEmpty && !c.isEmpty && (this.ni != 1 || this.mb != null)) {
                let g = c.bottom;
                let h = g - c.top;
                if (this.ai != null) {
                    let i = typeCast(NumericYAxis.$, this.ai);
                    if (i != null) {
                        let j = this.h9(g, h, b, c, d, c.top, c.bottom);
                        g = j.p0;
                        h = j.p1;
                    }
                }
                if (isNaN_(g)) {
                    g = 0;
                }
                this.hl(this.a4.ay(), g, c, this.a4.e(), true);
                this.av.bg = h;
                let k = this.a4.a1();
                let l = this.a4.f();
                let m = this.a4.az();
                let n = this.a4.a0();
                let o = this.a4.g();
                if (this.ni == 1) {
                    let p = this.i$e(b, c, d, e);
                    let q = this.i$g(b, c, d, e);
                    if (p < 0 || q < 0) {
                        return;
                    }
                    let r = NaN;
                    for (let s = p; s <= q; s++) {
                        let t = this.mk == null ? s : this.mk._inner[s];
                        let u = this.ef(this.mb.item(t).getTime(), f);
                        if (u == r) {
                            continue;
                        }
                        r = u;
                        if (this.categoryMode == 2) {
                            u += this.cf ? -this.getGroupCenter(s, b, c, d) : this.getGroupCenter(s, b, c, d);
                        }
                        if (u < e.left || u > e.right) {
                            continue;
                        }
                        this.ih(m, u, c, l, false);
                        this.ks.add(u);
                        if (this.kl != null && s < this.kl.count) {
                            let v = this.kl.item(t);
                            let w = super.fv(v);
                            if (!isNaN_(u) && !isInfinity(u) && w != null) {
                                if ((typeof w === 'string') && Base.equalsStatic(w, "")) {
                                }
                                else {
                                    this.c8.add1(w);
                                    this.c9.add(new LabelPosition(u));
                                }
                            }
                        }
                    }
                }
                else {
                    let x = this.ei(e.left, f);
                    let y = this.ei(e.right, f);
                    let z = Math.min(x, y);
                    let aa = Math.max(x, y);
                    let ab = new LinearNumericSnapper(0, z, aa, e.width, this.eu());
                    let ac = this.mf ? this.nm() : ab.g;
                    this.n0(truncate(ac));
                    let ad = truncate(Math.floor((z - this.actualMinimumValue.getTime()) / ac));
                    let ae = truncate(Math.ceil((aa - this.actualMinimumValue.getTime()) / ac));
                    let af = 0;
                    if (this.categoryMode == 2) {
                        af = this.getGroupCenter(0, b, c, d);
                        af = this.cf ? -af : af;
                    }
                    let ag = truncate(Math.ceil(e.right));
                    let ah = truncate(Math.floor(e.left));
                    let ai = this.ef(this.actualMinimumValue.getTime() + ad * ac, f) + af;
                    for (let aj = ad; aj <= ae; aj++) {
                        let ak = this.ef(this.actualMinimumValue.getTime() + (aj + 1) * ac, f) + af;
                        if (!isNaN_(ai) && !isInfinity(ai)) {
                            let al = truncate(Math.round(ai));
                            if (al <= ag) {
                                if (aj % 2 == 0) {
                                    this.ii(k, ai, ak, c);
                                }
                                this.ih(m, ai, c, l, false);
                                this.ks.add(ai);
                                if (this.cv) {
                                    let am = this.nr();
                                    if (am > 0 && am < ac) {
                                        if (ac / am < 20) {
                                            let an = ai;
                                            let ao = Math.abs(this.ef(this.actualMinimumValue.getTime() + am, f) - this.ef(this.actualMinimumValue.getTime(), f));
                                            while (an + ao < ak) {
                                                if (Math.abs(an + ao - ak) < 0.0001) {
                                                    break;
                                                }
                                                an += ao;
                                                if (an > 0) {
                                                    this.ih(n, an, c, o, false);
                                                }
                                            }
                                            this.n1(am);
                                        }
                                    }
                                    else {
                                        for (let ap = 1; ap < ab.i; ++ap) {
                                            let aq = this.ef(this.actualMinimumValue.getTime() + aj * ac + (ap * ac) / ab.i, f) + af;
                                            this.ih(n, aq, c, o, false);
                                        }
                                        if (ab.i > 0) {
                                            this.n1(truncate((ac / ab.i)));
                                        }
                                    }
                                }
                            }
                            if (al >= ah && al <= ag) {
                                let ar = this.actualMinimumValue.getTime() + aj * ac;
                                let ticks_ = truncate(Math.floor(ar));
                                let as = (new Date(ticks_));
                                let at = this.fv(as);
                                if (at != null) {
                                    this.c8.add1(at);
                                    this.c9.add(new LabelPosition(ai));
                                }
                            }
                        }
                        ai = ak;
                    }
                }
                if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                    if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                        this.bh.lb();
                    }
                }
                this.av.a9 = this.c8;
                this.av.ba = this.c9;
                this.ly();
            }
        }
        nm() {
            return this.np;
        }
        nr() {
            return this.nt;
        }
        n0(a) {
            this.np = a;
        }
        n1(a) {
            this.nq = a;
        }
        nk() {
            return this.ns != 0;
        }
        nj() {
            return this.np == 0;
        }
        nl(a) {
            return this.mb == null ? dateMinValue() : this.mb.item(a);
        }
        nz(a, b) {
            if (a > b || this.kl == null || this.kl.count == 0) {
                return;
            }
            let c = (a.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            let d = (b.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            this.bh.sg = new Rect(0, c, this.bh.sg.y, d - c, this.bh.sg.height);
        }
        hr(a, b, c, d) {
            super.hr(a, b, c, d);
            switch (b) {
                case CategoryDateTimeXAxis.$$p[0]:
                    this.cn = true;
                    this.av.al = this.ni == 1;
                    this.h3(false);
                    break;
                case CategoryDateTimeXAxis.$$p[1]:
                    this.cn = true;
                    this.h3(false);
                    break;
            }
        }
        m7() {
            super.m7();
            if (this.nk()) {
                this.np = this.ns;
                let a = this.bh != null ? this.bh.r0 : Rect.empty;
                let b = !a.isEmpty ? this.j7 : Rect.empty;
                let c = Math.abs(this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
                this.mf = this.nj() || (this.ni == 1) || (1 * c / this.nm() > (b.width / a.width)) ? false : true;
            }
            else {
                this.mf = false;
            }
        }
        m5(a, b) {
            let c = b.getTime() - a.getTime();
            let timeOffset_ = truncate(Math.round(intDivide(c, this.k9) / 2));
            return timeOffset_ == 0 ? timeSpanFromMilliseconds(1) : timeSpanFromMilliseconds(timeOffset_);
        }
        get_ca() {
            return true;
        }
        get isVertical() {
            return this.cm;
        }
        j$c(a, b) {
            return this.ei.apply(this, arguments);
        }
        j$b(a, b) {
            return this.ef.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.hh.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.hi.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.hj.apply(this, arguments);
        }
        get j$a() {
            return this.cf;
        }
        get i$a() {
            return this.cc;
        }
    }
    CategoryDateTimeXAxis.$t = /*@__PURE__*/ markType(CategoryDateTimeXAxis, 'CategoryDateTimeXAxis', TimeAxisBase.$);
    CategoryDateTimeXAxis.n4 = /*@__PURE__*/ DependencyProperty.i("MinorInterval", Number_$type, CategoryDateTimeXAxis.$, /*@__PURE__*/ new PropertyMetadata(2, 0, (a, b) => {
        (typeCast(CategoryDateTimeXAxis.$, a)).hx("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryDateTimeXAxis.$, a)).h3(false);
    }));
    CategoryDateTimeXAxis.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, CategoryDateTimeXAxis, 'hx', ['DisplayType:ni:n2', [TimeAxisDisplayType_$type, /*@__PURE__*/ enumGetBox(TimeAxisDisplayType_$type, 0)], 'Interval:ns:n3', [1, 0]]);
    return CategoryDateTimeXAxis;
})();
/**
 * @hidden
 */
export let CategoryDateTimeXAxisView = /*@__PURE__*/ (() => {
    class CategoryDateTimeXAxisView extends CategoryAxisBaseView {
        constructor(a) {
            super(a);
            this.bg = null;
            this.bg = a;
        }
        ag() {
            super.ag();
            this.a.fd = AxisDefaults.f;
        }
        o(a) {
            let b = this.n(dateFromTicks(truncate(a)));
            return b;
        }
    }
    CategoryDateTimeXAxisView.$t = /*@__PURE__*/ markType(CategoryDateTimeXAxisView, 'CategoryDateTimeXAxisView', CategoryAxisBaseView.$);
    return CategoryDateTimeXAxisView;
})();
