/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Base, Number_$type, typeCast, Array_$type, markType, TypeRegistrar } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { LinearCategorySnapper } from "./LinearCategorySnapper";
import { NumericYAxis } from "./NumericYAxis";
import { LabelPosition } from "./LabelPosition";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
export let CategoryXAxis = /*@__PURE__*/ (() => {
    class CategoryXAxis extends CategoryAxisBase {
        constructor() {
            super();
            this.mo = 1;
            this.mn = 1;
            this.mr = null;
            this.me = 0;
            this.mf = 0;
            this.ks = new List$1(Number_$type, 0);
            this.ab = CategoryXAxis.$;
        }
        a3() {
            return new CategoryXAxisView(this);
        }
        hn(a) {
            super.hn(a);
            this.mb = a;
        }
        get mq() {
            return this.mo;
        }
        set mq(a) {
            this.mo = a;
        }
        get mp() {
            return this.mn;
        }
        set mp(a) {
            this.mn = a;
        }
        au() {
            if (this.c2) {
                return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
            }
            else {
                return new HorizontalAxisLabelPanel();
            }
        }
        getCategorySize(a, b, c) {
            let d = this.j5(b, c);
            return d.width / (this.k9 * a.width);
        }
        ky(a, b, c) {
            let d = this.k5(a, b, c);
            let e = 0;
            if (!isNaN_(this.k4)) {
                e = Math.min(this.k4, 1);
            }
            else {
                e = 0;
            }
            ;
            let f = 1 - 0.5 * d;
            let g = this.lb == 0 ? 1 : this.lb;
            let h = this.getCategorySize(a, b, c) * f / (g - (g - 1) * e);
            return h;
        }
        getGroupCenter(a, b, c, d) {
            let e = 0.5;
            if (this.lb > 1) {
                let f = this.k5(b, c, d);
                let g = 0;
                if (!isNaN_(this.k4)) {
                    g = Math.min(this.k4, 1);
                }
                let h = 1 - 0.5 * f;
                let i = h / (this.lb - (this.lb - 1) * g);
                let j = (h - i) / (this.lb - 1);
                e = 0.25 * f + 0.5 * i + a * j;
            }
            return this.getCategorySize(b, c, d) * e;
        }
        d0() {
            return this.ml;
        }
        mw(a) {
            let b = this.bh != null ? this.bh.r0 : Rect.empty;
            b = b.copy();
            let c = this.j7;
            let d = this.j4();
            let e = new Rect(0, 0, 0, 1, 1);
            let f = new ScalerParams(0, e, e, this.cf, d);
            let g = !b.isEmpty && !c.isEmpty && this.kl != null ? this.kl.indexOf(a) : -1;
            let h = g > -1 ? this.ef(g, f) : NaN;
            if (!isNaN_(h) && this.bh.ed) {
                if (!isNaN_(h)) {
                    if (h < b.left + 0.1 * b.width) {
                        h = h + 0.4 * b.width;
                        b.x = h - 0.5 * b.width;
                    }
                    if (h > b.right - 0.1 * b.width) {
                        h = h - 0.4 * b.width;
                        b.x = h - 0.5 * b.width;
                    }
                }
                this.bh.oj(b, false, true);
            }
        }
        ef(a, b) {
            if (!b.c.isEmpty) {
                let c = this.mk(a, NumericScaler.ac, b.c, this.categoryMode);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.mk(a, b.e, b.d, this.categoryMode);
        }
        ma(a) {
            if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
                return a.asArray();
            }
            return null;
        }
        hh(a, b, c, d, e) {
            let f;
            let g = e.e;
            let h = e.d;
            let i = e.c;
            let j = e.a;
            let k = !i.isEmpty;
            let l = this.categoryMode == 0 ? this.k9 - 1 : this.k9;
            if (l < 0) {
                l = 0;
            }
            let m = i.left;
            let n = i.width;
            let o = g.left;
            let p = g.width;
            let q = h.left;
            let r = h.width;
            let s = 0;
            let t = 1;
            let u = this.ma(a);
            let v = false;
            if (u != null) {
                v = true;
            }
            let w;
            for (let x = 0; x < b.count; x++) {
                w = b.item(x);
                for (let y = c; y < d; y++) {
                    if (v) {
                        f = u[y];
                    }
                    else {
                        f = a.item(y);
                    }
                    if (k) {
                        let z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                        if (j) {
                            z = 1 - z;
                        }
                        z = m + n * (z - s) / t;
                        z = (z - q) / r;
                        let aa = q + r * (z - o) / p;
                        f[w] = aa;
                    }
                    else {
                        let ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                        if (j) {
                            ab = 1 - ab;
                        }
                        ab = q + r * (ab - o) / p;
                        f[w] = ab;
                    }
                }
            }
        }
        eg(a, b, c) {
            if (!b.c.isEmpty) {
                let d = this.mk(a, NumericScaler.ac, b.c, c);
                d = (d - b.d.left) / b.d.width;
                d = b.d.left + b.d.width * (d - b.e.left) / b.e.width;
                return d;
            }
            return this.mk(a, b.e, b.d, c);
        }
        mk(a, b, c, d) {
            let e = d == 0 ? this.k9 - 1 : this.k9;
            if (e < 0) {
                e = 0;
            }
            let f = e >= 1 ? (a) / (e) : e == 0 ? 0.5 : NaN;
            if (this.cg) {
                f = 1 - f;
            }
            return c.left + c.width * (f - b.left) / b.width;
        }
        ei(a, b) {
            if (!b.c.isEmpty) {
                let c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                c = (c * b.d.width) + b.d.left;
                c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
                return c;
            }
            return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
        }
        ej(a, b, c) {
            if (!b.c.isEmpty) {
                let d = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                d = (d * b.d.width) + b.d.left;
                d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
                return d;
            }
            return this.getUnscaledValue3(a, b.e, b.d, c);
        }
        getUnscaledValue3(a, b, c, d) {
            let e = b.left + (a - c.left) * b.width / c.width;
            if (this.cg) {
                e = 1 - e;
            }
            let f = d == 0 ? this.k9 - 1 : this.k9;
            if (f < 0) {
                f = 0;
            }
            return e * f;
        }
        mx(a, b) {
            if (a == NaN || b == NaN || this.kl == null || this.kl.count == 0) {
                return;
            }
            let c = a / this.kl.count;
            let d = (b + 1) / this.kl.count;
            this.bh.sg = new Rect(0, c, this.bh.sg.y, d - c, this.bh.sg.height);
        }
        h4(a) {
            super.h4(a);
            let b = this.bh != null ? this.bh.r0 : Rect.empty;
            let c = this.j7;
            let d = this.j2();
            let e = this.j1();
            let f = new ScalerParams(0, b, c, this.cf, d);
            let g = this.a4.ay();
            let h = this.a4.a1();
            let i = this.a4.az();
            let j = this.a4.a0();
            let k = this.a4.e();
            let l = this.a4.f();
            let m = this.a4.g();
            let n = this.kl;
            let o = this.mc();
            this.ig();
            this.hd(g);
            this.hd(h);
            this.hd(i);
            this.hd(j);
            this.c8.clear();
            this.c9.clear();
            this.ks.clear();
            this.a4.at(this, b, c);
            if (b.isEmpty || c.isEmpty) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
            }
            if (this.bq.count == 0 && this.bp.count == 0) {
                this.a4.y();
            }
            if (this.ay != null) {
                this.ay.registerAxis(this);
            }
            if (this.itemsSource == null || o == null || n.count == 0) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
                this.a4.y();
                return;
            }
            if (!b.isEmpty && !c.isEmpty) {
                let p = this.ei(e.left, f);
                let q = this.ei(e.right, f);
                let r = 0;
                let s = false;
                if (this.c1) {
                    let t = Math.abs(q - p);
                    r = Math.ceil(t) + 1;
                    if (this.cf) {
                        if (Math.abs(q - Math.floor(q)) < Math.abs(p - Math.ceil(p))) {
                            s = true;
                        }
                    }
                    else {
                        if (Math.abs(q - Math.ceil(q)) < Math.abs(p - Math.floor(p))) {
                            s = true;
                        }
                    }
                }
                if (this.cf) {
                    p = Math.ceil(p);
                    q = Math.floor(q);
                }
                else {
                    p = Math.floor(p);
                    q = Math.ceil(q);
                }
                if (this.c1) {
                    if (Math.abs(q - p) < r) {
                        if (this.cf) {
                            if (s) {
                                q--;
                            }
                            else {
                                p++;
                            }
                        }
                        else {
                            if (s) {
                                q++;
                            }
                            else {
                                p--;
                            }
                        }
                    }
                }
                let u = c.bottom;
                let v = u - c.top;
                if (this.ai != null) {
                    let w = typeCast(NumericYAxis.$, this.ai);
                    if (w != null) {
                        let x = this.h9(u, v, b, c, d, c.top, c.bottom);
                        u = x.p0;
                        v = x.p1;
                    }
                }
                this.hl(g, u, c, k, true);
                this.a4.ao(v);
                let y = Math.min(p, q);
                let z = Math.max(p, q);
                let aa = e.width;
                if (this.c1) {
                    let ab = this.ef(y, f);
                    let ac = this.ef(z, f);
                    aa = Math.abs(ac - ab);
                }
                let ad = new LinearCategorySnapper(1, y, z, aa, this.ml, this.categoryMode, this.eu());
                let ae = ad.g;
                ae = this.dy(ae, this.md(), b, c, d);
                if (ad.g != ae) {
                    ad = new LinearCategorySnapper(1, y, z, aa, ae, this.categoryMode, this.eu());
                }
                let af = Math.floor((y - 0) / ad.g);
                let ag = Math.ceil((z - 0) / ad.g);
                this.mg = ad.g;
                if (!isNaN_(af) && !isNaN_(ag)) {
                    let ah = truncate(af);
                    let ai = truncate(ag);
                    let aj = this.mj(0 + ah * ad.g, f);
                    let ak = this.ef(ad.g, f);
                    let al = Math.abs(ak - this.ef(0, f));
                    this.a4.ap(ak);
                    let am = truncate(Math.ceil(e.right));
                    let an = truncate(Math.floor(e.left));
                    let ao = this.mm;
                    let ap = ao > 0 && ao < ad.g;
                    let aq = c.right;
                    let ar = this.ks;
                    let as = ad.g;
                    let at = truncate(as);
                    let au = this.lb;
                    let av = this.cf;
                    let aw = this.categoryMode;
                    this.mr = null;
                    for (let ax = ah; ax <= ai; ++ax) {
                        let ay = this.mj(0 + (ax + 1) * ad.g, f);
                        if (aj <= aq) {
                            if (ax % 2 == 0) {
                                this.ii(h, aj, ay, c);
                            }
                            this.ih(i, aj, c, l, false);
                            ar.add(aj);
                        }
                        if (this.categoryMode != 0 && this.lb != 0 && this.cv) {
                            if (ap) {
                                let az = al * this.mm;
                                if (this.cf) {
                                    let a0 = aj;
                                    while (a0 - az > ay) {
                                        a0 -= az;
                                        if (Math.abs(a0 - ay) < 0.0001) {
                                            break;
                                        }
                                        this.ih(j, a0, c, m, false);
                                    }
                                }
                                else {
                                    let a1 = aj;
                                    while (a1 + az < ay) {
                                        a1 += az;
                                        if (Math.abs(a1 - ay) < 0.0001) {
                                            break;
                                        }
                                        this.ih(j, a1, c, m, false);
                                    }
                                }
                                this.mh = this.mm;
                            }
                            else {
                                for (let a2 = 0; a2 < truncate(ad.g); a2++) {
                                    for (let a3 = 0; a3 < this.lb; a3++) {
                                        let a4 = this.getGroupCenter(a3, b, c, d);
                                        if (this.cf) {
                                            a4 = -a4;
                                        }
                                        let a5 = this.ef(a2 + ax * ad.g, f) + a4;
                                        this.ih(j, a5, c, m, false);
                                    }
                                }
                                this.mh = 0.5;
                            }
                        }
                        let a6 = this.mi(ax * as, aj, aw == 0, f);
                        let a7 = truncate(Math.round(a6));
                        if (a7 >= an && a7 <= am) {
                            let a8 = 0;
                            if (as >= 1) {
                                a8 = ax * truncate(Math.floor(as));
                            }
                            else {
                                if ((ax * as) * 2 % 2 == 0) {
                                    a8 = truncate(Math.floor(ax * as));
                                }
                                else {
                                    a8 = -1;
                                }
                            }
                            if (o != null && a8 < n.count && a8 >= 0) {
                                let a9 = o.getItem(a8);
                                let ba = this.fv(a9);
                                this.mr = a9;
                                if (!isNaN_(a6) && !isInfinity(a6) && ba != null) {
                                    if ((typeof ba === 'string') && Base.equalsStatic(ba, "")) {
                                    }
                                    else {
                                        this.c8.add1(ba);
                                        this.c9.add(new LabelPosition(a6));
                                    }
                                }
                            }
                        }
                        aj = ay;
                    }
                }
                this.mr = null;
                if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                    if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                        this.bh.lb();
                    }
                }
                this.a4.au(this.c8, this.c9);
                this.ly();
            }
        }
        c0() {
            if (this.cn && this.c1) {
                this.bb = this.ba();
            }
            if (this.kl == null) {
                return false;
            }
            let a = this.kl.count;
            if (a != this.mp) {
                let b = new AxisRangeChangedEventArgs(0, 1, 1, this.mp, a);
                this.mp = a;
                this.hy(b);
                return true;
            }
            return false;
        }
        get ml() {
            return this.c(CategoryXAxis.my);
        }
        set ml(a) {
            this.h(CategoryXAxis.my, a);
        }
        md() {
            return !isNaN_(this.ml);
        }
        get mg() {
            return this.me;
        }
        set mg(a) {
            if (this.mg != a) {
                let b = this.me;
                this.me = a;
                this.hx("ActualInterval", b, this.mg);
            }
        }
        er() {
            return this.mg;
        }
        get mm() {
            return this.c(CategoryXAxis.mz);
        }
        set mm(a) {
            this.h(CategoryXAxis.mz, a);
        }
        get mh() {
            return this.mf;
        }
        set mh(a) {
            if (this.mh != a) {
                let b = this.mf;
                this.mf = a;
                this.hx("ActualMinorInterval", b, this.mh);
            }
        }
        ko(a) {
            if (a == null) {
                return false;
            }
            let b = this.bd();
            if (b == null) {
                return false;
            }
            return b.synchronizeHorizontally;
        }
        get_a1() {
            return 0;
        }
        get a1() {
            return this.get_a1();
        }
        mc() {
            return this.kl;
        }
        mj(a, b) {
            return this.ef(a, b);
        }
        mi(a, b, c, d) {
            if (!c) {
                let e = this.mj(a + 1, d);
                return (b + e) / 2;
            }
            return b;
        }
        get isVertical() {
            return this.cm;
        }
        j$c(a, b) {
            return this.ei.apply(this, arguments);
        }
        j$b(a, b) {
            return this.ef.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.hh.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.hi.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.hj.apply(this, arguments);
        }
        get j$a() {
            return this.cf;
        }
    }
    CategoryXAxis.$t = /*@__PURE__*/ markType(CategoryXAxis, 'CategoryXAxis', CategoryAxisBase.$);
    CategoryXAxis.my = /*@__PURE__*/ DependencyProperty.i("Interval", Number_$type, CategoryXAxis.$, /*@__PURE__*/ new PropertyMetadata(2, NaN, (a, b) => {
        a.hx("Interval", b.oldValue, b.newValue);
        a.h3(false);
    }));
    CategoryXAxis.mz = /*@__PURE__*/ DependencyProperty.i("MinorInterval", Number_$type, CategoryXAxis.$, /*@__PURE__*/ new PropertyMetadata(2, NaN, (a, b) => {
        (typeCast(CategoryXAxis.$, a)).hx("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryXAxis.$, a)).h3(false);
    }));
    return CategoryXAxis;
})();
/**
 * @hidden
 */
export let CategoryXAxisView = /*@__PURE__*/ (() => {
    class CategoryXAxisView extends CategoryAxisBaseView {
        constructor(a) {
            super(a);
            this.bg = null;
            this.bg = a;
        }
        ag() {
            super.ag();
            this.a.fd = AxisDefaults.f;
        }
    }
    CategoryXAxisView.$t = /*@__PURE__*/ markType(CategoryXAxisView, 'CategoryXAxisView', CategoryAxisBaseView.$);
    return CategoryXAxisView;
})();
