/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-react-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, Number_$type, enumGetBox, fromEnum, Point_$type, markType, markDep, runOn } from "igniteui-react-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { Tuple$2 } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { PathFigure } from "igniteui-react-core";
import { LineSegment } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Defaults } from "./Defaults";
import { TranslateTransform } from "igniteui-react-core";
import { LineGeometry } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
/**
 * @hidden
 */
export let CrosshairLayer = /*@__PURE__*/ (() => {
    class CrosshairLayer extends AnnotationLayer {
        constructor() {
            super();
            this.xAxisAnnotationFormatLabel = null;
            this.yAxisAnnotationFormatLabel = null;
            this.q5 = null;
            this.q4 = null;
            let a = new CrosshairLayerFrame();
            let b = new CrosshairLayerFrame();
            let c = new CrosshairLayerFrame();
            let d = this.hd / 1000;
            this.pt = a;
            this.ps = b;
            this.pu = c;
            this.ab = CrosshairLayer.$;
        }
        get_c7() {
            return true;
        }
        get_c5() {
            return true;
        }
        bv() {
            return new CrosshairLayerView(this);
        }
        lo(a) {
            super.lo(a);
            this.qx = a;
        }
        qz() {
            return this.xAxisAnnotationFormatLabel != null;
        }
        q0() {
            return this.yAxisAnnotationFormatLabel != null;
        }
        get tc() {
            return new Thickness(1, this.q7, this.q9, this.q8, this.q6);
        }
        get td() {
            return new Thickness(1, this.rc, this.re, this.rd, this.rb);
        }
        qc(a, b) {
            if (this.qy == null || this.qy == a) {
                if (!this.as.c) {
                    this.l7(b);
                }
            }
        }
        qe(a, b) {
            super.qe(a, b);
            let c = a;
            let d = this.q3;
            let e = this.q2;
            c.ad.clear();
            c.ae.clear();
            c.ac.clear();
            c.af.clear();
            AxisAnnotationFrameManager.b(c);
            if (this.pz(this.qy)) {
                this.sb(this.qy, c, d, e);
            }
            else {
                for (let f of fromEnum(this.cb.series)) {
                    if (this.pz(f)) {
                        this.sb(f, c, d, e);
                    }
                    if (f.isStacked) {
                        f.k1((g) => {
                            if (this.pz(g)) {
                                this.sb(g, c, d, e);
                            }
                            return true;
                        });
                    }
                }
            }
        }
        pz(a) {
            if (!super.pz(a)) {
                return false;
            }
            if (this.rm != null) {
                if (a.dq) {
                    let b = a.je();
                    if (!Base.equalsStatic(this.rm, b)) {
                        return false;
                    }
                }
                else {
                    if (!Base.equalsStatic(this.rm, a.name)) {
                        return false;
                    }
                }
            }
            let c = this.p7(a);
            if (!c.c) {
                return false;
            }
            return true;
        }
        lh() {
            super.lh();
            if (!this.as.c && !this.cs()) {
                return;
            }
            if (this.cs()) {
                this.sc(this.pu, false);
            }
            else {
                this.sc(this.ps, false);
            }
        }
        sb(a, b, c, d) {
            let e = this.p7(a);
            if (!e.c) {
                return;
            }
            let f = e.d;
            f = a.pb(f, c, d);
            let g = this.oo;
            if (g == null) {
                g = this.os;
            }
            if (g == null) {
                g = a.oo;
                if (g != null) {
                    g = this.qx.cb(g);
                }
            }
            let h = g;
            let i = g;
            if (this.s4 != null) {
                h = this.s4;
            }
            if (this.s5 != null) {
                i = this.s5;
            }
            b.ac.add(h);
            b.af.add(i);
            b.ad.add(f.y);
            b.ae.add(f.x);
            if (this.q1 && !isNaN_(f.y)) {
                AxisAnnotationFrameManager.c(b, f, a, this.cb, this.getEffectiveViewport(), g, this.s6, this.s8, this.s7, this.tc, this.ra, this.s9, this.tb, this.ta, this.td, this.rf, this.tf == 0, this.te == 0);
            }
        }
        sc(a, b) {
            let c = false;
            if (this.q4 == null) {
                c = true;
                this.q5 = new List$1(Axis.$, 0);
                this.q4 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
            }
            AxisAnnotationFrameManager.d(this, a, c, this.q4, this.q5, b, this.rg, this.rh, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
        }
        sa(a, b, c, d, e) {
            let f = a.item(b);
            b++;
            if (e) {
                f._stroke = d.af._inner[c];
                f._fill = d.af._inner[c];
            }
            else {
                f._stroke = d.ac._inner[c];
                f._fill = d.ac._inner[c];
            }
            f.ac = this.fn;
            f.ai = this.o1;
            f.ad = this.o2;
            return new Tuple$2(Path.$, Number_$type, f, b);
        }
        qh(a, b) {
            super.qh(a, b);
            let c = this.qx.b5;
            let d = a;
            let e = d.ad.count;
            let f = 0;
            let g = b.bu.left;
            let h = b.bu.right;
            let i = b.bu.top;
            let j = b.bu.bottom;
            let k = this.tf == 0;
            let l = this.te == 0;
            for (let m = 0; m < e; m++) {
                let n = Math.floor(d.ad._inner[m]);
                let o = Math.floor(d.ae._inner[m]);
                let p = null;
                if (k) {
                    if (isNaN_(n)) {
                        continue;
                    }
                    let q = this.sa(c, f, m, d, true);
                    p = q.c;
                    f = q.d;
                    let r = new PathGeometry();
                    let s = new PathFigure();
                    s._startPoint = { $type: Point_$type, x: o, y: i };
                    let t = new LineSegment(1);
                    t.c = { $type: Point_$type, x: o, y: j };
                    s._segments.add(t);
                    r.c.add(s);
                    p.ak = r;
                }
                if (l) {
                    if (isNaN_(n)) {
                        continue;
                    }
                    let u = this.sa(c, f, m, d, false);
                    p = u.c;
                    f = u.d;
                    let v = new PathGeometry();
                    let w = new PathFigure();
                    w._startPoint = { $type: Point_$type, x: g, y: n };
                    let x = new LineSegment(1);
                    x.c = { $type: Point_$type, x: h, y: n };
                    w._segments.add(x);
                    v.c.add(w);
                    p.ak = v;
                }
            }
            c.count = f;
            if (this.cs()) {
                this.sc(this.pu, true);
            }
            else {
                this.sc(this.ps, false);
            }
        }
        ei() {
            return true;
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    if (d == null) {
                        if (this.q4 != null && this.q4.count > 0) {
                            let e;
                            if (this.cs()) {
                                e = this.pu;
                            }
                            else {
                                e = this.ps;
                            }
                            AxisAnnotationFrameManager.b(e);
                            AxisAnnotationFrameManager.d(this, e, true, this.q4, this.q5, true, this.rg, this.rh, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
                        }
                    }
                    break;
                case CrosshairLayer.$$p[1]:
                    this.l7(true);
                    break;
                case CrosshairLayer.$$p[8]:
                    this.l7(true);
                    break;
                case CrosshairLayer.$$p[4]:
                case CrosshairLayer.$$p[5]:
                    this.l7(true);
                    break;
                case CrosshairLayer.$$p[2]:
                case CrosshairLayer.$$p[9]:
                case CrosshairLayer.$$p[11]:
                case CrosshairLayer.$$p[13]:
                case CrosshairLayer.$$p[15]:
                case CrosshairLayer.$$p[14]:
                case CrosshairLayer.$$p[12]:
                case CrosshairLayer.$$p[16]:
                case CrosshairLayer.$$p[17]:
                case CrosshairLayer.$$p[18]:
                case CrosshairLayer.$$p[20]:
                case CrosshairLayer.$$p[22]:
                case CrosshairLayer.$$p[24]:
                case CrosshairLayer.$$p[23]:
                case CrosshairLayer.$$p[21]:
                case CrosshairLayer.$$p[25]:
                case CrosshairLayer.$$p[26]:
                case CrosshairLayer.$$p[0]:
                case CrosshairLayer.$$p[7]:
                case CrosshairLayer.$$p[6]:
                    this.l7(true);
                    break;
            }
        }
    }
    CrosshairLayer.$t = /*@__PURE__*/ markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
    CrosshairLayer.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:s4:sd', [Brush.$, null], 'HorizontalLineVisibility:te:se', [Visibility_$type, /*@__PURE__*/ enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:q1:sf', [0, false], 'SkipUnknownValues:q2:sg', [0, true], 'TargetSeriesName:rm:sh', [2, null], 'TargetSeries:qy:si', [Series.$, null], 'UseInterpolation:q3:sj', [0, true], 'VerticalLineStroke:s5:sk', [Brush.$, null], 'VerticalLineVisibility:tf:sl', [Visibility_$type, /*@__PURE__*/ enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackground:s6:sm', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:rg:sn', [1, -1], 'XAxisAnnotationOutline:s7:so', [Brush.$, null], 'XAxisAnnotationPaddingBottom:q6:sp', [1, NaN], 'XAxisAnnotationPaddingLeft:q7:sq', [1, NaN], 'XAxisAnnotationPaddingRight:q8:sr', [1, NaN], 'XAxisAnnotationPaddingTop:q9:ss', [1, NaN], 'XAxisAnnotationStrokeThickness:ra:st', [1, NaN], 'XAxisAnnotationTextColor:s8:su', [Brush.$, null], 'YAxisAnnotationBackground:s9:sv', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:rh:sw', [1, -1], 'YAxisAnnotationOutline:ta:sx', [Brush.$, null], 'YAxisAnnotationPaddingBottom:rb:sy', [1, NaN], 'YAxisAnnotationPaddingLeft:rc:sz', [1, NaN], 'YAxisAnnotationPaddingRight:rd:s0', [1, NaN], 'YAxisAnnotationPaddingTop:re:s1', [1, NaN], 'YAxisAnnotationStrokeThickness:rf:s2', [1, NaN], 'YAxisAnnotationTextColor:tb:s3', [Brush.$, null]]);
    return CrosshairLayer;
})();
/**
 * @hidden
 */
export let CrosshairLayerView = /*@__PURE__*/ (() => {
    class CrosshairLayerView extends AnnotationLayerView {
        constructor(a) {
            super(a);
            this.b4 = null;
            this.b5 = null;
            this.b6 = null;
            this.b4 = a;
            this.b6 = new List$1(Path.$, 0);
        }
        as() {
            super.as();
            this.b5 = ((() => {
                let $ret = new Pool$1(Path.$);
                $ret.create = runOn(this, this.cc);
                $ret.activate = runOn(this, this.b7);
                $ret.disactivate = runOn(this, this.b9);
                $ret.destroy = runOn(this, this.b8);
                return $ret;
            })());
            this.b4.gp = Defaults.j;
        }
        cc() {
            let a = new Path();
            a.j = new TranslateTransform();
            this.b6.add(a);
            return a;
        }
        b7(a) {
            a._visibility = 0;
        }
        b9(a) {
            a._visibility = 1;
        }
        b8(a) {
            this.b6.remove(a);
        }
        ca(a, b, c, d) {
            if (a.ak == null || a.ak.c.x != d || a.ak.d.x != c) {
                let e = ((() => {
                    let $ret = new LineGeometry();
                    $ret.d = { $type: Point_$type, x: c, y: b };
                    $ret.c = { $type: Point_$type, x: d, y: b };
                    return $ret;
                })());
                a.ak = e;
            }
        }
        cb(a) {
            if (a == null) {
                return a;
            }
            return BrushUtil.l(a, 0.1);
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d && !b) {
                for (let c = 0; c < this.b6.count; c++) {
                    let d = this.b6._inner[c];
                    if (d._visibility == 0) {
                        a.s(d);
                    }
                }
            }
        }
        al(a) {
            super.al(a);
            for (let b = 0; b < this.b6.count; b++) {
                this.e.a7.exportPathData(a, this.b6._inner[b], "crosshairLine", ["Main", "Crosshair"]);
            }
        }
    }
    CrosshairLayerView.$t = /*@__PURE__*/ markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
    return CrosshairLayerView;
})();
