/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventArgs, Base, markType, typeCast, Point_$type, String_$type, runOn, Number_$type, enumGetBox, fromEnum, toEnum, Date_$type, markDep, Delegate_$type } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-react-core";
import { IFastItemColumn$1_$type } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { SeriesView } from "./SeriesView";
import { truncate, intDivide, isInfinity, isNaN_ } from "igniteui-react-core";
import { IHasCategoryAxis_$type } from "./IHasCategoryAxis";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode_$type } from "./CategoryMode";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FastReflectionHelper } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { FinancialValueList } from "./FinancialValueList";
import { CategoryXAxis } from "./CategoryXAxis";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { SafeReadOnlyDoubleCollection } from "./SafeReadOnlyDoubleCollection";
import { SafeEnumerable } from "./SafeEnumerable";
import { CalculatedColumn } from "./CalculatedColumn";
import { TrendCalculators } from "igniteui-react-core";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { dateToStringFormat } from "igniteui-react-core";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
import { SRProvider } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
export let FinancialEventArgs = /*@__PURE__*/ (() => {
    class FinancialEventArgs extends EventArgs {
        constructor(a, b, c, d, e) {
            super();
            this._position = 0;
            this._count = 0;
            this._dataSource = null;
            this._supportingCalculations = null;
            this._basedOn = null;
            this.position = a;
            this.count = b;
            this.dataSource = c;
            this.supportingCalculations = d;
            if (c != null) {
                c.series = e;
            }
        }
        get position() {
            return this._position;
        }
        set position(a) {
            this._position = a;
        }
        get count() {
            return this._count;
        }
        set count(a) {
            this._count = a;
        }
        get dataSource() {
            return this._dataSource;
        }
        set dataSource(a) {
            this._dataSource = a;
        }
        get supportingCalculations() {
            return this._supportingCalculations;
        }
        set supportingCalculations(a) {
            this._supportingCalculations = a;
        }
        get basedOn() {
            return this._basedOn;
        }
        set basedOn(a) {
            this._basedOn = a;
        }
    }
    FinancialEventArgs.$t = /*@__PURE__*/ markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
    return FinancialEventArgs;
})();
/**
 * @hidden
 */
export let FinancialBucketCalculator = /*@__PURE__*/ (() => {
    class FinancialBucketCalculator extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.c = 0;
            this.d = 0;
            this.b = 0;
            if (a == null) {
                throw new ArgumentNullException(0, "view");
            }
            this.a = a;
            this.c = -1;
            this.d = this.d;
            this.b = 0;
        }
        getBucket(a) {
            return null;
        }
        getBucketWithoutUnknowns(a) {
            return this.getBucket(a);
        }
        getErrorBucket(a, b) {
            return NaN;
        }
        getBucketInfo(a, b, c, d) {
            a = this.c;
            b = this.d;
            c = this.b;
            d = this.a.bz.gk;
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d
            };
        }
        e(a) {
            let b = this.a.bv;
            let c = this.a.bu;
            let d = this.a.bu;
            if (this.a.bz != null) {
                d = this.a.bz.getEffectiveViewport1(this.a);
            }
            if (b.isEmpty || c.isEmpty || this.a.bz.pz == null) {
                this.b = 0;
                return;
            }
            let e = (this.a.bz.pz != null) ? this.a.bz.pz.cf : false;
            let f = new ScalerParams(0, b, c, e, d);
            let g = this.a.bz.pg(this.a);
            let h = typeCast(ISortingAxis_$type, this.a.bz.pz);
            if (h == null || h.i$b == null) {
                let i = Math.floor(this.a.bz.pz.ei(g.left, f));
                let j = Math.ceil(this.a.bz.pz.ei(g.right, f));
                if (this.a.bz.pz.cf) {
                    j = Math.ceil(this.a.bz.pz.ei(g.left, f));
                    i = Math.floor(this.a.bz.pz.ei(g.right, f));
                }
                let k = Math.floor((j - i + 1) * a / g.width);
                this.b = truncate(Math.max(1, k));
                this.c = truncate(Math.floor(i / this.b));
                this.d = truncate(Math.ceil(j / this.b));
            }
            else {
                this.c = h.i$e(b, c, d, g);
                this.d = h.i$g(b, c, d, g);
                this.b = 1;
            }
        }
        cacheValues() {
        }
        unCacheValues() {
        }
    }
    FinancialBucketCalculator.$t = /*@__PURE__*/ markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
    return FinancialBucketCalculator;
})();
/**
 * @hidden
 */
export let FinancialSeries = /*@__PURE__*/ (() => {
    class FinancialSeries extends Series {
        constructor() {
            super();
            this.qq = null;
            this.qo = null;
            this.qp = null;
            this.qn = null;
            this.qr = null;
            this.q0 = false;
            this.assigningCategoryStyle = null;
            this.p8 = null;
            this.ra = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
            this.rb = new Dictionary$2(String_$type, String_$type, 0);
            this.qz = false;
            this.qj = null;
            this.p3 = null;
            this.p5 = null;
            this.p1 = null;
            this.qb = null;
            this.typical = null;
            this.typicalBasedOn = null;
            this.qy = false;
            this.rn = null;
            this.rl = null;
            this.rm = null;
            this.rk = null;
            this.ro = null;
            this.p4 = null;
            this.p0 = null;
            this.p6 = 0;
            this.qk = null;
            this.qm = null;
            this.p8 = new CategorySeriesRenderManager();
            this.q0 = false;
            this.qb = new CategoryTransitionSourceFramePreparer();
            this.p4 = new CategoryFrame(3);
            this.ab = FinancialSeries.$;
            this.p7 = 0;
        }
        lo(a) {
            super.lo(a);
            this.qg = a;
        }
        get_dk() {
            return true;
        }
        ag() {
            return [this.pz, this.ql];
        }
        hn(a, b) {
            let c = this.jf(b);
            if (c == FinancialSeries.$$p[6]) {
                return this.ho(a, b, this.sf);
            }
            if (c == FinancialSeries.$$p[1]) {
                return this.ho(a, b, this.r6);
            }
            if (c == FinancialSeries.$$p[4]) {
                return this.ho(a, b, this.sb);
            }
            if (c == FinancialSeries.$$p[0]) {
                return this.ho(a, b, this.r3);
            }
            if (c == FinancialSeries.$$p[8]) {
                return this.ho(a, b, this.sj);
            }
            return super.hn(a, b);
        }
        rz() {
            return 2;
        }
        rx() {
            return 4;
        }
        ah(a) {
            let b = this.aj(this.pz, this.p1.f, this.rw(this.by), this.ry(this.by), this.pe(a), true);
            if (b == null) {
                return null;
            }
            let c = b[0];
            let d = b[1];
            let e = new Array(1);
            let f = new Array(2);
            let g = this.rz();
            f[0] = { $type: Point_$type, x: c[0], y: c[g] };
            f[1] = { $type: Point_$type, x: d[0], y: d[g] };
            e[0] = f;
            return e;
        }
        ai(a) {
            let b = this.aj(this.pz, this.p1.f, this.rw(this.by), this.ry(this.by), this.pe(a), true);
            if (b == null) {
                return null;
            }
            let c = b[0];
            let d = b[1];
            let e = new Array(1);
            let f = new Array(2);
            f[0] = { $type: Point_$type, x: c[0], y: c[1] };
            f[1] = { $type: Point_$type, x: d[0], y: d[1] };
            e[0] = f;
            return e;
        }
        oy() {
            return this.s5;
        }
        oz() {
            return this.s5;
        }
        kl() {
            super.kl();
            this.pz = null;
            this.ql = null;
        }
        get qv() {
            return this.qq;
        }
        set qv(a) {
            if (this.qq != a) {
                let b = this.qq;
                this.qq = a;
                this.raisePropertyChanged("OpenColumn", b, this.qq);
            }
        }
        get qt() {
            return this.qo;
        }
        set qt(a) {
            if (this.qo != a) {
                let b = this.qo;
                this.qo = a;
                this.raisePropertyChanged("HighColumn", b, this.qo);
            }
        }
        get qu() {
            return this.qp;
        }
        set qu(a) {
            if (this.qp != a) {
                let b = this.qp;
                this.qp = a;
                this.raisePropertyChanged("LowColumn", b, this.qp);
            }
        }
        get qs() {
            return this.qn;
        }
        set qs(a) {
            if (this.qn != a) {
                let b = this.qn;
                this.qn = a;
                this.raisePropertyChanged("CloseColumn", b, this.qn);
            }
        }
        get qx() {
            return this.qr;
        }
        set qx(a) {
            if (this.qr != a) {
                let b = this.qr;
                this.qr = a;
                this.raisePropertyChanged("VolumeColumn", b, this.qr);
            }
        }
        q7() {
            return (this.assigningCategoryStyle != null && this.q0) || this.bk != 1;
        }
        sr(a) {
            if (this.assigningCategoryStyle != null && this.q0) {
                this.assigningCategoryStyle(this, a);
            }
        }
        sp(a, b, c, d, e, f) {
            let g = this.bk != 1;
            this.p8.a1(this.p8.b, d.ck, a, b, c, d, e, f, false);
            this.p8.ab(this.fl);
            let h = this.p8.aw;
            let i = null;
            let j = this.ci;
            if (g && this.cb != null) {
                i = this.cb.a3.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = f;
            this.sr(h);
            this.p8.z(this, i, f, g, b < 0);
        }
        rp(a) {
            return this.f0(a, this.pz);
        }
        g9(a, b) {
            return this.ha(a, b, this.pz, runOn(this, this.rp), new FinancialValueList(this.qv, this.qt, this.qu, this.qs, this.qx));
        }
        g7(a, b) {
            return this.g8(a, b, this.pz, runOn(this, this.rp), new FinancialValueList(this.qv, this.qt, this.qu, this.qs, this.qx));
        }
        fw(a, b, c, d, e) {
            if (c == null) {
                return Number.POSITIVE_INFINITY;
            }
            let f = this.pz.k9;
            return this.fx(a, b, this.pz, d, e, f, runOn(this, this.rp));
        }
        getOffsetValue() {
            return this.rq(this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by));
        }
        getCategoryWidth() {
            return this.pz.getCategorySize(this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by));
        }
        pb(a, b, c) {
            return this.pd(a, b, c, this.rq(this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by)), this.ql, this.pz, null, null, null);
        }
        ga(a, b, c) {
            let d = this.getEffectiveViewport1(this.by);
            let e = this.rq(this.by.bv, this.by.bu, d);
            let f = new ScalerParams(0, this.by.bv, this.by.bu, this.pz.cf, d);
            return this.gc(new FinancialValueList(this.qv, this.qt, this.qu, this.qs, this.qx), a, this.pz, f, e, runOn(this, this.rp), b, c);
        }
        f6(a, b, c) {
            let d = this.getEffectiveViewport1(this.by);
            let e = this.rq(this.by.bv, this.by.bu, d);
            let f = new ScalerParams(0, this.by.bv, this.by.bu, this.pz.cf, d);
            return this.gc(this.qt, a, this.pz, f, e, runOn(this, this.rp), b, c);
        }
        f8(a, b, c) {
            let d = this.getEffectiveViewport1(this.by);
            let e = this.rq(this.by.bv, this.by.bu, d);
            let f = new ScalerParams(0, this.by.bv, this.by.bu, this.pz.cf, d);
            return this.gc(this.qu, a, this.pz, f, e, runOn(this, this.rp), b, c);
        }
        rr(a, b, c) {
            let d = this.getEffectiveViewport1(this.by);
            let e = this.rq(this.by.bv, this.by.bu, d);
            let f = new ScalerParams(0, this.by.bv, this.by.bu, this.pz.cf, d);
            return this.gc(this.qs, a, this.pz, f, e, runOn(this, this.rp), b, c);
        }
        rs(a, b, c) {
            let d = this.getEffectiveViewport1(this.by);
            let e = this.rq(this.by.bv, this.by.bu, d);
            let f = new ScalerParams(0, this.by.bv, this.by.bu, this.pz.cf, d);
            return this.gc(this.qv, a, this.pz, f, e, runOn(this, this.rp), b, c);
        }
        rt(a, b, c) {
            let d = this.getEffectiveViewport1(this.by);
            let e = this.rq(this.by.bv, this.by.bu, d);
            let f = new ScalerParams(0, this.by.bv, this.by.bu, this.pz.cf, d);
            return this.gc(this.qx, a, this.pz, f, e, runOn(this, this.rp), b, c);
        }
        o7(a, b, c) {
            return this.pd(a, b, c, this.rq(this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by)), this.ql, this.pz, runOn(this, this.f6), (d, e) => this.ha(d, e, this.pz, runOn(this, this.rp), this.qt), (d, e) => this.g8(d, e, this.pz, runOn(this, this.rp), this.qt));
        }
        o9(a, b, c) {
            return this.pd(a, b, c, this.rq(this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by)), this.ql, this.pz, runOn(this, this.f8), (d, e) => this.ha(d, e, this.pz, runOn(this, this.rp), this.qu), (d, e) => this.g8(d, e, this.pz, runOn(this, this.rp), this.qu));
        }
        s7(a, b, c) {
            return this.pd(a, b, c, this.rq(this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by)), this.ql, this.pz, runOn(this, this.rs), (d, e) => this.ha(d, e, this.pz, runOn(this, this.rp), this.qv), (d, e) => this.g8(d, e, this.pz, runOn(this, this.rp), this.qv));
        }
        s6(a, b, c) {
            return this.pd(a, b, c, this.rq(this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by)), this.ql, this.pz, runOn(this, this.rr), (d, e) => this.ha(d, e, this.pz, runOn(this, this.rp), this.qs), (d, e) => this.g8(d, e, this.pz, runOn(this, this.rp), this.qs));
        }
        s8(a, b, c) {
            return this.pd(a, b, c, this.rq(this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by)), this.ql, this.pz, runOn(this, this.rt), (d, e) => this.ha(d, e, this.pz, runOn(this, this.rp), this.qx), (d, e) => this.g8(d, e, this.pz, runOn(this, this.rp), this.qx));
        }
        k5() {
            super.k5();
            if (this.pz != null) {
                this.pz.h3(false);
            }
            if (this.ql != null) {
                this.ql.h3(false);
            }
        }
        mu(a, b) {
            this.qg.bx.e(this.gk);
            this.l7(false);
        }
        mt(a, b) {
            if (this.ew && this.gq < 0.05) {
                this.ex = true;
            }
            this.qg.bx.e(this.gk);
            this.l7(false);
        }
        qw(a, b, c) {
            let d = this.cf(b);
            this.ra.addItem(d, b);
            this.rb.addItem(b, c);
            return d;
        }
        so(a, b) {
            if (b == null) {
                return;
            }
            a.deregisterColumn(b);
            let c = this.ra.item(b);
            this.rb.removeItem(c);
            this.ra.removeItem(b);
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            switch (b) {
                case "SyncLink":
                    if (this.b6 != null && this.cb != null) {
                        this.qg.bx.e(this.gk);
                        this.l7(false);
                    }
                    break;
                case "SeriesViewer":
                    if (c != null && d == null) {
                        if (this.pz != null) {
                            this.pz.by(this);
                        }
                        if (this.ql != null) {
                            this.ql.by(this);
                        }
                    }
                    if (c == null && d != null) {
                        if (this.pz != null) {
                            this.pz.cq(this);
                        }
                        if (this.ql != null) {
                            this.ql.cq(this);
                        }
                    }
                    this.qg.bx.e(this.gk);
                    this.l7(false);
                    break;
                case "FastItemsSource":
                    this.qz = true;
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        this.so(typeCast(IFastItemsSource_$type, c), this.qv);
                        this.so(typeCast(IFastItemsSource_$type, c), this.qt);
                        this.so(typeCast(IFastItemsSource_$type, c), this.qu);
                        this.so(typeCast(IFastItemsSource_$type, c), this.qs);
                        this.so(typeCast(IFastItemsSource_$type, c), this.qx);
                        this.qv = null;
                        this.qt = null;
                        this.qu = null;
                        this.qs = null;
                        this.qx = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        if (stringIsNullOrEmpty(this.sf) == false) {
                            this.qv = this.qw(typeCast(IFastItemsSource_$type, d), this.sf, "OpenColumn");
                        }
                        if (stringIsNullOrEmpty(this.r6) == false) {
                            this.qt = this.qw(typeCast(IFastItemsSource_$type, d), this.r6, "HighColumn");
                        }
                        if (stringIsNullOrEmpty(this.sb) == false) {
                            this.qu = this.qw(typeCast(IFastItemsSource_$type, d), this.sb, "LowColumn");
                        }
                        if (stringIsNullOrEmpty(this.r3) == false) {
                            this.qs = this.qw(typeCast(IFastItemsSource_$type, d), this.r3, "CloseColumn");
                        }
                        if (stringIsNullOrEmpty(this.sj) == false) {
                            this.qx = this.qw(typeCast(IFastItemsSource_$type, d), this.sj, "VolumeColumn");
                        }
                    }
                    this.qz = false;
                    if (this.ql != null && !this.ql.cy()) {
                        this.qg.bx.e(this.gk);
                        this.l7(false);
                    }
                    break;
                case FinancialSeries.$$p[6]:
                    if (this.ci != null) {
                        this.so(this.ci, this.qv);
                        this.qv = this.qw(this.ci, this.sf, "OpenColumn");
                    }
                    break;
                case "OpenColumn":
                    if (this.ql != null && !this.ql.cy() && !this.qz) {
                        this.qg.bx.e(this.gk);
                        this.l7(false);
                    }
                    break;
                case FinancialSeries.$$p[1]:
                    if (this.ci != null) {
                        this.so(this.ci, this.qt);
                        this.qt = this.qw(this.ci, this.r6, "HighColumn");
                    }
                    break;
                case "HighColumn":
                    if (this.ql != null && !this.ql.cy() && !this.qz) {
                        this.qg.bx.e(this.gk);
                        this.l7(false);
                    }
                    break;
                case FinancialSeries.$$p[4]:
                    if (this.ci != null) {
                        this.so(this.ci, this.qu);
                        this.qu = this.qw(this.ci, this.sb, "LowColumn");
                    }
                    break;
                case "LowColumn":
                    if (this.ql != null && !this.ql.cy() && !this.qz) {
                        this.qg.bx.e(this.gk);
                        this.l7(false);
                    }
                    break;
                case FinancialSeries.$$p[0]:
                    if (this.ci != null) {
                        this.so(this.ci, this.qs);
                        this.qs = this.qw(this.ci, this.r3, "CloseColumn");
                    }
                    break;
                case "CloseColumn":
                    if (this.ql != null && !this.ql.cy() && !this.qz) {
                        this.qg.bx.e(this.gk);
                        this.l7(false);
                    }
                    this.st();
                    break;
                case FinancialSeries.$$p[8]:
                    if (this.ci != null) {
                        this.so(this.ci, this.qx);
                        this.qx = this.qw(this.ci, this.sj, "VolumeColumn");
                    }
                    break;
                case "VolumeColumn":
                    if (this.ql != null && !this.ql.cy() && !this.qz) {
                        this.qg.bx.e(this.gk);
                        this.l7(false);
                    }
                    break;
                case FinancialSeries.$$p[9]:
                    if (c != null) {
                        c.by(this);
                    }
                    if (d != null) {
                        d.cq(this);
                    }
                    this.qg.bx.e(this.gk);
                    this.l7(false);
                    this.le();
                    this.qk = typeCast(ITimeRangeSelectorAxis_$type, this.pz);
                    break;
                case FinancialSeries.$$p[10]:
                    if (c != null) {
                        c.by(this);
                    }
                    if (d != null) {
                        d.cq(this);
                    }
                    this.qg.bx.e(this.gk);
                    if (this.ql != null) {
                        this.ql.cy();
                    }
                    {
                        this.l7(false);
                    }
                    this.le();
                    break;
                case "TransitionProgress":
                    this.p5.c(this.gq, this.p3, this.p1);
                    if (this.cu(this.by)) {
                        return;
                    }
                    if (this.gq == 1) {
                        this.p1.v();
                        this.ss(this.p1, this.qg);
                        if (this.ew) {
                            this.ew = false;
                            this.kp();
                            this.cc.r = truncate(this.gd());
                            this.cc.b = this.cd;
                        }
                    }
                    else {
                        this.ss(this.p5, this.qg);
                    }
                    if (this.cb != null) {
                        this.cb.nd(this);
                    }
                    break;
                case FinancialSeries.$$p[5]:
                    this.l7(false);
                    break;
                case "IsCustomCategoryStyleAllowed":
                    this.q0 = this.q3();
                    this.l7(false);
                    break;
                case "CategoryMode":
                    if (this.pz != null) {
                        this.pz.lz(true);
                    }
                    break;
            }
        }
        q2(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        q1(a) {
            if (typeCast(CategoryXAxis.$, a) !== null || a.cc) {
                return true;
            }
            return false;
        }
        ps(a, b, c) {
            if (b < a || a < 0 || a > this.ci.count || b < 0 || b > this.ci.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.ck;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.ci.item(g);
            }
            return d;
        }
        rw(a) {
            return a.bx.b;
        }
        ry(a) {
            return a.bx.c;
        }
        pr(a, b) {
            return this.ps(a, b, this.ql);
        }
        get_dt() {
            return true;
        }
        km() {
            super.km();
            this.qj = null;
        }
        av(a, b, c) {
            if (this.cz && this.eb(this.bk) && !c) {
                let d = this.qi(a, b, this.qj);
                this.qj = d;
                return d;
            }
            else {
                let e = this.qh(a, b, this.qj);
                this.qj = e;
                return e;
            }
        }
        r0(a) {
            let b = this.p2();
            let c = this.by.bu;
            let d = this.by.bv;
            let e = this.pz;
            let f = 0;
            if (e.cm) {
                let g = (a.y - d.top) / d.height;
                f = g * c.height + c.top;
            }
            else {
                let h = (a.x - d.left) / d.width;
                f = h * c.width + c.left;
            }
            let i = b.f.count;
            let j = 0;
            for (j = 0; j < i; j++) {
                let k = b.f._inner[j];
                let l = null;
                if (j < i - 1) {
                    l = b.f._inner[j + 1];
                }
                if (k[0] <= f && l == null || l[0] >= f) {
                    if (l != null) {
                        if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                            return j;
                        }
                        else {
                            return j + 1;
                        }
                    }
                    else {
                        return j;
                    }
                }
            }
            return j;
        }
        qi(a, b, c) {
            let d = this.ci.count;
            let e = this.qg.bx.c;
            let f = this.qg.bx.d;
            let g = this.qg.bx.b;
            let h = this.pz;
            let i = -1;
            let j = -1;
            if (h.ck) {
                let k = this.p2();
                let l = this.r0(b);
                i = l;
                j = l;
            }
            else {
                let m = this.g3(b);
                i = truncate(Math.floor((intDivide(m, g)))) * g;
                j = i + (g - 1);
            }
            if (c != null && c.h == i && c.g == j) {
                return c;
            }
            let n = new HighlightingInfo();
            n.b = this;
            n.h = i;
            n.g = j;
            return n;
        }
        qh(a, b, c) {
            let d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ci.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        }
        q3() {
            return this.q5;
        }
        fy(a) {
            let b = this.by.bv;
            let c = this.by.bu;
            let d = -1;
            if (!b.isEmpty && !c.isEmpty && this.pz != null) {
                let e = this.getEffectiveViewport1(this.by);
                let f = new ScalerParams(0, b, c, this.pz.cf, e);
                let g = this.pg(this.by);
                let h = this.pz.ei(g.left, f);
                let i = this.pz.ei(g.right, f);
                let j = (a.x - b.left) / b.width;
                let k = h + (j * (i - h));
                if (this.pz.categoryMode != 0) {
                    k -= 0.5;
                }
                d = k;
            }
            return d;
        }
        g3(a) {
            return truncate(Math.round(this.fy(a)));
        }
        get_d5() {
            return typeCast(ISortingAxis_$type, this.pz) !== null;
        }
        ar() {
            return this.pz;
        }
        g5(a) {
            let b = this.by.bv;
            let c = this.by.bu;
            let d = this.getEffectiveViewport1(this.by);
            if (b.isEmpty || c.isEmpty) {
                return -1;
            }
            let e = new Rect(0, 0, 0, 1, 1);
            let f = new ScalerParams(0, b, c, this.pz.cf, d);
            let g = typeCast(ISortingAxis_$type, this.pz);
            let h = this.pg(this.by);
            let i = h.left;
            let j = h.right;
            let k = this.o6(a).x;
            let l = this.pz.ei(k, f);
            let m = this.pz.ei(i, f);
            let n = this.pz.ei(j, f);
            l = Math.max(m, Math.min(n, l));
            let o = g.i$f(l);
            return o;
        }
        hk(a) {
            let b = 0;
            if (typeCast(ISortingAxis_$type, this.pz) !== null) {
                b = this.g5(a);
                if (b == -1) {
                    return null;
                }
            }
            else {
                b = this.g3(a);
            }
            return b >= 0 && this.ci != null && b < this.ci.count ? this.ci.item(b) : null;
        }
        p2() {
            let a = this.p1;
            if (this.cs()) {
                if (this.cc.g) {
                    this.cc.t();
                }
                a = this.p5;
            }
            return a;
        }
        rq(a, b, c) {
            if (this.pz == null) {
                return 0;
            }
            return this.pz.kz(a, b, c, this.hc);
        }
        em() {
            return this.q6;
        }
        p9() {
            return 11;
        }
        b7() {
            return 3;
        }
        ss(a, b) {
            this.pf = a.aa;
            b.au();
        }
        sq(a, b) {
            a.u();
        }
        e5(a, b, c) {
            let d = super.e5(a, b, c);
            let e = c;
            if (this.ci == null || this.ci.count == 0 || !c.o() || b.isEmpty || a.isEmpty || this.pz == null || this.ql == null || e.bx.b < 1 || this.pz.bh == null || this.ql.bh == null || this.ql.ld == this.ql.lc || this.pz.itemsSource == null || this.pz.k9 < 1) {
                e.bx.b = 0;
                d = false;
            }
            return d;
        }
        getViewInfo(a, b) {
            b = this.by.bv;
            a = this.by.bu;
            return {
                p0: a,
                p1: b
            };
        }
        ru(a) {
            let b = 0;
            let c = a.bv;
            let d = a.bu;
            let e = this.getEffectiveViewport1(this.by);
            if (!c.isEmpty && !d.isEmpty && this.ql != null) {
                let f = new ScalerParams(0, c, d, this.ql.cf, e);
                f.b = this.f4();
                b = this.ql.ef(this.ql.ln, f);
            }
            return b;
        }
        kp() {
            super.kp();
            this.p3.v();
            this.p1.v();
            this.p5.v();
        }
        l8(a) {
            super.l8(a);
            this.qg.bx.e(this.gk);
            if (this.cu(this.by)) {
                return;
            }
            if (this.eo) {
                if (this.cs()) {
                    this.ss(this.p5, this.qg);
                }
                else {
                    this.ss(this.p1, this.qg);
                }
                return;
            }
            if (this.ek(a)) {
                let b = this.p3;
                if (this.cs()) {
                    if (this.cc.g) {
                        this.cc.t();
                    }
                    this.p3 = this.p5;
                    this.p5 = b;
                }
                else {
                    this.p3 = this.p1;
                    this.p1 = b;
                }
                this.sq(this.p1, this.qg);
                if (this.ey) {
                    this.cc.w();
                    this.cc.r = truncate(this.ge());
                    this.cc.b = this.ce != null ? this.ce : this.cd;
                    this.qb.p(this.p3, this.p1, this.isVertical, this.pz, this.ql, this.qa, this.p9(), this.b8, this.b7(), () => this.ru(this.qg), this.qg.bu);
                }
                this.kk();
                this.mf();
                if (this.ey) {
                    this.ex = false;
                    this.ew = true;
                }
            }
            else {
                this.sq(this.p1, this.qg);
                this.ss(this.p1, this.qg);
            }
        }
        q8(a) {
            for (let b of fromEnum(a)) {
                switch (b) {
                    case "HighColumn":
                        if (this.qt == null) {
                            return false;
                        }
                        break;
                    case "LowColumn":
                        if (this.qu == null) {
                            return false;
                        }
                        break;
                    case "OpenColumn":
                        if (this.qv == null) {
                            return false;
                        }
                        break;
                    case "CloseColumn":
                        if (this.qs == null) {
                            return false;
                        }
                        break;
                    case "VolumeColumn":
                        if (this.qx == null) {
                            return false;
                        }
                        break;
                }
            }
            return true;
        }
        get q9() {
            return this.pz != null && typeCast(ISortingAxis_$type, this.pz) !== null;
        }
        q4() {
            return this.typical != null;
        }
        sn(a) {
            this.typical(this, a);
        }
        get rh() {
            return this.re();
        }
        *_re() {
            let a = false;
            if (this.q4()) {
                let b = this.qc(0, this.ci.count);
                this.sn(new FinancialEventArgs(0, this.ci.count, b, this.qd(b), this));
                if (b.typicalColumn != null) {
                    a = true;
                    for (let c of fromEnum(b.typicalColumn)) {
                        yield c;
                    }
                }
            }
            if (!a) {
                if (this.q9 && this.pz.i$b != null) {
                    let d = this.ci.count;
                    let e = this.pz.i$b;
                    for (let f = 0; f < d; ++f) {
                        yield (this.qt.item(e.item(f)) + this.qu.item(e.item(f)) + this.qs.item(e.item(f))) / 3;
                    }
                }
                else {
                    let g = this.ci.count;
                    for (let h = 0; h < g; ++h) {
                        yield (this.qt.item(h) + this.qu.item(h) + this.qs.item(h)) / 3;
                    }
                }
            }
        }
        re() {
            return toEnum(() => this._re());
        }
        get rg() {
            return this.rd();
        }
        *_rd() {
            if (this.q9 && this.pz.i$b != null) {
                let a = this.qt.count;
                let b = this.pz.i$b;
                if (a > 0) {
                    yield this.rv(this.qt.item(b.item(0)) - this.qu.item(b.item(0)));
                }
                for (let c = 1; c < a; ++c) {
                    yield Math.max(this.rv(this.qt.item(b.item(c)) - this.qu.item(b.item(c))), Math.max(this.rv(Math.abs(this.qt.item(b.item(c)) - this.qs.item(b.item(c - 1)))), this.rv(Math.abs(this.qu.item(b.item(c)) - this.qs.item(b.item(c - 1))))));
                }
            }
            else {
                let d = this.qt.count;
                if (d > 0) {
                    yield this.rv(this.qt.item(0) - this.qu.item(0));
                }
                for (let e = 1; e < d; ++e) {
                    yield Math.max(this.rv(this.qt.item(e) - this.qu.item(e)), Math.max(this.rv(Math.abs(this.qt.item(e) - this.qs.item(e - 1))), this.rv(Math.abs(this.qu.item(e) - this.qs.item(e - 1)))));
                }
            }
        }
        rd() {
            return toEnum(() => this._rd());
        }
        get rf() {
            return this.rc();
        }
        *_rc() {
            if (this.q9 && this.pz.i$b != null) {
                let a = this.qu.count;
                let b = this.pz.i$b;
                if (a > 0) {
                    yield this.rv(this.qu.item(b.item(0)));
                }
                for (let c = 1; c < a; c++) {
                    yield Math.min(this.rv(this.qu.item(b.item(c))), this.rv(this.qs.item(b.item(c - 1))));
                }
            }
            else {
                let d = this.qu.count;
                if (d > 0) {
                    yield this.rv(this.qu.item(0));
                }
                for (let e = 1; e < d; e++) {
                    yield Math.min(this.rv(this.qu.item(e)), this.rv(this.qs.item(e - 1)));
                }
            }
        }
        rc() {
            return toEnum(() => this._rc());
        }
        rj(a) {
            if (a == null) {
                return null;
            }
            if (this.q9 && this.pz.i$b != null) {
                return new SafeSortedReadOnlyDoubleCollection(0, a, this.pz.i$b);
            }
            return new SafeReadOnlyDoubleCollection(0, a);
        }
        ri() {
            let a = new List$1(String_$type, 0);
            a.add("HighColumn");
            a.add("LowColumn");
            a.add("CloseColumn");
            if (this.typicalBasedOn != null && this.ci != null && !this.qy) {
                this.qy = true;
                let b = this.qc(0, this.ci.count);
                this.qy = false;
                let c = new FinancialEventArgs(0, this.ci.count, b, this.qd(b), this);
                this.typicalBasedOn(this, c);
                if (c.basedOn != null && c.basedOn.count > 0) {
                    return c.basedOn;
                }
            }
            return a;
        }
        getOpenColumnAsArray() {
            if (this.qv == null) {
                return null;
            }
            if (this.pz != null && typeCast(ISortingAxis_$type, this.pz) !== null) {
                if (this.rn != null) {
                    return this.rn.asArray();
                }
                let a = new List$1(Number_$type, 2, this.qv.count);
                let b = this.pz.i$b;
                let c = this.qv.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rn = a;
                return this.rn.asArray();
            }
            else {
                return this.qv.asArray();
            }
        }
        getHighColumnAsArray() {
            if (this.qt == null) {
                return null;
            }
            if (this.pz != null && typeCast(ISortingAxis_$type, this.pz) !== null) {
                if (this.rl != null) {
                    return this.rl.asArray();
                }
                let a = new List$1(Number_$type, 2, this.qt.count);
                let b = this.pz.i$b;
                let c = this.qt.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rl = a;
                return this.rl.asArray();
            }
            else {
                return this.qt.asArray();
            }
        }
        getLowColumnAsArray() {
            if (this.qu == null) {
                return null;
            }
            if (this.pz != null && typeCast(ISortingAxis_$type, this.pz) !== null) {
                if (this.rm != null) {
                    return this.rm.asArray();
                }
                let a = new List$1(Number_$type, 2, this.qu.count);
                let b = this.pz.i$b;
                let c = this.qu.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rm = a;
                return this.rm.asArray();
            }
            else {
                return this.qu.asArray();
            }
        }
        getCloseColumnAsArray() {
            if (this.qs == null) {
                return null;
            }
            if (this.pz != null && typeCast(ISortingAxis_$type, this.pz) !== null) {
                if (this.rk != null) {
                    return this.rk.asArray();
                }
                let a = new List$1(Number_$type, 2, this.qs.count);
                let b = this.pz.i$b;
                let c = this.qs.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rk = a;
                return this.rk.asArray();
            }
            else {
                return this.qs.asArray();
            }
        }
        getVolumeColumnAsArray() {
            if (this.qx == null) {
                return null;
            }
            if (this.pz != null && typeCast(ISortingAxis_$type, this.pz) !== null) {
                if (this.ro != null) {
                    return this.ro.asArray();
                }
                let a = new List$1(Number_$type, 2, this.qx.count);
                let b = this.pz.i$b;
                let c = this.qx.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.ro = a;
                return this.ro.asArray();
            }
            else {
                return this.qx.asArray();
            }
        }
        kr(a, b, c, d) {
            super.kr(a, b, c, d);
            if (this.pz == null || !(typeCast(ISortingAxis_$type, this.pz) !== null)) {
                return;
            }
            let e = this.pz.i$b;
            switch (a) {
                case 1:
                    for (let f = b; f < c; f++) {
                        let g = e._inner[f];
                        if (this.rn != null) {
                            this.rn.insert(f, this.qv.item(g));
                        }
                        if (this.rl != null) {
                            this.rl.insert(f, this.qt.item(g));
                        }
                        if (this.rm != null) {
                            this.rm.insert(f, this.qu.item(g));
                        }
                        if (this.rk != null) {
                            this.rk.insert(f, this.qs.item(g));
                        }
                        if (this.ro != null) {
                            this.ro.insert(f, this.qx.item(g));
                        }
                    }
                    break;
                case 0:
                    if (this.rn != null) {
                        this.rn.v(b, c);
                    }
                    if (this.rl != null) {
                        this.rl.v(b, c);
                    }
                    if (this.rm != null) {
                        this.rm.v(b, c);
                    }
                    if (this.rk != null) {
                        this.rk.v(b, c);
                    }
                    if (this.ro != null) {
                        this.ro.v(b, c);
                    }
                    break;
                case 4:
                    if (this.rn != null) {
                        this.rn = new List$1(Number_$type, 0);
                    }
                    if (this.rl != null) {
                        this.rl = new List$1(Number_$type, 0);
                    }
                    if (this.rm != null) {
                        this.rm = new List$1(Number_$type, 0);
                    }
                    if (this.rk != null) {
                        this.rk = new List$1(Number_$type, 0);
                    }
                    if (this.ro != null) {
                        this.ro = new List$1(Number_$type, 0);
                    }
                    break;
                case 3:
                case 2:
                    for (let h = b; h < c; h++) {
                        let i = e._inner[h];
                        if (this.rn != null) {
                            this.rn._inner[h] = this.qv.item(i);
                        }
                        if (this.rl != null) {
                            this.rl._inner[h] = this.qt.item(i);
                        }
                        if (this.rm != null) {
                            this.rm._inner[h] = this.qu.item(i);
                        }
                        if (this.rk != null) {
                            this.rk._inner[h] = this.qs.item(i);
                        }
                        if (this.ro != null) {
                            this.ro._inner[h] = this.qx.item(i);
                        }
                    }
                    break;
            }
            this.st();
            this.mq();
        }
        qc(a, b) {
            let c = this.rj(this.qv);
            let d = this.rj(this.qs);
            let e = this.rj(this.qt);
            let f = this.rj(this.qu);
            let g = this.rj(this.qx);
            let h = ((() => {
                let $ret = new FinancialCalculationDataSource();
                $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(this.rh), this.ri());
                $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(this.rg), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("HighColumn");
                    $ret.add("LowColumn");
                    $ret.add("CloseColumn");
                    return $ret;
                })()));
                $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(this.rf), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("LowColumn");
                    $ret.add("CloseColumn");
                    return $ret;
                })()));
                $ret.openColumn = c;
                $ret.closeColumn = d;
                $ret.highColumn = e;
                $ret.lowColumn = f;
                $ret.volumeColumn = g;
                $ret.calculateFrom = a;
                $ret.calculateCount = b;
                $ret.minimumValue = NaN;
                $ret.maximumValue = NaN;
                $ret.count = this.ci != null ? this.ci.count : 0;
                return $ret;
            })());
            return h;
        }
        rv(a) {
            if (isInfinity(a) || isNaN_(a)) {
                return 0;
            }
            return a;
        }
        qd(a) {
            return ((() => {
                let $ret = new FinancialCalculationSupportingCalculations();
                $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
                $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
                $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
                $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
                $ret.h = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.shortPeriod), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("VolumeColumn");
                    return $ret;
                })()));
                $ret.f = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.longPeriod), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("VolumeColumn");
                    return $ret;
                })()));
                $ret.g = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.shortPeriod), a.typicalColumn.basedOn);
                $ret.e = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.longPeriod), a.typicalColumn.basedOn);
                $ret.k = Series.fa;
                $ret.j = Series.e9;
                $ret.i = runOn(this, this.rv);
                return $ret;
            })());
        }
        get categoryAxis() {
            return this.pz;
        }
        l9(a, b) {
            super.l9(a, b);
            if (!this.ev) {
                this.by.a2(b);
                return;
            }
            let c = typeCast(FinancialSeriesView.$, this.bx);
            this.by.a2(b);
            c.bx.e(this.gk);
            if (this.cu(this.bx)) {
                return;
            }
            if (!this.ep) {
                this.sq(this.p4, c);
            }
            this.ep = false;
            this.ss(this.p4, c);
            this.ev = false;
        }
        l6(a, b, c, d, e) {
            super.l6(a, b, c, d, e);
            let f = this.a5.a$h.item(d);
            let g = f;
            g.bx.e(this.gk);
            f.a1(c);
            if (this.cu(g)) {
                return;
            }
            if (this.p0 == null) {
                this.p0 = new CategoryFrame(3);
            }
            this.p0.u();
            this.sq(this.p0, g);
            this.ss(this.p0, g);
        }
        an(a) {
            if (this.pz == a) {
                return this.ql;
            }
            if (this.ql == a) {
                return this.pz;
            }
            return null;
        }
        preferredCategoryMode(a) {
            let b = typeCast(IDateTimeAxis_$type, this.pz);
            return b != null ? b.preferredCategoryMode(this) : this.p7;
        }
        get p7() {
            return this.p6;
        }
        set p7(a) {
            let b = this.p7;
            if (a != b) {
                this.p6 = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.p7));
            }
        }
        get_dz() {
            return true;
        }
        mc(a, b) {
            super.mc(a, b);
            this.s5 = a;
        }
        st() {
            this.fu = this.qs == null || this.qs.count == 0 ? NaN : this.qs.item(this.qs.count - 1);
        }
        hm(a) {
            if (this.qk != null && a != null) {
                if (this.qm == null || this.qm.propertyName != this.qk.dateTimeMemberPath) {
                    this.qm = new FastReflectionHelper(false, this.qk.dateTimeMemberPath);
                }
                let b = this.qm.getPropertyValue(a);
                if (typeCast(Date_$type, b) !== null) {
                    return dateToStringFormat(b, this.qk.itemLabelFormat());
                }
            }
            return super.hm(a);
        }
    }
    FinancialSeries.$t = /*@__PURE__*/ markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
    FinancialSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:r3:su', [2, null], 'HighMemberPath:r6:sv', [2, null], 'IsCustomCategoryStyleAllowed:q5:sw', [0, false], 'IsTransitionInEnabled:q6:sx', [0, false], 'LowMemberPath:sb:sy', [2, null], 'NegativeBrush:s5:sz', [Brush.$, null], 'OpenMemberPath:sf:s0', [2, null], 'TransitionInMode:qa:s1', [CategoryTransitionInMode_$type, /*@__PURE__*/ enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:sj:s2', [2, null], 'XAxis:pz:s3', [CategoryAxisBase.$, null], 'YAxis:ql:s4', [NumericYAxis.$, null]]);
    return FinancialSeries;
})();
/**
 * @hidden
 */
export let FinancialCalculationSupportingCalculations = /*@__PURE__*/ (() => {
    class FinancialCalculationSupportingCalculations extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.c = null;
            this.d = null;
            this.b = null;
            this.h = null;
            this.f = null;
            this.g = null;
            this.e = null;
            this.k = null;
            this.j = null;
            this.i = null;
        }
    }
    FinancialCalculationSupportingCalculations.$t = /*@__PURE__*/ markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
    return FinancialCalculationSupportingCalculations;
})();
/**
 * @hidden
 */
export let DataSourceSupportingCalculation = /*@__PURE__*/ (() => {
    class DataSourceSupportingCalculation extends SupportingCalculation$1 {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(Delegate_$type, 0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(Delegate_$type, 1, c, d);
                    }
                    break;
            }
        }
    }
    DataSourceSupportingCalculation.$t = /*@__PURE__*/ markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', /*@__PURE__*/ SupportingCalculation$1.$.specialize(Delegate_$type));
    return DataSourceSupportingCalculation;
})();
/**
 * @hidden
 */
export let FinancialCalculationDataSource = /*@__PURE__*/ (() => {
    class FinancialCalculationDataSource extends Base {
        constructor() {
            super(...arguments);
            this._openColumn = null;
            this._closeColumn = null;
            this._highColumn = null;
            this._lowColumn = null;
            this._volumeColumn = null;
            this._indicatorColumn = null;
            this._typicalColumn = null;
            this._trueRange = null;
            this._trueLow = null;
            this._period = 0;
            this._shortPeriod = 0;
            this._longPeriod = 0;
            this._count = 0;
            this._calculateFrom = 0;
            this._calculateCount = 0;
            this._multiplier = 0;
            this._minimumValue = 0;
            this._maximumValue = 0;
            this._specifiesRange = false;
            this._series = null;
        }
        get openColumn() {
            return this._openColumn;
        }
        set openColumn(a) {
            this._openColumn = a;
        }
        get closeColumn() {
            return this._closeColumn;
        }
        set closeColumn(a) {
            this._closeColumn = a;
        }
        get highColumn() {
            return this._highColumn;
        }
        set highColumn(a) {
            this._highColumn = a;
        }
        get lowColumn() {
            return this._lowColumn;
        }
        set lowColumn(a) {
            this._lowColumn = a;
        }
        get volumeColumn() {
            return this._volumeColumn;
        }
        set volumeColumn(a) {
            this._volumeColumn = a;
        }
        get indicatorColumn() {
            return this._indicatorColumn;
        }
        set indicatorColumn(a) {
            this._indicatorColumn = a;
        }
        get typicalColumn() {
            return this._typicalColumn;
        }
        set typicalColumn(a) {
            this._typicalColumn = a;
        }
        get trueRange() {
            return this._trueRange;
        }
        set trueRange(a) {
            this._trueRange = a;
        }
        get trueLow() {
            return this._trueLow;
        }
        set trueLow(a) {
            this._trueLow = a;
        }
        get period() {
            return this._period;
        }
        set period(a) {
            this._period = a;
        }
        get shortPeriod() {
            return this._shortPeriod;
        }
        set shortPeriod(a) {
            this._shortPeriod = a;
        }
        get longPeriod() {
            return this._longPeriod;
        }
        set longPeriod(a) {
            this._longPeriod = a;
        }
        get count() {
            return this._count;
        }
        set count(a) {
            this._count = a;
        }
        get calculateFrom() {
            return this._calculateFrom;
        }
        set calculateFrom(a) {
            this._calculateFrom = a;
        }
        get calculateCount() {
            return this._calculateCount;
        }
        set calculateCount(a) {
            this._calculateCount = a;
        }
        get multiplier() {
            return this._multiplier;
        }
        set multiplier(a) {
            this._multiplier = a;
        }
        get minimumValue() {
            return this._minimumValue;
        }
        set minimumValue(a) {
            this._minimumValue = a;
        }
        get maximumValue() {
            return this._maximumValue;
        }
        set maximumValue(a) {
            this._maximumValue = a;
        }
        get specifiesRange() {
            return this._specifiesRange;
        }
        set specifiesRange(a) {
            this._specifiesRange = a;
        }
        get series() {
            return this._series;
        }
        set series(a) {
            this._series = a;
        }
    }
    FinancialCalculationDataSource.$t = /*@__PURE__*/ markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
    return FinancialCalculationDataSource;
})();
/**
 * @hidden
 */
export let FinancialSeriesView = /*@__PURE__*/ (() => {
    class FinancialSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.bz = null;
            this.bx = null;
            this.b1 = 0;
            this.b1 = -1;
            this.bz = a;
            this.bx = this.by();
        }
        b0(a) {
            if (this.b1 != a.t) {
                return true;
            }
            return false;
        }
        b2(a) {
            this.b1 = a.t;
        }
        as() {
            super.as();
            if (!this.q) {
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'>";
            if (this.bz.pz.cc) {
                a += "<span>${itemLabel}</span><br/>";
            }
            else if (this.bz.pz.fw != null) {
                a += "<span>${item." + this.bz.pz.fw + "}</span><br/>";
            }
            a += "<span class='ui-priority-primary'";
            let b = this.e.a5.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            let c = new SRProvider(this.w);
            let d = c.b1("financialSeries_Open");
            let e = c.b1("financialSeries_High");
            let f = c.b1("financialSeries_Low");
            let g = c.b1("financialSeries_Close");
            d = stringIsNullOrEmpty(d) ? "Open" : d;
            e = stringIsNullOrEmpty(e) ? "High" : e;
            f = stringIsNullOrEmpty(f) ? "Low" : f;
            g = stringIsNullOrEmpty(g) ? "Close" : g;
            a += ">" + this.bz.hs + "</span><table><tr><td>" + d + ":</td><td>" + "${item." + this.bz.sf + "}</td></tr><tr><td>" + e + ":</td><td>" + "${item." + this.bz.r6 + "}</td></tr><tr><td>" + f + ":</td><td>" + "${item." + this.bz.sb + "}</td></tr><tr><td>" + g + ":</td><td>" + "${item." + this.bz.r3 + "}</td></tr>";
            if (!stringIsNullOrEmpty(this.bz.sj)) {
                let h = c.b1("financialSeries_Volume");
                h = stringIsNullOrEmpty(h) ? "Volume" : h;
                a += "<tr><td>" + h + ":</td><td>" + "${item." + this.bz.sj + "}</td></tr>";
            }
            a += "</table></div>";
            return a;
        }
        af() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.o0 = a;
            this.e.gm = 5;
            this.e.gn = 2;
            this.e.go = 2;
        }
    }
    FinancialSeriesView.$t = /*@__PURE__*/ markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
    return FinancialSeriesView;
})();
