/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { CategoryFrame } from "./CategoryFrame";
import { Number_$type, typeCast, enumGetBox, EnumUtil, runOn, markType, markDep } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { CategorySeries } from "./CategorySeries";
import { NotImplementedException } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { LineGeometry } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { GeometryGroup } from "igniteui-react-core";
import { Defaults } from "./Defaults";
import { Extensions } from "igniteui-react-core";
import { IndicatorRenderer } from "./IndicatorRenderer";
/**
 * @hidden
 */
export let FinancialIndicator = /*@__PURE__*/ (() => {
    class FinancialIndicator extends FinancialSeries {
        constructor() {
            super();
            this._indicatorColumn = null;
            this.s9 = null;
            this.p3 = new CategoryFrame(3);
            this.p5 = new CategoryFrame(3);
            this.p1 = new CategoryFrame(3);
            this.indicatorColumn = new List$1(Number_$type, 0);
            this.s9 = new AxisRange(-100, 100);
        }
        get_dl() {
            return true;
        }
        bv() {
            return new FinancialIndicatorView(this);
        }
        lo(a) {
            super.lo(a);
            this.ta = a;
        }
        tn(a) {
            if (this.ql != null && !this.ql.cy()) {
                this.l7(true);
            }
        }
        tf(a, b, c) {
            if (isNaN_(b.x) || isNaN_(b.y)) {
                return false;
            }
            let d = this.ql;
            let e = 0;
            if (d != null) {
                e = d.e0(d.ln);
            }
            if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
                return true;
            }
            return false;
        }
        bp() {
            if (this.bq == 0) {
                return 1;
            }
            else {
                return super.bp();
            }
        }
        pk(a) {
            if (this.pz == null || this.ql == null) {
                return Rect.empty;
            }
            let b = this.o6(a);
            let c = this.by.bv;
            let d = this.by.bu;
            let e = this.getEffectiveViewport1(this.by);
            let f = new ScalerParams(0, c, d, this.ql.cf, e);
            f.b = this.f4();
            let g = this.aj(this.pz, this.p1.f, this.rw(this.by), this.ry(this.by), a, true);
            if (g == null) {
                return Rect.empty;
            }
            let h = g[0];
            let i = g[1];
            let j = Math.abs(b.x - h[0]);
            let k = Math.abs(b.x - i[0]);
            let l = this.ql.ef(this.ql.ln, f);
            let m = 1;
            if (j < k) {
                let n = h[0] - 0.5 * m;
                let o = h[1];
                let p = l;
                return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
            }
            else {
                let q = i[0] - 0.5 * m;
                let r = i[1];
                let s = l;
                return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
            }
        }
        er(a, b) {
            let c = this.pb(this.pe(a), true, false);
            if (this.tc == 1) {
                if (this.tf(a, c, b)) {
                    return true;
                }
            }
            if (this.tc == 1 || this.tc == 0) {
                if (this.eq(a, b)) {
                    return true;
                }
            }
            if (this.tc == 2) {
                if (this.eu(a, b)) {
                    return true;
                }
            }
            return false;
        }
        kr(a, b, c, d) {
            super.kr(a, b, c, d);
            if (this.pz != null && typeCast(ISortingAxis_$type, this.pz) !== null) {
                this.pz.i$i();
            }
            if (this.ta.b7) {
                this.ta.b5.g$e(a, b, c, d);
            }
            if (d != null && this.rb.containsKey(d)) {
                let e = this.rb.tryGetValue(d, d);
                d = e.p1;
            }
            if (this.pz != null && typeCast(ISortingAxis_$type, this.pz) !== null) {
                a = 4;
                b = 0;
                c = this.ci.count;
            }
            switch (a) {
                case 3:
                    if (this.te(b, c, d)) {
                        this.tp(b, c, d);
                        this.tn(true);
                    }
                    break;
                case 2:
                    if (this.te(b, this.ci.count - b, d)) {
                        this.tp(b, this.ci.count - b, d);
                        this.tn(true);
                    }
                    break;
                case 1:
                    if (this.te(b, this.ci.count - b, d)) {
                        let f = new Array(c);
                        for (let g = 0; g < c; g++) {
                            f[g] = 0;
                        }
                        this.indicatorColumn.s(b, f);
                        this.tp(b, this.ci.count - b, d);
                        this.tn(true);
                    }
                    break;
                case 0:
                    if (this.te(b, this.ci.count - b, d)) {
                        this.indicatorColumn.v(b, c);
                        this.tp(b, this.ci.count - b, d);
                        this.tn(true);
                    }
                    break;
                case 4:
                    if (this.te(b, this.ci.count - b, d)) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.ci.count);
                        let h = new Array(c);
                        for (let i = 0; i < c; i++) {
                            h[i] = 0;
                        }
                        this.indicatorColumn.s(0, h);
                        this.tp(b, this.ci.count - b, d);
                        this.tn(true);
                    }
                    break;
            }
        }
        get_tb() {
            return 0;
        }
        get tb() {
            return this.get_tb();
        }
        get t0() {
            return this.c(FinancialIndicator.tq);
        }
        set t0(a) {
            this.h(FinancialIndicator.tq, a);
        }
        tk() {
            return -1;
        }
        get indicatorColumn() {
            return this._indicatorColumn;
        }
        set indicatorColumn(a) {
            this._indicatorColumn = a;
        }
        lt(a, b, c, d) {
            switch (b) {
                case "XAxis":
                    this.ta.cd();
                    break;
                case "TrendLineType":
                    let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                    if (e != 0) {
                        this.ta.b5 = CategoryTrendLineManagerFactory.a(this.ta.b5, this.pz, this.my, this, this.cl);
                    }
                    break;
            }
            super.lt(a, b, c, d);
            if (this.ta.b7 && this.ta.b5.g$b(a, b, c, d)) {
                this.l7(false);
                let f = typeCast(FinancialIndicatorView.$, this.bx);
                if (f != null && f.b7) {
                    f.b5.g$b(a, b, c, d);
                }
                this.le();
            }
            switch (b) {
                case "FastItemsSource":
                    if (this.ci != null) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.ci.count);
                        let g = new Array(this.ci.count);
                        for (let h = 0; h < this.ci.count; h++) {
                            g[h] = 0;
                        }
                        this.indicatorColumn.s(0, g);
                        this.tp(0, this.ci.count, null);
                        if (this.ql != null && !this.ql.cy()) {
                            this.qg.bx.e(this.gk);
                            this.l7(false);
                        }
                    }
                    break;
                case "TrendLineBrush":
                    this.mk();
                    break;
                case FinancialIndicator.$$p[0]:
                    this.ko(true, this.by);
                    this.ml();
                    this.l7(false);
                    this.le();
                    break;
                case "OpenColumn":
                case "HighColumn":
                case "LowColumn":
                case "CloseColumn":
                case "VolumeColumn":
                    if (this.ci != null) {
                        if (this.indicatorColumn.count != this.ci.count) {
                            this.indicatorColumn = new List$1(Number_$type, 2, this.ci.count);
                            let i = new Array(this.ci.count);
                            for (let j = 0; j < this.ci.count; j++) {
                                i[j] = 0;
                            }
                            this.indicatorColumn.s(0, i);
                        }
                        if (this.te(0, this.ci.count - 1, b)) {
                            this.to();
                        }
                    }
                    break;
                case "XAxis":
                    if (this.pz != null && (typeCast(ISortingAxis_$type, this.pz) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                        this.to();
                    }
                    break;
                case "YAxis":
                case FinancialIndicator.$$p[1]:
                    this.to();
                    this.le();
                    break;
                case "TrendLineType":
                    this.le();
                    break;
            }
        }
        ga(a, b, c) {
            if (this.indicatorColumn == null) {
                return super.ga(a, b, c);
            }
            let d = this.getEffectiveViewport1(this.by);
            let e = this.rq(this.by.bv, this.by.bu, d);
            let f = new ScalerParams(0, this.by.bv, this.by.bu, this.pz.cf, d);
            f.c = this.cb.sf;
            return this.gc(this.indicatorColumn, a, this.pz, f, e, runOn(this, this.rp), b, c);
        }
        g9(a, b) {
            if (this.indicatorColumn == null) {
                return super.g9(a, b);
            }
            return this.ha(a, b, this.pz, runOn(this, this.rp), this.indicatorColumn);
        }
        g7(a, b) {
            if (this.indicatorColumn == null) {
                return super.g7(a, b);
            }
            return this.g8(a, b, this.pz, runOn(this, this.rp), this.indicatorColumn);
        }
        get_e4() {
            return true;
        }
        te(a, b, c) {
            if (c == null) {
                return true;
            }
            if (this.tg(a, b).contains(c)) {
                return true;
            }
            return false;
        }
        tp(a, b, c) {
            this.td(a, b);
        }
        ap(a) {
            if (this.ci == null) {
                return null;
            }
            if (a != null && a == this.ql) {
                return this.s9;
            }
            return null;
        }
        ej(a) {
            let b = this.ci != null ? this.ci.indexOf(a) : -1;
            let c = this.by.bv;
            c = c.copy();
            let d = this.by.bu;
            let e = new Rect(0, 0, 0, 1, 1);
            let f = this.pi(this.by);
            if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
                if (this.pz != null) {
                    let g = new ScalerParams(0, e, e, this.pz.cf, f);
                    let h = this.pz.ef(b, g);
                    if (h < c.left + 0.1 * c.width) {
                        h = h + 0.4 * c.width;
                    }
                    if (h > c.right - 0.1 * c.width) {
                        h = h - 0.4 * c.width;
                    }
                    c.x = h - 0.5 * c.width;
                }
                if (this.ql != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                    let i = new ScalerParams(0, e, e, this.ql.cf, f);
                    i.b = this.f4();
                    let j = this.ql.ef(this.indicatorColumn._inner[b], i);
                    if (j < c.top + 0.1 * c.height) {
                        j = j + 0.4 * c.height;
                    }
                    if (j > c.bottom - 0.1 * c.height) {
                        j = j - 0.4 * c.height;
                    }
                    c.y = j - 0.5 * c.height;
                }
                this.b6.au(this.cb, c, true);
            }
            return b >= 0;
        }
        e5(a, b, c) {
            let d = super.e5(a, b, c);
            if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
                d = false;
            }
            return d;
        }
        sq(a, b) {
            super.sq(a, b);
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.pz;
            let g = this.ql;
            let h = new ScalerParams(0, c, d, f.cf, e);
            let i = new ScalerParams(0, c, d, g.cf, e);
            i.b = this.f4();
            a.f.clear();
            a.m.clear();
            a.p.clear();
            let j = 0;
            let k = typeCast(ISortingAxis_$type, this.pz);
            if (k != null && k.i$b.count != this.ci.count) {
                return;
            }
            j = this.rq(c, d, e);
            let l = this.tk();
            if (l == -1) {
                l = this.trendLinePeriod;
            }
            let m = typeCast(FinancialIndicatorView.$, b);
            if (m.b7) {
                m.b5.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, l, (n) => this.pz.ef(n, h), (n) => this.ql.ef(n, i), ((() => {
                    let $ret = new TrendResolutionParams();
                    $ret.c = b.bx.b;
                    $ret.d = b.bx.c;
                    $ret.e = b.bx.d;
                    $ret.a = j;
                    $ret.b = this.gk;
                    $ret.f = d;
                    $ret.g = c;
                    return $ret;
                })()));
            }
            let n = this.pz.ei(2, h) - this.pz.ei(1, h);
            for (let o = b.bx.c; o <= b.bx.d; ++o) {
                let p;
                if (k == null) {
                    p = b.bx.getBucket(o);
                }
                else {
                    let q = k.i$b._inner[o];
                    let r = k.i$d(q);
                    let s = this.indicatorColumn._inner[o];
                    let t = s;
                    let u = r;
                    while (o < b.bx.d) {
                        q = k.i$b._inner[o + 1];
                        u = k.i$d(q);
                        if (u - r > n) {
                            break;
                        }
                        o++;
                        let v = this.indicatorColumn._inner[o];
                        s = Math.min(s, v);
                        t = Math.max(t, v);
                    }
                    let w = NaN;
                    if (!isNaN_(r)) {
                        w = this.pz.ef(r, h);
                    }
                    p = [w, s, t];
                }
                if (!isNaN_(p[0])) {
                    if (this.pz != null && typeCast(ISortingAxis_$type, this.pz) !== null) {
                        p[0] = p[0] + j;
                    }
                    else {
                        p[0] = f.ef(p[0], h) + j;
                    }
                    p[1] = g.ef(p[1], i);
                    if (b.bx.b > 1 || k != null) {
                        p[2] = g.ef(p[2], i);
                    }
                    else {
                        p[2] = p[1];
                    }
                    a.f.add(p);
                }
            }
            return;
        }
        ko(a, b) {
            super.ko(a, b);
            let c = b;
            c.b8(a);
            if (c.b7) {
                c.b5.g$d();
            }
        }
        p9() {
            switch (this.tc) {
                case 1: return 1;
                case 2: return 1;
                case 0: return 12;
            }
            return 1;
        }
        ss(a, b) {
            super.ss(a, b);
            let c = typeCast(FinancialIndicatorView.$, b);
            let d = (e) => a.f._inner[e][0];
            let e = (f) => a.f._inner[f][1];
            if (c.b7) {
                c.b5.g$d();
                c.b5.g$g(a.p);
            }
            let f = b.bu;
            let g = this.getEffectiveViewport1(b);
            let h = 0;
            let i = this.oo;
            let j = this.s5;
            if (b.b0(a)) {
                c.b8(false);
                if (a.f.count > 0) {
                    switch (this.tc) {
                        case 0:
                            let k = CategorySeries.q6(a.f, a.f.count - 1, f, b.bv, false);
                            c.cc(a.f.count, d, e, true, k);
                            break;
                        case 1:
                            if (this.ql != null) {
                                h = this.ru(b);
                            }
                            else {
                                h = 0.5 * (f.top + f.bottom);
                            }
                            let l = CategorySeries.q6(a.f, a.f.count - 1, f, b.bv, false);
                            c.ca(a.f.count, d, e, true, h, l);
                            break;
                        case 2:
                            h = this.ru(b);
                            c.cb(a.f.count, d, e, true, h);
                            break;
                        default: throw new NotImplementedException(0);
                    }
                }
                b.b2(a);
            }
            let m = a.f;
            let n = this.ci.count;
            this.p8.a0(this, this.q7(), runOn(this, this.pr), this.rw(b), this.ry(b));
            let o = false;
            let p = this.p8.b;
            if (p != null) {
                o = true;
            }
            this.p8.ak = i;
            this.p8.ag = i;
            if (o) {
                let q = new ScalerParams(0, b.bv, b.bu, this.pz.cf, g);
                this.p8.f = false;
                this.sp(m, -1, n, this.pz, q, b.q);
            }
            this.p8.ad(c.cu, true, false, true, false);
            this.p8.ad(c.cw, true, false, true, false);
            this.p8.ad(c.cv, false, true, false, false);
            c.cv._opacity = 0.8 * this.p8.j * this.fk;
            this.p8.ad(c.ct, true, false, false, false);
            this.p8.ak = j;
            this.p8.ag = j;
            if (o) {
                let r = new ScalerParams(0, b.bv, b.bu, this.pz.cf, g);
                this.p8.f = true;
                this.sp(m, -1, n, this.pz, r, b.q);
            }
            this.p8.ad(c.cq, true, false, true, false);
            this.p8.ad(c.cs, true, false, true, false);
            this.p8.ad(c.cr, false, true, false, false);
            c.cr._opacity = 0.8 * this.p8.j * this.fk;
            this.p8.ad(c.cp, true, false, false, false);
            c.ce();
        }
        mk() {
            super.mk();
            if (this.hc < 0) {
                return;
            }
            if (this.ta.b7) {
                this.ta.cf();
            }
        }
        to() {
            if (this.ta.b7) {
                this.ta.b5.g$i();
            }
            this.td(0, this.indicatorColumn.count);
            if (this.ql != null && !this.ql.cy()) {
                this.l7(false);
            }
        }
        ky(a) {
            super.ky(a);
            this.a7.exportTrendlineData(this, a, this.ta.b5.g$j);
        }
        a9(a) {
            if (this.tc == 1 || this.tc == 2) {
                return 3;
            }
            else if (this.tc == 0) {
                return 2;
            }
            return a;
        }
    }
    FinancialIndicator.$t = /*@__PURE__*/ markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialIndicator.tq = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    FinancialIndicator.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:tc:tr', [IndicatorDisplayType_$type, /*@__PURE__*/ enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:ti:ts', [1, 0], 'TrendLineType::ty', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::tx', [1, 1.5], 'TrendLinePeriod::tw', [1, 7], 'TrendLineBrush::tt', [Brush.$, null], 'TrendLineZIndex:tj:tz', [1, 1001], 'TrendLineDashArray:t1:tu', [DoubleCollection.$], 'TrendLineDashCap:t2:tv', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialIndicator;
})();
/**
 * @hidden
 */
export let FinancialIndicatorBucketCalculator = /*@__PURE__*/ (() => {
    class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = a * this.b;
            let c = Math.min(b + this.b - 1, this.f.b3.indicatorColumn.count - 1);
            let d = NaN;
            let e = NaN;
            for (let f = b; f <= c; ++f) {
                let g = this.f.b3.indicatorColumn._inner[f];
                if (!isNaN_(d)) {
                    if (!isNaN_(g)) {
                        d = Math.min(d, g);
                        e = Math.max(e, g);
                    }
                }
                else {
                    d = g;
                    e = g;
                }
            }
            if (!isNaN_(d)) {
                return [0.5 * (b + c), d, e];
            }
            return [NaN, NaN, NaN];
        }
    }
    FinancialIndicatorBucketCalculator.$t = /*@__PURE__*/ markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
    return FinancialIndicatorBucketCalculator;
})();
/**
 * @hidden
 */
export let FinancialIndicatorView = /*@__PURE__*/ (() => {
    class FinancialIndicatorView extends FinancialSeriesView {
        constructor(a) {
            super(a);
            this.b3 = null;
            this.b6 = null;
            this.cu = ((() => {
                let $ret = new Path();
                $ret.ak = new PathGeometry();
                return $ret;
            })());
            this.cq = ((() => {
                let $ret = new Path();
                $ret.ak = new PathGeometry();
                return $ret;
            })());
            this.cv = ((() => {
                let $ret = new Path();
                $ret.ak = new PathGeometry();
                return $ret;
            })());
            this.cr = ((() => {
                let $ret = new Path();
                $ret.ak = new PathGeometry();
                return $ret;
            })());
            this.cw = ((() => {
                let $ret = new Path();
                $ret.ak = new PathGeometry();
                return $ret;
            })());
            this.cs = ((() => {
                let $ret = new Path();
                $ret.ak = new PathGeometry();
                return $ret;
            })());
            this.ct = ((() => {
                let $ret = new Path();
                $ret.ak = new GeometryGroup();
                return $ret;
            })());
            this.cp = ((() => {
                let $ret = new Path();
                $ret.ak = new GeometryGroup();
                return $ret;
            })());
            this.b4 = null;
            this.cm = new Path();
            this.co = new Path();
            this.cn = new Path();
            this.cl = new Path();
            this.ci = new Path();
            this.ck = new Path();
            this.cj = new Path();
            this.ch = new Path();
            this.b3 = a;
            this.b6 = ((() => {
                let $ret = new Pool$1(LineGeometry.$);
                $ret.create = runOn(this, this.cg);
                $ret.destroy = runOn(this, this.b9);
                return $ret;
            })());
        }
        by() {
            return new FinancialIndicatorBucketCalculator(this);
        }
        as() {
            super.as();
            if (!this.q) {
                this.b3.s5 = Defaults.ah;
                this.b3.tc = this.b3.tb;
            }
        }
        cg() {
            return new LineGeometry();
        }
        b9(a) {
        }
        get b5() {
            if (this.b4 == null) {
                this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.my, this.e, this.e.cl);
            }
            return this.b4;
        }
        set b5(a) {
            this.b4 = a;
        }
        get b7() {
            return this.b4 != null;
        }
        b8(a) {
            Extensions.e(this.cu.ak);
            Extensions.e(this.cv.ak);
            Extensions.e(this.cw.ak);
            Extensions.e(this.cq.ak);
            Extensions.e(this.cr.ak);
            Extensions.e(this.cs.ak);
            Extensions.d(this.ct.ak);
            Extensions.d(this.cp.ak);
            if (a) {
                this.b6.count = 0;
            }
            this.aq();
        }
        ce() {
        }
        cc(a, b, c, d, e) {
            IndicatorRenderer.g(a, b, c, d, this.bv, this.bu, this.cu, this.cq, this.bx.b, this.e.gk, e);
            this.aq();
        }
        ca(a, b, c, d, e, f) {
            IndicatorRenderer.e(a, b, c, d, this.bv, this.bu, this.cu, this.cv, this.cq, this.cr, e, this.bx.b, this.e.gk, f);
            this.aq();
        }
        cb(a, b, c, d, e) {
            IndicatorRenderer.f(a, b, c, d, this.bu, e, this.b6, this.ct, this.cp);
            this.aq();
        }
        cf() {
            this.b3.t0 = null;
            if (this.b3.trendLineBrush != null) {
                this.b3.t0 = this.b3.trendLineBrush;
            }
            else {
                this.b3.t0 = this.b3.oo;
            }
        }
        bc() {
            super.bc();
            let a = this.bo();
            this.cm.ak = this.cu.ak;
            this.co.ak = this.cw.ak;
            this.cn.ak = this.cv.ak;
            this.cl.ak = this.ct.ak;
            this.ci.ak = this.cq.ak;
            this.ck.ak = this.cs.ak;
            this.cj.ak = this.cr.ak;
            this.ch.ak = this.cp.ak;
            this.cm._stroke = a;
            this.co._stroke = a;
            this.cm.ac = this.e.fn + 3;
            this.co.ac = this.e.fn + 3;
            this.cn._fill = a;
            this.cn._opacity = 1;
            this.cl._stroke = a;
            this.cl.ac = this.e.fn + 3;
            this.ci._stroke = a;
            this.ck._stroke = a;
            this.ci.ac = this.e.fn + 3;
            this.ck.ac = this.e.fn + 3;
            this.cj._fill = a;
            this.cj._opacity = 1;
            this.ch._stroke = a;
            this.ch.ac = this.e.fn + 3;
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d) {
                if (b) {
                    if (this.b3.tc == 2) {
                        a.s(this.cl);
                        a.s(this.ch);
                    }
                    else {
                        a.s(this.cn);
                        a.s(this.cm);
                        a.s(this.co);
                        a.s(this.cj);
                        a.s(this.ci);
                        a.s(this.ck);
                    }
                }
                else {
                    if (this.b3.tc == 2) {
                        a.s(this.ct);
                        a.s(this.cp);
                    }
                    else {
                        a.s(this.cv);
                        a.s(this.cu);
                        a.s(this.cw);
                        a.s(this.cr);
                        a.s(this.cq);
                        a.s(this.cs);
                    }
                }
            }
        }
        a5(a, b) {
            if (a.d) {
                if (this.b3.trendLineType != 0 && !b) {
                    let c = this.b5.g$j;
                    c.ac = this.b3.trendLineThickness;
                    c._stroke = this.b3.t0;
                    c.ad = this.b3.t2;
                    c.ai = this.b3.t1;
                    a.u(c);
                }
            }
            super.a5(a, b);
        }
        al(a) {
            super.al(a);
            this.e.a7.exportPathData(a, this.ct, "positiveColumnsShape", ["Positive", "Main"]);
            this.e.a7.exportPathData(a, this.cp, "negativeColumnsShape", ["Negative"]);
            this.e.a7.exportPathData(a, this.cu, "positive0", ["Positive", "Main"]);
            this.e.a7.exportPathData(a, this.cw, "positive1", ["Positive"]);
            this.e.a7.exportPathData(a, this.cv, "positive01", ["PositiveFill"]);
            this.e.a7.exportPathData(a, this.cq, "negative0", ["Negative", "Main"]);
            this.e.a7.exportPathData(a, this.cs, "negative1", ["Negative"]);
            this.e.a7.exportPathData(a, this.cr, "negative01", ["NegativeFill"]);
        }
        cd() {
            if (this.b7) {
                this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.my, this.e, this.e.cl);
            }
        }
    }
    FinancialIndicatorView.$t = /*@__PURE__*/ markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
    return FinancialIndicatorView;
})();
