/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { TrendLineType_$type } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { PriceDisplayType_$type } from "./PriceDisplayType";
import { enumGetBox, EnumUtil, typeCast, fromEnum, runOn, Point_$type, markType, markDep } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { RectUtil } from "igniteui-react-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { AxisRange } from "./AxisRange";
import { ScalerParams } from "./ScalerParams";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { Pool$1 } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { PathFigure } from "igniteui-react-core";
import { LineSegment } from "igniteui-react-core";
import { GeometryGroup } from "igniteui-react-core";
import { LineGeometry } from "igniteui-react-core";
import { RectangleGeometry } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { boxArray$1 } from "igniteui-react-core";
import { FinancialPriceBucketCalculator } from "./FinancialPriceBucketCalculator";
import { Defaults } from "./Defaults";
import { Extensions } from "igniteui-react-core";
/**
 * @hidden
 */
export let FinancialPriceSeries = /*@__PURE__*/ (() => {
    class FinancialPriceSeries extends FinancialSeries {
        constructor() {
            super();
            this.ab = FinancialPriceSeries.$;
            this.p3 = new CategoryFrame(5);
            this.p5 = new CategoryFrame(5);
            this.p1 = new CategoryFrame(5);
        }
        get_dn() {
            return true;
        }
        bv() {
            return new FinancialPriceSeriesView(this);
        }
        lo(a) {
            super.lo(a);
            this.ta = a;
        }
        get tu() {
            return this.c(FinancialPriceSeries.tk);
        }
        set tu(a) {
            this.h(FinancialPriceSeries.tk, a);
        }
        kr(a, b, c, d) {
            super.kr(a, b, c, d);
            if (this.pz != null && typeCast(ISortingAxis_$type, this.pz) !== null) {
                this.pz.i$i();
            }
            this.ta.bx.e(this.gk);
            if (this.ta.b7) {
                this.ta.b5.g$e(a, b, c, d);
            }
            if (this.ql != null) {
                this.ql.cy();
            }
            this.l7(true);
        }
        bp() {
            if (this.bq == 0) {
                return 1;
            }
            else {
                return super.bp();
            }
        }
        pk(a) {
            if (this.p1 == null || this.p1.f.count == 0) {
                return Rect.empty;
            }
            let b = this.o6(a);
            let c = this.by.bv;
            let d = this.by.bu;
            let e = this.getEffectiveViewport1(this.by);
            let f = this.aj(this.pz, this.p1.f, this.rw(this.by), this.ry(this.by), a, true);
            let g = f[0];
            let h = f[1];
            let i = Math.abs(b.x - g[0]);
            let j = Math.abs(b.x - h[0]);
            let k = this.tc(this.qg, e);
            k = Math.max(k, 3);
            let l = (k - 1) / 2;
            if (i < j) {
                let m = g[0] - l;
                let n = g[0];
                let o = g[0] + l;
                let p = g[1];
                let q = g[2];
                let r = g[3];
                let s = g[4];
                let t = Math.min(Math.min(Math.min(p, q), r), s);
                let u = Math.max(Math.max(Math.max(p, q), r), s);
                return new Rect(0, m, t, Math.abs(o - m), u - t);
            }
            else {
                let v = h[0] - l;
                let w = h[0];
                let x = h[0] + l;
                let y = h[1];
                let z = h[2];
                let aa = h[3];
                let ab = h[4];
                let ac = Math.min(Math.min(Math.min(y, z), aa), ab);
                let ad = Math.max(Math.max(Math.max(y, z), aa), ab);
                return new Rect(0, v, ac, Math.abs(x - v), ad - ac);
            }
        }
        s9(a, b) {
            let c = a[0] - b;
            let d = a[0];
            let e = a[0] + b;
            let f = a[1];
            let g = a[2];
            let h = a[3];
            let i = a[4];
            let j = Math.min(Math.min(Math.min(f, g), h), i);
            let k = Math.max(Math.max(Math.max(f, g), h), i);
            let l = Math.min(g, h);
            let m = Math.max(g, h);
            let n = Math.min(f, i);
            let o = Math.max(f, i);
            if (this.tb == 1) {
                let p = new Array(3);
                let q = new Rect(0, c, f, b, 0);
                let r = new Rect(0, d, i, b, 0);
                let s = new Rect(0, d, l, 0, m - l);
                p[0] = q;
                p[1] = r;
                p[2] = s;
                return p;
            }
            else {
                let t = new Array(2);
                let u = new Rect(0, d, l, 0, m - l);
                let v = new Rect(0, c, n, b * 2, o - n);
                t[0] = u;
                t[1] = v;
                return t;
            }
        }
        ak(a) {
            let b = new List$1(Rect.$, 0);
            let c = this.o6(a);
            let d = this.by.bv;
            let e = this.by.bu;
            let f = this.getEffectiveViewport1(this.by);
            let g = this.aj(this.pz, this.p1.f, this.rw(this.by), this.ry(this.by), a, true);
            let h = g[0];
            let i = g[1];
            let j = Math.abs(c.x - h[0]);
            let k = Math.abs(c.x - i[0]);
            let l = this.tc(this.qg, f);
            l = Math.max(l, 3);
            let m = (l - 1) / 2;
            if (j < k) {
                return this.s9(h, m);
            }
            else {
                return this.s9(i, m);
            }
        }
        er(a, b) {
            if (this.eu(a, b)) {
                return true;
            }
            return false;
        }
        eu(a, b) {
            let c = this.pl(a);
            if (c.isEmpty) {
                return false;
            }
            let d = RectUtil.r(c, (this.fn / 2) + this.f1(b));
            if (d.containsPoint(a)) {
                let e = this.al(a);
                if (e != null) {
                    for (let f = 0; f < e.length; f++) {
                        let g = e[f];
                        let h = RectUtil.r(g, (this.fn / 2) + this.f1(b));
                        if (h.containsPoint(a)) {
                            return true;
                        }
                    }
                }
            }
            return false;
        }
        lt(a, b, c, d) {
            switch (b) {
                case FinancialSeries.$$p[9]:
                    this.ta.cd();
                    if (this.cb != null) {
                        this.cb.la();
                    }
                    break;
                case "TrendLineType":
                    let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                    if (e != 0) {
                        this.ta.b5 = CategoryTrendLineManagerFactory.a(this.ta.b5, this.pz, this.my, this, this.cl);
                    }
                    break;
            }
            super.lt(a, b, c, d);
            if (this.ta.b7 && this.ta.b5 != null && this.ta.b5.g$b(a, b, c, d)) {
                this.l7(false);
                this.le();
            }
            switch (b) {
                case FinancialPriceSeries.$$p[0]:
                    if (this.my != null) {
                        this.tj();
                        this.ml();
                        this.p1.w();
                        this.ss(this.p1, this.ta);
                    }
                    this.le();
                    break;
                case "ActualHighlightingMode":
                    this.l7(true);
                    break;
                case "TrendLineBrush":
                    this.mk();
                    break;
                case "TrendLineType":
                    this.le();
                    break;
                case FinancialSeries.$$p[5]:
                case FinancialPriceSeries.$$p[1]:
                    this.lq();
                    break;
            }
        }
        tj() {
            this.ta.ch();
            if (this.bx != null) {
                this.bx.ch();
            }
        }
        ap(a) {
            if (a != null && a == this.ql && this.qu != null && !isNaN_(this.qu.minimum) && this.qt != null && !isNaN_(this.qt.maximum)) {
                return new AxisRange(this.qu.minimum, this.qt.maximum);
            }
            return null;
        }
        aq(a) {
            if (a.isEmpty && this.cb != null) {
                a = this.cb.r0;
            }
            if (this.qu == null || this.qt == null) {
                return null;
            }
            let b = this.pg(this.by);
            let c = new ScalerParams(0, a, this.cb.sf, this.pz.cf, this.getEffectiveViewport());
            let d = (this.pz.ei(b.left, c));
            let e = (this.pz.ei(b.right, c));
            if (this.pz.cf) {
                let f = d;
                d = e;
                e = f;
            }
            let g = null;
            if (this.pz.ck) {
                g = this.pz;
                d = g.i$f(d);
                e = g.i$f(e);
            }
            else {
                d = Math.floor(d);
                e = Math.ceil(e);
            }
            d = Math.max(0, Math.min(this.qu.count - 1, d));
            e = Math.max(0, Math.min(this.qu.count - 1, e));
            let h = 1.7976931348623157E+308;
            let i = -1.7976931348623157E+308;
            for (let j = truncate(d); j <= truncate(e); j++) {
                let k = j;
                if (g != null) {
                    k = g.i$b._inner[j];
                }
                let l = this.qu.item(k);
                if (this.qu.mayContainUnknowns) {
                    if (isInfinity(l) || isNaN_(l)) {
                        continue;
                    }
                }
                let m = this.qt.item(k);
                if (this.qt.mayContainUnknowns) {
                    if (isInfinity(m) || isNaN_(m)) {
                        continue;
                    }
                }
                h = Math.min(h, l);
                i = Math.max(i, m);
            }
            let n = new AxisRange(h, i);
            n = this.ao(n, this.ql, a);
            return n;
        }
        f4() {
            return Series.f5(this.qv, typeCast(ISortingAxis_$type, this.pz));
        }
        ej(a) {
            let b = this.ci != null ? this.ci.indexOf(a) : -1;
            let c = this.by.bv;
            c = c.copy();
            let d = this.by.bu;
            let e = new Rect(0, 0, 0, 1, 1);
            let f = this.pi(this.by);
            if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
                if (this.pz != null) {
                    let g = new ScalerParams(0, e, e, this.pz.cf, f);
                    let h = this.pz.ef(b, g);
                    if (h < c.left + 0.1 * c.width) {
                        h = h + 0.4 * c.width;
                    }
                    if (h > c.right - 0.1 * c.width) {
                        h = h - 0.4 * c.width;
                    }
                    c.x = h - 0.5 * c.width;
                }
                if (this.ql != null && this.qu != null && this.qt != null && b < this.qu.count && b < this.qt.count) {
                    let i = new ScalerParams(0, e, e, this.ql.cf, f);
                    i.b = this.f4();
                    let j = this.ql.ef(this.qu.item(b), i);
                    let k = this.ql.ef(this.qt.item(b), i);
                    if (!isNaN_(j) && !isNaN_(k)) {
                        let l = Math.abs(j - k);
                        if (c.height < l) {
                            c.height = l;
                            c.y = Math.min(j, k);
                        }
                        else {
                            if (j < c.top + 0.1 * c.height) {
                                j = j + 0.4 * c.height;
                            }
                            if (j > c.bottom - 0.1 * c.height) {
                                j = j - 0.4 * c.height;
                            }
                            c.y = j - 0.5 * c.height;
                        }
                    }
                }
                this.b6.au(this.cb, c, true);
            }
            return b >= 0;
        }
        e5(a, b, c) {
            let d = super.e5(a, b, c);
            if (this.qv == null || this.qs == null || this.qt == null || this.qu == null) {
                d = false;
            }
            return d;
        }
        sq(a, b) {
            super.sq(a, b);
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.pz;
            let g = this.ql;
            let h = new ScalerParams(0, c, d, f.cf, e);
            let i = ((() => {
                let $ret = new ScalerParams(0, c, d, g.cf, e);
                $ret.b = this.f4();
                return $ret;
            })());
            a.f.clear();
            a.m.clear();
            a.p.clear();
            let j = 0;
            let k = typeCast(ISortingAxis_$type, this.pz);
            if (k != null && (k.i$b == null || k.i$b.count != this.ci.count)) {
                return;
            }
            j = this.rq(c, d, e);
            let l = typeCast(FinancialPriceSeriesView.$, b);
            let m = this.gk;
            if (this.trendLineType != 0) {
                let n = new Array(this.ci.count);
                let o = 0;
                for (let p of fromEnum(this.rh)) {
                    n[o] = p;
                    o++;
                }
                if (this.ta.b7) {
                    this.ta.b5.prepareLineCore(a.p, this.trendLineType, boxArray$1(n), this.trendLinePeriod, (q) => this.pz.ef(q, h), (q) => this.ql.ef(q, i), ((() => {
                        let $ret = new TrendResolutionParams();
                        $ret.c = b.bx.b;
                        $ret.d = b.bx.c;
                        $ret.e = b.bx.d;
                        $ret.a = j;
                        $ret.b = m;
                        $ret.f = d;
                        return $ret;
                    })()));
                }
            }
            let q = this.pz.ei(2, h) - this.pz.ei(1, h);
            for (let r = b.bx.c; r <= b.bx.d; ++r) {
                let s;
                if (k == null) {
                    s = b.bx.getBucket(r);
                }
                else {
                    let t = k.i$b._inner[r];
                    let u = k.i$d(t);
                    let v = this.qv.item(t);
                    let w = this.qt.item(t);
                    let x = this.qu.item(t);
                    let y = this.qs.item(t);
                    let z = v;
                    let aa = w;
                    let ab = x;
                    let ac = y;
                    let ad = u;
                    while (r < b.bx.d) {
                        t = k.i$b._inner[r + 1];
                        ad = k.i$d(t);
                        if (ad - u > q * m) {
                            break;
                        }
                        r++;
                        aa = Math.max(aa, this.qt.item(t));
                        ab = Math.min(ab, this.qu.item(t));
                        ac = this.qs.item(t);
                    }
                    let ae = NaN;
                    if (!isNaN_(u)) {
                        ae = this.pz.ef(u, h);
                    }
                    s = [ae, z, aa, ab, ac];
                }
                if (!isNaN_(s[0])) {
                    if (k != null) {
                        s[0] = s[0] + j;
                    }
                    else {
                        s[0] = f.ef(s[0], h) + j;
                    }
                    s[1] = g.ef(s[1], i);
                    s[2] = g.ef(s[2], i);
                    s[3] = g.ef(s[3], i);
                    s[4] = g.ef(s[4], i);
                    a.f.add(s);
                }
            }
            return;
        }
        ko(a, b) {
            super.ko(a, b);
            let c = typeCast(FinancialPriceSeriesView.$, b);
            c.cb();
            if (a) {
                c.b6.count = 0;
            }
            if (c.b7 && c.b5 != null) {
                c.b5.g$d();
            }
        }
        mt(a, b) {
            super.mt(a, b);
            if (this.cb != null) {
                this.cb.la();
            }
        }
        pp() {
            if (this.pz != null && this.pz.categoryMode == 0) {
                let a = this.getEffectiveViewport1(this.by);
                let b = this.tc(this.qg, a) / 2;
                return new Thickness(1, b, 0, b, 0);
            }
            return super.pp();
        }
        get_cz() {
            return true;
        }
        ss(a, b) {
            super.ss(a, b);
            if (this.pz == null || this.ql == null) {
                return;
            }
            let c = false;
            if (b.b0(a)) {
                c = true;
                b.b2(a);
            }
            this.p8.a0(this, this.q7(), runOn(this, this.pr), this.rw(b), this.ry(b));
            let d = false;
            let e = this.p8.b;
            if (e != null) {
                d = true;
            }
            let f = typeCast(FinancialPriceSeriesView.$, b);
            f.ca();
            f.b8 = false;
            if (f.b7) {
                f.b5.g$d();
            }
            if (this.trendLineType != 0) {
                f.b5.g$g(a.p);
            }
            if (d) {
                this.ti(a, b, c);
            }
            else {
                f.b6.count = 0;
                this.th(a, b);
            }
        }
        f3() {
            let a = this.getEffectiveViewport1(this.by);
            return this.tc(this.qg, a);
        }
        ti(a, b, c) {
            let d = this.tb;
            let e = this.getEffectiveViewport1(b);
            let f = this.tc(b, e);
            let g = (f - 1) / 2;
            let h = typeCast(FinancialPriceSeriesView.$, b);
            h.b8 = true;
            let i = a.f;
            let j = 0;
            let k = this.ci.count;
            let l = this.pz;
            let m = new ScalerParams(0, b.bv, b.bu, l.cf, e);
            let n = this.oo;
            let o = this.s5;
            if (o == null) {
                o = n;
            }
            let p = this.or;
            let q = this.tv;
            if (q == null) {
                q = p;
            }
            for (let r = 0; r < i.count; ++r) {
                let s = i._inner[r][0] - g;
                let t = i._inner[r][0];
                let u = i._inner[r][0] + g;
                let v = i._inner[r][1];
                let w = i._inner[r][2];
                let x = i._inner[r][3];
                let y = i._inner[r][4];
                if (isNaN_(v) || isNaN_(w) || isNaN_(x) || isNaN_(y)) {
                    continue;
                }
                let z = h.b6.item(j);
                j++;
                let aa = v < y;
                let ab = new PathGeometry();
                if (c) {
                    switch (d) {
                        case 0:
                            if (aa) {
                                let ac = v;
                                v = y;
                                y = ac;
                            }
                            let ad = new PathFigure();
                            ad._startPoint = { $type: Point_$type, x: t, y: x };
                            ad._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: t, y: v };
                                return $ret;
                            })()));
                            let ae = new PathFigure();
                            ae._startPoint = { $type: Point_$type, x: s, y: y };
                            ae._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: u, y: y };
                                return $ret;
                            })()));
                            ae._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: u, y: v };
                                return $ret;
                            })()));
                            ae._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: s, y: v };
                                return $ret;
                            })()));
                            ae._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: s, y: y };
                                return $ret;
                            })()));
                            let af = new PathFigure();
                            af._startPoint = { $type: Point_$type, x: t, y: y };
                            af._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: t, y: w };
                                return $ret;
                            })()));
                            ab.c.add(ad);
                            ab.c.add(ae);
                            ab.c.add(af);
                            break;
                        case 1:
                            let ag = new PathFigure();
                            ag._startPoint = { $type: Point_$type, x: s, y: v };
                            ag._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: t, y: v };
                                return $ret;
                            })()));
                            let ah = new PathFigure();
                            ah._startPoint = { $type: Point_$type, x: t, y: x };
                            ah._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: t, y: w };
                                return $ret;
                            })()));
                            let ai = new PathFigure();
                            ai._startPoint = { $type: Point_$type, x: t, y: y };
                            ai._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: u, y: y };
                                return $ret;
                            })()));
                            ab.c.add(ag);
                            ab.c.add(ah);
                            ab.c.add(ai);
                            break;
                    }
                }
                if (aa) {
                    this.p8.ak = o;
                    this.p8.ag = o;
                    this.p8.ah = q;
                    this.p8.al = q;
                    this.p8.f = true;
                }
                else {
                    this.p8.ak = n;
                    this.p8.ag = n;
                    this.p8.ah = p;
                    this.p8.al = p;
                    this.p8.f = false;
                }
                this.sp(i, r, k, l, m, b.q);
                if (d == 1) {
                    this.p8.ad(z, true, false, false, false);
                }
                else {
                    this.p8.ad(z, false, false, false, false);
                }
                if (c) {
                    z.ak = ab;
                }
            }
            h.b6.count = j;
            h.cc();
        }
        tc(a, b) {
            let c = this.pz.ky(a.bv, a.bu, b);
            c = Math.max(c, this.gk * 0.9);
            c = Math.max(c, 3);
            return c;
        }
        th(a, b) {
            let c = this.tb;
            let d = this.getEffectiveViewport1(b);
            let e = this.tc(b, d);
            let f = (e - 1) / 2;
            let g = typeCast(FinancialPriceSeriesView.$, b);
            let h = g.ck();
            let i = g.cj();
            let j = a.f;
            for (let k = 0; k < j.count; ++k) {
                let l = j._inner[k][0] - f;
                let m = j._inner[k][0];
                let n = j._inner[k][0] + f;
                let o = j._inner[k][1];
                let p = j._inner[k][2];
                let q = j._inner[k][3];
                let r = j._inner[k][4];
                if (isNaN_(o) || isNaN_(p) || isNaN_(q) || isNaN_(r)) {
                    continue;
                }
                let s = o < r;
                let t = s ? i : h;
                switch (c) {
                    case 0:
                        if (s) {
                            let u = o;
                            o = r;
                            r = u;
                        }
                        t.d.add(((() => {
                            let $ret = new LineGeometry();
                            $ret.d = { $type: Point_$type, x: m, y: q };
                            $ret.c = { $type: Point_$type, x: m, y: o };
                            return $ret;
                        })()));
                        t.d.add(((() => {
                            let $ret = new RectangleGeometry();
                            $ret.e = new Rect(0, l, r, n - l, o - r);
                            return $ret;
                        })()));
                        t.d.add(((() => {
                            let $ret = new LineGeometry();
                            $ret.d = { $type: Point_$type, x: m, y: r };
                            $ret.c = { $type: Point_$type, x: m, y: p };
                            return $ret;
                        })()));
                        break;
                    case 1:
                        t.d.add(((() => {
                            let $ret = new LineGeometry();
                            $ret.d = { $type: Point_$type, x: l, y: o };
                            $ret.c = { $type: Point_$type, x: m, y: o };
                            return $ret;
                        })()));
                        t.d.add(((() => {
                            let $ret = new LineGeometry();
                            $ret.d = { $type: Point_$type, x: m, y: q };
                            $ret.c = { $type: Point_$type, x: m, y: p };
                            return $ret;
                        })()));
                        t.d.add(((() => {
                            let $ret = new LineGeometry();
                            $ret.d = { $type: Point_$type, x: m, y: r };
                            $ret.c = { $type: Point_$type, x: n, y: r };
                            return $ret;
                        })()));
                        break;
                }
            }
        }
        hq(a, b) {
            if (this.ta.b7 && a == this.ta.b5.g$j) {
                return null;
            }
            return super.hq(a, b);
        }
        mk() {
            super.mk();
            if (this.hc < 0) {
                return;
            }
            this.ta.ci();
        }
        ky(a) {
            super.ky(a);
            if (this.ta.b7) {
                this.a7.exportTrendlineData(this, a, this.ta.b5.g$j);
            }
        }
        oz() {
            return this.tv;
        }
        mc(a, b) {
            super.mc(a, b);
            this.tv = b;
        }
        a9(a) {
            if (this.tb == 0) {
                return 3;
            }
            else if (this.tb == 1) {
                return 2;
            }
            return a;
        }
    }
    FinancialPriceSeries.$t = /*@__PURE__*/ markType(FinancialPriceSeries, 'FinancialPriceSeries', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialPriceSeries.tk = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialPriceSeries.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    FinancialPriceSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, FinancialPriceSeries, 'raisePropertyChanged', ['DisplayType:tb:tl', [PriceDisplayType_$type, /*@__PURE__*/ enumGetBox(PriceDisplayType_$type, 0)], 'NegativeOutline:tv:tm', [Brush.$, null], 'TrendLineType::ts', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::tr', [1, 1.5], 'TrendLinePeriod::tq', [1, 7], 'TrendLineBrush::tn', [Brush.$, null], 'TrendLineZIndex:te:tt', [1, 1001], 'TrendLineDashArray:tw:to', [DoubleCollection.$], 'TrendLineDashCap:tx:tp', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialPriceSeries;
})();
/**
 * @hidden
 */
export let FinancialPriceSeriesView = /*@__PURE__*/ (() => {
    class FinancialPriceSeriesView extends FinancialSeriesView {
        constructor(a) {
            super(a);
            this.b3 = null;
            this.b6 = null;
            this.b9 = null;
            this.cn = ((() => {
                let $ret = new Path();
                $ret.ak = new GeometryGroup();
                return $ret;
            })());
            this.cm = ((() => {
                let $ret = new Path();
                $ret.ak = new GeometryGroup();
                return $ret;
            })());
            this.b4 = null;
            this.cl = new Path();
            this.b8 = false;
            this.b3 = a;
            this.b9 = new List$1(Path.$, 0);
            this.b6 = ((() => {
                let $ret = new Pool$1(Path.$);
                $ret.create = runOn(this, this.co);
                $ret.activate = runOn(this, this.ce);
                $ret.disactivate = runOn(this, this.cg);
                $ret.destroy = runOn(this, this.cf);
                return $ret;
            })());
        }
        co() {
            let a = new Path();
            this.b9.add(a);
            a._visibility = 1;
            return a;
        }
        ce(a) {
            a._visibility = 0;
        }
        cg(a) {
            a._visibility = 1;
        }
        cf(a) {
            this.b9.remove(a);
        }
        by() {
            return new FinancialPriceBucketCalculator(this);
        }
        as() {
            super.as();
            if (!this.q) {
                this.b3.tb = Defaults.g;
                this.b3.s5 = Defaults.ah;
                this.b3.tv = Defaults.ai;
                this.b3.gk = Defaults.k;
                this.b3.gp = Defaults.l;
                this.b3.ox = this.b3.or;
            }
        }
        get b5() {
            if (this.b4 == null) {
                this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.my, this.e, this.e.cl);
            }
            return this.b4;
        }
        set b5(a) {
            this.b4 = a;
        }
        get b7() {
            return this.b4 != null;
        }
        ch() {
            if (this.b3.tb == 1) {
                this.cn._stroke = this.e.oo;
            }
            else {
                this.cn._stroke = this.e.or;
            }
            if (this.b3.tb == 1) {
                this.cm._stroke = this.bz.s5;
            }
            else {
                this.cm._stroke = this.b3.tv;
            }
        }
        cb() {
            this.aq();
            this.b6.count = 0;
            this.ca();
        }
        ca() {
            let a = typeCast(GeometryGroup.$, this.cn.ak);
            let b = typeCast(GeometryGroup.$, this.cm.ak);
            Extensions.d(a);
            Extensions.d(b);
        }
        ck() {
            this.aq();
            return typeCast(GeometryGroup.$, this.cn.ak);
        }
        cj() {
            this.aq();
            return typeCast(GeometryGroup.$, this.cm.ak);
        }
        ci() {
            this.b3.tu = null;
            if (this.b3.trendLineBrush != null) {
                this.b3.tu = this.b3.trendLineBrush;
            }
            else {
                this.b3.tu = this.b3.oo;
            }
        }
        bb() {
            super.bb();
            this.cn.ac = this.e.fn;
            this.cn.ai = this.e.o1;
            this.cn.ad = this.e.o2;
            if (this.b3.tb == 1) {
                this.cn._stroke = this.e.oo;
            }
            else {
                this.cn._stroke = this.e.or;
                this.cn._fill = this.e.oo;
            }
            this.cm.ac = this.e.fn;
            this.cm.ai = this.e.o1;
            this.cm.ad = this.e.o2;
            if (this.b3.tb == 1) {
                this.cm._stroke = this.bz.s5;
            }
            else {
                this.cm._stroke = this.b3.tv;
                this.cm._fill = this.bz.s5;
            }
        }
        bc() {
            super.bc();
            let a = this.bo();
            this.cn.ac = this.e.fn + 3;
            if (this.b3.tb == 1) {
                this.cn._stroke = a;
            }
            else {
                this.cn._stroke = a;
                this.cn._fill = a;
            }
            this.cm.ac = this.e.fn + 3;
            if (this.b3.tb == 1) {
                this.cm._stroke = a;
            }
            else {
                this.cm._stroke = a;
                this.cm._fill = a;
            }
        }
        ac(a) {
            return this.b9._inner[a];
        }
        ab(a) {
            let b = this.b9._inner[a];
            this.cl._visibility = b._visibility;
            this.cl.ak = b.ak;
            let c = this.bp(a);
            this.cl._fill = c;
            this.cl._stroke = c;
            this.cl.ac = this.e.fn + 3;
            return this.cl;
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d) {
                if (this.b8) {
                    for (let c = 0; c < this.b9.count; c++) {
                        let d = this.aa(c, b);
                        if (d._visibility == 0) {
                            a.s(d);
                        }
                    }
                }
                else {
                    a.s(this.cn);
                    a.s(this.cm);
                }
            }
        }
        a5(a, b) {
            if (a.d) {
                if (this.b3.trendLineType != 0 && !b) {
                    let c = this.b5.g$j;
                    c.ac = this.b3.trendLineThickness;
                    c._stroke = this.b3.tu;
                    c.ai = this.b3.tw;
                    c.ad = this.b3.tx;
                    a.u(c);
                }
            }
            super.a5(a, b);
        }
        al(a) {
            super.al(a);
            if (this.b3.q7()) {
                for (let b = 0; b < this.b9.count; b++) {
                    let c = this.b9._inner[b];
                    if (c._fill == this.b3.s5) {
                        this.e.a7.exportPathData(a, c, "negativePathShape" + b, ["Negative"]);
                    }
                    else {
                        this.e.a7.exportPathData(a, c, "positivePathShape" + b, ["Positive", "Main"]);
                    }
                }
            }
            else {
                this.e.a7.exportPathData(a, this.cn, "positivePathShape", ["Positive", "Main"]);
                this.e.a7.exportPathData(a, this.cm, "negativePathShape", ["Negative"]);
            }
        }
        cc() {
            this.aq();
        }
        cd() {
            if (this.b7) {
                this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.my, this.e, this.e.cl);
            }
        }
    }
    FinancialPriceSeriesView.$t = /*@__PURE__*/ markType(FinancialPriceSeriesView, 'FinancialPriceSeriesView', FinancialSeriesView.$);
    return FinancialPriceSeriesView;
})();
