/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Color } from "igniteui-react-core";
import { ScatterFrame } from "./ScatterFrame";
import { Defaults } from "./Defaults";
import { KDTree2D } from "./KDTree2D";
import { typeGetValue, runOn, delegateRemove, typeCast, delegateCombine, markType, markDep, toNullable } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { KDPointData } from "./KDPointData";
import { ScalerParams } from "./ScalerParams";
import { ProgressiveLoadStatusEventArgs } from "./ProgressiveLoadStatusEventArgs";
import { SearchArgs } from "./SearchArgs";
import { KDTreeNode2D } from "./KDTreeNode2D";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity, logBase, intDivide } from "igniteui-react-core";
import { boxArray$1, arrayShallowClone } from "igniteui-react-core";
import { dateNow } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
/**
 * @hidden
 */
export let HighDensityScatterSeries = /*@__PURE__*/ (() => {
    class HighDensityScatterSeries extends Series {
        constructor() {
            super();
            this.p4 = null;
            this.p6 = null;
            this.rf = 0;
            this.p8 = false;
            this.qu = Defaults.aq.o;
            this.qt = Defaults.aq.n;
            this.qs = Defaults.aq.m;
            this.qr = Defaults.aq.l;
            this.qq = Defaults.ap.o;
            this.qp = Defaults.ap.n;
            this.qo = Defaults.ap.m;
            this.qn = Defaults.ap.l;
            this.pw = null;
            this.p1 = null;
            this.p2 = null;
            this.px = null;
            this.pz = null;
            this.qa = false;
            this.rg = 0;
            this.ri = 0;
            this.rc = 0;
            this.rb = 0;
            this.progressiveLoadStatusChanged = null;
            this.qf = null;
            this.ql = 0;
            this.qk = 0;
            this.qm = 0;
            this.q1 = 0;
            this.qz = 0;
            this.q0 = 0;
            this.q2 = 0;
            this.q4 = 0;
            this.q6 = 0;
            this.q5 = 0;
            this.q3 = 0;
            this.qh = 0;
            this.qi = 0;
            this.qj = 0;
            this.qg = 0;
            this.re = 0;
            this.rd = 0;
            this.pt = null;
            this.rh = 0;
            this.p9 = false;
            this._itemIndexes = null;
            this.pu = null;
            this.pr = null;
            this.p3 = null;
            this.ab = HighDensityScatterSeries.$;
            this.eh = false;
        }
        get_d1() {
            return true;
        }
        get_d8() {
            return true;
        }
        get p5() {
            return this.p4;
        }
        set p5(a) {
            if (this.p4 != a) {
                let b = this.p5;
                this.p4 = a;
                this.raisePropertyChanged("XColumn", b, this.p5);
            }
        }
        hn(a, b) {
            let c = this.jf(b);
            if (c == HighDensityScatterSeries.$$p[8]) {
                return this.ho(a, b, this.rx);
            }
            if (c == HighDensityScatterSeries.$$p[10]) {
                return this.ho(a, b, this.r1);
            }
            return super.hn(a, b);
        }
        get p7() {
            return this.p6;
        }
        set p7(a) {
            if (this.p6 != a) {
                let b = this.p7;
                this.p6 = a;
                this.raisePropertyChanged("YColumn", b, this.p7);
            }
        }
        sg() {
            if (this.pw == null) {
                return;
            }
            this.pw.s();
            let a = this.pw;
            a.progressiveThunkCompleted = delegateRemove(a.progressiveThunkCompleted, runOn(this, this.r3));
            this.pw = null;
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    if (this.cb != null) {
                        let e = this.getEffectiveViewport1(this.by);
                        this.p9 = !e.isEmpty;
                    }
                    break;
                case "FastItemsSource":
                    this.sg();
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.p5);
                        c.deregisterColumn(this.p7);
                        this.p5 = null;
                        this.p7 = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.p5 = this.cf(this.rx);
                        this.p7 = this.cf(this.r1);
                    }
                    if ((this.p0 != null && !this.p0.cy()) || (this.py != null && !this.py.cy())) {
                        this.l7(false);
                    }
                    this.lf();
                    break;
                case HighDensityScatterSeries.$$p[7]:
                    let f = this.px;
                    this.px = this.py;
                    this.sg();
                    if (f != null) {
                        f.rangeChanged = delegateRemove(f.rangeChanged, runOn(this, this.r6));
                    }
                    if (this.px != null) {
                        let g = this.px;
                        g.rangeChanged = delegateCombine(g.rangeChanged, runOn(this, this.r6));
                    }
                    if (c != null) {
                        c.by(this);
                    }
                    if (d != null) {
                        d.cq(this);
                    }
                    if ((this.py != null && !this.py.cy()) || (d == null && c != null)) {
                        this.l7(false);
                    }
                    break;
                case HighDensityScatterSeries.$$p[9]:
                    let h = this.pz;
                    this.pz = this.p0;
                    this.sg();
                    if (h != null) {
                        h.rangeChanged = delegateRemove(h.rangeChanged, runOn(this, this.r6));
                    }
                    if (this.pz != null) {
                        let i = this.pz;
                        i.rangeChanged = delegateCombine(i.rangeChanged, runOn(this, this.r6));
                    }
                    if (c != null) {
                        c.by(this);
                    }
                    if (d != null) {
                        d.cq(this);
                    }
                    if ((this.p0 != null && !this.p0.cy()) || (d == null && c != null)) {
                        this.l7(false);
                    }
                    break;
                case "MouseOverEnabled":
                    this.qa = this.eh;
                    this.l7(false);
                    break;
                case HighDensityScatterSeries.$$p[8]:
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.p5);
                        this.p5 = this.cf(this.rx);
                    }
                    break;
                case "XColumn":
                    this.sg();
                    if (this.py != null && !this.py.cy()) {
                        this.l7(false);
                    }
                    this.lf();
                    break;
                case HighDensityScatterSeries.$$p[10]:
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.p7);
                        this.p7 = this.cf(this.r1);
                    }
                    break;
                case "YColumn":
                    this.sg();
                    if (this.p0 != null && !this.p0.cy()) {
                        this.l7(false);
                    }
                    this.lf();
                    break;
                case HighDensityScatterSeries.$$p[6]:
                    this.sg();
                    this.l7(false);
                    this.le();
                    break;
                case HighDensityScatterSeries.$$p[3]:
                    this.l7(false);
                    this.le();
                    break;
                case HighDensityScatterSeries.$$p[1]:
                    this.l7(false);
                    this.le();
                    break;
                case HighDensityScatterSeries.$$p[0]:
                case HighDensityScatterSeries.$$p[2]:
                    if (!this.pv.b1(this.sv, this.su)) {
                        return;
                    }
                    this.sa();
                    this.l7(false);
                    this.le();
                    break;
                case HighDensityScatterSeries.$$p[4]:
                    this.rf = Math.max(typeGetValue(d) - 1, 0);
                    this.p8 = this.rf > 0;
                    this.l7(false);
                    this.le();
                    break;
                case HighDensityScatterSeries.$$p[5]:
                    this.l7(false);
                    this.le();
                    break;
            }
        }
        sa() {
            this.qr = this.sv.l;
            this.qu = this.sv.o;
            this.qt = this.sv.n;
            this.qs = this.sv.m;
            this.qn = this.su.l;
            this.qq = this.su.o;
            this.qp = this.su.n;
            this.qo = this.su.m;
            this.ox = BrushUtil.g(truncate(this.qr), truncate(this.qu), truncate(this.qt), truncate(this.qs));
            this.os = BrushUtil.g(truncate(this.qn), truncate(this.qq), truncate(this.qp), truncate(this.qo));
        }
        qc(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        qb(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        r6(a, b) {
            this.sg();
            this.l7(false);
        }
        get qy() {
            return this.qq - this.qu;
        }
        get qx() {
            return this.qp - this.qt;
        }
        get qw() {
            return this.qo - this.qs;
        }
        get qv() {
            return this.qn - this.qr;
        }
        e5(a, b, c) {
            let d = super.e5(a, b, c);
            if (this.p0 == null || this.py == null || this.py.bh == null || this.p0.bh == null || this.p7 == null || this.p5 == null || this.p7.count < 1 || this.p5.count < 1 || this.p7.count != this.p5.count || this.py.ld == this.py.lc || this.p0.ld == this.p0.lc || this.po.isEmpty) {
                d = false;
            }
            return d;
        }
        get rm() {
            return this.rg;
        }
        set rm(a) {
            let b = this.rg;
            this.rg = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.rg);
        }
        l8(a) {
            super.l8(a);
            this.r8(a, this.by);
        }
        r8(a, b) {
            if (this.cu(b)) {
                return;
            }
            if (this.pw == null && !this.qe) {
                let c = new List$1(KDPointData.$, 2, this.p5.count);
                let d = this.py;
                let e = this.p0;
                let f = new Rect(0, 0, 0, 1, 1);
                let g = new Rect(0, 0, 0, 1, 1);
                let h = new ScalerParams(1, f, g, d.cf);
                let i = new ScalerParams(1, f, g, e.cf);
                let j;
                let k;
                for (let l = 0; l < this.p5.count; l++) {
                    j = d.ef(this.p5.item(l), h);
                    k = e.ef(this.p7.item(l), i);
                    if (!isNaN_(j) && !isNaN_(k) && !isInfinity(j) && !isInfinity(k)) {
                        c.add(((() => {
                            let $ret = new KDPointData();
                            $ret.a = j;
                            $ret.b = k;
                            $ret.c = l;
                            return $ret;
                        })()));
                    }
                }
                if (this.qd) {
                    this.rb = 1;
                    this.rc = truncate(logBase(c.count, 2)) + 3;
                    this.rm = truncate(((this.rb / this.rc) * 100));
                    if (this.progressiveLoadStatusChanged != null) {
                        this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.rm));
                    }
                    this.pw = KDTree2D.b(c.toArray(), 1);
                    let m = this.pw;
                    m.progressiveThunkCompleted = delegateCombine(m.progressiveThunkCompleted, runOn(this, this.r3));
                    if (!this.pw.f(this.gz)) {
                        let n = this.pw;
                        n.progressiveThunkCompleted = delegateRemove(n.progressiveThunkCompleted, runOn(this, this.r3));
                    }
                    this.le();
                }
                else {
                    let o = dateNow();
                    this.pw = new KDTree2D(0, c.toArray(), 1);
                    let p = dateNow();
                }
            }
            if (this.qd && !this.qe) {
                this.r9(b);
            }
            else {
                this.sb(b);
            }
        }
        kr(a, b, c, d) {
            super.kr(a, b, c, d);
            this.sg();
            let e = false;
            if (this.py != null && !this.py.cy()) {
                e = true;
            }
            if (this.p0 != null && !this.p0.cy()) {
                e = true;
            }
            if (e) {
                this.l7(false);
            }
            this.lf();
        }
        r5(a) {
            let b = a;
            let c = this.re * this.rd;
            if (this.qa) {
                if (this._itemIndexes == null || this._itemIndexes.length != c) {
                    this._itemIndexes = new Array(c);
                    for (let d = 0; d < c; d++) {
                        this._itemIndexes[d] = 0;
                    }
                }
                else {
                    for (let e = 0; e < c; e++) {
                        this._itemIndexes[e] = 0;
                    }
                }
            }
        }
        sb(a) {
            let b;
            let c;
            let d = null;
            if (a.q) {
                d = this._itemIndexes;
            }
            let e = a.getViewInfo(c, b);
            c = e.p0;
            b = e.p1;
            let f = a;
            let g = this.getEffectiveViewport1(a);
            this.p1 = new ScalerParams(0, b, c, this.px.cf, g);
            this.p2 = new ScalerParams(0, b, c, this.pz.cf, g);
            this.r4(a);
            this.r5(a);
            let h = this.re * this.rd;
            if (this.pu == null || this.pu.length != h) {
                this.pu = new Array(h);
                this.pr = new Array(h);
            }
            let i = this.pu.length;
            let j = this.pu;
            let k = this.pr;
            for (let l = 0; l < i; l++) {
                j[l] = 0;
                k[l] = 0;
            }
            this.ri = truncate(Math.round(this.gk));
            this.pt = f.by();
            let m = this.pt.length;
            let n = this.pt;
            for (let o = 0; o < m; o++) {
                n[o] = 0;
            }
            let p = this.q9;
            let q = this.q8;
            if (isNaN_(p) || isInfinity(p)) {
                p = 0;
            }
            if (isNaN_(q) || isInfinity(q)) {
                q = 50;
            }
            this.ql = Math.min(p, q);
            this.qk = Math.max(p, q);
            if (this.ql < 0) {
                this.ql = 0;
            }
            if (this.qk < 0) {
                this.qk = 0;
            }
            this.qm = this.qk - this.ql;
            if (this.qe) {
                this.r7(a);
            }
            else {
                this.si(a);
            }
            f.b9();
            if (a.q) {
                this._itemIndexes = d;
                this.pv.ca();
            }
        }
        r9(a) {
            if (this.pw == null) {
                return;
            }
            this.sb(a);
        }
        r3(a, b) {
            this.pv.b8(() => {
                if (this.rb < this.rc - 1) {
                    this.rb++;
                }
                this.rm = truncate(((this.rb / this.rc) * 100));
                if (this.progressiveLoadStatusChanged != null) {
                    this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.rm));
                }
                this.r9(this.by);
                this.le();
                if (this.pw != null) {
                    if (!this.pw.f(this.gz)) {
                        let c = this.pw;
                        c.progressiveThunkCompleted = delegateRemove(c.progressiveThunkCompleted, runOn(this, this.r3));
                        this.rm = 100;
                        if (this.progressiveLoadStatusChanged != null) {
                            this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.rm));
                        }
                    }
                }
            });
        }
        r7(a) {
            let b = arrayShallowClone(this.p5.asArray());
            this.py.hi(boxArray$1(b), 0, b.length, this.p1);
            let c = arrayShallowClone(this.p7.asArray());
            this.rh = 0;
            let d = this.rf;
            let e = this.p8;
            let f = this.pu.length;
            this.p0.hi(boxArray$1(c), 0, c.length, this.p2);
            let g = 255 << 24 | truncate(this.qu) << 16 | truncate(this.qt) << 8 | truncate(this.qs);
            for (let h = 0; h < b.length; h++) {
                let i = truncate(b[h]);
                let j = truncate(c[h]);
                i = truncate(Math.floor(i));
                j = truncate(Math.floor(j));
                if (i < 0 || i >= this.re || j < 0 || j >= this.rd) {
                    continue;
                }
                if (e) {
                    let k = i - d;
                    let l = i + d;
                    l = l > (this.re - 1) ? (this.re - 1) : l;
                    k = k < 0 ? 0 : k;
                    let m = j + d;
                    let n = j - d;
                    for (let o = k; o <= l; o++) {
                        for (let p = n; p <= m; p++) {
                            let q = (p * this.re) + o;
                            if (q < 0 || q > f - 1) {
                                continue;
                            }
                            this.pu[q] = this.pu[q] + 1;
                            this.pr[q] = 1;
                            this.rh++;
                            if (this.qa) {
                                this._itemIndexes[q] = h + 1;
                            }
                        }
                    }
                }
                else {
                    let r = (j * this.re) + i;
                    this.pu[r] = this.pu[r] + 1;
                    this.pr[r] = 1;
                    this.rh++;
                    if (this.qa) {
                        this._itemIndexes[r] = h + 1;
                    }
                }
            }
            this.sc();
        }
        si(a) {
            let b;
            let c;
            let d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            if (this.pw == null) {
                return;
            }
            if (this.qf == null) {
                this.qf = new List$1(KDTreeNode2D.$, 2, truncate(Math.round(b.width * b.height)));
            }
            else {
                this.qf.clear();
            }
            let e = c.left;
            let f = c.right;
            let g = c.top;
            let h = c.bottom;
            this.q5 = c.top;
            this.q3 = c.height;
            this.q4 = c.left;
            this.q6 = c.width;
            this.q1 = b.top;
            this.qz = b.height;
            this.q0 = b.left;
            this.q2 = b.width;
            let i = this.getEffectiveViewport1(a);
            this.qh = (i.left - this.q0) / this.q2;
            this.qi = (i.top - this.q1) / this.qz;
            let j = (i.right - this.q0) / this.q2;
            this.qj = j - this.qh;
            let k = (i.bottom - this.q1) / this.qz;
            this.qg = k - this.qi;
            if (this.p9) {
                e = (e - this.qh) / this.qj;
                f = (f - this.qh) / this.qj;
                g = (g - this.qi) / this.qg;
                h = (h - this.qi) / this.qg;
            }
            let l = this.gk / b.width * c.width;
            let m = this.gk / b.height * c.height;
            let n = Math.min(l, m);
            let o = ((() => {
                let $ret = new SearchArgs();
                $ret.c = e;
                $ret.a = f;
                $ret.d = g;
                $ret.b = h;
                $ret.e = l;
                $ret.f = m;
                $ret.g = 0x7FFFFFFF;
                return $ret;
            })());
            this.pw.t(this.qf, o, 0, 1, 0, 1);
            let p;
            this.rh = 0;
            for (let q = 0; q < this.qf.count; q++) {
                p = this.qf._inner[q];
                this.sd(p);
            }
            this.sc();
        }
        sd(a) {
            if (a.g) {
                return;
            }
            let b = a.e != null && a.e.a;
            let c = a.a == null ? 0 : a.a.length;
            let d = (a.h - c) + 1;
            if (b && d > 0) {
            }
            else {
                d = 1;
            }
            this.sf(a.b, d, b, a.e);
            if (c > 0 && !b) {
                let e;
                for (let f = 0; f < c; f++) {
                    e = a.a[f];
                    this.sf(e, d, false, a.e);
                }
            }
            if (a.e != null) {
                a.e.a = false;
            }
        }
        ej(a) {
            let b = this.cb != null ? this.cb.r0 : Rect.empty;
            let c = this.cb != null ? this.cb.sf : Rect.empty;
            let d = new Rect(0, 0, 0, 1, 1);
            let e = this.pi(this.by);
            let f = new ScalerParams(0, d, d, this.py.cf, e);
            let g = new ScalerParams(0, d, d, this.p0.cf, e);
            let h = !b.isEmpty && !c.isEmpty && this.ci != null ? this.ci.indexOf(a) : -1;
            let i = this.py != null && this.p5 != null && h < this.p5.count ? this.py.ef(this.p5.item(h), f) : NaN;
            let j = this.p0 != null && this.p7 != null && h < this.p7.count ? this.p0.ef(this.p7.item(h), g) : NaN;
            if (!isNaN_(i)) {
                if (i < b.left + 0.1 * b.width) {
                    i = i + 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
                if (i > b.right - 0.1 * b.width) {
                    i = i - 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
            }
            if (!isNaN_(j)) {
                if (j < b.top + 0.1 * b.height) {
                    j = j + 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
                if (j > b.bottom - 0.1 * b.height) {
                    j = j - 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
            }
            if (this.b6 != null) {
                this.b6.au(this.cb, b, true);
            }
            return h >= 0;
        }
        sf(a, b, c, d) {
            let e = this.rk(b);
            let f = a.c;
            let g = this.rf;
            if (c) {
                let h = d.d;
                let i = d.b;
                let j = d.e;
                let k = d.c;
                if (this.p9) {
                    h = this.qh + this.qj * h;
                    i = this.qh + this.qj * i;
                    j = this.qi + this.qg * j;
                    k = this.qi + this.qg * k;
                }
                let l = truncate((this.q0 + this.q2 * (h - this.q4) / this.q6));
                let m = truncate((this.q0 + this.q2 * (i - this.q4) / this.q6));
                let n = truncate((this.q1 + this.qz * (j - this.q5) / this.q3));
                let o = truncate((this.q1 + this.qz * (k - this.q5) / this.q3));
                l = truncate(Math.floor(l));
                m = truncate(Math.floor(m));
                n = truncate(Math.floor(n));
                o = truncate(Math.floor(o));
                if (this.p8) {
                    l -= g;
                    m += g;
                    n -= g;
                    o += g;
                }
                let p = ((m - l) + 1) * ((o - n) + 1);
                let q = b / p;
                let r = q;
                for (let s = l; s <= m; s++) {
                    for (let t = n; t <= o; t++) {
                        this.se(f, s, t, q, r);
                    }
                }
            }
            else {
                let u = a.a;
                let v = a.b;
                if (this.p9) {
                    u = this.qh + this.qj * u;
                    v = this.qi + this.qg * v;
                }
                let w = truncate((this.q0 + this.q2 * (u - this.q4) / this.q6));
                let x = truncate((this.q1 + this.qz * (v - this.q5) / this.q3));
                w = truncate(Math.floor(w));
                x = truncate(Math.floor(x));
                if (this.p8) {
                    let y = w - g;
                    let z = w + g;
                    let aa = x + g;
                    let ab = x - g;
                    let ac = ((z - y) + 1) * ((aa - ab) + 1);
                    let ad = b / ac;
                    let ae = ad;
                    for (let af = y; af <= z; af++) {
                        for (let ag = ab; ag <= aa; ag++) {
                            this.se(f, af, ag, ad, ae);
                        }
                    }
                }
                else {
                    this.se(f, w, x, b, 1);
                }
            }
        }
        rj(a, b) {
            return truncate((Math.floor(255 * b))) << 24 | truncate(Math.floor(b * (this.qu + a * this.qy))) << 16 | truncate(Math.floor(b * (this.qt + a * this.qx))) << 8 | truncate(Math.floor(b * (this.qs + a * this.qw)));
        }
        rk(a) {
            return 255 << 24 | truncate(Math.floor((this.qu + a * this.qy))) << 16 | truncate(Math.floor((this.qt + a * this.qx))) << 8 | truncate(Math.floor((this.qs + a * this.qw)));
        }
        q7(a) {
            return (a >> 24 & 255) / 255;
        }
        se(a, b, c, d, e) {
            if (b < 0 || b >= this.re || c < 0 || c >= this.rd) {
                return;
            }
            let f = (c * this.re) + b;
            this.pu[f] = this.pu[f] + d;
            this.pr[f] = this.pr[f] + e;
            if (this.qa) {
                this._itemIndexes[f] = a + 1;
            }
            this.rh += truncate(d);
        }
        sc() {
            let a = 0;
            let b = 0;
            let c = this.qm;
            let d = this.ql;
            let e = this.qk;
            let f = this.pu.length;
            let g = this.pu;
            let h = this.pr;
            let i = this.pt;
            let j = NaN;
            let k = NaN;
            let l = 0;
            let m = 0;
            for (let n = 0; n < f; n++) {
                a = g[n];
                if (a != 0) {
                    b = h[n];
                    if (a >= e) {
                        a = 1;
                    }
                    else if (a <= d) {
                        a = 0;
                    }
                    else {
                        a = (a - d) / (c);
                    }
                    if (b > 1) {
                        b = 1;
                    }
                    if (b < 0.2) {
                        b = 0.2;
                    }
                    if (j != a || k != b) {
                        l = this.rj(a, b);
                        j = a;
                        k = b;
                    }
                    i[m] = l >> 16 & 255;
                    i[m + 1] = l >> 8 & 255;
                    i[m + 2] = l & 255;
                    i[m + 3] = l >> 24 & 255;
                }
                m += 4;
            }
        }
        r4(a) {
            let b = a;
            b.b6();
        }
        bv() {
            return new HighDensityScatterSeriesView(this);
        }
        lo(a) {
            super.lo(a);
            this.pv = a;
        }
        ap(a) {
            if (a != null && a == this.py && this.p5 != null) {
                return new AxisRange(this.p5.minimum, this.p5.maximum);
            }
            if (a != null && a == this.p0 && this.p7 != null) {
                return new AxisRange(this.p7.minimum, this.p7.maximum);
            }
            return null;
        }
        mt(a, b) {
            if (this.cb != null) {
                let c = this.getEffectiveViewport1(this.by);
                this.p9 = !c.isEmpty;
            }
            this.l7(false);
        }
        mu(a, b) {
            this.l7(false);
        }
        hk(a) {
            if (!this.qa || this._itemIndexes == null || this.cb == null || this.ci == null || this._itemIndexes.length != (this.re * this.rd)) {
                return null;
            }
            let b = this.cb.r0;
            let c = (a.x - b.left) / b.width;
            let d = (a.y - b.top) / b.height;
            let e = truncate(Math.round(this.po.left + (this.po.width * c)));
            let f = truncate(Math.round(this.po.top + (this.po.height * d)));
            let g = this.rn(e, f);
            if (g < 0 || g > this._itemIndexes.length - 1) {
                return null;
            }
            let h = this._itemIndexes[g] - 1;
            if (h < 0 || h > this.ci.count) {
                return null;
            }
            return this.ci.item(h);
        }
        rn(a, b) {
            let c = (this.re * b) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            let d = 1;
            c = (this.re * (b - d)) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.re * (b + d)) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.re * (b)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.re * (b)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.re * (b - d)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.re * (b + d)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.re * (b - d)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.re * (b + d)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            return 0;
        }
        sh(a, b, c) {
            this.pt = a;
            this.re = b;
            this.rd = c;
        }
        get_ez() {
            return true;
        }
        set_ez(a) {
            super.set_ez(a);
        }
        ko(a, b) {
            super.ko(a, b);
            this.pv.b7();
            if (this.bx != null) {
                this.bx.b7();
            }
            this.le();
        }
        l9(a, b) {
            super.l9(a, b);
            if (!this.ev) {
                this.by.a2(b);
                return;
            }
            this.by.a2(b);
            if (this.cu(this.bx)) {
                return;
            }
            let c = typeCast(HighDensityScatterSeriesView.$, this.bx);
            let d = new ScatterFrame();
            this.r8(false, c);
            this.ev = false;
        }
        l6(a, b, c, d, e) {
            super.l6(a, b, c, d, e);
            let f = this.a5.a$h.item(d);
            let g = f;
            f.a1(c);
            if (this.cu(g)) {
                return;
            }
            if (this.p3 == null) {
                this.p3 = new ScatterFrame();
            }
            this.r8(false, f);
        }
        kl() {
            super.kl();
            this.py = null;
            this.p0 = null;
        }
    }
    HighDensityScatterSeries.$t = /*@__PURE__*/ markType(HighDensityScatterSeries, 'HighDensityScatterSeries', Series.$);
    HighDensityScatterSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, HighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:su:sj', [Color.$, Defaults.ap], 'HeatMaximum:q8:sk', [1, 50], 'HeatMinimumColor:sv:sl', [Color.$, Defaults.aq], 'HeatMinimum:q9:sm', [1, 0], 'PointExtent:rl:sn', [1, 1], 'ProgressiveLoad:qd:so', [0, true], 'UseBruteForce:qe:sp', [0, false], 'XAxis:py:sq', [NumericXAxis.$, null], 'XMemberPath:rx:sr', [2, null], 'YAxis:p0:ss', [NumericYAxis.$, null], 'YMemberPath:r1:st', [2, null]]);
    return HighDensityScatterSeries;
})();
/**
 * @hidden
 */
export let HighDensityScatterSeriesView = /*@__PURE__*/ (() => {
    class HighDensityScatterSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.bz = null;
            this.bx = null;
            this.b5 = 0;
            this.b4 = 0;
            this.b2 = null;
            this.b3 = null;
            this.b0 = null;
            this.bz = a;
        }
        as() {
            super.as();
            if (!this.q) {
                this.bz.gk = Defaults.q;
                this.bz.sv = Defaults.aq;
                this.bz.su = Defaults.ap;
                this.bz.os = Defaults.al;
                this.bz.ox = Defaults.ak;
            }
        }
        ca() {
            this.bz.sh(this.bx, this.b5, this.b4);
        }
        b6() {
            if (this.b2 == null) {
                this.b2 = this.e.gz.createElement("canvas");
                let a = this.e.gz.get2DCanvasContext(this.b2);
                this.b0 = new RenderingContext(new CanvasViewRenderer(), a);
            }
            let b;
            if (this.p) {
                b = this.bu;
            }
            else {
                b = this.e.cb.r5();
            }
            let c = truncate(Math.round(b.left));
            let d = truncate(Math.round(b.top));
            let e = truncate(Math.round(b.width));
            let f = truncate(Math.round(b.height));
            let g = this.b5;
            let h = this.b4;
            this.b5 = e;
            this.b4 = f;
            if (g != this.b5 || h != this.b4 || this.bx == null) {
                this.b2.setAttribute("width", e.toString());
                this.b2.setAttribute("height", f.toString());
                this.b3 = this.b0.g().getImageData(0, 0, e, f);
                let imageDataArray_ = this.b3.data;
                this.bx = imageDataArray_;
            }
            this.bz.sh(this.bx, this.b5, this.b4);
        }
        by() {
            return this.bx;
        }
        b9() {
            let a = truncate(Math.round(this.bu.left));
            let b = truncate(Math.round(this.bu.left));
            let c = truncate(Math.round(this.bu.width));
            let d = truncate(Math.round(this.bu.height));
            this.b0.g().putImageData(this.b3, 0, 0);
            this.aq();
        }
        b8(a) {
            if (this.e.gz != null) {
                this.e.gz.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        }
        a6(a, b) {
            super.a6(a, b);
            if (b) {
                if (!this.bz.eh) {
                    return;
                }
                let c = new Rectangle();
                c.n = this.bu.left;
                c.o = this.bu.top;
                c.width = this.bu.width;
                c.height = this.bu.height;
                c._fill = this.bo();
                a.v(c);
                return;
            }
            if (this.b2 == null) {
                return;
            }
            let d = truncate(Math.round(this.bu.left));
            let e = truncate(Math.round(this.bu.top));
            let f = truncate(Math.round(this.bu.width));
            let g = truncate(Math.round(this.bu.height));
            this.k.n(this.b2.getNativeElement(), this.e._opacity, d, e, f, g, d, e, f, g);
        }
        b1(a, b) {
            return Color.e(toNullable(Color.$, a), toNullable(Color.$, null)) && Color.e(toNullable(Color.$, b), toNullable(Color.$, null));
        }
        b7() {
            if (this.bx != null) {
                for (let a = 0; a < this.bx.length; a++) {
                    this.bx[a] = 0;
                }
                this.b9();
            }
        }
        al(a) {
            super.al(a);
            if (this.bx == null) {
                this.e.a7.exportSeriesPixelsData(a, null, this.b5, this.b4);
                return;
            }
            let b = new Array(intDivide(this.bx.length, 4));
            let c;
            for (let d = 0; d < intDivide(this.bx.length, 4); d++) {
                c = d * 4;
                b[d] = this.bx[c + 3] << 24 | this.bx[c] << 16 | this.bx[c + 1] << 8 | this.bx[c + 2];
            }
            this.e.a7.exportSeriesPixelsData(a, b, this.b5, this.b4);
        }
    }
    HighDensityScatterSeriesView.$t = /*@__PURE__*/ markType(HighDensityScatterSeriesView, 'HighDensityScatterSeriesView', SeriesView.$);
    return HighDensityScatterSeriesView;
})();
