/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler_$type } from "./IScaler";
import { markType } from "igniteui-react-core";
import { VerticalAxisLabelPanel } from "./VerticalAxisLabelPanel";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { RangeInfo } from "./RangeInfo";
import { VerticalLogarithmicScaler } from "./VerticalLogarithmicScaler";
import { FastVerticalLinearScaler } from "./FastVerticalLinearScaler";
import { isNaN_ } from "igniteui-react-core";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
export let NumericYAxis = /*@__PURE__*/ (() => {
    class NumericYAxis extends StraightNumericAxisBase {
        constructor() {
            super();
            this.ab = NumericYAxis.$;
            this.kl = this.kj();
        }
        a3() {
            return new NumericYAxisView(this);
        }
        au() {
            return new VerticalAxisLabelPanel();
        }
        get_cm() {
            return true;
        }
        ee() {
            return this.j1().height;
        }
        ef(a, b) {
            if (this.mp != null) {
                return this.mp.p(a, b);
            }
            return this.mo.p(a, b);
        }
        hi(a, b, c, d) {
            if (this.mp != null) {
                this.mp.v(a, b, c, d);
                return;
            }
            this.mo.v(a, b, c, d);
        }
        hh(a, b, c, d, e) {
            if (this.mp != null) {
                this.mp.u(a, b, c, d, e);
                return;
            }
            this.mo.u(a, b, c, d, e);
        }
        ei(a, b) {
            if (this.mp != null) {
                return this.mp.q(a, b);
            }
            return this.mo.q(a, b);
        }
        hj(a, b, c, d) {
            if (this.mp != null) {
                this.mp.j(a, b, c, d);
                return;
            }
            this.mo.j(a, b, c, d);
        }
        m6(a, b) {
            if (this.bh == null || a == NaN || b == NaN) {
                return;
            }
            let c = this.mu(a, this);
            let d = this.mu(b, this);
            if (c == NaN || d == NaN) {
                return;
            }
            this.bh.sg = new Rect(0, this.bh.sg.x, d, this.bh.sg.width, c - d);
        }
        kj() {
            let a = super.kj();
            a.b.c = (b) => {
                if (this.ay == null || this.ay.visibility == 0) {
                    this.av.bg = b;
                    if (this.ay != null && (this.ay.location == 7 || this.ay.location == 6)) {
                        this.bh.lb();
                    }
                }
            };
            a.k = (b, c, d) => this.hl(c, d, b.z, b.b, false);
            a.l = (b, c, d, e) => this.hm(c, d, e, b.z);
            a.m = (b, c) => {
                let d = b.y;
                let e = new ScalerParams(0, b.aa, b.z, this.cg, d);
                return this.ef(c, e);
            };
            a.q = (b, c) => true;
            a.j = (b) => this.ih(b.t, b.n, b.z, b.a, true);
            a.e = (b) => {
                b.n = this.ay != null && (this.ay.location == 7 || this.ay.location == 3) ? b.z.right : b.z.left;
                let c = b.y;
                let d = new ScalerParams(0, b.aa, b.z, this.cg, c);
                if (this.ai != null && this.ai.bh != null) {
                    let e = b.n;
                    let f = b.r;
                    let g = this.h9(e, f, b.aa, b.z, b.y, b.z.left, b.z.right);
                    e = g.p0;
                    f = g.p1;
                    b.n = e;
                    b.r = f;
                }
            };
            a.p = (b, c, d) => {
                let e = Math.round(c);
                return e >= Math.floor(b.z.top) && e <= Math.ceil(b.z.bottom);
            };
            return a;
        }
        km(a, b, c, d) {
            let e = d;
            let f = super.km(a, b, c, d);
            let g = new ScalerParams(0, b, a, this.cf, c);
            let h = NaN;
            let i = NaN;
            if (!this.cf && b.top == 0) {
                i = this.lc;
            }
            else if (this.cf && b.bottom == 1) {
                h = this.lc;
            }
            if (isNaN_(h)) {
                h = this.ei(e.bottom, g);
            }
            if (isNaN_(i)) {
                i = this.ei(e.top, g);
            }
            let j = Math.min(h, i);
            let k = Math.max(h, i);
            this.lg = j;
            this.lf = k;
            let l = ((() => {
                let $ret = new RangeInfo();
                $ret.d = j;
                $ret.c = k;
                $ret.b = e.height;
                return $ret;
            })());
            f.k.add(l);
            return f;
        }
        h4(a) {
            super.h4(a);
            let b = this.bh != null ? this.bh.r0 : Rect.empty;
            let c = this.j7;
            let d = this.j2();
            let e = this.j1();
            let f = this.kl.c(a, c, b, d, e);
            if (f != null) {
                this.lb = f.f.m;
                this.le = f.f.l;
            }
        }
        ij(a, b) {
            super.ij(a, b);
            if (b.height != a.height) {
                this.cy();
            }
        }
        get_a1() {
            return 1;
        }
        get a1() {
            return this.get_a1();
        }
        ko() {
            if (this.k2) {
                return new VerticalLogarithmicScaler();
            }
            switch (this.mn) {
                case 0: return new FastVerticalLinearScaler();
                case 1: return new VerticalLogarithmicScaler();
            }
            return null;
        }
        j$c(a, b) {
            return this.ei.apply(this, arguments);
        }
        j$b(a, b) {
            return this.ef.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.hh.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.hi.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.hj.apply(this, arguments);
        }
        get j$a() {
            return this.cf;
        }
    }
    NumericYAxis.$t = /*@__PURE__*/ markType(NumericYAxis, 'NumericYAxis', StraightNumericAxisBase.$, [IScaler_$type]);
    return NumericYAxis;
})();
/**
 * @hidden
 */
export let NumericYAxisView = /*@__PURE__*/ (() => {
    class NumericYAxisView extends StraightNumericAxisBaseView {
        constructor(a) {
            super(a);
            this.bi = null;
            this.bi = a;
        }
        ag() {
            super.ag();
            this.a.jq = AxisDefaults.h;
        }
    }
    NumericYAxisView.$t = /*@__PURE__*/ markType(NumericYAxisView, 'NumericYAxisView', StraightNumericAxisBaseView.$);
    return NumericYAxisView;
})();
