/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FastItemDateTimeColumn } from "igniteui-react-core";
import { CategoryXAxis } from "./CategoryXAxis";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { TimeAxisLabellingMode_$type } from "./TimeAxisLabellingMode";
import { TimeAxisLabelFormatCollection } from "./TimeAxisLabelFormatCollection";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { EventArgs, runOn, delegateCombine, typeCast, enumGetBox, Date_$type, markType } from "igniteui-react-core";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { TimeAxisBase } from "./TimeAxisBase";
import { TimeXAxis } from "./TimeXAxis";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { truncate } from "igniteui-react-core";
import { dateMaxValue, dateMinValue, dateAdd, dateSubtract } from "igniteui-react-core";
import { timeSpanFromMilliseconds, timeSpanTotalMilliseconds } from "igniteui-react-core";
/**
 * @hidden
 */
export let OrdinalTimeXAxis = /*@__PURE__*/ (() => {
    class OrdinalTimeXAxis extends CategoryXAxis {
        constructor() {
            super();
            this.m7 = dateMaxValue();
            this.m6 = dateMinValue();
            this.nd = dateMaxValue();
            this.nc = dateMinValue();
            this.m9 = dateMaxValue();
            this.m8 = dateMinValue();
            this.nn = null;
            this.nm = null;
            this.m2 = 0;
            this.m4 = null;
            this.m0 = null;
            this.nw = 0;
            this.nb = dateMinValue();
            this.na = dateMaxValue();
            this.visibleRangeChanged = null;
            FastItemDateTimeColumn.o();
            this.m0 = new TimeAxisLabelFormatCollection();
            let a = this.m1;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.ny));
            this.mq = 0;
        }
        eh(a, b, c) {
            return this.ef(a, new ScalerParams(0, b, c, this.cf, this.j2()));
        }
        eg(a, b, c) {
            return this.ef(a, b);
        }
        ef(a, b) {
            if (!b.c.isEmpty) {
                let c = this.nk(a, NumericScaler.ac, b.c);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.nk(a, b.e, b.d);
        }
        nk(a, b, c) {
            let d = this.mp;
            let e = this.mq;
            let f = this.mp - this.mq;
            let g = f >= 1 ? (a - e) / (d - e) : f == 0 ? 0.5 : NaN;
            if (this.cg) {
                g = 1 - g;
            }
            return c.left + c.width * (g - b.left) / b.width;
        }
        hh(a, b, c, d, e) {
            let f;
            let g = e.e;
            let h = e.d;
            let i = e.c;
            let j = e.a;
            let k = !i.isEmpty;
            let l = i.left;
            let m = i.width;
            let n = g.left;
            let o = g.width;
            let p = h.left;
            let q = h.width;
            let r = 0;
            let s = 1;
            let t = this.mp;
            let u = this.mq;
            let v = this.mp - this.mq;
            let w = this.ma(a);
            let x = w != null;
            for (let y = 0; y < b.count; y++) {
                let z = b.item(y);
                for (let aa = c; aa < d; aa++) {
                    f = x ? w[aa] : a.item(aa);
                    if (k) {
                        let ab = v >= 1 ? (f[z] - u) / (t - u) : v == 0 ? 0.5 : NaN;
                        if (j) {
                            ab = 1 - ab;
                        }
                        ab = l + m * (ab - r) / s;
                        let ac = (ab - p) / q;
                        ac = p + q * (ac - n) / o;
                        f[z] = ac;
                    }
                    else {
                        let ad = v >= 1 ? (f[z] - u) / (t - u) : v == 0 ? 0.5 : NaN;
                        if (j) {
                            ad = 1 - ad;
                        }
                        ad = p + q * (ad - n) / o;
                        f[z] = ad;
                    }
                }
            }
        }
        hi(a, b, c, d) {
            for (let e = b; e < c; e++) {
                a.item(e, this.ef(a.item(e), d));
            }
        }
        ek(a, b, c) {
            return this.ei(a, new ScalerParams(0, b, this.j7, this.cf, this.j2()));
        }
        getUnscaledValue3(a, b, c, d) {
            return this.ei(a, new ScalerParams(0, b, this.j7, this.cf, this.j2()));
        }
        ei(a, b) {
            if (!b.c.isEmpty) {
                let c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                c = (c * b.d.width) + b.d.left;
                c = this.nl(c, NumericScaler.ac, b.c);
                return c;
            }
            return this.nl(a, b.e, b.d);
        }
        nl(a, b, c) {
            let d = b.left + (a - c.left) * b.width / c.width;
            if (this.cg) {
                d = 1 - d;
            }
            return this.mq + d * (this.mp - this.mq);
        }
        ej(a, b, c) {
            return this.ei(a, b);
        }
        hj(a, b, c, d) {
            for (let e = b; e < c; e++) {
                a.item(e, this.ei(a.item(e), d));
            }
        }
        hr(a, b, c, d) {
            super.hr(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.m5);
                        this.m5 = null;
                    }
                    if (this.kl != null) {
                        this.m5 = TimeAxisBase.md(this.dateTimeMemberPath, this);
                    }
                    break;
                case "DateTimeMemberPath":
                    if (this.kl != null) {
                        this.kl.deregisterColumn(this.m5);
                        this.m5 = TimeAxisBase.md(this.dateTimeMemberPath, this);
                    }
                    break;
                case "DateTimeColumn":
                    this.cy();
                    this.nw = this.nv();
                    break;
                case "MinimumValue":
                case "MaximumValue":
                    this.cy();
                    this.h2();
                    break;
                case "LabellingMode":
                    this.h2();
                    break;
            }
        }
        get actualMinimumValue() {
            return this.m7;
        }
        set actualMinimumValue(a) {
            this.m7 = a;
        }
        get actualMaximumValue() {
            return this.m6;
        }
        set actualMaximumValue(a) {
            this.m6 = a;
        }
        get visibleMinimum() {
            return this.nd;
        }
        set visibleMinimum(a) {
            this.nd = a;
        }
        get visibleMaximum() {
            return this.nc;
        }
        set visibleMaximum(a) {
            this.nc = a;
        }
        get nh() {
            return this.m9;
        }
        set nh(a) {
            this.m9 = a;
        }
        get ng() {
            return this.m8;
        }
        set ng(a) {
            this.m8 = a;
        }
        nz() {
            if (this.m5 == null || this.m5.count == 0 || this.m5.count < this.mq - 1) {
                this.actualMinimumValue = dateMinValue();
                this.actualMaximumValue = dateMaxValue();
                return;
            }
            let a = Math.max(0, Math.min(this.mq, this.m5.count - 1));
            let b = Math.max(0, Math.min(this.mp, this.m5.count - 1));
            let c = +(this.actualMinimumValue) != +(this.m5.item(a)) || +(this.actualMaximumValue) != +(this.m5.item(b));
            if (c) {
                let d = this.actualMinimumValue;
                let e = this.actualMaximumValue;
                this.actualMinimumValue = this.m5.item(a);
                this.actualMaximumValue = this.m5.item(b);
                this.n0();
            }
        }
        n0() {
            if (this.m5 == null || this.m5.count == 0 || this.bh == null) {
                let a = +(this.visibleMinimum) != +(this.actualMinimumValue) || +(this.visibleMaximum) != +(this.actualMaximumValue);
                this.visibleMinimum = this.actualMinimumValue;
                this.visibleMaximum = this.actualMaximumValue;
                this.nh = this.visibleMinimum;
                this.ng = this.visibleMaximum;
                if (a && this.visibleRangeChanged != null) {
                    this.visibleRangeChanged(this, EventArgs.empty);
                }
                return;
            }
            let b = this.j1();
            let c = new ScalerParams(1, this.bh.sg, this.bh.sf, this.cf);
            c.c = this.j2();
            let d = this.ei(b.left, c);
            let e = this.ei(b.right, c);
            let f = truncate(Math.floor(d));
            let g = truncate(Math.ceil(e));
            let h = f >= 0 && f < this.m5.count ? this.m5.item(f) : this.actualMinimumValue;
            let i = g >= 0 && g < this.m5.count ? this.m5.item(g) : this.actualMaximumValue;
            let j = h;
            let k = i;
            if (d > f) {
                let l = f + 1;
                let m = l >= 0 && l < this.m5.count ? this.m5.item(l) : i;
                let n = dateAdd(+h, +(timeSpanFromMilliseconds(timeSpanTotalMilliseconds((+m - +h)) * (d - f))));
                j = n;
            }
            if (e < g) {
                let o = g - 1;
                let p = o >= 0 && o < this.m5.count ? this.m5.item(o) : h;
                let q = dateSubtract(+i, +(timeSpanFromMilliseconds(timeSpanTotalMilliseconds((+i - +p)) * (g - e))));
                k = q;
            }
            this.nh = j;
            this.ng = k;
            let r = +(this.visibleMinimum) != +h || +(this.visibleMaximum) != +i;
            this.visibleMinimum = h;
            this.visibleMaximum = i;
            if (r && this.visibleRangeChanged != null) {
                this.visibleRangeChanged(this, EventArgs.empty);
            }
        }
        h4(a) {
            let b = TimeXAxis.og(this.actualMinimumValue, false, this.actualMinimumValue, this.m3, this.nu, this.m1, this.fg);
            if (b != this.nn && this.c1) {
                this.h8();
            }
            this.nn = b;
            super.h4(a);
        }
        get dateTimeMemberPath() {
            return this.nm;
        }
        set dateTimeMemberPath(a) {
            let b = this.dateTimeMemberPath;
            if (a != b) {
                this.nm = a;
                this.hx("DateTimeMemberPath", b, this.dateTimeMemberPath);
            }
        }
        get m3() {
            return this.m2;
        }
        set m3(a) {
            let b = this.m3;
            if (a != b) {
                this.m2 = a;
                this.hx("LabellingMode", enumGetBox(TimeAxisLabellingMode_$type, b), enumGetBox(TimeAxisLabellingMode_$type, this.m3));
            }
        }
        get m5() {
            return this.m4;
        }
        set m5(a) {
            if (this.m4 != a) {
                let b = this.m4;
                this.m4 = a;
                this.hx("DateTimeColumn", b, this.m4);
            }
        }
        ik(a, b) {
            super.ik(a, b);
            this.n0();
        }
        getWindowRectForSelection(a, b) {
            if (this.m5 == null) {
                return Rect.empty;
            }
            let c = a > b;
            let d = c ? b : a;
            let e = c ? a : b;
            let f = -1;
            while (++f < this.m5.count && this.m5.item(f) < d) {
            }
            let g = this.m5.count;
            while (--g >= 0 && this.m5.item(g) > e) {
            }
            let h = new ScalerParams(0, new Rect(0, 0, 0, 1, 1), new Rect(0, 0, 0, 1, 1), this.cf, this.bh.r4);
            let i = this.ef(f, h);
            let j = this.ef(g + 1, h);
            return new Rect(0, i, NaN, Math.max(0, j - i), NaN);
        }
        get m1() {
            return this.m0;
        }
        ny(a, b) {
            this.h3(false);
        }
        ht(a) {
            super.ht(a);
            this.dateTimeMemberPath = a;
        }
        fv(a) {
            if (this.at != null) {
                return this.at(a);
            }
            if (this.ah != null) {
                return this.ah.i(a);
            }
            if (!(typeCast(Date_$type, a) !== null)) {
                return super.fv(a);
            }
            let b = dateMinValue();
            let c = false;
            if (this.mr != null) {
                if (typeCast(Date_$type, this.mr) !== null) {
                    b = this.mr;
                    c = true;
                }
            }
            let d = TimeXAxis.ob(a, c, b, this.m3, this.nu, this.m1, this.fg);
            return d == null ? super.fv(a) : d;
        }
        f9(a) {
            let b = 0;
            if (this.categoryMode == 0) {
                b = truncate(Math.round(a));
            }
            else {
                b = truncate(Math.floor(a));
            }
            if (b < 0 || b > this.la - 1) {
                return super.f9(a);
            }
            let c = this.m5.item(b);
            let d = this.fv(c);
            if (d == null) {
                return null;
            }
            return d.toString();
        }
        get nx() {
            return +(this.visibleMaximum) - +(this.visibleMinimum);
        }
        get nu() {
            return +(this.ng) - +(this.nh);
        }
        mc() {
            return this.m5;
        }
        ij(a, b) {
            super.ij(a, b);
            this.n0();
        }
        mj(a, b) {
            let c = this.categoryMode == 0 ? 0 : 0.5;
            return super.mj(a + c, b);
        }
        mi(a, b, c, d) {
            return b;
        }
        nv() {
            if (this.m5 == null || this.m5.count < 2) {
                return (0);
            }
            return TimeXAxis.om((a) => this.m5.item(a), this.m5.count);
        }
        itemLabelFormat() {
            return TimeXAxis.oi(this.nw);
        }
        get minimumValue() {
            return this.nb;
        }
        set minimumValue(a) {
            let b = this.minimumValue;
            if (+a != +b) {
                this.nb = a;
                this.hr(this, "MinimumValue", b, this.minimumValue);
            }
        }
        get maximumValue() {
            return this.na;
        }
        set maximumValue(a) {
            let b = this.maximumValue;
            if (+a != +b) {
                this.na = a;
                this.hr(this, "MaximumValue", b, this.maximumValue);
            }
        }
        c0() {
            if (+(this.minimumValue) == +(dateMaxValue()) || +(this.maximumValue) == +(dateMinValue())) {
                return super.c0();
            }
            if (this.cn && this.c1) {
                this.bb = this.ba();
            }
            if (this.kl == null || this.m5 == null) {
                return false;
            }
            let a = this.mq;
            if (+(this.minimumValue) != +(dateMinValue())) {
                let b = -1;
                while (b++ <= this.m5.count) {
                    if (this.m5.item(b) >= this.minimumValue) {
                        break;
                    }
                }
                a = b;
            }
            let c = this.categoryMode == 0 ? this.kl.count - 1 : this.kl.count;
            if (+(this.maximumValue) != +(dateMaxValue())) {
                let d = this.kl.count;
                while (d-- > 0) {
                    if (this.m5.item(d) <= this.maximumValue) {
                        break;
                    }
                }
                c = d;
            }
            if (a != this.mq || c != this.mp) {
                let e = new AxisRangeChangedEventArgs(0, this.mq, a, this.mp, c);
                this.mq = a;
                this.mp = c;
                this.hy(e);
                this.nz();
                this.ln();
                return true;
            }
            return false;
        }
        lw(a) {
            super.lw(a);
            this.cz(true);
        }
        get isVertical() {
            return this.cm;
        }
        j$c(a, b) {
            return this.ei.apply(this, arguments);
        }
        j$b(a, b) {
            return this.ef.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.hh.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.hi.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.hj.apply(this, arguments);
        }
        get j$a() {
            return this.cf;
        }
    }
    OrdinalTimeXAxis.$t = /*@__PURE__*/ markType(OrdinalTimeXAxis, 'OrdinalTimeXAxis', CategoryXAxis.$, [ITimeRangeSelectorAxis_$type]);
    return OrdinalTimeXAxis;
})();
