/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, runOn, EnumUtil, typeCast, fromEnum, markDep } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { NotImplementedException } from "igniteui-react-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { truncate, intDivide, isNaN_ } from "igniteui-react-core";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { RadialFrame } from "./RadialFrame";
import { DependencyProperty } from "igniteui-react-core";
import { HighlightingInfo } from "./HighlightingInfo";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { RadialAxes } from "./RadialAxes";
import { Visibility_$type } from "igniteui-react-core";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { PropertyMetadata } from "igniteui-react-core";
import { round10N } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
/**
 * @hidden
 */
export let RadialBucketCalculator = /*@__PURE__*/ (() => {
    class RadialBucketCalculator extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.c = 0;
            this.d = 0;
            this.b = 0;
            this.a = a;
        }
        getBucket(a) {
            throw new NotImplementedException(0);
        }
        getBucketWithoutUnknowns(a) {
            return this.getBucket(a);
        }
        getErrorBucket(a, b) {
            return NaN;
        }
        getBucketInfo(a, b, c, d) {
            a = this.c;
            b = this.d;
            c = this.b;
            d = this.a.cr.gk;
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d
            };
        }
        e(a) {
            let b = this.a.bv;
            let c = this.a.bu;
            let d = this.a.cr.q8;
            if (b.isEmpty || c.isEmpty || d == null || this.a.cr.ci == null || this.a.cr.ci.count == 0) {
                this.b = 0;
                return;
            }
            let e = Math.floor(d.mr(c, b));
            let f = Math.ceil(d.mq(c, b));
            if (d.cf) {
                f = Math.ceil(d.mr(c, b));
                e = Math.floor(d.mq(c, b));
            }
            if (f < e) {
                f = d.k9 + f;
            }
            let g = this.a.cr.rf;
            let h = g != null ? g.mu : 0.75;
            let i = Math.min(c.width, c.height) * 0.5 * (h) * 2 * Math.PI;
            let j = Math.floor((f - e + 1) * a / i);
            this.b = truncate(Math.max(1, j));
            this.c = truncate(Math.max(0, Math.floor(e / this.b) - 1));
            this.d = truncate(Math.ceil(f / this.b));
        }
        cacheValues() {
        }
        unCacheValues() {
        }
    }
    RadialBucketCalculator.$t = /*@__PURE__*/ markType(RadialBucketCalculator, 'RadialBucketCalculator', Base.$, [IBucketizer_$type]);
    return RadialBucketCalculator;
})();
/**
 * @hidden
 */
export let RadialBase = /*@__PURE__*/ (() => {
    class RadialBase extends MarkerSeries {
        constructor() {
            super();
            this.rm = null;
            this.rn = null;
            this.rp = false;
            this.ro = false;
            this.rd = null;
            this.re = null;
            this.assigningRadialStyle = null;
            this.assigningRadialMarkerStyle = null;
            this.rk = new RadialFrame(3);
            this.rl = new RadialFrame(3);
            this.ri = new RadialFrame(3);
            this.rg = null;
            this.rm = new RadialSeriesRenderManager();
            this.rn = new SeriesRenderer$2(RadialFrame.$, RadialBaseView.$, 1, runOn(this, this.sa), runOn(this, this.sd), runOn(this, this.cs), runOn(this, this.mf), runOn(this, this.r9), (a) => this.rh.cs.e(this.gk));
        }
        lo(a) {
            super.lo(a);
            this.rh = a;
        }
        r9() {
            if (this.cc.g) {
                this.cc.t();
            }
        }
        get categoryAxis() {
            return this.q8;
        }
        ar() {
            return this.q8;
        }
        q5(a, b) {
            return null;
        }
        cy(a, b, c, d) {
            if (!this.hasMarkers) {
                return false;
            }
            let e = this.q8;
            let f = new ScalerParams(1, this.cb.r0, this.po, e.cf);
            f.c = this.getEffectiveViewport1(this.by);
            let g = this.rf;
            let h = new ScalerParams(1, this.cb.r0, this.po, g.cf);
            h.c = this.getEffectiveViewport1(this.by);
            a.clear();
            this.pz.cf((i) => {
                if (i._visibility == 0) {
                    let j = new SeriesPointOfInterest();
                    let k = i.n;
                    let l = i.o;
                    if (k < this.po.left || k > this.po.right || l < this.po.top || l > this.po.bottom) {
                        return;
                    }
                    let m;
                    let n;
                    let o = this.rg.g(k, l, this.by.bv, this.by.bu, m, n);
                    m = o.p4;
                    n = o.p5;
                    j.b = m;
                    j.c = n;
                    if (b) {
                        if (c) {
                            j.d = this.r4(j.c, d);
                        }
                        else {
                            let p = this.gf(i);
                            if (!isNaN_(p)) {
                                j.d = this.r4(p, d);
                            }
                            else {
                                j.d = this.r4(j.c, d);
                            }
                        }
                    }
                    else {
                        j.d = e.f9(i.ak);
                    }
                    j.a = i.content;
                    a.add(j);
                }
            });
            return true;
        }
        r4(a, b) {
            if (b >= 0) {
                return round10N(a, b).toString();
            }
            else {
                return a.toString();
            }
        }
        get_d6() {
            return true;
        }
        get_dt() {
            return true;
        }
        ra(a, b, c) {
            let d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ci.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        }
        rb(a, b, c) {
            let d = this.rh.cs.c;
            let e = this.rh.cs.d;
            let f = this.rh.cs.b;
            let g = this.rj();
            let h = this.ci.count;
            let i = this.q8;
            let j = -1;
            let k = -1;
            let l = this.g3(b);
            j = truncate(Math.floor((intDivide(l, f)))) * f;
            k = j + (f - 1);
            if (c != null && c.h == j && c.g == k) {
                return c;
            }
            let m = new HighlightingInfo();
            m.b = this;
            m.h = j;
            m.g = k;
            return m;
        }
        rc(a, b, c) {
            let d = this.rh.cs.c;
            let e = this.rh.cs.d;
            let f = this.rh.cs.b;
            let g = this.rj();
            let h = this.ci.count;
            let i = this.q8;
            let j = -1;
            let k = -1;
            let l = this.g3(b);
            j = truncate(Math.floor((intDivide(l, f)))) * f;
            k = j + (f - 1);
            if (c != null && c.h == j && c.g == k) {
                return c;
            }
            let m = new HighlightingInfo();
            m.e = true;
            m.b = this;
            m.h = j;
            m.g = k;
            return m;
        }
        av(a, b, c) {
            if (this.cz && this.eb(this.bk) && !c) {
                let d = this.rb(a, b, this.rd);
                this.rd = d;
                return d;
            }
            else {
                let e = this.ra(a, b, this.rd);
                this.rd = e;
                return e;
            }
        }
        aw(a, b, c) {
            if (this.eb(this.bk) && !c) {
                let d = this.rc(a, b, this.re);
                this.re = d;
                return d;
            }
            else {
                let e = this.ra(a, b, this.re);
                e.e = true;
                this.re = e;
                return e;
            }
        }
        ry() {
            return (this.assigningRadialStyle != null && this.rp) || (this.bk != 1);
        }
        rx() {
            return (this.assigningRadialMarkerStyle != null && this.ro) || (this.bk != 1);
        }
        sc(a) {
            if (this.assigningRadialStyle != null && this.rp) {
                this.assigningRadialStyle(this, a);
            }
        }
        sb(a) {
            if (this.assigningRadialMarkerStyle != null && this.ro) {
                this.assigningRadialMarkerStyle(this, a);
            }
        }
        r0(a) {
            return a.cs.b;
        }
        r1(a) {
            return a.cs.c;
        }
        ag() {
            return [this.q8, this.rf];
        }
        mu(a, b) {
            this.rh.cs.e(this.gk);
            this.l7(false);
        }
        mt(a, b) {
            this.rh.cs.e(this.gk);
            this.l7(false);
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    if (c != null && d == null) {
                        if (this.q8 != null) {
                            this.q8.by(this);
                        }
                        if (this.rf != null) {
                            this.rf.by(this);
                        }
                    }
                    if (c == null && d != null) {
                        if (this.q8 != null) {
                            this.q8.cq(this);
                        }
                        if (this.rf != null) {
                            this.rf.cq(this);
                        }
                    }
                    this.rh.cs.e(this.gk);
                    this.l7(false);
                    break;
                case RadialBase.$$p[0]:
                    if (this.q8 != null && this.rf != null) {
                        this.rg = new RadialAxes(this.rf, this.q8);
                    }
                    if (c != null) {
                        c.by(this);
                    }
                    if (d != null) {
                        d.cq(this);
                    }
                    this.rh.cs.e(this.gk);
                    this.l7(false);
                    break;
                case RadialBase.$$p[4]:
                    if (this.q8 != null && this.rf != null) {
                        this.rg = new RadialAxes(this.rf, this.q8);
                    }
                    if (c != null) {
                        c.by(this);
                    }
                    if (d != null) {
                        d.cq(this);
                    }
                    this.rh.cs.e(this.gk);
                    if (this.rf == null || !this.rf.cy()) {
                        this.l7(false);
                    }
                    break;
                case "SyncLink":
                    if (this.b6 != null && this.cb != null) {
                        this.rh.cs.e(this.gk);
                        this.l7(false);
                    }
                    break;
                case "TransitionProgress":
                    this.rl.c(this.gq, this.rk, this.ri);
                    if (this.cu(this.by)) {
                        return;
                    }
                    if (this.gq == 1) {
                        this.sd(this.ri, this.rh);
                    }
                    else {
                        this.sd(this.rl, this.rh);
                    }
                    if (this.cb != null) {
                        this.cb.nd(this);
                    }
                    break;
                case RadialBase.$$p[1]:
                    this.l7(false);
                    this.le();
                    break;
                case "VisibilityProxy":
                    if (EnumUtil.getEnumValue(Visibility_$type, c) != 0 && EnumUtil.getEnumValue(Visibility_$type, d) == 0) {
                        this.rh.cs.e(this.gk);
                    }
                    break;
                case RadialBase.$$p[3]:
                    this.rp = this.rw();
                    this.l7(false);
                    break;
                case RadialBase.$$p[2]:
                    this.ro = this.rv();
                    this.l7(false);
                    break;
            }
        }
        rw() {
            return this.ru;
        }
        rv() {
            return this.rt;
        }
        rr(a) {
            if (typeCast(NumericRadiusAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        rq(a) {
            if (typeCast(CategoryAngleAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        hk(a) {
            let b = this.g3(a);
            return b >= 0 && this.ci != null && b < this.ci.count ? this.ci.item(b) : null;
        }
        rz(a) {
            let b = this.by.bv;
            let c = this.by.bu;
            if (this.q8 != null && !b.isEmpty && !c.isEmpty && this.rg != null) {
                let d = this.rg.c(a);
                if (d < 0) {
                    d += Math.PI * 2;
                }
                if (d > Math.PI * 2) {
                    d -= Math.PI * 2;
                }
                return d;
            }
            return NaN;
        }
        fy(a) {
            let b = this.by.bv;
            let c = this.by.bu;
            let d = -1;
            if (this.q8 != null && !b.isEmpty && !c.isEmpty && this.rg != null) {
                let e = this.rg.c(a);
                if (e < 0) {
                    e += Math.PI * 2;
                }
                if (e > Math.PI * 2) {
                    e -= Math.PI * 2;
                }
                let f = this.q8.getUnscaledAngle(e);
                if (this.q8.categoryMode != 0) {
                    f -= 0.5;
                }
                d = f;
            }
            return d;
        }
        g3(a) {
            let b = truncate(Math.round(this.fy(a)));
            if (this.ci != null && b == this.ci.count) {
                b = 0;
            }
            return b;
        }
        ej(a) {
            return false;
        }
        rj() {
            let a = this.ri;
            if (this.cs()) {
                if (this.cc.g) {
                    this.cc.t();
                }
                a = this.rl;
            }
            return a;
        }
        k5() {
            super.k5();
            if (this.q8 != null) {
                this.q8.h3(false);
            }
            if (this.rf != null) {
                this.rf.h3(false);
            }
        }
        e5(a, b, c) {
            let d = true;
            let e = c;
            if (!super.e5(a, b, c) || !c.o() || b.isEmpty || a.isEmpty || this.q8 == null || this.q8.itemsSource == null || this.rf == null || this.rg == null || this.ci == null || this.q8.bh == null || this.rf.bh == null || this.rf.ld == this.rf.lc) {
                e.cs.b = 0;
                d = false;
            }
            return d;
        }
        l8(a) {
            let b;
            let c;
            let d = this.getViewInfo(c, b);
            c = d.p0;
            b = d.p1;
            if (!this.e5(c, b, this.by)) {
                this.ko(true, this.by);
                return;
            }
            let e = new SeriesRenderingArguments(this, c, b, a, this.eo);
            let f = this.rn.g(e, this.rk, this.ri, this.rl, this.rh);
            this.rk = f.p1;
            this.ri = f.p2;
            this.rl = f.p3;
        }
        r2() {
            let a = 0;
            for (let b of fromEnum(this.cb.series)) {
                if (b == this) {
                    return a;
                }
                let c = typeCast(RadialBase.$, b);
                if (c != null && c.q8 == this.q8 && c.preferredCategoryMode(c.q8) == 2) {
                    a++;
                }
            }
            return -1;
        }
    }
    RadialBase.$t = /*@__PURE__*/ markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
    RadialBase.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:q8:se', [CategoryAngleAxis.$, null], 'ClipSeriesToBounds:rs:sf', [0, false], 'IsCustomRadialMarkerStyleAllowed:rt:sg', [0, false], 'IsCustomRadialStyleAllowed:ru:sh', [0, false], 'ValueAxis:rf:si', [NumericRadiusAxis.$, null]]);
    return RadialBase;
})();
/**
 * @hidden
 */
export let RadialBaseView = /*@__PURE__*/ (() => {
    class RadialBaseView extends MarkerSeriesView {
        constructor(a) {
            super(a);
            this.cs = null;
            this.cr = null;
            this.ct = null;
            this.cu = 0;
            this.cv = null;
            this.cr = a;
            this.ct = new Pool$1(Marker.$);
            this.ci(this.ct);
        }
        cf(a) {
            this.ct.c(a);
        }
    }
    RadialBaseView.$t = /*@__PURE__*/ markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);
    return RadialBaseView;
})();
