/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { ColorScale } from "./ColorScale";
import { runOn, delegateRemove, delegateCombine, typeCast, Point_$type, markType, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { FastItemIntColumn } from "igniteui-react-core";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { SeriesView } from "./SeriesView";
import { TriangleRasterizer } from "./TriangleRasterizer";
import { ScalerParams } from "./ScalerParams";
import { ObservableColorCollection } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { ColorUtil } from "igniteui-react-core";
import { CustomPaletteColorScale } from "./CustomPaletteColorScale";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, intDivide } from "igniteui-react-core";
import { boxArray$1 } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ScatterAreaSeries = /*@__PURE__*/ (() => {
    class ScatterAreaSeries extends ScatterTriangulationSeries {
        constructor() {
            super();
            this.ra = null;
            this.rf = null;
            this.q8 = null;
            this.q9 = null;
            FastItemIntColumn.m();
            this.ab = ScatterAreaSeries.$;
        }
        get_c9() {
            return true;
        }
        get rc() {
            return this.ra;
        }
        set rc(a) {
            let b = this.ra != a;
            if (b) {
                let c = this.ra;
                if (this.ra != null) {
                    let d = this.ra;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.rp));
                }
                this.ra = a;
                if (this.ra != null) {
                    let e = this.ra;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.rp));
                }
                this.raisePropertyChanged("ColorScale", c, this.ra);
            }
        }
        rp(a, b) {
            this.rr();
            this.l7(false);
        }
        hn(a, b) {
            let c = this.jf(b);
            if (c == ScatterAreaSeries.$$p[1]) {
                return this.ho(a, b, this.rk);
            }
            return super.hn(a, b);
        }
        get rg() {
            return this.rf;
        }
        set rg(a) {
            let b = this.rg != a;
            if (b) {
                let c = this.rg;
                this.rf = a;
                this.raisePropertyChanged("ColorColumn", c, this.rg);
            }
        }
        get_ez() {
            return true;
        }
        set_ez(a) {
            super.set_ez(a);
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.rg);
                        this.rg = null;
                    }
                    let f = typeCast(IFastItemsSource_$type, d);
                    if (f != null) {
                        this.rg = this.cf(this.rk);
                    }
                    this.l7(false);
                    break;
                case ScatterAreaSeries.$$p[1]:
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.rg);
                        this.rg = this.cf(this.rk);
                    }
                    this.l7(false);
                    this.le();
                    break;
                case "ColorScale":
                    this.rr();
                    this.l7(false);
                    this.le();
                    break;
            }
        }
        l8(a) {
            super.l8(a);
            this.rq(this.by);
        }
        l6(a, b, c, d, e) {
            super.l6(a, b, c, d, e);
            let f = this.a5.a$h.item(d);
            f.a1(c);
            if (this.cu(f)) {
                return;
            }
            this.rq(f);
        }
        rq(a) {
            if (this.cu(a)) {
                return;
            }
            let b;
            let c;
            let d = a.getViewInfo(c, b);
            c = d.p0;
            b = d.p1;
            let e = a;
            let f = null;
            let g = null;
            let h = this.pr;
            let i = this.ps;
            let j = this.getEffectiveViewport1(a);
            let k = new ScalerParams(1, b, c, h.cf);
            k.c = j;
            let l = new ScalerParams(1, b, c, i.cf);
            l.c = j;
            g = this.re(a, k, l);
            if (g != null) {
                e.b8(g);
            }
            else {
                e.cb(f);
            }
        }
        rn(a) {
            let b;
            let c;
            let d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            let e = truncate(Math.round(b.width)) * truncate(Math.round(b.height));
            let f = a.b0;
            if (f == null || f.length != e) {
                f = new Array(e);
                for (let g = 0; g < e; g++) {
                    f[g] = 0;
                }
            }
            else {
                for (let h = 0; h < e; h++) {
                    f[h] = 0;
                }
            }
            a.b0 = f;
        }
        hk(a) {
            let b = truncate(Math.round(this.po.width));
            let c = truncate(Math.round(this.po.height));
            let d = this.by.b0;
            if (d == null || d.length != (b * c) || this.p1 == null || this.p1.count < 1 || this.p2 == null || this.p2.count < 1 || this.p3 == null || this.p3.count < 1) {
                return null;
            }
            let e = this.cb.sg;
            let f = (a.x - e.left) / e.width;
            let g = (a.y - e.top) / e.height;
            let h = truncate(Math.round(b * f));
            let i = truncate(Math.round(c * g));
            let j = (b * i) + h;
            if (j < 0 || j > d.length - 1) {
                return null;
            }
            let k = d[j] - 1;
            if (k < 0 || k > this.p1.count) {
                return null;
            }
            let l = this.q8.length;
            let m = this.p1.item(k);
            let n = this.p2.item(k);
            let o = this.p3.item(k);
            if ((m >= l) || (n >= l) || (o >= l)) {
                return null;
            }
            let p = (this.q8[m] - this.po.left) / this.po.width;
            let q = (this.q9[m] - this.po.top) / this.po.height;
            let r = (this.q8[n] - this.po.left) / this.po.width;
            let s = (this.q9[n] - this.po.top) / this.po.height;
            let t = (this.q8[o] - this.po.left) / this.po.width;
            let u = (this.q9[o] - this.po.top) / this.po.height;
            let v = Math.pow(p - f, 2) + Math.pow(q - g, 2);
            let w = Math.pow(r - f, 2) + Math.pow(s - g, 2);
            let x = Math.pow(t - f, 2) + Math.pow(u - g, 2);
            if (v < w && v < x) {
                return this.ci.item(m);
            }
            if (w < v && w < x) {
                return this.ci.item(n);
            }
            if (x < v && x < w) {
                return this.ci.item(o);
            }
            return this.ci.item(m);
        }
        re(a, b, c) {
            let d;
            let e;
            let f = a.getViewInfo(e, d);
            e = f.p0;
            d = f.p1;
            e = new Rect(0, 0, 0, e.width, e.height);
            b = new ScalerParams(0, b.e, e, b.a, b.c);
            c = new ScalerParams(0, c.e, e, c.a, c.c);
            c.b = this.f4();
            let g = a;
            let h = this.pr;
            let i = this.ps;
            let j = this.p1.count;
            let k;
            let xArr_ = this.p4.asArray();
            k = (xArr_.slice(0));
            let l;
            let yArr_ = this.p5.asArray();
            l = (yArr_.slice(0));
            let m = this.rg.asArray();
            let n = this.p1.asArray();
            let o = this.p2.asArray();
            let p = this.p3.asArray();
            this.q8 = k;
            this.q9 = l;
            h.hi(boxArray$1(k), 0, k.length, b);
            i.hi(boxArray$1(l), 0, l.length, c);
            let q = this.rb;
            let r = g.b2(b.d, q, this.rg);
            let s = e.top;
            let t = e.left;
            let u = e.right;
            let v = e.bottom;
            let w;
            let x;
            let y;
            let z;
            this.rn(g);
            let aa = g.b0;
            let ab = k.length;
            for (let ac = 0; ac < j; ac++) {
                let ad = n[ac];
                let ae = o[ac];
                let af = p[ac];
                if ((ad >= ab) || (ae >= ab) || (af >= ab) || (ad < 0) || (ae < 0) || (af < 0)) {
                    continue;
                }
                let ag = k[ad];
                let ah = l[ad];
                let ai = { $type: Point_$type, x: ag, y: ah };
                let aj = k[ae];
                let ak = l[ae];
                let al = { $type: Point_$type, x: aj, y: ak };
                let am = k[af];
                let an = l[af];
                let ao = { $type: Point_$type, x: am, y: an };
                w = al.y < ao.y ? al.y : ao.y;
                w = ai.y < w ? ai.y : w;
                x = al.y > ao.y ? al.y : ao.y;
                x = ai.y > x ? ai.y : x;
                y = al.x < ao.x ? al.x : ao.x;
                y = ai.x < y ? ai.x : y;
                z = al.x > ao.x ? al.x : ao.x;
                z = ai.x > z ? ai.x : z;
                if (w < v && x > s && y < u && z > t) {
                    let ap = m[ad];
                    let aq = m[ae];
                    let ar = m[af];
                    r.p(ac, aa, ai, al, ao, ap, aq, ar);
                }
            }
            return r;
        }
        rh() {
            let a = new Color();
            let b = this.oo;
            if (b == null) {
                a = ColorUtil.r("#000000");
            }
            else {
                a = ColorUtil.q(b);
            }
            let c = new ObservableColorCollection();
            c.add(ColorUtil.v(a, -0.5));
            c.add(a);
            return c;
        }
        rr() {
            let a = this.rc;
            if (a == null) {
                a = ((() => {
                    let $ret = new CustomPaletteColorScale();
                    $ret.palette = this.rh();
                    $ret.interpolationMode = 2;
                    return $ret;
                })());
            }
            else if (typeCast(CustomPaletteColorScale.$, a) !== null) {
                let b = a;
                if (b.palette == null || b.palette.count == 0) {
                    b.palette = this.rh();
                }
                a = b;
            }
            let c = new ObservableColorCollection();
            if (typeCast(CustomPaletteColorScale.$, a) !== null) {
                c = a.palette;
            }
            else {
                c = this.rh();
            }
            this.rb = a;
        }
        mk() {
            super.mk();
            this.rr();
        }
        ko(a, b) {
            super.ko(a, b);
            let c = b;
            c.b7();
        }
        bv() {
            return new ScatterAreaSeriesView(this);
        }
        lo(a) {
            super.lo(a);
            this.rd = typeCast(ScatterAreaSeriesView.$, a);
        }
        ro(a) {
            if (this.rd != null) {
                this.rd.b6(a);
            }
        }
    }
    ScatterAreaSeries.$t = /*@__PURE__*/ markType(ScatterAreaSeries, 'ScatterAreaSeries', ScatterTriangulationSeries.$);
    ScatterAreaSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:rb:rs', [ColorScale.$, null], 'ColorMemberPath:rk:rt', [2, null]]);
    return ScatterAreaSeries;
})();
/**
 * @hidden
 */
export let ScatterAreaSeriesView = /*@__PURE__*/ (() => {
    class ScatterAreaSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.b1 = null;
            this.bx = null;
            this.b5 = null;
            this.b4 = null;
            this.b3 = null;
            this.b1 = a;
        }
        get b0() {
            return this.bx;
        }
        set b0(a) {
            this.bx = a;
        }
        ca(a, b) {
        }
        b6(a) {
        }
        by() {
            return this.bz(true);
        }
        bz(a) {
            this.b9();
            let b = truncate(Math.round(this.bu.left));
            let c = truncate(Math.round(this.bu.left));
            let d = truncate(Math.round(this.bu.width));
            let e = truncate(Math.round(this.bu.height));
            let f = d.toString();
            let g = e.toString();
            if (this.b4.getAttribute("width") != f) {
                this.b4.setAttribute("width", d.toString());
            }
            if (this.b4.getAttribute("height") != g) {
                this.b4.setAttribute("height", e.toString());
            }
            let h = this.b3.g();
            if (a) {
                h.clearRect(0, 0, d, e);
            }
            this.b5 = h.getImageData(0, 0, d, e);
            let imageDataArray_ = this.b5.data;
            return imageDataArray_;
        }
        b9() {
            if (this.b4 == null) {
                this.b4 = this.e.gz.createElement("canvas");
                let a = this.e.gz.get2DCanvasContext(this.b4);
                this.b3 = new RenderingContext(new CanvasViewRenderer(), a);
            }
        }
        b2(a, b, c) {
            let d = truncate(Math.round(this.bu.left));
            let e = truncate(Math.round(this.bu.left));
            let f = truncate(Math.round(this.bu.width));
            let g = truncate(Math.round(this.bu.height));
            return new TriangleRasterizer(this.by(), b, c.minimum, c.maximum, c, f, g);
        }
        b8(a) {
            this.cb(null);
        }
        b7() {
            if (this.b3 != null) {
                this.b3.k(this.bu.left, this.bu.top, this.bu.width, this.bu.height);
            }
            this.aq();
        }
        a6(a, b) {
            super.a6(a, b);
            if (this.b4 == null) {
                return;
            }
            if (b) {
                let c = new Rectangle();
                c.n = this.bu.left;
                c.o = this.bu.top;
                c.width = this.bu.width;
                c.height = this.bu.height;
                c._fill = this.bo();
                a.v(c);
            }
            else {
                let d = truncate(Math.round(this.bu.left));
                let e = truncate(Math.round(this.bu.top));
                let f = truncate(Math.round(this.bu.width));
                let g = truncate(Math.round(this.bu.height));
                a.m(this.b4.getNativeElement(), 1, d, e, f, g);
            }
        }
        cb(a) {
            let b = truncate(Math.round(this.bu.left));
            let c = truncate(Math.round(this.bu.left));
            let d = truncate(Math.round(this.bu.width));
            let e = truncate(Math.round(this.bu.height));
            this.b9();
            this.b3.g().putImageData(this.b5, 0, 0);
            this.aq();
        }
        al(a) {
            super.al(a);
            let b = truncate(Math.round(this.bu.width));
            let c = truncate(Math.round(this.bu.height));
            let d = this.bz(false);
            if (d == null || d.length == 0) {
                this.e.a7.exportSeriesPixelsData(a, null, b, c);
                return;
            }
            let e = new Array(intDivide(d.length, 4));
            let f;
            for (let g = 0; g < intDivide(d.length, 4); g++) {
                f = g * 4;
                e[g] = d[f + 3] << 24 | d[f] << 16 | d[f + 1] << 8 | d[f + 2];
            }
            this.e.a7.exportSeriesPixelsData(a, e, b, c);
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a5.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.b1.hs + "</span><br/><span>" + "(${item." + this.b1.qp + "}, ${item." + this.b1.qt + "})</span>";
            if (!stringIsNullOrEmpty(this.b1.rk)) {
                a += "<span>, Value: ${item." + this.b1.rk + "}</span>";
            }
            a += "</div>";
            return a;
        }
    }
    ScatterAreaSeriesView.$t = /*@__PURE__*/ markType(ScatterAreaSeriesView, 'ScatterAreaSeriesView', SeriesView.$);
    return ScatterAreaSeriesView;
})();
