/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { ScatterItemSearchMode_$type } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "./HighlightingInfo";
import { ScatterFrame } from "./ScatterFrame";
import { Base, enumGetBox, Number_$type, typeCast, fromEnum, Point_$type, runOn, markType, markDep, PointUtil } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { GeometryUtil } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { PathGeometry } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { boxArray$1, arrayShallowClone } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ScatterBase = /*@__PURE__*/ (() => {
    class ScatterBase extends MarkerSeries {
        constructor() {
            super();
            this.rk = null;
            this.ry = null;
            this.rz = null;
            this.ub = null;
            this.uc = null;
            this.rt = 1;
            this.q5 = null;
            this.q6 = null;
            this.rq = null;
            this.rs = null;
            this.ro = null;
            this.r3 = false;
            this.r2 = false;
            this.rg = null;
            this.rh = null;
            this.assigningScatterStyle = null;
            this.assigningScatterMarkerStyle = null;
            this.rx = null;
            this.rr = null;
            this.rn = null;
            this.ru = this.rv();
            this.rx = new ScatterSeriesRenderManager();
            this.rr = new ScatterFrame();
            this.uc = Rect.empty;
            this.ub = Rect.empty;
        }
        bv() {
            return new ScatterBaseView(this);
        }
        kl() {
            super.kl();
            this.xAxis = null;
            this.yAxis = null;
        }
        lo(a) {
            super.lo(a);
            this.rl = a;
        }
        get_d8() {
            return true;
        }
        ag() {
            return [this.xAxis, this.yAxis];
        }
        hn(a, b) {
            let c = this.jf(b);
            if (c == ScatterBase.$$p[8]) {
                return this.ho(a, b, this.sx);
            }
            if (c == ScatterBase.$$p[10]) {
                return this.ho(a, b, this.s1);
            }
            return null;
        }
        cy(a, b, c, d) {
            if (!this.hasMarkers) {
                return false;
            }
            let e = this.xAxis;
            let f = new ScalerParams(1, this.cb.r0, this.po, e.cf);
            f.c = this.getEffectiveViewport1(this.by);
            let g = this.yAxis;
            let h = new ScalerParams(1, this.cb.r0, this.po, g.cf);
            h.c = this.getEffectiveViewport1(this.by);
            a.clear();
            this.pz.cf((i) => {
                if (i._visibility == 0) {
                    let j = new SeriesPointOfInterest();
                    let k = i.n;
                    let l = i.o;
                    if (k < this.po.left || k > this.po.right || l < this.po.top || l > this.po.bottom) {
                        return;
                    }
                    j.b = e.ei(k, f);
                    j.c = g.ei(l, h);
                    j.a = i.content;
                    a.add(j);
                }
            });
            return true;
        }
        bp() {
            if (this.bq == 0) {
                if (this.sl <= 2000) {
                    return 1;
                }
                else {
                    return super.bp();
                }
            }
            else {
                return super.bp();
            }
        }
        pm(a) {
            if (!this.hasMarkers || !this.p2()) {
                return Rect.empty;
            }
            let b = this.pz.by(this.o6(a));
            if (b != null) {
                return this.pz.cp(b);
            }
            return Rect.empty;
        }
        er(a, b) {
            if (this.p3(a, b)) {
                return true;
            }
            return false;
        }
        get r0() {
            return this.ry;
        }
        set r0(a) {
            if (this.ry != a) {
                let b = this.r0;
                this.ry = a;
                this.raisePropertyChanged("XColumn", b, this.r0);
            }
        }
        get r1() {
            return this.rz;
        }
        set r1(a) {
            if (this.rz != a) {
                let b = this.r1;
                this.rz = a;
                this.raisePropertyChanged("YColumn", b, this.r1);
            }
        }
        get t8() {
            return this.c(ScatterBase.tp);
        }
        set t8(a) {
            this.h(ScatterBase.tp, a);
        }
        get GetErrorBarsXAxis() {
            return this.xAxis;
        }
        get GetErrorBarsYAxis() {
            return this.yAxis;
        }
        k5() {
            super.k5();
            if (this.xAxis != null) {
                this.xAxis.h3(false);
            }
            if (this.yAxis != null) {
                this.yAxis.h3(false);
            }
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            if (this.rl.cx.g$b(a, b, c, d)) {
                this.l7(false);
                this.le();
            }
            switch (b) {
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.r0);
                        c.deregisterColumn(this.r1);
                        this.r0 = null;
                        this.r1 = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.r0 = this.cf(this.sx);
                        this.r1 = this.cf(this.s1);
                    }
                    if ((this.yAxis != null && !this.yAxis.cy()) || (this.xAxis != null && !this.xAxis.cy())) {
                        this.l7(false);
                    }
                    break;
                case ScatterBase.$$p[7]:
                    if (c != null) {
                        c.by(this);
                    }
                    if (d != null) {
                        d.cq(this);
                    }
                    if ((this.xAxis != null && !this.xAxis.cy()) || (d == null && c != null)) {
                        this.l7(false);
                    }
                    this.le();
                    break;
                case ScatterBase.$$p[9]:
                    if (c != null) {
                        c.by(this);
                    }
                    if (d != null) {
                        d.cq(this);
                    }
                    if ((this.yAxis != null && !this.yAxis.cy()) || (d == null && c != null)) {
                        this.l7(false);
                    }
                    this.le();
                    break;
                case ScatterBase.$$p[8]:
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.r0);
                        this.r0 = this.cf(this.sx);
                    }
                    break;
                case "XColumn":
                    this.rl.cx.g$i();
                    if (this.xAxis != null && !this.xAxis.cy()) {
                        this.l7(false);
                    }
                    break;
                case ScatterBase.$$p[10]:
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.r1);
                        this.r1 = this.cf(this.s1);
                    }
                    break;
                case "YColumn":
                    this.rl.cx.g$i();
                    if (this.yAxis != null && !this.yAxis.cy()) {
                        this.l7(false);
                    }
                    break;
                case ScatterBase.$$p[5]:
                    this.l7(false);
                    this.le();
                    break;
                case ScatterBase.$$p[6]:
                    this.l7(false);
                    this.le();
                    break;
                case "TransitionProgress":
                    this.rs.c(this.gq, this.rq, this.ro);
                    this.s3();
                    try {
                        if (this.cu(this.by)) {
                            return;
                        }
                        if ((Math.round(this.gq * 100000) / 100000) == 1) {
                            this.tn(this.ro, this.rl);
                        }
                        else {
                            this.tn(this.rs, this.rl);
                        }
                        if (this.cb != null) {
                            this.cb.nd(this);
                        }
                    }
                    finally {
                        this.to();
                    }
                    break;
                case "TrendLineBrush":
                    this.mk();
                    break;
                case ScatterBase.$$p[0]:
                    if (this.rm != null) {
                        this.rm.r = this;
                    }
                    this.l7(false);
                    this.le();
                    break;
                case "TrendLineType":
                    this.le();
                    break;
                case ScatterBase.$$p[2]:
                    this.r3 = this.sb();
                    this.l7(false);
                    break;
                case ScatterBase.$$p[1]:
                    this.r2 = this.sa();
                    this.l7(false);
                    break;
                case ScatterBase.$$p[3]:
                    this.ru = this.rv();
                    break;
            }
        }
        sb() {
            return this.r7;
        }
        sa() {
            return this.r6;
        }
        r5(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        r4(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        to() {
            this.ub = Rect.empty;
            this.uc = Rect.empty;
        }
        s3() {
            let a = this.getViewInfo(this.ub, this.uc);
            this.ub = a.p0;
            this.uc = a.p1;
        }
        r9(a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.sx == a || this.s1 == a) {
                return true;
            }
            return false;
        }
        kr(a, b, c, d) {
            let e = false;
            if (!this.r9(d, a)) {
                return;
            }
            this.rl.cx.g$e(a, b, c, d);
            if (this.xAxis != null && !this.xAxis.cy()) {
                e = true;
            }
            if (this.yAxis != null && !this.yAxis.cy()) {
                e = true;
            }
            if (e) {
                this.l7(true);
            }
        }
        tf(a) {
            this.tg(a, null);
        }
        tg(a, b) {
            let c = this.r0 != null ? this.r0.count : 0;
            let d = this.r1 != null ? this.r1.count : 0;
            let e = Math.min(c, d);
            if (e <= this.sl) {
                a.m.clear();
                let f = new List$1(OwnedPoint.$, 0);
                for (let g of fromEnum(a.u.values)) {
                    f.add(g);
                }
                let h = this.ci;
                f.aa((i, j) => {
                    let k = h.indexOf(i.a);
                    let l = h.indexOf(j.a);
                    if (k < l) {
                        return -1;
                    }
                    if (k > l) {
                        return 1;
                    }
                    return 0;
                });
                if (b != null) {
                    b.i = a.m;
                }
                for (let i of fromEnum(f)) {
                    if (h.indexOf(i.a) >= 0) {
                        if (b != null) {
                            b.j(i.c);
                        }
                        else {
                            a.m.add({ $type: Point_$type, x: i.c.x, y: i.c.y });
                        }
                    }
                }
            }
        }
        ap(a) {
            if (a != null && a == this.xAxis && this.r0 != null) {
                return new AxisRange(this.r0.minimum, this.r0.maximum);
            }
            if (a != null && a == this.yAxis && this.r1 != null) {
                return new AxisRange(this.r1.minimum, this.r1.maximum);
            }
            return null;
        }
        hk(a) {
            let b = this.g3(a);
            if (this.ci != null && b >= 0 && b < this.ci.count) {
                return this.ci.item(b);
            }
            return null;
        }
        get ru() {
            return this.rt;
        }
        set ru(a) {
            let b = this.rt;
            this.rt = a;
            if (b != this.rt) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ScatterItemSearchMode_$type, b), enumGetBox(ScatterItemSearchMode_$type, this.rt));
            }
        }
        rv() {
            if (this.rw != 0) {
                return this.rw;
            }
            return this.r8 ? 4 : 1;
        }
        g3(a) {
            let b = truncate(Math.round(this.fy(a)));
            return b;
        }
        fy(a) {
            switch (this.ru) {
                case 1: return this.sh(a);
                case 3: return this.si(a);
                case 2: return this.sf(a);
                case 4: return this.sg(a);
            }
            return -1;
        }
        sg(a) {
            return this.sj(a, false);
        }
        sf(a) {
            let b = this.o6(a);
            let c = b.x;
            let d = b.y;
            if (this.ci == null || this.xAxis == null || this.yAxis == null || this.r0 == null || this.r1 == null) {
                return -1;
            }
            if (this.ci.count > this.sk) {
                return -1;
            }
            this.s6();
            let e = this.q5;
            let f = this.q6;
            if (e == null || f == null) {
                return -1;
            }
            let g = 1.7976931348623157E+308;
            let h = -1;
            for (let i = 0; i < this.r0.count; i++) {
                let j = e[i];
                let k = f[i];
                let l = (c - j) * (c - j) + (d - k) * (d - k);
                if (l < g) {
                    g = l;
                    h = i;
                }
            }
            return h;
        }
        s6() {
            let a = this.by.bv;
            let b = this.by.bu;
            let c = this.getEffectiveViewport();
            if (this.rk == null) {
                return;
            }
            let d = new ScalerParams(0, a, b, this.rk.d, c);
            let e = ((() => {
                let $ret = new ScalerParams(0, a, b, this.rk.e, c);
                $ret.b = this.f4();
                return $ret;
            })());
            if (this.q5 == null || this.q6 == null) {
                let f = arrayShallowClone(this.r0.asArray());
                let g = arrayShallowClone(this.r1.asArray());
                this.xAxis.hi(boxArray$1(f), 0, f.length, d);
                this.yAxis.hi(boxArray$1(g), 0, g.length, e);
                this.q5 = f;
                this.q6 = g;
            }
        }
        get_r8() {
            return false;
        }
        get r8() {
            return this.get_r8();
        }
        sj(a, b) {
            if (!this.r8) {
                return -1;
            }
            let c = { $type: Point_$type, x: 0, y: 0 };
            let d = true;
            let e = this.rp();
            if (e == null) {
                return -1;
            }
            if (e.m == null) {
                return -1;
            }
            if (this.ci == null || this.ci.count > this.sk) {
                return -1;
            }
            this.s6();
            let f = this.q5;
            let g = this.q6;
            if (f == null || g == null) {
                return -1;
            }
            let h = this.o6(a);
            let i = 1.7976931348623157E+308;
            let j = -1;
            for (let k = 0; k < this.q5.length; k++) {
                let l = { $type: Point_$type, x: this.q5[k], y: this.q6[k] };
                if (k > 0) {
                    if (!b || e.j.containsKey(this.ci.item(k)) || e.j.containsKey(this.ci.item(k - 1))) {
                        let m = GeometryUtil.d(h, c, l);
                        if (m < i) {
                            i = m;
                            j = k;
                        }
                    }
                }
                c = l;
            }
            if (j >= 0) {
                let n = { $type: Point_$type, x: this.q5[j], y: this.q6[j] };
                let o = { $type: Point_$type, x: this.q5[j - 1], y: this.q6[j - 1] };
                if (!b || (e.j.containsKey(this.ci.item(j)) && e.j.containsKey(this.ci.item(j - 1)))) {
                    let p = GeometryUtil.h(h, o, n);
                    return (j - 1) + p;
                }
                else if (e.j.containsKey(this.ci.item(j))) {
                    return j;
                }
                else {
                    return j - 1;
                }
            }
            return -1;
        }
        si(a) {
            return this.sj(a, true);
        }
        sh(a) {
            let b = null;
            let c = 1.7976931348623157E+308;
            let d = this.o6(a);
            let e = d.x;
            let f = d.y;
            if (this.rl.cy.e > this.sk) {
                return -1;
            }
            this.rl.c5((g) => {
                if (g._visibility == 0) {
                    let h = this.rl.cp(g);
                    let i = h.left + h.width / 2;
                    let j = h.top + h.height / 2;
                    let k = (e - i) * (e - i) + (f - j) * (f - j);
                    if (k < c) {
                        c = k;
                        b = g;
                    }
                }
            });
            if (b != null) {
                return b.ak;
            }
            return -1;
        }
        pb(a, b, c) {
            if (this.xAxis == null || this.yAxis == null || this.r0 == null || this.r1 == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let d = this.by.bv;
            let e = this.by.bu;
            let f = this.getEffectiveViewport();
            let g = new ScalerParams(0, d, e, this.xAxis.cf, f);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.cf, f);
                $ret.b = this.f4();
                return $ret;
            })());
            if (b) {
                let i = this.fy(a);
                if (i == -1) {
                    return { $type: Point_$type, x: NaN, y: NaN };
                }
                let j = truncate(Math.floor(i));
                let k = truncate(Math.ceil(i));
                if (j < 0) {
                    j = 0;
                }
                if (k < 0) {
                    k = 0;
                }
                if (k > this.ci.count - 1) {
                    k = this.ci.count - 1;
                }
                if (j > this.ci.count - 1) {
                    j = this.ci.count - 1;
                }
                if (k == j) {
                    let l = this.xAxis.ef(this.r0.item(j), g);
                    let m = this.yAxis.ef(this.r1.item(j), h);
                    return { $type: Point_$type, x: l, y: m };
                }
                let n = i - Math.floor(i);
                let o = this.xAxis.ef(this.r0.item(j), g);
                let p = this.yAxis.ef(this.r1.item(j), h);
                let q = this.xAxis.ef(this.r0.item(k), g);
                let r = this.yAxis.ef(this.r1.item(k), h);
                let s = q - o;
                let t = r - p;
                return { $type: Point_$type, x: o + s * n, y: p + t * n };
            }
            else {
                let u = this.g3(a);
                if (u == -1) {
                    return { $type: Point_$type, x: NaN, y: NaN };
                }
                let v = this.xAxis.ef(this.r0.item(u), g);
                let w = this.yAxis.ef(this.r1.item(u), h);
                return { $type: Point_$type, x: v, y: w };
            }
        }
        ej(a) {
            let b = this.cb != null ? this.cb.r0 : Rect.empty;
            b = b.copy();
            let c = this.cb != null ? this.cb.sf : Rect.empty;
            let d = new Rect(0, 0, 0, 1, 1);
            let e = this.pi(this.by);
            let f = new ScalerParams(0, d, d, this.xAxis.cf, e);
            let g = ((() => {
                let $ret = new ScalerParams(0, d, d, this.yAxis.cf, e);
                $ret.b = this.f4();
                return $ret;
            })());
            let h = !b.isEmpty && !c.isEmpty && this.ci != null ? this.ci.indexOf(a) : -1;
            let i = this.xAxis != null && this.r0 != null && h < this.r0.count ? this.xAxis.ef(this.r0.item(h), f) : NaN;
            let j = this.yAxis != null && this.r1 != null && h < this.r1.count ? this.yAxis.ef(this.r1.item(h), g) : NaN;
            if (!isNaN_(i)) {
                if (i < b.left + 0.1 * b.width) {
                    i = i + 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
                if (i > b.right - 0.1 * b.width) {
                    i = i - 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
            }
            if (!isNaN_(j)) {
                if (j < b.top + 0.1 * b.height) {
                    j = j + 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
                if (j > b.bottom - 0.1 * b.height) {
                    j = j - 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
            }
            if (this.b6 != null) {
                this.b6.au(this.cb, b, true);
            }
            return h >= 0;
        }
        mt(a, b) {
            this.l7(false);
        }
        mu(a, b) {
            this.l7(false);
        }
        rp() {
            let a = this.ro;
            if (this.cs()) {
                if (this.cc.g) {
                    this.cc.t();
                }
                a = this.rs;
            }
            return a;
        }
        s4(a, b, c, d, e) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
            let f = this.getEffectiveViewport1(a);
            let g = this.ci;
            let h;
            let i;
            let j = ((() => {
                let $ret = new ScalerParams(0, d, e, this.rk.d, f);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let k = ((() => {
                let $ret = new ScalerParams(0, d, e, this.rk.e, f);
                $ret.c = this.getEffectiveViewport1(a);
                $ret.b = this.f4();
                return $ret;
            })());
            let l = false;
            let m = 0;
            if (this.cb != null) {
                if (this.cb.ex()) {
                    let n = this.cb.km(d, j);
                    l = n.c;
                    m = n.d;
                }
            }
            for (let o = 0; o < c; o++) {
                h = this.r0.item(o);
                i = this.r1.item(o);
                let p = { $type: Point_$type, x: this.rk.a.ef(h, j), y: this.rk.b.ef(i, k) };
                if (l) {
                    if (p.x < e.left || p.x > e.right) {
                        if (p.x + m >= e.left && p.x + m <= e.right) {
                            p = { $type: Point_$type, x: p.x + m, y: i };
                        }
                    }
                }
                if (!isInfinity(p.x) && !isInfinity(p.y)) {
                    let q = g.item(o);
                    if (!b.g.containsKey(q)) {
                        let r = { $type: Point_$type, x: h, y: i };
                        let s = { $type: Point_$type, x: p.x, y: p.y };
                        b.g.addItem(q, ((() => {
                            let $ret = new OwnedPoint();
                            $ret.a = q;
                            $ret.b = r;
                            $ret.c = s;
                            return $ret;
                        })()));
                    }
                }
            }
        }
        tc(a, b) {
            this.q5 = null;
            this.q6 = null;
            a.j.clear();
            a.n.clear();
            a.h.clear();
            a.l.clear();
            a.i.clear();
            a.k.clear();
            let c = Math.min(this.r0 != null ? this.r0.count : 0, this.r1 != null ? this.r1.count : 0);
            let d = b.bv;
            let e = b.bu;
            let f = this.getEffectiveViewport1(b);
            let g = new ScalerParams(0, d, e, this.xAxis.cf, f);
            g.c = this.getEffectiveViewport1(b);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.cf, f);
                $ret.b = this.f4();
                return $ret;
            })());
            h.c = this.getEffectiveViewport1(b);
            if (c < 1) {
                return;
            }
            this.rk = ((() => {
                let $ret = new ScatterAxisInfoCache();
                $ret.a = this.xAxis;
                $ret.b = this.yAxis;
                $ret.d = this.xAxis.cf;
                $ret.e = this.yAxis.cf;
                $ret.c = this.ci;
                return $ret;
            })());
            let i = b;
            if (c <= this.sl) {
                this.s4(i, a, c, d, e);
            }
            if (this.p2()) {
                b.cv.l(a.j, this.sl, d, e, this.gk);
            }
            let j = ((() => {
                let $ret = new Clipper(0, e, false);
                $ret.i = a.n;
                return $ret;
            })());
            let k = this.pg(b);
            let l = this.xAxis.ei(k.left, g);
            let m = this.xAxis.ei(k.right, g);
            b.cx.h(a.n, this.trendLineType, this.r0, this.r1, this.trendLinePeriod, (n) => this.xAxis.ef(n, g), (n) => this.yAxis.ef(n, h), ((() => {
                let $ret = new TrendResolutionParams();
                $ret.b = this.gk;
                $ret.f = e;
                $ret.g = d;
                return $ret;
            })()), j, l, m);
            this.ta(a, b);
        }
        ko(a, b) {
            super.ko(a, b);
            let c = b;
            c.c4(a);
        }
        get_dt() {
            return true;
        }
        re(a, b, c) {
            return null;
        }
        rf(a, b, c) {
            let d = this.rp();
            let e = this.rl.by(this.o6(b));
            let f = -1;
            if (e == null) {
                if (a != null) {
                    f = this.ci.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else {
                f = e.ak;
            }
            if (f == -1) {
                return null;
            }
            let g = new HighlightingInfo();
            g.b = this;
            g.h = f;
            g.g = f;
            g.d = false;
            g.e = true;
            if (c != null && c.h == g.h && c.g == g.g) {
                return c;
            }
            return g;
        }
        pp() {
            if (this.p0 != 1 && this.p0 != 13) {
                let a = this.pz.cq();
                let b = (a.width / 2) + (this.p5 / 2);
                let c = (a.height / 2) + (this.p5 / 2);
                return new Thickness(1, b, c, b, c);
            }
            return new Thickness(1, 0, 0, 0, 0);
        }
        rd(a, b, c) {
            let d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ci.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        }
        av(a, b, c) {
            if (this.cz && this.eb(this.bk) && !c) {
                let d = this.re(a, b, this.rg);
                this.rg = d;
                return d;
            }
            else {
                let e = this.rd(a, b, this.rg);
                this.rg = e;
                return e;
            }
        }
        aw(a, b, c) {
            if (this.eb(this.bk) && !c) {
                let d = this.rf(a, b, this.rh);
                this.rh = d;
                return d;
            }
            else {
                let e = this.rd(a, b, this.rh);
                e.e = true;
                this.rh = e;
                return e;
            }
        }
        sd() {
            return (this.assigningScatterStyle != null && this.r3) || (this.bk != 1);
        }
        sc() {
            return (this.assigningScatterMarkerStyle != null && this.r2) || (this.bk != 1);
        }
        tn(a, b) {
            let c = b.bu;
            this.rk = ((() => {
                let $ret = new ScatterAxisInfoCache();
                $ret.a = this.xAxis;
                $ret.b = this.yAxis;
                $ret.d = this.xAxis.cf;
                $ret.e = this.yAxis.cf;
                return $ret;
            })());
            if (this.p2()) {
                b.cv.j(a.j, this.p4);
                if (this.sc()) {
                    this.s5(b, a);
                }
            }
            b.cm();
            let d = ((() => {
                let $ret = new Clipper(1, NaN, c.bottom, NaN, c.top, false);
                $ret.i = b.cx.g$j.ak;
                return $ret;
            })());
            b.cx.g$h(a.n, d);
            this.tk(a, b);
        }
        q8(a, b) {
            return this.q9(a, b);
        }
        q9(a, b) {
            if (b < a || a < 0 || a > this.r0.count || b < 0 || b > this.r0.count) {
                return null;
            }
            let c = new Array((b - a) + 1);
            for (let d = a; d <= b; d++) {
                let e = d;
                c[d - a] = this.ci.item(d);
            }
            return c;
        }
        s5(a, b) {
            a.b3 = true;
            this.rx.aw(this, this.sc(), runOn(this, this.q8));
            let c = this.rx.d;
            let d = c != null;
            let e = this.getEffectiveViewport1(a);
            let f = this.ci == null ? 0 : this.ci.count;
            this.rl.cf((g) => {
                if (g._visibility == 0) {
                    let h = g.ak;
                    let i = g.content;
                    if (i == null) {
                        i = new DataContext();
                        g.content = i;
                    }
                    if (d) {
                        this.s7(h, f, a.q);
                    }
                    this.rx.ac(g, i);
                }
            });
        }
        s8(a, b, c) {
            let d = this.bk != 1;
            this.rx.ay(this.rx.b, a, b, false);
            this.rx.ab(this.fl);
            let e = this.rx.av;
            let f = null;
            let g = this.ci;
            if (d && this.cb != null) {
                f = this.cb.a3.getHighlightingInfo(this, g, e.o, e.n, false);
                e.b = f;
            }
            e.f = c;
            this.ti(e);
            this.rx.z(this, f, c, d, a < 0);
        }
        s7(a, b, c) {
            let d = this.bk != 1;
            this.rx.ay(this.rx.d, a, b, true);
            this.rx.aa(this.fl);
            let e = this.rx.au;
            let f = null;
            let g = this.ci;
            let h = null;
            if (d && this.cb != null) {
                f = this.cb.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                if (this.cb.a3.isCrossSeriesHighlight(this)) {
                    h = this.cb.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                }
                e.b = f;
            }
            e.f = c;
            this.th(e);
            this.rx.y(this, f, c, d, e.m, this.cb.a3.totalHighlightingProgress);
        }
        ti(a) {
            if (this.assigningScatterStyle != null && this.r3) {
                this.assigningScatterStyle(this, a);
            }
        }
        th(a) {
            if (this.assigningScatterMarkerStyle != null && this.r2) {
                this.assigningScatterMarkerStyle(this, a);
            }
        }
        ta(a, b) {
            let c = new ErrorBarsHelper(this, b);
            if (this.rm == null) {
                return;
            }
            let d = this.rm.u;
            let e = this.rm.v;
            let f = 0;
            let g = 0;
            let h = 0;
            let i = 0;
            for (let j of fromEnum(a.j.keys)) {
                let k = a.j.item(j);
                if (d != null) {
                    switch (d.getCalculatorType()) {
                        case 1:
                            let l = this.td(k, c, d, h, i, true);
                            h = l.p3;
                            i = l.p4;
                            break;
                        case 0:
                            let m = this.tb(k, c, d, h, i, true);
                            h = m.p3;
                            i = m.p4;
                            break;
                        case 2:
                            let n = this.s9(k, c, d, j, h, i, true);
                            h = n.p4;
                            i = n.p5;
                            break;
                        case 3:
                            let o = this.te(c, d, f, h, i, true);
                            f = o.p2;
                            h = o.p3;
                            i = o.p4;
                            break;
                        case 4:
                            let p = this.tb(k, c, d, h, i, true);
                            h = p.p3;
                            i = p.p4;
                            break;
                    }
                    ;
                    let q = new OwnedPoint();
                    q.c = c.l(d, this.rk.a, k.c, f);
                    q.a = k.a;
                    a.h.addItem(j, q);
                    a.i.addItem(j, [h, i]);
                }
                if (e != null) {
                    switch (e.getCalculatorType()) {
                        case 1:
                            let r = this.td(k, c, e, h, i, false);
                            h = r.p3;
                            i = r.p4;
                            break;
                        case 0:
                            let s = this.tb(k, c, e, h, i, false);
                            h = s.p3;
                            i = s.p4;
                            break;
                        case 2:
                            let t = this.s9(k, c, e, j, h, i, false);
                            h = t.p4;
                            i = t.p5;
                            break;
                        case 3:
                            let u = this.te(c, e, g, h, i, false);
                            g = u.p2;
                            h = u.p3;
                            i = u.p4;
                            break;
                        case 4:
                            let v = this.tb(k, c, e, h, i, false);
                            h = v.p3;
                            i = v.p4;
                            break;
                    }
                    ;
                    let w = new OwnedPoint();
                    w.c = c.m(e, this.rk.b, k.c, g);
                    w.a = k.a;
                    a.l.addItem(j, w);
                    a.k.addItem(j, [h, i]);
                }
            }
        }
        td(a, b, c, d, e, f) {
            if (f) {
                let g;
                let h, i;
                i = this.rk.a;
                if (this.rm.s == 0) {
                    g = a.c.x;
                    h = this.rk.a;
                }
                else {
                    g = a.c.y;
                    h = this.rk.b;
                }
                let j = b.f(g, c, h, i, d, e);
                d = j.p4;
                e = j.p5;
            }
            else {
                let k;
                let l, m;
                m = this.rk.b;
                if (this.rm.t == 0) {
                    k = a.c.x;
                    l = this.rk.a;
                }
                else {
                    k = a.c.y;
                    l = this.rk.b;
                }
                let n = b.f(k, c, l, m, d, e);
                d = n.p4;
                e = n.p5;
            }
            return {
                p3: d,
                p4: e
            };
        }
        tb(a, b, c, d, e, f) {
            if (f) {
                let g = b.j(a.c.x, c, this.rk.a, d, e);
                d = g.p3;
                e = g.p4;
            }
            else {
                let h = b.j(a.c.y, c, this.rk.b, d, e);
                d = h.p3;
                e = h.p4;
            }
            return {
                p3: d,
                p4: e
            };
        }
        s9(a, b, c, d, e, f, g) {
            let h = c.getItemColumn();
            let i = this.ci.indexOf(d);
            if (h != null && i < h.count) {
                let j = h.item(i);
                if (g) {
                    let k = b.h(a.c.x, j, this.rk.a, e, f);
                    e = k.p3;
                    f = k.p4;
                }
                else {
                    let l = b.h(a.c.y, j, this.rk.b, e, f);
                    e = l.p3;
                    f = l.p4;
                }
            }
            else {
                e = NaN;
                f = NaN;
            }
            return {
                p4: e,
                p5: f
            };
        }
        te(a, b, c, d, e, f) {
            let g = a.i(b, c);
            c = g.p1;
            if (f) {
                let h = a.k(c, b, this.rk.a, d, e);
                d = h.p3;
                e = h.p4;
            }
            else {
                let i = a.k(c, b, this.rk.b, d, e);
                d = i.p3;
                e = i.p4;
            }
            return {
                p2: c,
                p3: d,
                p4: e
            };
        }
        tk(a, b) {
            if (!b.o() || this.rm == null) {
                b.c6();
                return;
            }
            this.tl(a, b);
            this.tm(a, b);
        }
        tl(a, b) {
            b.c2();
            let c = new ErrorBarsHelper(this, b);
            let d = new PathGeometry();
            let e = this.rm.u;
            for (let f of fromEnum(a.j.keys)) {
                if (e != null && a.i.containsKey(f)) {
                    let g = a.i.item(f)[0];
                    let h = a.i.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        let i = a.h.item(f).c;
                        if (this.rm.o == 1 || this.rm.o == 2) {
                            c.d(d, i, g, true);
                        }
                        if (this.rm.o == 1 || this.rm.o == 3) {
                            c.d(d, i, h, false);
                        }
                    }
                }
            }
            b.c7(d);
        }
        tm(a, b) {
            b.c3();
            let c = new ErrorBarsHelper(this, b);
            let d = new PathGeometry();
            let e = this.rm.v;
            for (let f of fromEnum(a.j.keys)) {
                if (e != null && a.k.containsKey(f)) {
                    let g = a.k.item(f)[0];
                    let h = a.k.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        let i = a.l.item(f).c;
                        if (this.rm.p == 1 || this.rm.p == 2) {
                            c.e(d, i, g, true);
                        }
                        if (this.rm.p == 1 || this.rm.p == 3) {
                            c.e(d, i, h, false);
                        }
                    }
                }
            }
        }
        e5(a, b, c) {
            let d = true;
            if (!super.e5(a, b, c) || b.isEmpty || a.isEmpty || this.xAxis == null || this.yAxis == null || this.xAxis.bh == null || this.yAxis.bh == null || this.r0 == null || this.r1 == null || this.r0.count == 0 || this.r1.count == 0 || this.ci == null || this.ci.count != this.r0.count || this.ci.count != this.r1.count || this.xAxis.bh == null || this.yAxis.bh == null || this.xAxis.ld == this.xAxis.lc || this.yAxis.ld == this.yAxis.lc) {
                d = false;
            }
            return d;
        }
        getViewInfo(a, b) {
            if (!this.ub.isEmpty && !this.uc.isEmpty) {
                a = this.ub;
                b = this.uc;
                return {
                    p0: a,
                    p1: b
                };
            }
            a = this.by.bu;
            b = this.by.bv;
            return {
                p0: a,
                p1: b
            };
        }
        l8(a) {
            this.s3();
            try {
                if (this.cu(this.by)) {
                    return;
                }
                if (this.ci != null && this.ci.count > this.sl) {
                    a = false;
                }
                if (this.ek(a) && !this.eo) {
                    let b = this.rq;
                    if (this.cs()) {
                        if (this.cc.g) {
                            this.cc.t();
                        }
                        this.rq = this.rs;
                        this.rs = b;
                    }
                    else {
                        this.rq = this.ro;
                        this.ro = b;
                    }
                    this.tc(this.ro, this.rl);
                    this.mf();
                }
                else {
                    if (!this.eo) {
                        this.tc(this.ro, this.rl);
                    }
                    this.tn(this.ro, this.rl);
                }
            }
            finally {
                this.to();
            }
        }
        mk() {
            super.mk();
            if (this.hc < 0) {
                return;
            }
            this.rl.da();
        }
        l9(a, b) {
            super.l9(a, b);
            if (!this.ev) {
                this.by.a2(b);
                return;
            }
            this.by.a2(b);
            if (this.cu(this.bx)) {
                return;
            }
            let c = typeCast(ScatterBaseView.$, this.bx);
            if (!this.ep) {
                this.rr = new ScatterFrame();
                this.tc(this.rr, c);
            }
            this.ep = false;
            this.tn(this.rr, c);
            this.ev = false;
        }
        l6(a, b, c, d, e) {
            super.l6(a, b, c, d, e);
            let f = this.a5.a$h.item(d);
            let g = f;
            f.a1(c);
            if (this.cu(g)) {
                return;
            }
            if (this.rn == null) {
                this.rn = new ScatterFrame();
            }
            this.tc(this.rn, g);
            this.tn(this.rn, g);
        }
        tj(a, b) {
            let c = new List$1(Base.$, 0);
            for (let d of fromEnum(b.c)) {
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
            for (let e of fromEnum(c)) {
                b.h(e);
            }
        }
        q7(a, b, c, d, e) {
            if (c == null || c.length != this.rk.c.count) {
                c = new Array(this.rk.c.count);
                for (let f = 0; f < this.rk.c.count; f++) {
                    c[f] = PointUtil.create();
                }
            }
            let g = this.getEffectiveViewport1(a);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.xAxis.cf, g);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let i = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.cf, g);
                $ret.c = this.getEffectiveViewport1(a);
                $ret.b = this.f4();
                return $ret;
            })());
            let j = this.pg(a);
            let k = this.rk.a.ei(j.left, h);
            let l = this.rk.a.ei(j.right, h);
            let m = this.rk.b.ei(j.bottom, i);
            let n = this.rk.b.ei(j.top, i);
            if (this.rk.d) {
                let o = k;
                k = l;
                l = o;
            }
            if (this.rk.e) {
                let p = m;
                m = n;
                n = p;
            }
            let q = this.rk;
            let r = q.a;
            let s = q.b;
            let t;
            let u;
            let v = this.r0;
            let w = this.r1;
            let x = false;
            let y = 0;
            let z = 0;
            if (this.cb != null) {
                if (this.cb.ex()) {
                    let aa = this.cb.km(d, h);
                    x = aa.c;
                    y = aa.d;
                    z = r.ei(0 + y, h);
                    let ab = r.ei(0, h);
                    z -= ab;
                }
            }
            for (let ac = 0; ac < this.rk.c.count; ac++) {
                t = v.item(ac);
                u = w.item(ac);
                if (x) {
                    if (t >= k && t <= l && u >= m && u <= n) {
                        c[ac].x = r.ef(t, h);
                        c[ac].y = s.ef(u, i);
                    }
                    else {
                        if ((t + z) >= k && (t + z) <= l && u >= m && u <= n) {
                            c[ac].x = r.ef(t, h) + y;
                            c[ac].y = s.ef(u, i);
                        }
                        else {
                            c[ac].x = NaN;
                            c[ac].y = NaN;
                        }
                    }
                }
                else {
                    if (t >= k && t <= l && u >= m && u <= n) {
                        c[ac].x = r.ef(t, h);
                        c[ac].y = s.ef(u, i);
                    }
                    else {
                        c[ac].x = NaN;
                        c[ac].y = NaN;
                    }
                }
            }
            return c;
        }
        se(a, b) {
            if (b == null) {
                b = new List$1(Number_$type, 2, a.e);
            }
            else {
                b.clear();
            }
            let c = 0;
            let d = this.ci;
            for (let e of fromEnum(a.c)) {
                b.add(d.indexOf(e));
            }
            return b;
        }
        ky(a) {
            super.ky(a);
            this.a7.exportTrendlineData(this, a, this.rl.cx.g$j);
        }
        f4() {
            return Series.f5(this.r1, null);
        }
    }
    ScatterBase.$t = /*@__PURE__*/ markType(ScatterBase, 'ScatterBase', MarkerSeries.$, [ISupportsErrorBars_$type, ITrendLineSeries_$type]);
    ScatterBase.tp = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, ScatterBase.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    ScatterBase.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ScatterBase, 'raisePropertyChanged', ['ErrorBarSettings:rm:tq', [ScatterErrorBarSettings.$, null], 'IsCustomScatterMarkerStyleAllowed:r6:tr', [0, false], 'IsCustomScatterStyleAllowed:r7:ts', [0, false], 'ItemSearchMode:rw:tt', [ScatterItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:sk:tu', [1, 10000], 'MarkerCollisionAvoidance:rc:tv', [CollisionAvoidanceType_$type, /*@__PURE__*/ enumGetBox(CollisionAvoidanceType_$type, 0)], 'MaximumMarkers:sl:tw', [1, 400], 'XAxis::t4', [NumericXAxis.$, null], 'XMemberPath:sx:t5', [2, null], 'YAxis::t6', [NumericYAxis.$, null], 'YMemberPath:s1:t7', [2, null], 'TrendLineType::t2', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::t1', [1, 1.5], 'TrendLinePeriod::t0', [1, 7], 'TrendLineBrush::tx', [Brush.$, null], 'TrendLineZIndex:sm:t3', [1, 1001], 'TrendLineDashArray:t9:ty', [DoubleCollection.$], 'TrendLineDashCap:ua:tz', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return ScatterBase;
})();
/**
 * @hidden
 */
export let ScatterSeriesRenderManager = /*@__PURE__*/ (() => {
    class ScatterSeriesRenderManager extends SeriesRenderManager {
        constructor() {
            super(...arguments);
            this.au = null;
            this.av = null;
        }
        c() {
            this.au = new AssigningScatterMarkerStyleEventArgs();
            return this.au;
        }
        a() {
            this.av = new AssigningScatterStyleEventArgs();
            return this.av;
        }
        aw(a, b, c) {
            this.w(a, b, c);
        }
        ax(a, b, c) {
            this.x(a, b, c);
        }
        ay(a, b, c, d) {
            if (b == -1) {
                a.c = false;
                a.o = 0;
                a.n = c - 1;
            }
            else {
                if (d) {
                    a.o = b;
                    a.n = b;
                }
                else {
                    a.c = false;
                    a.o = b;
                    a.n = b;
                }
            }
        }
    }
    ScatterSeriesRenderManager.$t = /*@__PURE__*/ markType(ScatterSeriesRenderManager, 'ScatterSeriesRenderManager', SeriesRenderManager.$);
    return ScatterSeriesRenderManager;
})();
/**
 * @hidden
 */
export let ScatterBaseView = /*@__PURE__*/ (() => {
    class ScatterBaseView extends MarkerSeriesView {
        constructor(a) {
            super(a);
            this.cv = null;
            this.ct = null;
            this.cw = null;
            this.c1 = null;
            this.dc = null;
            this.dd = null;
            this.cx = null;
            this.db = null;
            this.cy = null;
            this.cw = a;
            this.cy = new HashPool$2(Base.$, Marker.$);
            this.ch(this.cy);
            this.cx = new ScatterTrendLineManager();
        }
        as() {
            super.as();
            this.cv = this.cu();
            this.dc = new Path();
            this.dd = new Path();
            if (!this.q) {
                this.cw.sl = 2000;
            }
        }
        de(a) {
            if (this.db == null) {
                this.db = new DataTemplateMeasureInfo();
                this.db.context = this.k.g();
            }
            this.db.width = a.width;
            this.db.height = a.height;
            this.db.data = a.content;
            let b = a.ah;
            if (b.measure != null) {
                b.measure(this.db);
            }
            return new Size(1, this.db.width, this.db.height);
        }
        cu() {
            let a = new NumericMarkerManager(1, (b) => this.cy.item(b), (b) => this.cw.rk.c.item(b), runOn(this, this.c9), runOn(this, this.cr), runOn(this, this.cz), () => this.cw.rc);
            a.q = runOn(this, this.de);
            return a;
        }
        c9(a) {
            this.cw.tj(a, this.cy);
        }
        c0() {
            return this.b4;
        }
        cs() {
            return this.ct;
        }
        cr() {
            this.ct = this.cw.q7(this, this.cy, this.ct, this.bv, this.bu);
            return this.ct;
        }
        cz() {
            this.c1 = this.cw.se(this.cy, this.c1);
            return this.c1;
        }
        c2() {
        }
        c7(a) {
        }
        c3() {
        }
        c8(a) {
        }
        da() {
            if (this.cw.trendLineBrush != null) {
                this.cw.t8 = this.cw.trendLineBrush;
            }
            else {
                this.cw.t8 = this.cw.oo;
            }
        }
        cf(a) {
            this.cy.f(a);
        }
        c5(a) {
            this.cy.g(a);
        }
        c6() {
        }
        a5(a, b) {
            super.a5(a, b);
            if (a.d) {
                if (this.cw.trendLineType != 0 && !b) {
                    let c = this.cx.g$j;
                    c.ac = this.cw.trendLineThickness;
                    c._stroke = this.cw.t8;
                    c.ai = this.cw.t9;
                    c.ad = this.cw.ua;
                    a.u(c);
                }
            }
        }
        c4(a) {
            if (a) {
                this.c6();
                this.cy.clear();
            }
            this.cx.g$d();
            this.aq();
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a5.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.cw.hs + "</span><br/><span>" + "x: </span><span class='ui-priority-primary'>${item." + this.cw.sx + "}</span><br/><span>" + "y: </span><span class='ui-priority-primary'>${item." + this.cw.s1 + "}</span></div>";
            return a;
        }
    }
    ScatterBaseView.$t = /*@__PURE__*/ markType(ScatterBaseView, 'ScatterBaseView', MarkerSeriesView.$);
    return ScatterBaseView;
})();
