/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-react-core";
import { IEnumerable_$type, runOn, delegateCombine, delegateRemove, typeCast, markType, markDep } from "igniteui-react-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { Triangulator } from "igniteui-react-core";
import { TriangulationStatusEventArgs } from "igniteui-react-core";
import { FastItemsSource } from "igniteui-react-core";
import { SeriesViewer } from "./SeriesViewer";
import { Axis } from "./Axis";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-react-core";
/**
 * @hidden
 */
export let ScatterTriangulationSeries = /*@__PURE__*/ (() => {
    class ScatterTriangulationSeries extends Series {
        constructor() {
            super(...arguments);
            this.py = null;
            this.pz = null;
            this.p7 = false;
            this.pu = null;
            this.triangulationStatusChanged = null;
            this.qa = null;
            this.pv = null;
            this.pw = null;
            this.px = null;
        }
        kl() {
            super.kl();
            this.pr = null;
            this.ps = null;
        }
        hn(a, b) {
            let c = this.jf(b);
            if (c == ScatterTriangulationSeries.$$p[6]) {
                return this.ho(a, b, this.qp);
            }
            if (c == ScatterTriangulationSeries.$$p[8]) {
                return this.ho(a, b, this.qt);
            }
            return super.hn(a, b);
        }
        get p4() {
            return this.py;
        }
        set p4(a) {
            let b = this.p4 != a;
            if (b) {
                let c = this.p4;
                this.py = a;
                this.raisePropertyChanged("XColumn", c, this.p4);
            }
        }
        get p5() {
            return this.pz;
        }
        set p5(a) {
            let b = this.p5 != a;
            if (b) {
                let c = this.p5;
                this.pz = a;
                this.raisePropertyChanged("YColumn", c, this.p5);
            }
        }
        l8(a) {
            let b = this.ci != null && this.p6 == null && this.qa == null && this.p4 != null && this.p5 != null && this.p4.count >= 3 && this.p5.count >= 3 && !this.p7;
            if (b) {
                this.qx();
                this.p7 = true;
            }
        }
        qx() {
            this.pu = new Triangulator(this.ci.count, this.p4, this.p5);
            let a = this.pu;
            a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.qy));
            this.pu.y();
        }
        qv() {
            if (this.pu == null) {
                return;
            }
            this.pu.r();
            let a = this.pu;
            a.triangulationStatusChanged = delegateRemove(a.triangulationStatusChanged, runOn(this, this.qy));
            this.pu = null;
        }
        qy(a, b) {
            if (this.triangulationStatusChanged != null) {
                this.triangulationStatusChanged(this, new TriangulationStatusEventArgs(b.currentStatus));
            }
            if (b.currentStatus >= 100) {
                if (this.pu == null) {
                    return;
                }
                let c = this.pu;
                c.triangulationStatusChanged = delegateRemove(c.triangulationStatusChanged, runOn(this, this.qy));
                this.qa = this.pu.n();
                this.pu = null;
                let d = ((() => {
                    let $ret = new FastItemsSource();
                    $ret.e = this.qa;
                    return $ret;
                })());
                this.p1 = this.p0(d, "v1");
                this.p2 = this.p0(d, "v2");
                this.p3 = this.p0(d, "v3");
                this.l7(false);
            }
        }
        p0(a, b) {
            if (b == null) {
                return a.registerColumnInt(null, null, false);
            }
            let c = null;
            let d = SeriesViewer.b8(b, this.coercionMethods);
            c = d.a;
            return a.registerColumnInt(b, c, this.expectFunctions);
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.p4);
                        e.deregisterColumn(this.p5);
                        this.p4 = null;
                        this.p5 = null;
                    }
                    this.qw();
                    let f = typeCast(IFastItemsSource_$type, d);
                    if (f != null) {
                        this.p4 = this.cf(this.qp);
                        this.p5 = this.cf(this.qt);
                    }
                    this.l7(false);
                    break;
                case ScatterTriangulationSeries.$$p[6]:
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.p4);
                        this.p4 = this.cf(this.qp);
                    }
                    this.qw();
                    this.l7(false);
                    this.le();
                    break;
                case ScatterTriangulationSeries.$$p[8]:
                    if (this.ci != null) {
                        this.ci.deregisterColumn(this.p5);
                        this.p5 = this.cf(this.qt);
                    }
                    this.qw();
                    this.l7(false);
                    this.le();
                    break;
                case ScatterTriangulationSeries.$$p[5]:
                    if (c != null) {
                        (typeCast(Axis.$, c)).by(this);
                    }
                    if (d != null) {
                        (typeCast(Axis.$, d)).cq(this);
                    }
                    if ((this.pr != null && !this.pr.cy()) || (d == null && c != null)) {
                        this.l7(false);
                    }
                    this.le();
                    break;
                case ScatterTriangulationSeries.$$p[7]:
                    if (c != null) {
                        (typeCast(Axis.$, c)).by(this);
                    }
                    if (d != null) {
                        (typeCast(Axis.$, d)).cq(this);
                    }
                    if ((this.ps != null && !this.ps.cy()) || (d == null && c != null)) {
                        this.l7(false);
                    }
                    this.le();
                    break;
                case ScatterTriangulationSeries.$$p[1]:
                    if (this.trianglesSource != null) {
                        this.qv();
                        this.p6 = ((() => {
                            let $ret = new FastItemsSource();
                            $ret.e = this.trianglesSource;
                            return $ret;
                        })());
                    }
                    else {
                        this.p6 = null;
                    }
                    break;
                case ScatterTriangulationSeries.$$p[0]:
                    let g = typeCast(IFastItemsSource_$type, c);
                    if (g != null) {
                        g.deregisterColumn(this.p1);
                        g.deregisterColumn(this.p2);
                        g.deregisterColumn(this.p3);
                        this.p1 = null;
                        this.p2 = null;
                        this.p3 = null;
                    }
                    let h = typeCast(IFastItemsSource_$type, d);
                    if (h != null) {
                        this.p1 = this.p0(h, this.qh);
                        this.p2 = this.p0(h, this.qj);
                        this.p3 = this.p0(h, this.ql);
                    }
                    this.l7(false);
                    this.le();
                    break;
                case ScatterTriangulationSeries.$$p[2]:
                    if (this.p6 != null) {
                        this.p6.deregisterColumn(this.p1);
                        this.p1 = this.p0(this.p6, this.qh);
                    }
                    this.l7(false);
                    this.le();
                    break;
                case ScatterTriangulationSeries.$$p[3]:
                    if (this.p6 != null) {
                        this.p6.deregisterColumn(this.p2);
                        this.p2 = this.p0(this.p6, this.qj);
                    }
                    this.l7(false);
                    this.le();
                    break;
                case ScatterTriangulationSeries.$$p[4]:
                    if (this.p6 != null) {
                        this.p6.deregisterColumn(this.p3);
                        this.p3 = this.p0(this.p6, this.ql);
                    }
                    this.l7(false);
                    this.le();
                    break;
                case "XColumn":
                    if (this.pr != null) {
                        this.pr.cy();
                    }
                    break;
                case "YColumn":
                    if (this.ps != null) {
                        this.ps.cy();
                    }
                    break;
            }
        }
        p9(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        p8(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        e5(a, b, c) {
            return super.e5(a, b, c) && this.ci != null && this.pr != null && this.ps != null && this.pr.bh != null && this.ps.bh != null && a.width > 0 && a.height > 0 && this.p1 != null && this.p1.count > 0 && this.p2 != null && this.p2.count > 0 && this.p3 != null && this.p3.count > 0 && this.p4 != null && this.p4.count > 0 && this.p5 != null && this.p5.count > 0;
        }
        qw() {
            if (this.trianglesSource == null) {
                this.qa = null;
                this.p1 = null;
                this.p2 = null;
                this.p3 = null;
                this.p7 = false;
            }
        }
        k5() {
            super.k5();
            if (this.pr != null) {
                this.pr.h2();
            }
            if (this.ps != null) {
                this.ps.h2();
            }
        }
        kr(a, b, c, d) {
            super.kr(a, b, c, d);
            this.qw();
            this.l7(false);
        }
        ap(a) {
            if (a != null && a == this.pr && this.p4 != null) {
                return new AxisRange(this.p4.minimum, this.p4.maximum);
            }
            if (a != null && a == this.ps && this.p5 != null) {
                return new AxisRange(this.p5.minimum, this.p5.maximum);
            }
            return null;
        }
        mu(a, b) {
            this.l7(false);
        }
        mt(a, b) {
            this.l7(false);
        }
        get p1() {
            return this.pv;
        }
        set p1(a) {
            let b = this.p1 != a;
            if (b) {
                let c = this.p1;
                this.pv = a;
                this.raisePropertyChanged("TriangleVertexColumn1", c, this.p1);
            }
        }
        get p2() {
            return this.pw;
        }
        set p2(a) {
            let b = this.p2 != a;
            if (b) {
                let c = this.p2;
                this.pw = a;
                this.raisePropertyChanged("TriangleVertexColumn2", c, this.p2);
            }
        }
        get p3() {
            return this.px;
        }
        set p3(a) {
            let b = this.p3 != a;
            if (b) {
                let c = this.p3;
                this.px = a;
                this.raisePropertyChanged("TriangleVertexColumn3", c, this.p3);
            }
        }
        get_d9() {
            return true;
        }
        get_dy() {
            return true;
        }
    }
    ScatterTriangulationSeries.$t = /*@__PURE__*/ markType(ScatterTriangulationSeries, 'ScatterTriangulationSeries', Series.$);
    ScatterTriangulationSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ScatterTriangulationSeries, 'raisePropertyChanged', ['FastTrianglesSource:p6:qz', [IFastItemsSource_$type, null], 'TrianglesSource::q0', [IEnumerable_$type, null], 'TriangleVertexMemberPath1:qh:q1', [2, null], 'TriangleVertexMemberPath2:qj:q2', [2, null], 'TriangleVertexMemberPath3:ql:q3', [2, null], 'XAxis:pr:q4', [NumericXAxis.$, null], 'XMemberPath:qp:q5', [2, null], 'YAxis:ps:q6', [NumericYAxis.$, null], 'YMemberPath:qt:q7', [2, null]]);
    return ScatterTriangulationSeries;
})();
