/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { DependencyProperty } from "igniteui-react-core";
import { SplineType_$type } from "./SplineType";
import { AxisRange } from "./AxisRange";
import { Array_$type, typeCast, Point_$type, enumGetBox, markType, markDep } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CollisionAvoider } from "./CollisionAvoider";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { ScalerParams } from "./ScalerParams";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { Numeric } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_ } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
export let SplineSeriesBase = /*@__PURE__*/ (() => {
    class SplineSeriesBase extends HorizontalAnchoredCategorySeries {
        constructor() {
            super(...arguments);
            this.uq = null;
            this.uw = NaN;
            this.uv = NaN;
        }
        bv() {
            return new SplineSeriesBaseView(this);
        }
        lo(a) {
            super.lo(a);
            this.ur = a;
        }
        ap(a) {
            if (!this.ut || this.uq == null || this.uq.length == 0) {
                return super.ap(a);
            }
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            this.u3(this.ur);
            if (this.uq == null || this.uq.length == 0) {
                return null;
            }
            if (a == this.fetchYAxis()) {
                if (isNaN_(this.uz) || isNaN_(this.u0)) {
                    return null;
                }
                return new AxisRange(this.u0, this.uz);
            }
            return null;
        }
        get_da() {
            return true;
        }
        uo(a) {
            if (a.cr.d == 0) {
                return null;
            }
            let b = new List$1(Array_$type, 0);
            let c = a.bv;
            let d = a.bu;
            let e = this.getEffectiveViewport1(a);
            let f = 0;
            let g = 0;
            let h = 0;
            let i = this;
            let j = typeCast(CategoryAxisBase.$, i.fetchXAxis());
            let k = i.pg(this.by);
            let l = i.ci;
            if (c.isEmpty || d.isEmpty || j == null || l == null || l.count == 0) {
                f = 0;
                return null;
            }
            let m = this.gk;
            let n = typeCast(ISortingAxis_$type, j);
            if (n == null || n.i$b == null) {
                let o = new ScalerParams(0, c, d, j.cf, e);
                let p = 0;
                let q = j.la - 1;
                let r = Math.floor((q - p + 1) * m / k.width);
                f = truncate(Math.max(1, r));
                g = truncate(Math.max(0, Math.floor(p / f) - 1));
                h = truncate(Math.ceil(q / f));
            }
            else {
                g = 0;
                h = j.la - 1;
                f = 1;
            }
            if (n != null && n.i$b.count != this.ci.count) {
                return null;
            }
            this.u3(a);
            let s = truncate(Math.ceil(d.width / (h - g)));
            let t = new CollisionAvoider();
            if (n != null) {
                return this.up(a);
            }
            let u = (v) => v;
            let v = (w) => this.valueColumn.item(w);
            let w = a;
            w.c6();
            for (let x = g; x <= h; ++x) {
                let y = null;
                if (f == 1) {
                    if (x >= (this.valueColumn.count - 1)) {
                        break;
                    }
                    let z = u(x);
                    let aa = v(x);
                    let ab = u(x + 1);
                    let ac = v(x + 1);
                    let ad = ab - z;
                    let ae = this.uq[x];
                    let af = this.uq[x + 1];
                    b.add([aa, ac]);
                    for (let ag = 1; ag < s; ++ag) {
                        let ah = z + ad * ag / s;
                        let ai = (ab - ah) / ad;
                        let aj = (ah - z) / ad;
                        let ak = ai * aa + aj * ac + ((ai * ai * ai - ai) * ae + (aj * aj * aj - aj) * af) * (ad * ad) / 6;
                        b.add([ak, ak]);
                    }
                }
                else {
                    y = a.cr.getBucket(x);
                    if (!isNaN_(y[0])) {
                        b.add([y[1], y[2]]);
                    }
                }
            }
            w.c8();
            return b.toArray();
        }
        up(a) {
            let b = typeCast(ISortingAxis_$type, this.t5);
            let c = this.getEffectiveViewport1(a);
            let d = a.bv;
            let e = a.bu;
            let f = new List$1(Array_$type, 0);
            if (b == null) {
                return null;
            }
            let g = this.t5;
            let h = 0;
            let i = 0;
            let j = 0;
            let k = this.gk;
            let l = this.pg(this.by);
            if (b == null || b.i$b == null) {
                let m = new ScalerParams(0, d, e, g.cf, c);
                let n = 0;
                let o = g.la - 1;
                let p = Math.floor((o - n + 1) * k / l.width);
                h = truncate(Math.max(1, p));
                i = truncate(Math.max(0, Math.floor(n / h) - 1));
                j = truncate(Math.ceil(o / h));
            }
            else {
                i = 0;
                j = g.la - 1;
                h = 1;
            }
            let q = (r) => r;
            let r = (s) => this.valueColumn.item(b.i$b._inner[s]);
            let s = truncate(Math.ceil(e.width / (j - i)));
            let t = new CollisionAvoider();
            if (h <= 0 || (i <= 0 && j <= 0)) {
                return null;
            }
            for (let u = i; u < j + 1; ++u) {
                let v = null;
                let w = u * h;
                if (b != null && b.i$b != null && w >= 0 && w < b.i$b.count) {
                    w = b.i$b._inner[w];
                }
                if (u >= (this.valueColumn.count - 1)) {
                    break;
                }
                let x = q(u);
                let y = r(u);
                let z = q(u + 1);
                let aa = r(u + 1);
                let ab = z - x;
                let ac = this.uq[u];
                let ad = this.uq[u + 1];
                f.add([y, y]);
                for (let ae = 1; ae < s; ++ae) {
                    let af = ae / s;
                    let ag = x + ab * af;
                    let ah = (z - ag) / ab;
                    let ai = (ag - x) / ab;
                    let aj = ah * y + ai * aa + ((ah * ah * ah - ah) * ac + (ai * ai * ai - ai) * ad) * (ab * ab) / 6;
                    f.add([aj, aj]);
                }
            }
            return f.toArray();
        }
        u4(a, b, c, d, e, f) {
            let g = typeCast(ISortingAxis_$type, d);
            let h = this.getEffectiveViewport1(f);
            if (g == null) {
                return;
            }
            let i = new ScalerParams(0, b, c, d.cf, h);
            let j = new ScalerParams(0, b, c, e.cf, h);
            j.b = this.f4();
            let k = this.p2();
            let l = 0;
            let m = this.uy(d, b, c, h);
            let n = (o) => o;
            let o = (p) => this.valueColumn.item(g.i$b._inner[p]);
            let p = this.rl.cr.f;
            let q = this.rl.cr.e;
            let r = truncate(Math.ceil(c.width / (p - q)));
            let s = new CollisionAvoider();
            let t = this.rl.cr.d;
            if (t <= 0 || (q <= 0 && p <= 0)) {
                this.rl.cu.count = l;
                return;
            }
            let u = 0;
            let v = 0;
            for (let w = q; w < p + 1; ++w) {
                let x = null;
                let y = w * t;
                if (g != null && g.i$b != null && y >= 0 && y < g.i$b.count) {
                    y = g.i$b._inner[y];
                }
                if (w >= (this.valueColumn.count - 1)) {
                    if (k && this.uu(a, a.f._inner[a.f.count - 1], s, Math.min(y, this.ci.count - 1), l, f, u - 1)) {
                        ++l;
                    }
                    break;
                }
                let z = n(w);
                let aa = o(w);
                let ab = n(w + 1);
                let ac = o(w + 1);
                let ad = ab - z;
                let ae = this.uq[w];
                let af = this.uq[w + 1];
                let ag = g.i$d(g.i$b._inner[w]);
                let ah = d.ef(ag, i) + m;
                let ai = e.ef(aa, j);
                a.f.add([ah, ai, ai]);
                u++;
                v = u;
                for (let aj = 1; aj < r; ++aj) {
                    let ak = aj / r;
                    let al = z + ad * ak;
                    let am = (ab - al) / ad;
                    let an = (al - z) / ad;
                    let ao = am * aa + an * ac + ((am * am * am - am) * ae + (an * an * an - an) * af) * (ad * ad) / 6;
                    let ap = g.i$d(g.i$b._inner[w]);
                    let aq = g.i$d(g.i$b._inner[w + 1]);
                    let ar = ap + (aq - ap) * ak;
                    al = d.ef(ar, i) + m;
                    ao = e.ef(ao, j);
                    a.f.add([al, ao, ao]);
                    u++;
                }
                if (k) {
                    x = [ah, ai, ai];
                }
                if (k && this.uu(a, x, s, Math.min(y, this.ci.count - 1), l, f, v - 1)) {
                    ++l;
                }
            }
            f.cu.count = l;
        }
        uu(a, b, c, d, e, f, g) {
            let h = b[0];
            let i = b[1];
            let j = new Rect(0, h - 5, i - 5, 11, 11);
            if (!isNaN_(h) && !isNaN_(i) && c.tryAdd(j)) {
                a.m.add({ $type: Point_$type, x: h, y: i });
                let k = f.cu.item(e);
                k.content.item = this.ci.item(d);
                k.al = g;
                return true;
            }
            return false;
        }
        aj(a, b, c, d, e, f) {
            if (a == null || a.ck || this.sc(this.by) > 1 || this.sc(this.by) == 0) {
                return super.aj(this.rb(), this.rc.f, this.sc(this.by), this.sd(this.by), e, f);
            }
            if (this.rc.f.count == 0) {
                return null;
            }
            let g = this.ur.cr.f;
            let h = this.by.bu;
            let i = truncate(Math.ceil(h.width));
            if (g != d) {
                i = truncate(Math.ceil(h.width / (g - d)));
            }
            let j = -1;
            let k = -1;
            let l = this.fy(e);
            let m = this.g9(e, f);
            let n = this.g7(e, f);
            let o = truncate(Math.floor(m / this.sc(this.by)));
            let p = truncate(Math.floor(n / this.sc(this.by)));
            j = o - this.sd(this.by);
            k = p - this.sd(this.by);
            let q = j * i;
            let r = k * i;
            let s = 0;
            if (m != n) {
                s = (l - m) / (n - m);
            }
            let t = truncate(Math.floor(q + s * (r - q)));
            j = t;
            k = t + 1;
            if (j < 0) {
                j = 0;
            }
            if (j > this.rc.f.count - 1) {
                j = this.rc.f.count - 1;
            }
            if (k < 0) {
                k = 0;
            }
            if (k > this.rc.f.count - 1) {
                k = this.rc.f.count - 1;
            }
            let u = this.rc.f._inner[j];
            let v = this.rc.f._inner[k];
            let w = new Array(2);
            w[0] = u;
            w[1] = v;
            return w;
        }
        sr(a, b) {
            super.sr(a, b);
            if (a.f.count <= 1) {
                return;
            }
            if (b.cr.d == 0) {
                return;
            }
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.t5;
            let g = this.ub;
            let h = new ScalerParams(0, c, d, f.cf, e);
            let i = ((() => {
                let $ret = new ScalerParams(0, c, d, g.cf, e);
                $ret.b = this.f4();
                return $ret;
            })());
            a.f.clear();
            a.m.clear();
            let j = this.p2();
            let k = 0;
            let l = typeCast(ISortingAxis_$type, this.t5);
            if (l != null && l.i$b.count != this.ci.count) {
                return;
            }
            let m = this.uy(f, c, d, e);
            let n = b.cr.d;
            this.u3(b);
            let o = b.cr.f;
            let p = b.cr.e;
            let q = truncate(Math.ceil(d.width / (o - p)));
            let r = new CollisionAvoider();
            if (l != null) {
                this.u4(a, c, d, f, g, b);
                return;
            }
            let s = (t) => t;
            let t = (u) => this.valueColumn.item(u);
            let u = b;
            u.c6();
            let v = 0;
            let w = 0;
            for (let x = p; x <= o; ++x) {
                let y = null;
                if (n == 1) {
                    if (x >= (this.valueColumn.count - 1)) {
                        if (j && this.uu(a, a.f._inner[a.f.count - 1], r, Math.min(x * n, this.ci.count - 1), k, b, v - 1)) {
                            ++k;
                        }
                        break;
                    }
                    let z = s(x);
                    let aa = t(x);
                    let ab = s(x + 1);
                    let ac = t(x + 1);
                    let ad = ab - z;
                    let ae = this.uq[x];
                    let af = this.uq[x + 1];
                    let ag = f.ef(z, h) + m;
                    let ah = g.ef(aa, i);
                    a.f.add([ag, ah, ah]);
                    v++;
                    w = v;
                    for (let ai = 1; ai < q; ++ai) {
                        let aj = z + ad * ai / q;
                        let ak = (ab - aj) / ad;
                        let al = (aj - z) / ad;
                        let am = ak * aa + al * ac + ((ak * ak * ak - ak) * ae + (al * al * al - al) * af) * (ad * ad) / 6;
                        aj = f.ef(aj, h) + m;
                        am = g.ef(am, i);
                        a.f.add([aj, am, am]);
                        v++;
                    }
                    if (j) {
                        y = b.cr.getBucket(x);
                        y[0] = (f.ef(y[0], h) + m);
                        y[1] = g.ef(y[1], i);
                        y[2] = g.ef(y[2], i);
                    }
                }
                else {
                    y = b.cr.getBucket(x);
                    if (!isNaN_(y[0])) {
                        y[0] = (f.ef(y[0], h) + m);
                        y[1] = g.ef(y[1], i);
                        y[2] = g.ef(y[2], i);
                        a.f.add(y);
                        v++;
                        w = v;
                    }
                }
                if (j && this.uu(a, y, r, Math.min(x * n, this.ci.count - 1), k, b, w - 1)) {
                    ++k;
                }
            }
            u.c8();
            b.cu.count = k;
        }
        u3(a) {
            let b = a.cr.d;
            let c = (d) => d;
            let d = (e) => this.valueColumn.item(e);
            if (b < 1 || this.valueColumn == null || this.valueColumn.count == 0) {
                return;
            }
            if ((this.uq == null || this.uq.length != this.valueColumn.count) && b == 1) {
                let e = this.us == 0 ? NaN : 0;
                if (this.t5 != null && typeCast(ISortingAxis_$type, this.t5) !== null && this.t5.i$b != null) {
                    let f = new SafeSortedReadOnlyDoubleCollection(1, this.valueColumn, this.t5.i$b, NaN);
                    d = (g) => f.item(g);
                }
                this.uq = Numeric.c(this.valueColumn.count, c, d, e, e);
                if (this.ut) {
                    let g = -1.7976931348623157E+308;
                    let h = 1.7976931348623157E+308;
                    let i = this.uo(a);
                    if (i == null) {
                        return;
                    }
                    for (let j = 0; j < i.length; j++) {
                        if (isNaN_(i[j][0]) || isNaN_(i[j][1])) {
                            continue;
                        }
                        if (i[j][1] > g) {
                            g = i[j][1];
                        }
                        if (i[j][0] < h) {
                            h = i[j][0];
                        }
                    }
                    this.u0 = h;
                    this.uz = g;
                }
            }
        }
        ux(a, b, c, d, e, f, g) {
            let h = d - b;
            let i = b + h * a;
            let j = (d - i) / h;
            let k = (i - b) / h;
            let l = j * c + k * e + ((j * j * j - j) * f + (k * k * k - k) * g) * (h * h) / 6;
            return l;
        }
        f2(a, b, c, d, e, f, g, h) {
            let i = NaN;
            if (c >= 0 && c < b.count) {
                i = b.item(c);
            }
            let j = NaN;
            if (d >= 0 && d < b.count) {
                j = b.item(d);
            }
            if (f == 0) {
                return j;
            }
            if (e == b.count - 1) {
                return i;
            }
            if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
                return i;
            }
            if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
                return j;
            }
            let k = e;
            let l = f;
            let m = i;
            let n = j;
            let o = NaN;
            let p = NaN;
            if (this.uq != null && e >= 0 && e < this.uq.length) {
                o = this.uq[e];
            }
            if (this.uq != null && f >= 0 && f < this.uq.length) {
                p = this.uq[f];
            }
            return this.ux(a, k, m, l, n, o, p);
        }
        uy(a, b, c, d) {
            let e = this.preferredCategoryMode(a);
            if (e == 0 && a.categoryMode != 0) {
                e = 1;
            }
            let f = 0;
            switch (e) {
                case 0:
                    f = 0;
                    break;
                case 1:
                    f = 0.5 * a.getCategorySize(b, c, d);
                    break;
                case 2:
                    f = a.getGroupCenter(this.hc, b, c, d);
                    break;
            }
            if (a.cf) {
                f = -f;
            }
            return f;
        }
        get u0() {
            return this.uw;
        }
        set u0(a) {
            this.uw = a;
        }
        get uz() {
            return this.uv;
        }
        set uz(a) {
            this.uv = a;
        }
        u5() {
            this.uq = null;
            this.u0 = NaN;
            this.uz = NaN;
            if (this.yAxis != null) {
                this.yAxis.cy();
            }
        }
        lt(a, b, c, d) {
            switch (b) {
                case "ValueColumn":
                case "FastItemsSource":
                    this.u5();
                    break;
            }
            super.lt(a, b, c, d);
            switch (b) {
                case SplineSeriesBase.$$p[1]:
                    this.u5();
                    this.l7(false);
                    this.le();
                    break;
            }
        }
        kr(a, b, c, d) {
            this.u5();
            super.kr(a, b, c, d);
        }
        get useHighMarkerFidelity() {
            return this.r7;
        }
    }
    SplineSeriesBase.$t = /*@__PURE__*/ markType(SplineSeriesBase, 'SplineSeriesBase', HorizontalAnchoredCategorySeries.$);
    SplineSeriesBase.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, SplineSeriesBase, 'raisePropertyChanged', ['IsSplineShapePartOfRange:ut:u6', [0, false], 'SplineType:us:u7', [SplineType_$type, /*@__PURE__*/ enumGetBox(SplineType_$type, 0)]]);
    return SplineSeriesBase;
})();
/**
 * @hidden
 */
export let SplineSeriesBaseView = /*@__PURE__*/ (() => {
    class SplineSeriesBaseView extends AnchoredCategorySeriesView {
        constructor(a) {
            super(a);
            this.da = null;
            this.da = a;
        }
        af() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.o0 = a;
            this.e.gm = 3;
            this.e.gn = 1;
            this.e.go = 4;
            this.e.e3 = false;
        }
    }
    SplineSeriesBaseView.$t = /*@__PURE__*/ markType(SplineSeriesBaseView, 'SplineSeriesBaseView', AnchoredCategorySeriesView.$);
    return SplineSeriesBaseView;
})();
