/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FastItemDateTimeColumn } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { DependencyProperty } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { typeCast, Number_$type, Date_$type, fromEnum, runOn, delegateRemove, delegateCombine, markType, markDep, TypeRegistrar } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { NumericScaler } from "./NumericScaler";
import { SeriesViewer } from "./SeriesViewer";
import { SortedListView$1 } from "./SortedListView$1";
import { ArrayExtension } from "igniteui-react-core";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_ } from "igniteui-react-core";
import { dateMinValue, dateSubtract, dateAdd, dateMaxValue, dateFromTicks } from "igniteui-react-core";
/**
 * @hidden
 */
export let TimeAxisBase = /*@__PURE__*/ (() => {
    class TimeAxisBase extends CategoryAxisBase {
        constructor() {
            super();
            this.ma = null;
            this.mj = null;
            this.me = false;
            this.mm = dateMaxValue();
            this.ml = dateMinValue();
            FastItemDateTimeColumn.o();
        }
        ef(a, b) {
            if (!b.c.isEmpty) {
                let c = this.mr(a, NumericScaler.ac, b.c, Rect.empty);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.mr(a, b.e, b.d, b.c);
        }
        ft(a, b) {
            let c = this.go(b);
            if (c == this.dateTimeMemberPath) {
                return this.fu(a, b, this.dateTimeMemberPath);
            }
            return super.ft(a, b);
        }
        mr(a, b, c, d) {
            let e;
            if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
                e = -1;
            }
            else {
                e = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            }
            let f = 0;
            if (this.categoryMode == 2) {
                f = this.getGroupCenter(0, b, c, d);
            }
            if (this.cf) {
                e = 1 - e;
                f = -f;
            }
            return c.left + c.width * (e - b.left) / b.width - f;
        }
        ms(a, b, c) {
            let d;
            if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
                d = -1;
            }
            else {
                d = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            }
            let e = 0;
            if (this.cf) {
                d = 1 - d;
                e = -e;
            }
            return c.left + c.width * (d - b.left) / b.width - e;
        }
        ei(a, b) {
            if (!b.c.isEmpty) {
                let c = b.d.left;
                let d = b.d.width;
                if (this.categoryMode != 0) {
                    let e = this.getCategorySize(b.e, b.d, b.c);
                    c += e / 2;
                    d -= e;
                }
                let f = b.e.left + b.e.width * (a - c) / b.d.width;
                f = (f * b.d.width) + b.d.left;
                f = this.getUnscaledValue3(f, NumericScaler.ac, b.c, this.categoryMode);
                return f;
            }
            return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
        }
        getUnscaledValue3(a, b, c, d) {
            let e = b.left + b.width * (a - c.left) / c.width;
            if (this.cf) {
                e = 1 - e;
            }
            return truncate(Math.floor(this.actualMinimumValue.getTime() + e * (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime())));
        }
        i$h() {
            this.m7();
        }
        m7() {
            let a = this.bh != null ? this.bh.r0 : Rect.empty;
            let b = !a.isEmpty ? this.j7 : Rect.empty;
            let c = (new Date());
            let d = (new Date());
            let e = false;
            if (!a.isEmpty && !b.isEmpty && this.mb != null) {
                let f = typeCast(FastItemDateTimeColumn.$, this.mb);
                if (f != null) {
                    if (this.mk == null) {
                        this.m8();
                    }
                }
                else {
                    this.mk = null;
                }
                if (this.mb.count > 0) {
                    e = true;
                    let g = this.mk == null ? 0 : this.mk._inner[0];
                    let h = this.mk == null ? this.mb.count - 1 : this.mk._inner[this.mb.count - 1];
                    c = this.mb.item(g);
                    d = this.mb.item(h);
                    this.mf = false;
                    if (this.categoryMode == 2) {
                        let i = this.m5(c, d);
                        if (+c != +(dateMinValue())) {
                            c = dateSubtract(+c, +i);
                        }
                        d = dateAdd(+d, +i);
                    }
                }
            }
            if (this.mi()) {
                e = true;
                c = this.minimumValue;
            }
            if (this.mh()) {
                e = true;
                d = this.maximumValue;
            }
            let j = +(this.actualMinimumValue) != +c || +(this.actualMaximumValue) != +d;
            if (e && j) {
                let k = this.actualMinimumValue;
                let l = this.actualMaximumValue;
                this.actualMinimumValue = c;
                this.actualMaximumValue = d;
                this.nc();
            }
        }
        nc() {
        }
        get mb() {
            return this.ma;
        }
        set mb(a) {
            if (this.ma != a) {
                let b = this.ma;
                this.ma = a;
                this.hx("DateTimeColumn", b, this.ma);
            }
        }
        get mk() {
            return this.mj;
        }
        set mk(a) {
            this.mj = a;
        }
        get i$b() {
            if (this.mk == null) {
                let a = typeCast(FastItemDateTimeColumn.$, this.mb);
                if (a != null) {
                    this.m8();
                }
                else {
                    this.mk = null;
                }
            }
            return this.mk;
        }
        m8() {
            if (this.mg) {
                this.mk = new List$1(Number_$type, 0);
                let a = this.mk;
                let b = this.mb.count;
                for (let c = 0; c < b; c++) {
                    a.add(c);
                }
            }
            else {
                let d = typeCast(FastItemDateTimeColumn.$, this.mb);
                this.mk = d.h();
            }
        }
        i$e(a, b, c, d) {
            return this.mu(a, b, c, d);
        }
        mu(a, b, c, d) {
            if (b.isEmpty) {
                return -1;
            }
            let e = d;
            let f = new ScalerParams(0, a, b, this.cf, c);
            let g, h;
            if (this.cf) {
                h = this.ei(e.left, f);
                g = this.ei(e.right, f);
            }
            else {
                g = this.ei(e.left, f);
                h = this.ei(e.right, f);
            }
            let i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(g)));
            return this.mt(dateFromTicks(i));
        }
        mt(a) {
            if (this.mb == null || this.mk.count != this.mb.count) {
                return -1;
            }
            let b = new SortedListView$1(Date_$type, this.mb, this.mk);
            let c = this.mv(a, b);
            if (c >= 0 && c < this.mk.count) {
                let d = this.mb.item(this.mk._inner[c]);
                if (d > a) {
                    c--;
                    if (c < 0) {
                        c = 0;
                    }
                }
                return c;
            }
            return this.mk.count - 1;
        }
        i$g(a, b, c, d) {
            return this.mx(a, b, c, d);
        }
        mx(a, b, c, d) {
            if (b.isEmpty) {
                return -1;
            }
            let e = d;
            let f = new ScalerParams(0, a, b, this.cf, c);
            let g, h;
            if (this.cf) {
                h = this.ei(e.left, f);
                g = this.ei(e.right, f);
            }
            else {
                g = this.ei(e.left, f);
                h = this.ei(e.right, f);
            }
            let i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(h)));
            return this.mw(dateFromTicks(i));
        }
        mw(a) {
            if (this.mb == null || this.mk.count != this.mb.count) {
                return -1;
            }
            let b = new SortedListView$1(Date_$type, this.mb, this.mk);
            let c = this.mv(a, b);
            if (c >= this.mk.count) {
                c = this.mk.count - 1;
            }
            if (c >= 0 && c < this.mk.count) {
                let d = this.mb.item(this.mk._inner[c]);
                if (d < a) {
                    c++;
                    if (c > this.mk.count - 1) {
                        c = this.mk.count - 1;
                    }
                }
                return c;
            }
            return 0;
        }
        i$d(a) {
            if (this.mb == null) {
                return NaN;
            }
            let b = this.ma.item(a);
            let c = b.getTime();
            let d = c;
            return d;
        }
        i$c(a) {
            let b = this;
            if (b.i$b == null) {
                return -1;
            }
            let c = new SortedListView$1(Date_$type, this.mb, b.i$b);
            let ticks_ = a;
            let d = (new Date(ticks_));
            let e = this.mv(d, c);
            if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
                let diff1_ = d.getTime() - c.item(e - 1).getTime();
                let diff2_ = c.item(e).getTime() - d.getTime();
                let f = e - 1;
                let g = e;
                if (f < 0 && g >= 0) {
                    return g;
                }
                if (g > b.i$b.count - 1 && f < b.i$b.count) {
                    return f;
                }
                if (f < 0 && g < 0) {
                    return -1;
                }
                if (f > b.i$b.count - 1 && g > b.i$b.count - 1) {
                    return -1;
                }
                let h = diff1_ / (diff1_ + diff2_);
                if (isNaN_(h)) {
                    h = 0;
                }
                return f + h;
            }
            if (e >= 0 && e < b.i$b.count) {
                return e;
            }
            let i = this.j2();
            if (e == b.i$b.count && this.bh != null && this.ef(a, new ScalerParams(0, this.bh.r0, this.j7, this.cf, i)) < (this.j7.right + 2)) {
                return e - 1;
            }
            if (e == -1 && this.bh != null && Math.abs(this.ef(a, new ScalerParams(0, this.bh.r0, this.j7, this.cf, i)) - this.j7.left) < 2) {
                return 0;
            }
            return -1;
        }
        mv(a, b) {
            let c = this;
            if (this.mb == null || c.i$b == null) {
                return -1;
            }
            let d = -1;
            let e = ArrayExtension.binarySearch$11(Date_$type, b, (f) => {
                if (a < f) {
                    return -1;
                }
                if (a > f) {
                    return 1;
                }
                return 0;
            });
            if (e >= 0) {
                d = e;
            }
            else {
                d = ~e;
            }
            while (d >= 0 && d < b.count && d - 1 >= 0 && +(b.item(d)) == +(b.item(d - 1))) {
                d--;
            }
            return d;
        }
        i$f(a) {
            let b = this;
            if (b.i$b == null || this.mb == null || b.i$b.count != this.mb.count) {
                return -1;
            }
            let c = new SortedListView$1(Date_$type, this.mb, b.i$b);
            let ticks_ = a;
            let d = (new Date(ticks_));
            let e = this.mv(d, c);
            let f = this.j2();
            if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
                let g = +d - +(c.item(e - 1));
                let h = +(c.item(e)) - +d;
                if (g < h) {
                    e = e - 1;
                }
            }
            if (e >= 0 && e < b.i$b.count) {
                return b.i$b._inner[e];
            }
            if (e == b.i$b.count && this.bh != null && this.ef(a, new ScalerParams(0, this.bh.r0, this.j7, this.cf, f)) < (this.j7.right + 2)) {
                return e - 1;
            }
            if (e == -1 && this.bh != null && Math.abs(this.ef(a, new ScalerParams(0, this.bh.r0, this.j7, this.cf, f)) - this.j7.left) < 2) {
                return 0;
            }
            return -1;
        }
        i$i() {
            this.mk = null;
            this.h2();
        }
        get_mf() {
            return this.me;
        }
        set_mf(a) {
            this.me = a;
        }
        get mf() {
            return this.get_mf();
        }
        set mf(a) {
            this.set_mf(a);
        }
        ht(a) {
            super.ht(a);
            this.dateTimeMemberPath = a;
        }
        hw(a) {
            super.hw(a);
            this.minimumValue = a;
        }
        hv(a) {
            super.hw(a);
            this.maximumValue = a;
        }
        c0() {
            if (this.cn && this.c1) {
                this.bb = this.ba();
            }
            let a = this.actualMinimumValue.getTime();
            let b = this.actualMaximumValue.getTime();
            this.m7();
            let c = !this.mi() ? this.actualMinimumValue.getTime() : this.minimumValue.getTime();
            let d = !this.mh() ? this.actualMaximumValue.getTime() : this.maximumValue.getTime();
            let e = new AxisRangeChangedEventArgs(0, a, c, b, d);
            this.hy(e);
            return true;
        }
        mi() {
            if (+(this.minimumValue) == +(dateMinValue())) {
                return false;
            }
            return (this.minimumValue != null);
        }
        mh() {
            if (+(this.maximumValue) == +(dateMaxValue())) {
                return false;
            }
            return (this.maximumValue != null);
        }
        get actualMinimumValue() {
            return this.mm;
        }
        set actualMinimumValue(a) {
            let b = +(this.mm) != +a;
            if (b) {
                let c = this.mm;
                this.mm = a;
                this.hx("ActualMinimumValue", c, a);
            }
        }
        fy() {
            return this.actualMinimumValue;
        }
        get actualMaximumValue() {
            return this.ml;
        }
        set actualMaximumValue(a) {
            let b = +(this.ml) != +a;
            if (b) {
                let c = this.ml;
                this.ml = a;
                this.hx("ActualMaximumValue", c, a);
            }
        }
        fx() {
            return this.maximumValue;
        }
        m9(a) {
            this.h4(a);
            if (this.kl == null) {
                return;
            }
            for (let b of fromEnum(this.c7())) {
                b.l7(a);
            }
        }
        hr(a, b, c, d) {
            super.hr(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.mb);
                        this.mb = null;
                        e.event = delegateRemove(e.event, runOn(this, this.m6));
                    }
                    let f = typeCast(IFastItemsSource_$type, d);
                    if (f != null) {
                        this.mk = null;
                        this.mb = this.mc(this.dateTimeMemberPath);
                        f.event = delegateCombine(f.event, runOn(this, this.m6));
                    }
                    this.m9(false);
                    break;
                case TimeAxisBase.$$p[0]:
                    if (this.kl != null) {
                        this.kl.deregisterColumn(this.mb);
                        this.mb = this.mc(this.dateTimeMemberPath);
                        this.mk = null;
                    }
                    break;
                case TimeAxisBase.$$p[3]:
                    this.cy();
                    this.m9(false);
                    break;
                case TimeAxisBase.$$p[2]:
                    this.cy();
                    this.m9(false);
                    break;
                case "DateTimeColumn":
                    this.m7();
                    break;
            }
        }
        m6(a, b) {
            this.mk = null;
        }
        mc(a) {
            return TimeAxisBase.md(a, this);
        }
        static md(a, b) {
            if (a == null) {
                return b.kl.registerColumnDateTime(null, null, false);
            }
            let c = null;
            let d = SeriesViewer.b8(a, b.coercionMethods);
            c = d.a;
            return b.kl.registerColumnDateTime(a, c, b.expectFunctions);
        }
        au() {
            if (this.c2) {
                return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
            }
            else {
                return new HorizontalAxisLabelPanel();
            }
        }
        get_a1() {
            return 0;
        }
        get a1() {
            return this.get_a1();
        }
        h4(a) {
            super.h4(a);
            let b = this.a4.ay();
            let c = this.a4.a1();
            let d = this.a4.az();
            let e = this.a4.a0();
            let f = this.a4.e();
            let g = this.a4.f();
            let h = this.a4.g();
            this.ig();
            this.hd(b);
            this.hd(c);
            this.hd(d);
            this.hd(e);
            this.c8.clear();
            this.c9.clear();
            this.ks.clear();
            this.av.ad = this;
            let i = this.bh != null ? this.bh.r0 : Rect.empty;
            let j = !i.isEmpty ? this.j7 : Rect.empty;
            this.av.c5 = i;
            this.av.c4 = j;
            if (i.isEmpty || j.isEmpty) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
            }
            if (this.bq.count == 0) {
                this.av.ab.clear();
            }
            if (this.ay != null) {
                this.ay.registerAxis(this);
            }
            this.m7();
        }
        get_cc() {
            return true;
        }
        startCursor() {
        }
        resetCursor() {
        }
        StartTimeCursor() {
            this.startCursor();
        }
        ResetTimeCursor() {
            this.resetCursor();
        }
        getCategorySize(a, b, c) {
            if (this.k9 == 0) {
                return 0;
            }
            let d = this.j5(b, c);
            return d.width / (this.k9 * a.width);
        }
        getGroupCenter(a, b, c, d) {
            return this.getCategorySize(b, c, d) * 0.5;
        }
        ky(a, b, c) {
            let d = this.k5(a, b, c);
            let e = 1 - 0.5 * d;
            let f = this.getCategorySize(a, b, c) * e;
            return f;
        }
        get_ck() {
            return true;
        }
        m5(a, b) {
            return (0);
        }
        preferredCategoryMode(a) {
            return this.ca ? 0 : 1;
        }
        get isVertical() {
            return this.cm;
        }
        j$c(a, b) {
            return this.ei.apply(this, arguments);
        }
        j$b(a, b) {
            return this.ef.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.hh.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.hi.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.hj.apply(this, arguments);
        }
        get j$a() {
            return this.cf;
        }
        get i$a() {
            return this.cc;
        }
    }
    TimeAxisBase.$t = /*@__PURE__*/ markType(TimeAxisBase, 'TimeAxisBase', CategoryAxisBase.$, [ISortingAxis_$type, IDateTimeAxis_$type]);
    TimeAxisBase.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, TimeAxisBase, 'hx', ['DateTimeMemberPath::nd', [2, null], 'IsDataPreSorted:mg:ne', [0, false], 'MaximumValue::nf', [3, null], 'MinimumValue::ng', [3, null]]);
    return TimeAxisBase;
})();
