/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryYAxis } from "./CategoryYAxis";
import { IVerticalAnchoredCategorySeriesInteractionManager_$type } from "./IVerticalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { runOn, typeCast, EnumUtil, markType, markDep } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { Rect } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
/**
 * @hidden
 */
export let VerticalAnchoredCategorySeries = /*@__PURE__*/ (() => {
    class VerticalAnchoredCategorySeries extends AnchoredCategorySeries {
        constructor() {
            super(...arguments);
            this.t6 = null;
        }
        kl() {
            super.kl();
            this.xAxis = null;
            this.yAxis = null;
        }
        get t7() {
            if (this.t6 == null) {
                this.t6 = DVContainer.instance.createInstance(IVerticalAnchoredCategorySeriesInteractionManager_$type, () => this.cl.n);
            }
            return this.t6;
        }
        get_isVertical() {
            return true;
        }
        rb() {
            return this.yAxis;
        }
        rw() {
            return this.xAxis;
        }
        getOffsetValue() {
            return this.rh.r(this.rb(), this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by));
        }
        getCategoryWidth() {
            return this.yAxis.getCategorySize(this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by));
        }
        g7(a, b) {
            return this.g8(a, b, this.rb(), runOn(this, this.sa), this.valueColumn);
        }
        g9(a, b) {
            return this.ha(a, b, this.rb(), runOn(this, this.sa), this.valueColumn);
        }
        fw(a, b, c, d, e) {
            if (this.valueColumn == null) {
                return Number.POSITIVE_INFINITY;
            }
            return this.fx(a, b, this.yAxis, d, e, this.valueColumn.count, runOn(this, this.sa));
        }
        aq(a) {
            if (a.isEmpty && this.cb != null) {
                a = this.cb.r0;
            }
            if (this.valueColumn == null) {
                return null;
            }
            let b = this.pg(this.by);
            let c = this.rb();
            let d = new ScalerParams(0, a, this.cb.sf, c.cf, this.getEffectiveViewport());
            let e = (c.ei(b.top, d));
            let f = (c.ei(b.bottom, d));
            if (!c.cf) {
                let g = e;
                e = f;
                f = g;
            }
            e -= this.tf;
            f += this.tf;
            let h = null;
            if (c.ck) {
                h = c;
                e = h.i$f(e);
                f = h.i$f(f);
            }
            else {
                e = Math.floor(e);
                f = Math.ceil(f);
            }
            if (isNaN_(e) || isNaN_(f)) {
                return null;
            }
            e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
            f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
            let i = 1.7976931348623157E+308;
            let j = -1.7976931348623157E+308;
            if (truncate(e) <= truncate(f)) {
                for (let k = truncate(e); k <= truncate(f); k++) {
                    let l = k;
                    if (h != null) {
                        l = h.i$b._inner[k];
                    }
                    let m = this.valueColumn.item(l);
                    if (this.valueColumn.mayContainUnknowns) {
                        if (isInfinity(m) || isNaN_(m)) {
                            continue;
                        }
                    }
                    i = Math.min(i, m);
                    j = Math.max(j, m);
                }
            }
            let n = new AxisRange(i, j);
            n = this.ao(n, this.rw(), a);
            return n;
        }
        bp() {
            if (this.bq == 0) {
                return 1;
            }
            else {
                return super.bp();
            }
        }
        pm(a) {
            if (!this.hasMarkers || !this.p2()) {
                return Rect.empty;
            }
            return this.t7.e$b(this, this.rc.m, a, runOn(this, this.uf));
        }
        uf(a) {
            return this.s4.c9(a);
        }
        er(a, b) {
            if (this.eq(a, b)) {
                return true;
            }
            if (this.p3(a, b)) {
                return true;
            }
            return false;
        }
        ga(a, b, c) {
            if (this.cb == null) {
                return NaN;
            }
            let d = this.getEffectiveViewport1(this.by);
            let e = this.rb();
            let f = new ScalerParams(0, this.cb.r0, this.by.bu, e.cf, d);
            let g = this.rh.r(e, this.cb.r0, this.by.bu, d);
            return this.gc(this.valueColumn, a, e, f, g, runOn(this, this.sa), b, c);
        }
        pb(a, b, c) {
            let d = this.rb();
            return this.pd(a, b, c, this.rh.r(d, this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by)), this.rw(), d, null, null, null);
        }
        fetchXAxis() {
            return this.xAxis;
        }
        fetchYAxis() {
            return this.yAxis;
        }
        tn(a) {
            this.xAxis = typeCast(NumericXAxis.$, a);
        }
        to(a) {
            this.yAxis = typeCast(CategoryYAxis.$, a);
        }
        r6() {
            return this.xAxis != null && this.xAxis.cy();
        }
        q5(a, b) {
            return this.s1(a, b, this.yAxis);
        }
        fy(a) {
            return this.t7.e$a(this, a);
        }
        sa(a) {
            return this.f0(a, this.rb());
        }
        g3(a) {
            return truncate(Math.round(this.fy(a)));
        }
        hk(a) {
            let b = this.g3(a);
            return b >= 0 && this.ci != null && b < this.ci.count ? this.ci.item(b) : null;
        }
        lt(a, b, c, d) {
            super.lt(a, b, c, d);
            switch (b) {
                case VerticalAnchoredCategorySeries.$$p[0]:
                    if (c != d) {
                        this.ks(typeCast(Axis.$, c));
                        this.ly(typeCast(Axis.$, d));
                        this.rl.cr.g(this.gk);
                        this.l7(false);
                        this.le();
                    }
                    break;
                case VerticalAnchoredCategorySeries.$$p[1]:
                    if (c != d) {
                        this.ks(typeCast(Axis.$, c));
                        this.ly(typeCast(Axis.$, d));
                        this.rl.cr.g(this.gk);
                        this.r6();
                        this.l7(false);
                        this.le();
                    }
                    break;
                case "TrendLineType":
                    let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                    if (e != 0) {
                        this.s4.c2 = CategoryTrendLineManagerFactory.a(this.s4.c2, this.yAxis, this.my, this, this.cl);
                    }
                    break;
            }
        }
        ua(a) {
            if (typeCast(CategoryYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        t9(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        get useHighMarkerFidelity() {
            return this.r7;
        }
    }
    VerticalAnchoredCategorySeries.$t = /*@__PURE__*/ markType(VerticalAnchoredCategorySeries, 'VerticalAnchoredCategorySeries', AnchoredCategorySeries.$);
    VerticalAnchoredCategorySeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, VerticalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::ud', [NumericXAxis.$, null], 'YAxis::ue', [CategoryYAxis.$, null]]);
    return VerticalAnchoredCategorySeries;
})();
