/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
export let XYChart = /*@__PURE__*/ (() => {
    class XYChart extends DomainChart {
        constructor() {
            super(...arguments);
            this.l4 = null;
            this.l5 = null;
            this.ml = 0;
            this.mn = 5;
            this.mm = 0;
            this.mk = 5;
            this.m2 = 5;
            this.m4 = 0;
            this.m3 = 5;
            this.m1 = 0;
            this.rv = null;
            this.r2 = null;
            this.rt = null;
            this.ru = null;
            this.mw = 0;
            this.nd = 0;
            this.mv = NaN;
            this.nc = NaN;
            this.my = NaN;
            this.nf = NaN;
            this.mx = NaN;
            this.ne = NaN;
            this.mu = NaN;
            this.nb = NaN;
            this.r1 = null;
            this.r8 = null;
            this.on = null;
            this.or = null;
            this.op = null;
            this.ot = null;
            this.oi = null;
            this.oj = null;
            this.rw = null;
            this.r3 = null;
            this.mo = DeviceUtils.g(1);
            this.m5 = DeviceUtils.g(1);
            this.mp = DeviceUtils.g(1);
            this.m6 = DeviceUtils.g(1);
            this.ry = null;
            this.r5 = null;
            this.rz = null;
            this.r6 = null;
            this.mq = DeviceUtils.g(1);
            this.m7 = DeviceUtils.g(1);
            this.mr = DeviceUtils.g(8);
            this.m8 = 0;
            this.r0 = null;
            this.r7 = null;
            this.ms = DeviceUtils.g(1);
            this.m9 = DeviceUtils.g(1);
            this.oo = null;
            this.os = null;
            this.rx = null;
            this.r4 = null;
            this.mj = 0;
            this.m0 = 0;
            this.mi = NaN;
            this.mz = NaN;
            this.mt = 0;
            this.na = -90;
            this.me = false;
            this.mf = false;
            this.ro = 1;
            this.sr = 1;
            this.rn = 1;
            this.rp = 2;
            this.sp = 0;
            this.sq = 1;
            this.sv = 0;
            this.sw = 0;
            this.mc = 4;
            this.ma = 4;
            this.om = null;
            this.ly = null;
            this.oq = null;
            this.lz = null;
        }
        provideContainer(a) {
            if (a != null) {
                let b = this.l2();
                let c = this.l3();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            super.provideContainer(a);
        }
        jp() {
            super.jp();
            let a = this.l2();
            let b = this.l3();
            if (a != null && a.ay != null) {
                this.sb = a.ay.textColor;
            }
            if (b != null && b.ay != null) {
                this.si = b.ay.textColor;
            }
            this.sg = AxisDefaults.j;
            this.sn = AxisDefaults.j;
            this.sc = AxisDefaults.h;
            this.sj = AxisDefaults.h;
            this.sf = AxisDefaults.g;
            this.sm = AxisDefaults.g;
        }
        kb(a, b, c) {
            super.kb(a, b, c);
            switch (a) {
                case "XAxisLabelLeftMargin":
                    this.rf((d) => d.leftMargin = this.nn);
                    break;
                case "XAxisLabelTopMargin":
                    this.rf((d) => d.topMargin = this.np);
                    break;
                case "XAxisLabelRightMargin":
                    this.rf((d) => d.rightMargin = this.no);
                    break;
                case "XAxisLabelBottomMargin":
                    this.rf((d) => d.bottomMargin = this.nm);
                    break;
                case "YAxisLabelLeftMargin":
                    this.rk((d) => d.leftMargin = this.n4);
                    break;
                case "YAxisLabelTopMargin":
                    this.rk((d) => d.topMargin = this.n6);
                    break;
                case "YAxisLabelRightMargin":
                    this.rk((d) => d.rightMargin = this.n5);
                    break;
                case "YAxisLabelBottomMargin":
                    this.rk((d) => d.bottomMargin = this.n3);
                    break;
                case "ActualItemsSource":
                case "ShouldDisplayMockData":
                case "ShouldUseSkeletonStyleForMockData":
                    this.r9 = this.lr(this.sb);
                    this.sa = this.lr(this.si);
                    break;
                case "XAxisLabelTextColor":
                    this.r9 = this.lr(this.sb);
                    break;
                case "YAxisLabelTextColor":
                    this.sa = this.lr(this.si);
                    break;
                case "ActualXAxisLabelTextColor":
                    this.rf((d) => d.textColor = this.r9);
                    break;
                case "ActualYAxisLabelTextColor":
                    this.rk((d) => d.textColor = this.sa);
                    break;
                case "XAxisTitleMargin":
                    this.rh((d) => d.margin = this.ny);
                    break;
                case "YAxisTitleMargin":
                    this.rm((d) => d.margin = this.of);
                    break;
                case "XAxisTitleLeftMargin":
                    this.rh((d) => d.leftMargin = this.nx);
                    break;
                case "YAxisTitleLeftMargin":
                    this.rm((d) => d.leftMargin = this.oe);
                    break;
                case "XAxisTitleTopMargin":
                    this.rh((d) => d.topMargin = this.n0);
                    break;
                case "YAxisTitleTopMargin":
                    this.rm((d) => d.topMargin = this.oh);
                    break;
                case "XAxisTitleRightMargin":
                    this.rh((d) => d.rightMargin = this.nz);
                    break;
                case "YAxisTitleRightMargin":
                    this.rm((d) => d.rightMargin = this.og);
                    break;
                case "XAxisTitleBottomMargin":
                    this.rh((d) => d.bottomMargin = this.nw);
                    break;
                case "YAxisTitleBottomMargin":
                    this.rm((d) => d.bottomMargin = this.od);
                    break;
                case "XAxisTitleTextColor":
                    this.rh((d) => d.textColor = this.sh);
                    break;
                case "YAxisTitleTextColor":
                    this.rm((d) => d.textColor = this.so);
                    break;
                case "XAxisFormatLabel":
                    this.rd((d) => d.at = this.l6);
                    break;
                case "YAxisFormatLabel":
                    this.ri((d) => d.at = this.l7);
                    break;
            }
        }
        get l6() {
            return this.l4;
        }
        set l6(a) {
            let b = this.l6;
            if (a != b) {
                this.l4 = a;
                this.ka("XAxisFormatLabel", b, this.l6);
            }
        }
        get l7() {
            return this.l5;
        }
        set l7(a) {
            let b = this.l7;
            if (a != b) {
                this.l5 = a;
                this.ka("YAxisFormatLabel", b, this.l7);
            }
        }
        get nn() {
            return this.ml;
        }
        set nn(a) {
            let b = this.nn;
            if (a != b) {
                this.ml = a;
                this.ka("XAxisLabelLeftMargin", b, this.nn);
            }
        }
        get np() {
            return this.mn;
        }
        set np(a) {
            let b = this.np;
            if (a != b) {
                this.mn = a;
                this.ka("XAxisLabelTopMargin", b, this.np);
            }
        }
        get no() {
            return this.mm;
        }
        set no(a) {
            let b = this.no;
            if (a != b) {
                this.mm = a;
                this.ka("XAxisLabelRightMargin", b, this.no);
            }
        }
        get nm() {
            return this.mk;
        }
        set nm(a) {
            let b = this.nm;
            if (a != b) {
                this.mk = a;
                this.ka("XAxisLabelBottomMargin", b, this.nm);
            }
        }
        get n4() {
            return this.m2;
        }
        set n4(a) {
            let b = this.n4;
            if (a != b) {
                this.m2 = a;
                this.ka("YAxisLabelLeftMargin", b, this.n4);
            }
        }
        get n6() {
            return this.m4;
        }
        set n6(a) {
            let b = this.n6;
            if (a != b) {
                this.m4 = a;
                this.ka("YAxisLabelTopMargin", b, this.n6);
            }
        }
        get n5() {
            return this.m3;
        }
        set n5(a) {
            let b = this.n5;
            if (a != b) {
                this.m3 = a;
                this.ka("YAxisLabelRightMargin", b, this.n5);
            }
        }
        get n3() {
            return this.m1;
        }
        set n3(a) {
            let b = this.n3;
            if (a != b) {
                this.m1 = a;
                this.ka("YAxisLabelBottomMargin", b, this.n3);
            }
        }
        get sb() {
            return this.rv;
        }
        set sb(a) {
            let b = this.sb;
            if (a != b) {
                this.rv = a;
                this.ka("XAxisLabelTextColor", b, this.sb);
            }
        }
        get si() {
            return this.r2;
        }
        set si(a) {
            let b = this.si;
            if (a != b) {
                this.r2 = a;
                this.ka("YAxisLabelTextColor", b, this.si);
            }
        }
        get r9() {
            return this.rt;
        }
        set r9(a) {
            let b = this.rt;
            if (a != b) {
                this.rt = a;
                this.ka("ActualXAxisLabelTextColor", b, this.r9);
            }
        }
        get sa() {
            return this.ru;
        }
        set sa(a) {
            let b = this.ru;
            if (a != b) {
                this.ru = a;
                this.ka("ActualYAxisLabelTextColor", b, this.sa);
            }
        }
        get ny() {
            return this.mw;
        }
        set ny(a) {
            let b = this.ny;
            if (a != b) {
                this.mw = a;
                this.ka("XAxisTitleMargin", b, this.ny);
            }
        }
        get of() {
            return this.nd;
        }
        set of(a) {
            let b = this.of;
            if (a != b) {
                this.nd = a;
                this.ka("YAxisTitleMargin", b, this.of);
            }
        }
        get nx() {
            return this.mv;
        }
        set nx(a) {
            let b = this.nx;
            if (a != b) {
                this.mv = a;
                this.ka("XAxisTitleLeftMargin", b, this.nx);
            }
        }
        get oe() {
            return this.nc;
        }
        set oe(a) {
            let b = this.oe;
            if (a != b) {
                this.nc = a;
                this.ka("YAxisTitleLeftMargin", b, this.oe);
            }
        }
        get n0() {
            return this.my;
        }
        set n0(a) {
            let b = this.n0;
            if (a != b) {
                this.my = a;
                this.ka("XAxisTitleTopMargin", b, this.n0);
            }
        }
        get oh() {
            return this.nf;
        }
        set oh(a) {
            let b = this.oh;
            if (a != b) {
                this.nf = a;
                this.ka("YAxisTitleTopMargin", b, this.oh);
            }
        }
        get nz() {
            return this.mx;
        }
        set nz(a) {
            let b = this.nz;
            if (a != b) {
                this.mx = a;
                this.ka("XAxisTitleRightMargin", b, this.nz);
            }
        }
        get og() {
            return this.ne;
        }
        set og(a) {
            let b = this.og;
            if (a != b) {
                this.ne = a;
                this.ka("YAxisTitleRightMargin", b, this.og);
            }
        }
        get nw() {
            return this.mu;
        }
        set nw(a) {
            let b = this.nw;
            if (a != b) {
                this.mu = a;
                this.ka("XAxisTitleBottomMargin", b, this.nw);
            }
        }
        get od() {
            return this.nb;
        }
        set od(a) {
            let b = this.od;
            if (a != b) {
                this.nb = a;
                this.ka("YAxisTitleBottomMargin", b, this.od);
            }
        }
        get sh() {
            return this.r1;
        }
        set sh(a) {
            let b = this.sh;
            if (a != b) {
                this.r1 = a;
                this.ka("XAxisTitleTextColor", b, this.sh);
            }
        }
        get so() {
            return this.r8;
        }
        set so(a) {
            let b = this.so;
            if (a != b) {
                this.r8 = a;
                this.ka("YAxisTitleTextColor", b, this.so);
            }
        }
        kc(a, b, c) {
            super.kc(a, b, c);
            switch (a) {
                case "XAxisLabelTextStyle":
                    this.rf((d) => d.textStyle = this.pb);
                    break;
                case "YAxisLabelTextStyle":
                    this.rk((d) => d.textStyle = this.qg);
                    break;
                case "XAxisTitleTextStyle":
                    this.rh((d) => d.textStyle = this.pz);
                    break;
                case "YAxisTitleTextStyle":
                    this.rm((d) => d.textStyle = this.q4);
                    break;
            }
        }
        get pb() {
            return this.on;
        }
        set pb(a) {
            let b = this.pb;
            if (a != b) {
                this.on = a;
                this.ka("XAxisLabelTextStyle", b, this.pb);
            }
        }
        get qg() {
            return this.or;
        }
        set qg(a) {
            let b = this.qg;
            if (a != b) {
                this.or = a;
                this.ka("YAxisLabelTextStyle", b, this.qg);
            }
        }
        get pz() {
            return this.op;
        }
        set pz(a) {
            let b = this.pz;
            if (a != b) {
                this.op = a;
                this.ka("XAxisTitleTextStyle", b, this.pz);
            }
        }
        get q4() {
            return this.ot;
        }
        set q4(a) {
            let b = this.q4;
            if (a != b) {
                this.ot = a;
                this.ka("YAxisTitleTextStyle", b, this.q4);
            }
        }
        ra(a) {
            this.q7(a, (b) => b.leftMargin = this.nn);
            this.q7(a, (b) => b.topMargin = this.np);
            this.q7(a, (b) => b.rightMargin = this.no);
            this.q7(a, (b) => b.bottomMargin = this.nm);
            this.q7(a, (b) => b.textColor = this.r9);
            this.q8(a, (b) => b.textColor = this.sh);
            this.q8(a, (b) => b.leftMargin = this.nx);
            this.q8(a, (b) => b.topMargin = this.n0);
            this.q8(a, (b) => b.rightMargin = this.nz);
            this.q8(a, (b) => b.bottomMargin = this.nw);
            this.q7(a, (b) => b.textStyle = this.pb);
            this.q8(a, (b) => b.textStyle = this.pz);
        }
        rc(a) {
            this.q7(a, (b) => b.leftMargin = this.n4);
            this.q7(a, (b) => b.topMargin = this.n6);
            this.q7(a, (b) => b.rightMargin = this.n5);
            this.q7(a, (b) => b.bottomMargin = this.n3);
            this.q7(a, (b) => b.textColor = this.sa);
            this.q8(a, (b) => b.textColor = this.so);
            this.q8(a, (b) => b.leftMargin = this.oe);
            this.q8(a, (b) => b.topMargin = this.oh);
            this.q8(a, (b) => b.rightMargin = this.og);
            this.q8(a, (b) => b.bottomMargin = this.od);
            this.q7(a, (b) => b.textStyle = this.qg);
            this.q8(a, (b) => b.textStyle = this.q4);
        }
        ks(a) {
            let b = this.ab(a);
            let c = this.bb(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = a.data;
            c.name = this.g1(a);
            c.hs = this.g2(a, b);
            this.dataChart.series.add(c);
        }
        rd(a) {
            this.re(a, null);
        }
        re(a, b) {
            a(this.l2());
        }
        rj(a, b) {
            a(this.l3());
        }
        ri(a) {
            this.rj(a, true);
        }
        i9(a, b) {
            this.rd(a);
            this.rj(a, b);
        }
        rh(a) {
            this.q8(this.l2(), a);
        }
        rm(a) {
            this.q8(this.l3(), a);
        }
        rk(a) {
            this.q7(this.l3(), a);
        }
        rf(a) {
            this.q7(this.l2(), a);
        }
        ng(a) {
            let b = this.l2();
            return b.ef(a, new ScalerParams(1, this.lx, this.lw, b.cf));
        }
        ni(a) {
            let b = this.l2();
            return b.ei(a, new ScalerParams(1, this.lx, this.lw, b.cf));
        }
        nh(a) {
            let b = this.l3();
            return b.ef(a, new ScalerParams(1, this.lx, this.lw, b.cf));
        }
        nj(a) {
            let b = this.l3();
            return b.ei(a, new ScalerParams(1, this.lx, this.lw, b.cf));
        }
        kp(a) {
            super.kp(a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                let b = this.l2();
                let c = this.l3();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        }
        static ow(a, b) {
            for (let c of fromEnum(b)) {
                let d = c.findMatchingHint(16);
                if (d != null) {
                    let e = d.path;
                    return e;
                }
            }
            return null;
        }
        jk(a) {
            super.jk(a);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.l2());
                this.dataChart.axes.add(this.l3());
            }
        }
        q9(a) {
            if (a != null && this.ff != null && a.fh == null) {
                a.provideRenderer(this.ff);
            }
            a.jq = this.sc;
            a.en = this.nq;
            a.jr = this.sd;
            a.eq = this.nr;
            a.jt = this.sf;
            a.fc = this.ns;
            a.js = this.se;
            a.fd = this.nt;
            a.ju = this.sg;
            a.fe = this.nu;
            a.c1 = true;
            a.cr = this.cx;
            a.ct = this.cx;
            let b = a == this.l2();
            if (b) {
                a.g2 = this.pq;
            }
            a.fw = this.ok;
            a.gc = this.o2;
            a.ag = this.l0;
            this.q7(a, (c) => c.angle = this.nl);
            this.q7(a, (c) => {
                if (c.extent != this.nk) {
                    c.extent = this.nk;
                }
            });
            this.q7(a, (c) => c.horizontalAlignment = this.rq);
            this.q7(a, (c) => c.verticalAlignment = this.ss);
            this.q7(a, (c) => c.visibility = this.sx);
            this.q7(a, (c) => c.location = this.l8(this.mb));
            this.q8(a, (c) => c.horizontalAlignment = this.rr);
            this.q8(a, (c) => c.angle = this.nv);
            this.ra(a);
        }
        rb(a) {
            if (a == null) {
                return;
            }
            if (this.ff != null && a.fh == null) {
                a.provideRenderer(this.ff);
            }
            a.cr = this.cx;
            a.ct = this.cx;
            this.q7(a, (b) => b.angle = this.n2);
            this.q7(a, (b) => {
                if (b.extent != this.n1) {
                    b.extent = this.n1;
                }
            });
            this.q7(a, (b) => b.horizontalAlignment = this.rs);
            this.q7(a, (b) => b.verticalAlignment = this.st);
            this.q7(a, (b) => b.visibility = this.sy);
            this.q7(a, (b) => b.location = this.l9(this.md));
            this.q8(a, (b) => b.verticalAlignment = this.su);
            this.q8(a, (b) => b.angle = this.oc);
            a.jq = this.sj;
            a.en = this.n7;
            a.jr = this.sk;
            a.eq = this.n8;
            a.jt = this.sm;
            a.fc = this.n9;
            a.js = this.sl;
            a.fd = this.oa;
            a.ju = this.sn;
            a.fe = this.ob;
            let b = a == this.l3();
            if (b) {
                a.g2 = this.qv;
            }
            a.gc = this.p7;
            a.ag = this.l1;
            this.rc(a);
        }
        jh() {
            super.jh();
            this.q9(this.l2());
            this.rb(this.l3());
        }
        q7(a, b) {
            if (a == null) {
                return;
            }
            if (a.ay == null) {
                a.ay = new AxisLabelSettings();
                a.ay.angle = a.d1();
                a.ay.bottomMargin = a.d2();
                a.ay.leftMargin = a.d3();
                a.ay.rightMargin = a.d4();
                a.ay.topMargin = a.d5();
                a.ay.horizontalAlignment = a.jl();
                a.ay.location = a.az();
                a.ay.verticalAlignment = a.ke();
            }
            b(a.ay);
        }
        q8(a, b) {
            if (a == null) {
                return;
            }
            if (a.be == null) {
                a.be = new TitleSettings();
                a.be.bottomMargin = a.d7();
                a.be.leftMargin = a.d8();
                a.be.rightMargin = a.d9();
                a.be.topMargin = a.ea();
                a.be.location = a.a0();
                a.be.angle = a.d6();
                a.be.horizontalAlignment = a.jm();
                a.be.verticalAlignment = a.kf();
            }
            b(a.be);
        }
        ka(a, b, c) {
            super.ka(a, b, c);
            switch (a) {
                case "XAxisLabelAngle":
                    this.rf((d) => d.angle = this.nl);
                    break;
                case "YAxisLabelAngle":
                    this.rk((d) => d.angle = this.n2);
                    break;
                case "XAxisLabelHorizontalAlignment":
                    this.rf((d) => d.horizontalAlignment = this.rq);
                    break;
                case "YAxisLabelHorizontalAlignment":
                    this.rk((d) => d.horizontalAlignment = this.rs);
                    break;
                case "XAxisLabelVerticalAlignment":
                    this.rf((d) => d.verticalAlignment = this.ss);
                    break;
                case "YAxisLabelVerticalAlignment":
                    this.rk((d) => d.verticalAlignment = this.st);
                    break;
                case "XAxisLabelVisibility":
                    this.rf((d) => d.visibility = this.sx);
                    break;
                case "YAxisLabelVisibility":
                    this.rk((d) => d.visibility = this.sy);
                    break;
                case "XAxisLabel":
                    this.rd((d) => d.fw = this.ok);
                    break;
                case "YAxisLabel":
                    this.ri((d) => d.fw = this.ol);
                    break;
                case "XAxisLabelFormat":
                    this.rd((d) => d.gc = this.o2);
                    break;
                case "XAxisLabelFormatSpecifiers":
                    this.rd((d) => d.ag = this.l0);
                    break;
                case "YAxisLabelFormat":
                    this.ri((d) => d.gc = this.p7);
                    break;
                case "YAxisLabelFormatSpecifiers":
                    this.ri((d) => d.ag = this.l1);
                    break;
                case "XAxisTitleAngle":
                    this.rh((d) => d.angle = this.nv);
                    break;
                case "YAxisTitleAngle":
                    this.rm((d) => d.angle = this.oc);
                    break;
                case "XAxisTitleAlignment":
                    this.rh((d) => d.horizontalAlignment = this.rr);
                    break;
                case "YAxisTitleAlignment":
                    this.rm((d) => d.verticalAlignment = this.su);
                    break;
                case "XAxisTitle":
                    this.rd((d) => d.g2 = this.pq);
                    break;
                case "YAxisTitle":
                    this.rj((d) => d.g2 = this.qv, false);
                    break;
                case "XAxisMajorStroke":
                    this.re((d) => d.jq = this.sc, a);
                    break;
                case "YAxisMajorStroke":
                    this.ri((d) => d.jq = this.sj);
                    break;
                case "XAxisMajorStrokeThickness":
                    this.re((d) => d.en = this.nq, a);
                    break;
                case "YAxisMajorStrokeThickness":
                    this.ri((d) => d.en = this.n7);
                    break;
                case "XAxisMinorStroke":
                    this.rd((d) => d.jr = this.sd);
                    break;
                case "YAxisMinorStroke":
                    this.ri((d) => d.jr = this.sk);
                    break;
                case "XAxisMinorStrokeThickness":
                    this.rd((d) => d.eq = this.nr);
                    break;
                case "YAxisMinorStrokeThickness":
                    this.ri((d) => d.eq = this.n8);
                    break;
                case "XAxisTickLength":
                    this.rd((d) => d.fd = this.nt);
                    break;
                case "YAxisTickLength":
                    this.ri((d) => d.fd = this.oa);
                    break;
                case "XAxisTickStroke":
                    this.rd((d) => d.ju = this.sg);
                    break;
                case "YAxisTickStroke":
                    this.ri((d) => d.ju = this.sn);
                    break;
                case "XAxisTickStrokeThickness":
                    this.rd((d) => d.fe = this.nu);
                    break;
                case "YAxisTickStrokeThickness":
                    this.ri((d) => d.fe = this.ob);
                    break;
                case "XAxisStroke":
                    this.rd((d) => d.jt = this.sf);
                    break;
                case "YAxisStroke":
                    this.ri((d) => d.jt = this.sm);
                    break;
                case "XAxisStrokeThickness":
                    this.rd((d) => d.fc = this.ns);
                    break;
                case "YAxisStrokeThickness":
                    this.ri((d) => d.fc = this.n9);
                    break;
                case "XAxisExtent":
                    this.rf((d) => d.extent = this.nk);
                    break;
                case "YAxisExtent":
                    this.rk((d) => d.extent = this.n1);
                    break;
                case "XAxisStrip":
                    this.rd((d) => d.js = this.se);
                    break;
                case "YAxisStrip":
                    this.ri((d) => d.js = this.sl);
                    break;
                case "XAxisInverted":
                    this.rd((d) => d.cf = this.mg);
                    break;
                case "YAxisInverted":
                    this.ri((d) => d.cf = this.mh);
                    break;
                case "YAxisLabelLocation":
                    this.rl();
                    break;
                case "XAxisLabelLocation":
                    this.rg();
                    break;
            }
        }
        rl() {
            let a = this.l9(this.md);
            if (a == 2 || a == 7) {
                this.rs = 2;
            }
            else {
                this.rs = 0;
            }
            this.rk((b) => b.location = a);
        }
        rg() {
            let a = this.l8(this.mb);
            if (a == 1 || a == 5) {
                this.ss = 0;
            }
            else {
                this.ss = 2;
            }
            this.rf((b) => b.location = a);
        }
        l9(a) {
            if (a == 0) {
                return 2;
            }
            else if (a == 1) {
                return 3;
            }
            else if (a == 3) {
                return 7;
            }
            else if (a == 2) {
                return 6;
            }
            else {
                if (this.ai == 1) {
                    return 3;
                }
                else {
                    return 2;
                }
            }
        }
        l8(a) {
            if (a == 1) {
                return 1;
            }
            else if (a == 0) {
                return 0;
            }
            else if (a == 3) {
                return 5;
            }
            else if (a == 2) {
                return 4;
            }
            else {
                return 1;
            }
        }
        get ok() {
            return this.oi;
        }
        set ok(a) {
            let b = this.ok;
            if (a != b) {
                this.oi = a;
                this.ka("XAxisLabel", b, this.ok);
            }
        }
        get ol() {
            return this.oj;
        }
        set ol(a) {
            let b = this.ol;
            if (a != b) {
                this.oj = a;
                this.ka("YAxisLabel", b, this.ol);
            }
        }
        get sc() {
            return this.rw;
        }
        set sc(a) {
            let b = this.sc;
            if (a != b) {
                this.rw = a;
                this.ka("XAxisMajorStroke", b, this.sc);
            }
        }
        get sj() {
            return this.r3;
        }
        set sj(a) {
            let b = this.sj;
            if (a != b) {
                this.r3 = a;
                this.ka("YAxisMajorStroke", b, this.sj);
            }
        }
        get nq() {
            return this.mo;
        }
        set nq(a) {
            let b = this.nq;
            if (a != b) {
                this.mo = a;
                this.ka("XAxisMajorStrokeThickness", b, this.nq);
            }
        }
        get n7() {
            return this.m5;
        }
        set n7(a) {
            let b = this.n7;
            if (a != b) {
                this.m5 = a;
                this.ka("YAxisMajorStrokeThickness", b, this.n7);
            }
        }
        get nr() {
            return this.mp;
        }
        set nr(a) {
            let b = this.nr;
            if (a != b) {
                this.mp = a;
                this.ka("XAxisMinorStrokeThickness", b, this.nr);
            }
        }
        get n8() {
            return this.m6;
        }
        set n8(a) {
            let b = this.n8;
            if (a != b) {
                this.m6 = a;
                this.ka("YAxisMinorStrokeThickness", b, this.n8);
            }
        }
        get se() {
            return this.ry;
        }
        set se(a) {
            let b = this.se;
            if (a != b) {
                this.ry = a;
                this.ka("XAxisStrip", b, this.se);
            }
        }
        get sl() {
            return this.r5;
        }
        set sl(a) {
            let b = this.sl;
            if (a != b) {
                this.r5 = a;
                this.ka("YAxisStrip", b, this.sl);
            }
        }
        get sf() {
            return this.rz;
        }
        set sf(a) {
            let b = this.sf;
            if (a != b) {
                this.rz = a;
                this.ka("XAxisStroke", b, this.sf);
            }
        }
        get sm() {
            return this.r6;
        }
        set sm(a) {
            let b = this.sm;
            if (a != b) {
                this.r6 = a;
                this.ka("YAxisStroke", b, this.sm);
            }
        }
        get ns() {
            return this.mq;
        }
        set ns(a) {
            let b = this.ns;
            if (a != b) {
                this.mq = a;
                this.ka("XAxisStrokeThickness", b, this.ns);
            }
        }
        get n9() {
            return this.m7;
        }
        set n9(a) {
            let b = this.n9;
            if (a != b) {
                this.m7 = a;
                this.ka("YAxisStrokeThickness", b, this.n9);
            }
        }
        get nt() {
            return this.mr;
        }
        set nt(a) {
            let b = this.nt;
            if (a != b) {
                this.mr = a;
                this.ka("XAxisTickLength", b, this.nt);
            }
        }
        get oa() {
            return this.m8;
        }
        set oa(a) {
            let b = this.oa;
            if (a != b) {
                this.m8 = a;
                this.ka("YAxisTickLength", b, this.oa);
            }
        }
        get sg() {
            return this.r0;
        }
        set sg(a) {
            let b = this.sg;
            if (a != b) {
                this.r0 = a;
                this.ka("XAxisTickStroke", b, this.sg);
            }
        }
        get sn() {
            return this.r7;
        }
        set sn(a) {
            let b = this.sn;
            if (a != b) {
                this.r7 = a;
                this.ka("YAxisTickStroke", b, this.sn);
            }
        }
        get nu() {
            return this.ms;
        }
        set nu(a) {
            let b = this.nu;
            if (a != b) {
                this.ms = a;
                this.ka("XAxisTickStrokeThickness", b, this.nu);
            }
        }
        get ob() {
            return this.m9;
        }
        set ob(a) {
            let b = this.ob;
            if (a != b) {
                this.m9 = a;
                this.ka("YAxisTickStrokeThickness", b, this.ob);
            }
        }
        get pq() {
            return this.oo;
        }
        set pq(a) {
            let b = this.pq;
            if (a != b) {
                this.oo = a;
                this.ka("XAxisTitle", b, this.pq);
            }
        }
        get qv() {
            return this.os;
        }
        set qv(a) {
            let b = this.qv;
            if (a != b) {
                this.os = a;
                this.ka("YAxisTitle", b, this.qv);
            }
        }
        get sd() {
            return this.rx;
        }
        set sd(a) {
            let b = this.sd;
            if (a != b) {
                this.rx = a;
                this.ka("XAxisMinorStroke", b, this.sd);
            }
        }
        get sk() {
            return this.r4;
        }
        set sk(a) {
            let b = this.sk;
            if (a != b) {
                this.r4 = a;
                this.ka("YAxisMinorStroke", b, this.sk);
            }
        }
        get nl() {
            return this.mj;
        }
        set nl(a) {
            let b = this.nl;
            if (a != b) {
                this.mj = a;
                this.ka("XAxisLabelAngle", b, this.nl);
            }
        }
        get n2() {
            return this.m0;
        }
        set n2(a) {
            let b = this.n2;
            if (a != b) {
                this.m0 = a;
                this.ka("YAxisLabelAngle", b, this.n2);
            }
        }
        get nk() {
            return this.mi;
        }
        set nk(a) {
            let b = this.nk;
            if (a != b) {
                this.mi = a;
                this.ka("XAxisExtent", b, this.nk);
            }
        }
        get n1() {
            return this.mz;
        }
        set n1(a) {
            let b = this.n1;
            if (a != b) {
                this.mz = a;
                this.ka("YAxisExtent", b, this.n1);
            }
        }
        get nv() {
            return this.mt;
        }
        set nv(a) {
            let b = this.nv;
            if (a != b) {
                this.mt = a;
                this.ka("XAxisTitleAngle", b, this.nv);
            }
        }
        get oc() {
            return this.na;
        }
        set oc(a) {
            let b = this.oc;
            if (a != b) {
                this.na = a;
                this.ka("YAxisTitleAngle", b, this.oc);
            }
        }
        get mg() {
            return this.me;
        }
        set mg(a) {
            let b = this.mg;
            if (a != b) {
                this.me = a;
                this.ka("XAxisInverted", b, this.mg);
            }
        }
        get mh() {
            return this.mf;
        }
        set mh(a) {
            let b = this.mh;
            if (a != b) {
                this.mf = a;
                this.ka("YAxisInverted", b, this.mh);
            }
        }
        get rr() {
            return this.ro;
        }
        set rr(a) {
            let b = this.rr;
            if (a != b) {
                this.ro = a;
                this.ka("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.rr));
            }
        }
        get su() {
            return this.sr;
        }
        set su(a) {
            let b = this.su;
            if (a != b) {
                this.sr = a;
                this.ka("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.su));
            }
        }
        get rq() {
            return this.rn;
        }
        set rq(a) {
            let b = this.rq;
            if (a != b) {
                this.rn = a;
                this.ka("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.rq));
            }
        }
        get_rs() {
            return this.rp;
        }
        set_rs(a) {
            let b = this.rs;
            if (a != b) {
                this.rp = a;
                this.ka("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.rs));
            }
        }
        get rs() {
            return this.get_rs();
        }
        set rs(a) {
            this.set_rs(a);
        }
        get ss() {
            return this.sp;
        }
        set ss(a) {
            let b = this.ss;
            if (a != b) {
                this.sp = a;
                this.ka("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ss));
            }
        }
        get st() {
            return this.sq;
        }
        set st(a) {
            let b = this.st;
            if (a != b) {
                this.sq = a;
                this.ka("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.st));
            }
        }
        get sx() {
            return this.sv;
        }
        set sx(a) {
            let b = this.sx;
            if (a != b) {
                this.sv = a;
                this.ka("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.sx));
            }
        }
        get sy() {
            return this.sw;
        }
        set sy(a) {
            let b = this.sy;
            if (a != b) {
                this.sw = a;
                this.ka("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.sy));
            }
        }
        get_md() {
            return this.mc;
        }
        set_md(a) {
            let b = this.md;
            if (a != b) {
                this.mc = a;
                this.ka("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.md));
            }
        }
        get md() {
            return this.get_md();
        }
        set md(a) {
            this.set_md(a);
        }
        get_mb() {
            return this.ma;
        }
        set_mb(a) {
            let b = this.mb;
            if (a != b) {
                this.ma = a;
                this.ka("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.mb));
            }
        }
        get mb() {
            return this.get_mb();
        }
        set mb(a) {
            this.set_mb(a);
        }
        get o2() {
            return this.om;
        }
        set o2(a) {
            let b = this.om;
            if (a != b) {
                this.om = a;
                this.ka("XAxisLabelFormat", b, this.om);
            }
        }
        get l0() {
            return this.ly;
        }
        set l0(a) {
            let b = this.ly;
            if (a != b) {
                this.ly = a;
                this.ka("XAxisLabelFormatSpecifiers", b, this.ly);
            }
        }
        get p7() {
            return this.oq;
        }
        set p7(a) {
            let b = this.oq;
            if (a != b) {
                this.oq = a;
                this.ka("YAxisLabelFormat", b, this.oq);
            }
        }
        get l1() {
            return this.lz;
        }
        set l1(a) {
            let b = this.lz;
            if (a != b) {
                this.lz = a;
                this.ka("YAxisLabelFormatSpecifiers", b, this.lz);
            }
        }
    }
    XYChart.$t = /*@__PURE__*/ markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
})();
