/**
 * Represents event argument for DataLegendSummaryCalculationCustom
*/
export class IgrDataLegendSummaryCalculationEventArgs {
    constructor() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets actual value of data series
    */
    get data() {
        return this.i.data;
    }
    set data(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.data = v;
    }
    /**
     * Gets summary text displayed below data rows
    */
    get summaryText() {
        return this.i.summaryText;
    }
    set summaryText(v) {
        this.i.summaryText = v;
    }
    /**
     * Gets summary values displayed below data rows
    */
    get summaryValue() {
        return this.i.summaryValue;
    }
    set summaryValue(v) {
        this.i.summaryValue = +v;
    }
}
