/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { markType, Point_$type, enumGetBox, typeCast, runOn, markDep } from "igniteui-react-core";
import { isNaN_, intDivide, isInfinity } from "igniteui-react-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { RadialFrame } from "./RadialFrame";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { RadialBaseView } from "./RadialBaseView";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-react-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
var AnchoredRadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialBucketCalculator, _super);
    function AnchoredRadialBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    AnchoredRadialBucketCalculator.prototype.getBucket = function (a) {
        var b = this.f.cw.sr;
        var c = Math.min(a * this.b, b.count - 1);
        var d = Math.min(c + this.b - 1, b.count - 1);
        var e = NaN;
        var f = NaN;
        for (var g = c; g <= d; ++g) {
            var h = b.item(g);
            if (!isNaN_(e)) {
                if (!isNaN_(h)) {
                    e = Math.min(e, h);
                    f = Math.max(f, h);
                }
            }
            else {
                e = h;
                f = h;
            }
        }
        if (!isNaN_(e)) {
            return [0.5 * (c + d), e, f];
        }
        return [0.5 * (c + d), NaN, NaN];
    };
    AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
}(RadialBucketCalculator));
export { AnchoredRadialBucketCalculator };
/**
 * @hidden
 */
var AnchoredRadialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeries, _super);
    function AnchoredRadialSeries() {
        var _this = _super.call(this) || this;
        _this.sm = null;
        _this.sq = null;
        _this.tn = { $type: Point_$type, x: 0, y: 0 };
        _this.so = null;
        _this.sn = null;
        _this.so = new RadialFrame(3);
        _this.sm = new CategoryLineRasterizer();
        return _this;
    }
    AnchoredRadialSeries.prototype.bv = function () {
        return new AnchoredRadialSeriesView(this);
    };
    AnchoredRadialSeries.prototype.kl = function () {
        _super.prototype.kl.call(this);
        this.q8 = null;
        this.rf = null;
    };
    AnchoredRadialSeries.prototype.hn = function (a, b) {
        var c = this.jf(b);
        if (c == AnchoredRadialSeries.$$p[0]) {
            return this.ho(a, b, this.s3);
        }
        return _super.prototype.hn.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.lo = function (a) {
        _super.prototype.lo.call(this, a);
        this.sl = a;
    };
    AnchoredRadialSeries.prototype.g9 = function (a, b) {
        return this.ha(a, b, this.q8, null, this.sr);
    };
    AnchoredRadialSeries.prototype.g7 = function (a, b) {
        return this.g8(a, b, this.q8, null, this.sr);
    };
    AnchoredRadialSeries.prototype.fw = function (a, b, c, d, e) {
        if (this.sr == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.fx(a, b, this.q8, d, e, this.sr.count, null);
    };
    AnchoredRadialSeries.prototype.ga = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.by);
        var e = this.sw(this.q8, this.by.bv, this.by.bu, d);
        var f = new ScalerParams(0, this.by.bv, this.by.bu, this.q8.cf, d);
        f.c = this.cb.sf;
        return this.gc(this.sr, a, this.q8, f, e, null, b, c);
    };
    AnchoredRadialSeries.prototype.pb = function (a, b, c) {
        if (this.rf == null || this.q8 == null || this.by == null || this.by.bv.isEmpty || this.by.bu.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.getEffectiveViewport1(this.by);
        var e = new ScalerParams(0, this.by.bv, this.by.bu, this.rf.cf, d);
        e.c = this.getEffectiveViewport1(this.by);
        var f = this.ga(a, b, c);
        f = this.rf.ef(f, e);
        var g = this.rg.c(a);
        if (!b && this.q8 != null) {
            var h = this.g9(a, c);
            var i = this.g7(a, c);
            var j = this.sw(this.q8, this.by.bv, this.by.bu, d);
            var k = new ScalerParams(0, this.by.bv, this.by.bu, this.q8.cf, d);
            k.c = this.cb.sf;
            var l = this.fw(a, h, this.q8, k, j);
            var m = this.fw(a, i, this.q8, k, j);
            if (m <= l) {
                g = this.q8.ef(i, k) + j;
            }
            else {
                g = this.q8.ef(h, k) + j;
            }
        }
        var n = this.rg.d(g, f, this.by.bv, this.by.bu);
        var o = this.rg.e(g, f, this.by.bv, this.by.bu);
        return { $type: Point_$type, x: n, y: o };
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "sr", {
        get: function () {
            return this.sq;
        },
        set: function (a) {
            if (this.sq != a) {
                var b = this.sq;
                this.sq = a;
                this.raisePropertyChanged("ValueColumn", b, this.sq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredRadialSeries.prototype, "tj", {
        get: function () {
            return this.c(AnchoredRadialSeries.ta);
        },
        set: function (a) {
            this.h(AnchoredRadialSeries.ta, a);
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.ap = function (a) {
        if (a != null && a == this.q8 && this.sr != null && this.sr.count > 0) {
            return new AxisRange(0, this.sr.count - 1);
        }
        if (a != null && a == this.rf && this.sr != null && this.sr.count > 0) {
            return new AxisRange(this.sr.minimum, this.sr.maximum);
        }
        return null;
    };
    AnchoredRadialSeries.prototype.lt = function (a, b, c, d) {
        _super.prototype.lt.call(this, a, b, c, d);
        if (this.sl.cx.g$b(a, b, c, d)) {
            this.l7(false);
            this.le();
        }
        var e = typeCast(NumericAxisBase.$, this.rf);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) !== null) {
                    c.deregisterColumn(this.sr);
                    this.sr = null;
                }
                if (typeCast(IFastItemsSource_$type, d) !== null) {
                    this.sr = this.cf(this.s3);
                    this.sl.cs.e(this.gk);
                }
                if (e != null && !e.cy()) {
                    this.sl.cs.e(this.gk);
                    this.l7(false);
                }
                break;
            case AnchoredRadialSeries.$$p[0]:
                if (this.ci != null) {
                    this.ci.deregisterColumn(this.sr);
                    this.sr = this.cf(this.s3);
                }
                break;
            case "ValueColumn":
                if (e != null && !e.cy()) {
                    this.sl.cs.e(this.gk);
                    this.l7(false);
                }
                break;
            case "TrendLineBrush":
                this.mk();
                break;
            case "TrendLineType":
                this.le();
                break;
        }
    };
    AnchoredRadialSeries.prototype.kr = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.sl.cs.e(this.gk);
                break;
        }
        this.sl.cx.g$e(a, b, c, d);
        switch (a) {
            case 4:
                if (this.rf != null && !this.rf.cy()) {
                    this.l7(true);
                }
                break;
            case 1:
                if (this.rf != null && !this.rf.cy()) {
                    this.l7(true);
                }
                break;
            case 0:
                if (this.rf != null && !this.rf.cy()) {
                    this.l7(true);
                }
                break;
            case 2:
                if (this.s3 != null && this.sl.cs.b > 0 && this.rf != null && !this.rf.cy()) {
                    this.l7(true);
                }
                break;
            case 3:
                if (d == this.s3) {
                    if (this.rf != null && !this.rf.cy()) {
                        this.l7(true);
                    }
                }
                break;
        }
    };
    AnchoredRadialSeries.prototype.e5 = function (a, b, c) {
        var d = _super.prototype.e5.call(this, a, b, c);
        var e = c;
        if (this.ci == null || this.ci.count == 0 || this.q8 == null || this.sr == null || this.q8.k9 == 0 || this.rf == null || isInfinity(this.rf.ld) || isInfinity(this.rf.lc) || e.cs.b < 1) {
            d = false;
        }
        return d;
    };
    AnchoredRadialSeries.prototype.getOffsetValue = function () {
        return this.sw(this.q8, this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by));
    };
    AnchoredRadialSeries.prototype.getCategoryWidth = function () {
        return this.q8.getCategorySize(this.by.bv, this.by.bu, this.getEffectiveViewport1(this.by));
    };
    AnchoredRadialSeries.prototype.get_su = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "su", {
        get: function () {
            return this.get_su();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.sw = function (a, b, c, d) {
        var e = 0;
        var f = this.preferredCategoryMode(a);
        if (f == 0 && a.categoryMode != 0) {
            f = 1;
        }
        switch (f) {
            case 0:
                e = 0;
                break;
            case 1:
                e = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                e = a.getGroupCenter(this.r2(), b, c, d);
                break;
        }
        if (a.cf) {
            e = -e;
        }
        return e;
    };
    AnchoredRadialSeries.prototype.sa = function (a, b) {
        var _this = this;
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.q8;
        var g = this.rf;
        var h = g.ld;
        var i = g.lc;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = this.p2();
        var k = 0;
        var l = b;
        var m = new CollisionAvoider();
        var n = 0;
        var o = b.cs.d;
        n = this.sw(f, c, d, e);
        l.cx.i = this.rf.mu;
        l.cx.h = this.rf.mt;
        l.cx.j = function (p, q) { return _this.sx(p, q, c, d); };
        l.cx.k = function (p, q) { return _this.sy(p, q, c, d); };
        var p = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.p;
            return $ret;
        })());
        var q = ((function () {
            var $ret = new TrendResolutionParams();
            $ret.c = b.cs.b;
            $ret.d = b.cs.c;
            $ret.e = o;
            $ret.a = n;
            $ret.b = _this.gk;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })());
        l.cx.l(a.p, this.sp, this.sr, this.s0, function (r) { return _this.q8.getScaledAngle(r); }, function (r) { return _this.rf.m0(r); }, q, p);
        var r = true;
        if (this.sv(b)) {
            o--;
        }
        for (var s = b.cs.c; s <= o; ++s) {
            var t = s;
            if (t * b.cs.b >= this.q8.k9) {
                t -= intDivide((this.q8.k9), b.cs.b);
            }
            var u = b.cs.getBucket(t);
            if (!isNaN_(u[0])) {
                u[0] = f.getScaledAngle(u[0]) + n;
                if (u[1] < h || u[1] > i) {
                    continue;
                }
                u[1] = g.m0(u[1]);
                if (b.cs.b > 1) {
                    if (u[2] < h || u[2] > i) {
                        continue;
                    }
                    u[2] = g.m0(u[2]);
                }
                else {
                    u[2] = u[1];
                }
                if ((isNaN_(u[1]) || isNaN_(u[2])) && r && this.su && this.st()) {
                    o++;
                }
                else {
                    r = false;
                }
                a.f.add(u);
                if (j) {
                    var v = Math.min(t * b.cs.b, this.ci.count - 1);
                    var w = this.rg.d(u[0], u[1], c, d);
                    var x = this.rg.e(u[0], u[1], c, d);
                    var y = new Rect(0, w - 5, x - 5, 11, 11);
                    if (!isNaN_(w) && !isNaN_(x) && !isInfinity(w) && !isInfinity(x) && m.tryAdd(y)) {
                        a.m.add({ $type: Point_$type, x: w, y: x });
                        var z = b.ct.item(k);
                        z.al = t;
                        z.ak = v;
                        z.content.item = this.ci.item(v);
                        ++k;
                    }
                }
            }
            else {
                if (r && this.su && this.st()) {
                    o++;
                }
            }
        }
        b.ct.count = k;
        return;
    };
    AnchoredRadialSeries.prototype.sx = function (a, b, c, d) {
        return this.rg.d(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.sy = function (a, b, c, d) {
        return this.rg.e(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.sv = function (a) {
        var b = a;
        return !this.su && b.cs.c == 0 && b.cs.d == this.q8.k9;
    };
    AnchoredRadialSeries.prototype.sk = function (a, b, c) {
        var d = null;
        var e = c.bv;
        var f = c.bu;
        if (b > -1 && !e.isEmpty && !f.isEmpty) {
            var g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
            var h = f.bottom + 10;
            var i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
            var j = f.top - 10;
            d = new Clipper(1, g, h, i, j, false);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.s9 = function (a, b, c, d, e) {
        if (a.count > 0 && d.count > 0) {
            if (!e || this.ss()) {
                a.add(this.tn);
                a.add(a._inner[0]);
                d.add(this.tn);
                d.add(d._inner[0]);
            }
        }
    };
    AnchoredRadialSeries.prototype.st = function () {
        return !this.ss();
    };
    AnchoredRadialSeries.prototype.ss = function () {
        var a = this.by.bv;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    AnchoredRadialSeries.prototype.ko = function (a, b) {
        _super.prototype.ko.call(this, a, b);
        var c = b;
        if (a) {
            c.ct.clear();
        }
        c.cx.g$d();
    };
    AnchoredRadialSeries.prototype.sd = function (a, b) {
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.pg(b);
        var g = b;
        g.cx.g$g(a.p);
        CategoryMarkerManager.e(this, a.m, g.ct, this.p4);
        this.s6(b, a);
        g.cm();
        this.s5(d, c, e, f, g);
    };
    AnchoredRadialSeries.prototype.sj = function (a, b, c) {
        if (b < a || a < 0 || a > this.sr.count || b < 0 || b > this.sr.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.ck;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.ci.item(g);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.s7 = function (a, b, c, d, e, f) {
        var g = this.bk != 1;
        this.rm.a1(this.rm.d, d.ck, a, b, c, d, e, f, true);
        this.rm.aa(this.fl);
        var h = this.rm.av;
        var i = null;
        var j = this.ci;
        var k = null;
        if (g && this.cb != null) {
            i = this.cb.a3.getHighlightingInfo(this, j, h.o, h.n, true);
            if (this.cb.a3.isCrossSeriesHighlight(this)) {
                k = this.cb.a3.getHighlightingInfo(this, j, h.o, h.n, true);
            }
            h.b = i;
        }
        h.f = f;
        this.sb(h);
        this.rm.y(this, i, f, g, h.m, this.cb.a3.totalHighlightingProgress);
    };
    AnchoredRadialSeries.prototype.s8 = function (a, b, c, d, e, f) {
        var g = this.bk != 1;
        this.rm.a1(this.rm.b, d.ck, a, b, c, d, e, f, false);
        this.rm.ab(this.fl);
        var h = this.rm.aw;
        var i = null;
        var j = this.ci;
        if (g && this.cb != null) {
            i = this.cb.a3.getHighlightingInfo(this, j, h.o, h.n, false);
            h.b = i;
        }
        h.f = f;
        this.sc(h);
        this.rm.z(this, i, f, g, b < 0);
    };
    AnchoredRadialSeries.prototype.s6 = function (a, b) {
        a.b3 = true;
        this.rm.az(this, this.rx(), runOn(this, this.q5), this.r0(a), this.r1(a));
        var c = this.rm.d;
        var d = c != null;
        var e = this.q8;
        if (e == null) {
            return;
        }
        var f = this.getEffectiveViewport1(a);
        var g = new ScalerParams(0, a.bv, a.bu, e.cf, f);
        var h = this.ci == null ? 0 : this.ci.count;
        var i = a;
        var j = b.f;
        var k = i.cs.c;
        var l = i.cs.d;
        var m = i.cs.b;
        var n = k * m;
        for (var o = 0; o < a.ct.count; o++) {
            var p = a.ct.item(o);
            var q = p.content;
            if (d) {
                var r = p.al;
                this.s7(j, r, h, e, g, a.q);
            }
            this.rm.ac(p, q);
        }
    };
    AnchoredRadialSeries.prototype.s5 = function (a, b, c, d, e) {
        e.cy(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.mk = function () {
        _super.prototype.mk.call(this);
        if (this.hc < 0) {
            return;
        }
        this.sl.cz();
    };
    AnchoredRadialSeries.prototype.hq = function (a, b) {
        if (a == this.sl.cx.g$j) {
            return null;
        }
        return _super.prototype.hq.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.ej = function (a) {
        var b = this.by.bv;
        b = b.copy();
        var c = this.by.bu;
        var d = !b.isEmpty && !c.isEmpty && this.ci != null ? this.ci.indexOf(a) : -1;
        if (this.q8 == null || this.sr == null || this.rf == null) {
            return false;
        }
        if (d < 0 || d > this.sr.count - 1) {
            return false;
        }
        var e = this.q8.getScaledAngle(d);
        var f = this.rf.m0(this.sr.item(d));
        if (isNaN_(f)) {
            f = (this.rf.mt + this.rf.mu) / 2;
        }
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.b6 != null) {
            this.b6.au(this.cb, b, true);
        }
        return d >= 0;
    };
    AnchoredRadialSeries.prototype.l9 = function (a, b) {
        _super.prototype.l9.call(this, a, b);
        if (!this.ev) {
            this.by.a2(b);
            return;
        }
        this.by.a2(b);
        var c = typeCast(AnchoredRadialSeriesView.$, this.bx);
        c.cs.e(this.gk);
        if (this.cu(this.bx)) {
            return;
        }
        if (!this.ep) {
            this.so = new RadialFrame(3);
            this.sa(this.so, c);
        }
        this.ep = false;
        this.sd(this.so, c);
        this.ev = false;
    };
    AnchoredRadialSeries.prototype.l6 = function (a, b, c, d, e) {
        _super.prototype.l6.call(this, a, b, c, d, e);
        var f = this.a5.a$h.item(d);
        var g = f;
        g.cs.e(this.gk);
        f.a1(c);
        if (this.cu(g)) {
            return;
        }
        if (this.sn == null) {
            this.sn = new RadialFrame(3);
        }
        this.sn.u();
        this.sa(this.sn, g);
        this.sd(this.sn, g);
    };
    AnchoredRadialSeries.prototype.ky = function (a) {
        _super.prototype.ky.call(this, a);
        this.a7.exportTrendlineData(this, a, this.sl.cx.g$j);
    };
    AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.ta = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredRadialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberPath:s3:ti', [2, null], 'TrendLineType:sp:tg', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:sz:tf', [1, 1.5], 'TrendLinePeriod:s0:te', [1, 7], 'TrendLineZIndex:s1:th', [1, 1], 'TrendLineBrush:tk:tb', [Brush.$, null], 'TrendLineDashArray:tl:tc', [DoubleCollection.$], 'TrendLineDashCap:tm:td', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
}(RadialBase));
export { AnchoredRadialSeries };
/**
 * @hidden
 */
var AnchoredRadialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeriesView, _super);
    function AnchoredRadialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.cx = null;
        _this.cs = new AnchoredRadialBucketCalculator(_this);
        _this.cw = a;
        _this.cx = new RadialTrendLineManager();
        return _this;
    }
    AnchoredRadialSeriesView.prototype.cy = function (a, b, c, d) {
    };
    AnchoredRadialSeriesView.prototype.cz = function () {
        this.cw.tj = null;
        if (this.cw.tk != null) {
            this.cw.tj = this.cw.tk;
        }
        else {
            this.cw.tj = this.cw.oo;
        }
    };
    AnchoredRadialSeriesView.prototype.a5 = function (a, b) {
        if (a.d) {
            if (!b) {
            }
            if (this.cw.sp != 0 && !b) {
                var c = this.cx.g$j;
                c.ac = this.cw.sz;
                c._stroke = this.cw.tj;
                c.ai = this.cw.tl;
                c.ad = this.cw.tm;
                a.u(c);
            }
        }
        _super.prototype.a5.call(this, a, b);
    };
    AnchoredRadialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.cw.q8.fw != null) {
            a += "<span>${item." + this.cw.q8.fw + "}</span><br/>";
        }
        a += "<span";
        var b = this.e.a5.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cw.hs + ": </span><span class='ui-priority-primary'>" + "${item." + this.cw.s3 + "}</span></div>";
        return a;
    };
    AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
}(RadialBaseView));
export { AnchoredRadialSeriesView };
