/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-react-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { List$1 } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-react-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-react-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-react-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-react-core";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-react-core";
import { IChartScaleLegend_$type } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_, isInfinity, logBase } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
var BubbleSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeries, _super);
    function BubbleSeries() {
        var _this = _super.call(this) || this;
        _this.vt = null;
        _this.vs = null;
        _this.us = null;
        _this.uk = null;
        _this.uj = null;
        _this.ui = null;
        _this.ab = BubbleSeries.$;
        _this.rq = new ScatterFrame();
        _this.rs = new ScatterFrame();
        _this.ro = new ScatterFrame();
        return _this;
    }
    BubbleSeries.prototype.get_c1 = function () {
        return true;
    };
    BubbleSeries.prototype.bv = function () {
        return new BubbleSeriesView(this);
    };
    BubbleSeries.prototype.lo = function (a) {
        _super.prototype.lo.call(this, a);
        this.ug = a;
    };
    BubbleSeries.prototype.gl = function () {
        return 0.7;
    };
    BubbleSeries.prototype.pu = function () {
        if (this.pt == 0) {
            return 2;
        }
        return _super.prototype.pu.call(this);
    };
    BubbleSeries.prototype.isAttachedTo = function (a) {
        return this.a0 == a;
    };
    BubbleSeries.prototype.c0 = function () {
        return true;
    };
    BubbleSeries.prototype.k0 = function (a) {
        _super.prototype.k0.call(this, a);
        if (this.un != null && this.us != null && this.us.count > 0) {
            for (var b = 0; b < this.us.count; b++) {
                a(this.us._inner[b]);
            }
        }
    };
    Object.defineProperty(BubbleSeries.prototype, "um", {
        get: function () {
            return this.uo;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.vr = function (a) {
        var b = typeCast(CustomPaletteBrushScale.$, this.uf);
        var c = typeCast(ValueBrushScale.$, this.uf);
        var d = this.uf;
        if (b != null && this.ci != null) {
            return b.getBrush1(a, this.ci.count);
        }
        else if (c != null) {
            return c.getBrushByIndex(a, this.ul);
        }
        else if (d != null) {
            return d.getBrush(a);
        }
        return null;
    };
    Object.defineProperty(BubbleSeries.prototype, "legendReady", {
        get: function () {
            return this.uo != null && this.uo.count != 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "minScaleText", {
        get: function () {
            var a = this.ue(this.uh).b;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "maxScaleText", {
        get: function () {
            var a = this.ue(this.uh).a;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.forScaleColors = function (a) {
        for (var b = 0; b < this.uo.count; b++) {
            if (this.uf == null || !this.uf.isReady) {
                return false;
            }
            var c = NaN;
            if (this.ul != null) {
                c = (this.ul.item(b) - this.ul.minimum) / (this.ul.maximum - this.ul.minimum);
            }
            var d = (this.uo.item(b) - this.uo.minimum) / (this.uo.maximum - this.uo.minimum);
            if (isNaN_(c)) {
                c = 0;
            }
            if (isNaN_(d)) {
                d = c;
            }
            var e = this.q0;
            var f = this.vr(b);
            var g = f != null ? f : e;
            a(g, d);
        }
        return true;
    };
    BubbleSeries.prototype.hn = function (a, b) {
        var c = this.jf(b);
        if (c == BubbleSeries.$$p[3]) {
            return this.ho(a, b, this.u3);
        }
        if (c == BubbleSeries.$$p[7]) {
            return this.ho(a, b, this.u9);
        }
        if (c == ScatterBase.$$p[8]) {
            return this.ho(a, b, this.sx);
        }
        if (c == ScatterBase.$$p[10]) {
            return this.ho(a, b, this.s1);
        }
        if (c == BubbleSeries.$$p[0]) {
            return this.ho(a, b, this.uy);
        }
        return _super.prototype.hn.call(this, a, b);
    };
    Object.defineProperty(BubbleSeries.prototype, "uo", {
        get: function () {
            return this.uk;
        },
        set: function (a) {
            if (this.uk != a) {
                var b = this.uo;
                this.uk = a;
                this.raisePropertyChanged("RadiusColumn", b, this.uo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "un", {
        get: function () {
            return this.uj;
        },
        set: function (a) {
            if (this.uj != a) {
                var b = this.un;
                this.uj = a;
                this.raisePropertyChanged("LabelColumn", b, this.un);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "ul", {
        get: function () {
            return this.ui;
        },
        set: function (a) {
            if (this.ui != a) {
                var b = this.ul;
                this.ui = a;
                this.raisePropertyChanged("FillColumn", b, this.ul);
            }
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.s4 = function (a, b, c, d, e) {
        if (c <= this.sl) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        }
        var f = this.sl;
        var g = this.ci;
        var h;
        var i;
        var j = this.getEffectiveViewport1(a);
        var k = new ScalerParams(0, d, e, this.rk.d, j);
        var l = new ScalerParams(0, d, e, this.rk.e, j);
        var m = false;
        var n = 0;
        if (this.cb != null) {
            if (this.cb.ex()) {
                var o = this.cb.km(d, k);
                m = o.c;
                n = o.d;
            }
        }
        var _loop_1 = function (p) {
            h = this_1.r0.item(p);
            i = this_1.r1.item(p);
            var q = { $type: Point_$type, x: this_1.rk.a.ef(h, k), y: this_1.rk.b.ef(i, l) };
            if (m) {
                if (q.x < e.left || q.x > e.right) {
                    if (q.x + n >= e.left && q.x + n <= e.right) {
                        q = { $type: Point_$type, x: q.x + n, y: i };
                    }
                }
            }
            if (!isInfinity(q.x) && !isInfinity(q.y)) {
                var r_1 = g.item(p);
                if (c <= f) {
                    if (!b.g.containsKey(r_1)) {
                        var s_1 = { $type: Point_$type, x: h, y: i };
                        b.g.addItem(r_1, ((function () {
                            var $ret = new OwnedPoint();
                            $ret.a = r_1;
                            $ret.b = s_1;
                            $ret.c = q;
                            return $ret;
                        })()));
                    }
                }
            }
        };
        var this_1 = this;
        for (var p = 0; p < c; p++) {
            _loop_1(p);
        }
    };
    BubbleSeries.prototype.tc = function (a, b) {
        var c = typeCast(BubbleSeriesView.$, b);
        var d = c.cv;
        d.m = this.uo;
        _super.prototype.tc.call(this, a, b);
        var e = Math.min(this.r0 != null ? this.r0.count : 0, this.r1 != null ? this.r1.count : 0);
        if (e < 1) {
            return;
        }
        c.dh();
        c.di();
    };
    BubbleSeries.prototype.ve = function () {
        if (this.cb == null) {
            return;
        }
        if (this.a0 == null) {
            return;
        }
        if (this.a0.isItemwise) {
            var a = this.a0;
            this.a0.clearLegendItemsForSeries(this);
            this.vd();
            a.renderItemwiseContent(this);
        }
        if (this.a0.isScale) {
            var b = this.a0;
            b.restoreOriginalState();
            b.initializeLegend(this);
        }
    };
    BubbleSeries.ut = function (a, b, c, d, e) {
        if (e <= a || isNaN_(e) || isInfinity(e)) {
            return c;
        }
        if (e >= b) {
            return d;
        }
        var f = c + ((d - c) / (b - a)) * (e - a);
        return f;
    };
    BubbleSeries.uu = function (a, b, c, d, logBase_, e) {
        var f = logBase(e, logBase_);
        var g = logBase(a, logBase_);
        var h = logBase(b, logBase_);
        return BubbleSeries.ut(g, h, c, d, f);
    };
    BubbleSeries.prototype.e5 = function (a, b, c) {
        var d = _super.prototype.e5.call(this, a, b, c);
        if (this.uo == null || this.ci == null || this.uo.count == 0 || this.ci.count != this.uo.count) {
            d = false;
        }
        return d;
    };
    BubbleSeries.prototype.r9 = function (a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.sx == a || this.s1 == a || this.u9 == a) {
            return true;
        }
        return false;
    };
    BubbleSeries.prototype.vd = function () {
        var _this = this;
        var a = typeCast(IChartLegend_$type, this.a0);
        if (a == null || this.ci == null) {
            return;
        }
        this.us = new List$1(UIElement.$, 0);
        var b = typeCast(CustomPaletteBrushScale.$, this.uf);
        var c = typeCast(ValueBrushScale.$, this.uf);
        var d = this.uf;
        var e = this.ud();
        var f = e.b;
        var g = e.a;
        var h = this.ci;
        var _loop_2 = function (i) {
            var j = null;
            if (c != null && this_2.ul != null) {
                var k = this_2.ul.item(i);
                j = c.getBrushByRange(k, f, g);
            }
            else if (b != null) {
                j = b.getBrush1(i, h.count);
            }
            else if (d != null) {
                j = d.getBrush(i);
            }
            var l = new ContentControl();
            var m = this_2.un != null && this_2.un.item(i) != null ? this_2.un.item(i).toString() : "";
            l.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this;
                $ret.item = h.item(i);
                $ret.itemBrush = j;
                $ret.itemLabel = m;
                return $ret;
            })());
            var n = this_2.m0;
            if (n == null) {
                n = this_2.by.bl(this_2.b3);
            }
            l.ah = n;
            this_2.us.add(l);
        };
        var this_2 = this;
        for (var i = 0; i < h.count; i++) {
            _loop_2(i);
        }
    };
    BubbleSeries.prototype.kr = function (a, b, c, d) {
        _super.prototype.kr.call(this, a, b, c, d);
        if (this.uh != null) {
            this.uh.aa();
        }
        if (this.uf != null) {
            this.uf.x();
        }
        this.ve();
    };
    BubbleSeries.prototype.k7 = function () {
        _super.prototype.k7.call(this);
        this.ve();
    };
    BubbleSeries.prototype.ld = function () {
        _super.prototype.ld.call(this);
        this.ve();
    };
    BubbleSeries.prototype.lt = function (a, b, c, d) {
        var e_1, _a;
        _super.prototype.lt.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                if (this.uh != null) {
                    this.uh.aa();
                }
                if (this.uf != null) {
                    this.uf.x();
                }
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.uo);
                    c.deregisterColumn(this.ul);
                    c.deregisterColumn(this.un);
                    this.uo = null;
                    this.ul = null;
                    this.un = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.uo = this.cf(this.u9);
                    if (!stringIsNullOrEmpty(this.uy)) {
                        this.ul = this.cf(this.uy);
                    }
                    this.un = this.ch(this.u3);
                }
                this.l7(false);
                this.ve();
                break;
            case BubbleSeries.$$p[7]:
                if (this.uh != null) {
                    this.uh.aa();
                }
                if (this.ci != null) {
                    this.ci.deregisterColumn(this.uo);
                    this.uo = this.cf(this.u9);
                    this.ve();
                }
                break;
            case "RadiusColumn":
                if (this.uh != null) {
                    this.uh.aa();
                }
                this.rl.cx.g$i();
                this.l7(false);
                this.lf();
                break;
            case BubbleSeries.$$p[8]:
                if (c != null) {
                    c.l.remove(this);
                    c.aa();
                }
                if (d != null) {
                    d.l.add(this);
                    d.aa();
                }
                this.l7(false);
                this.le();
                break;
            case BubbleSeries.$$p[9]:
                this.l7(false);
                this.le();
                break;
            case "DiscreteLegendItemTemplate":
                this.ve();
                break;
            case BubbleSeries.$$p[1]:
                if (c != null) {
                    c.o.remove(this);
                    c.x();
                }
                if (d != null) {
                    d.o.add(this);
                    d.x();
                }
                this.l7(false);
                this.ve();
                this.le();
                break;
            case BubbleSeries.$$p[2]:
            case BubbleSeries.$$p[6]:
            case BubbleSeries.$$p[5]:
            case BubbleSeries.$$p[4]:
                this.l7(false);
                this.ve();
                this.le();
                break;
            case "FillColumn":
                this.l7(false);
                this.le();
                break;
            case BubbleSeries.$$p[0]:
                if (this.uf != null) {
                    this.uf.x();
                }
                if (this.ci != null) {
                    this.ci.deregisterColumn(this.ul);
                    this.ul = this.cf(this.uy);
                    this.ve();
                }
                break;
            case BubbleSeries.$$p[3]:
                if (this.ci != null) {
                    this.ci.deregisterColumn(this.un);
                    this.un = this.ch(this.u3);
                    this.ve();
                }
                break;
            case "ActualLegend":
                var e = typeCast(IChartLegend_$type, c);
                if (e != null && e.isItemwise) {
                    var f = typeCast(IChartItemLegend_$type, e);
                    f.clearLegendItemsForSeries(this);
                }
                if (e != null && e.isScale) {
                    var g = typeCast(IChartScaleLegend_$type, e);
                    var h = true;
                    var i = null;
                    if (this.cb != null) {
                        try {
                            for (var _b = __values(fromEnum(this.cb.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var j = _c.value;
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        catch (e_1_1) {
                            e_1 = { error: e_1_1 };
                        }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return))
                                    _a.call(_b);
                            }
                            finally {
                                if (e_1)
                                    throw e_1.error;
                            }
                        }
                    }
                    if (h) {
                        g.restoreOriginalState();
                    }
                    else {
                        g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                    }
                }
                this.ve();
                break;
            case "SeriesViewer":
                this.ve();
                break;
        }
    };
    BubbleSeries.prototype.updateSizeScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.uo != null) {
            a.b = this.uo.minimum;
            a.a = this.uo.maximum;
        }
        if (this.uh != null) {
            this.uh.ab(a.b, a.a);
        }
    };
    BubbleSeries.prototype.updateFillScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.ul != null) {
            a.b = this.ul.minimum;
            a.a = this.ul.maximum;
        }
        if (this.uf != null) {
            this.uf.z(a.b, a.a);
        }
    };
    BubbleSeries.prototype.ue = function (a) {
        var b = new ActualRange();
        b.b = NaN;
        b.a = NaN;
        if (this.uo != null) {
            b.b = this.uo.minimum;
            b.a = this.uo.maximum;
        }
        if (a != null) {
            a.x();
            if (this.ur) {
                b.b = a.globalMinimum;
                b.a = a.globalMaximum;
            }
        }
        return b;
    };
    BubbleSeries.prototype.ud = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.ul != null) {
            a.b = this.ul.minimum;
            a.a = this.ul.maximum;
        }
        var b = typeCast(ValueBrushScale.$, this.uf);
        if (b != null) {
            b.s();
            if (this.up && this.uf.o.count > 1) {
                a.b = b.q;
                a.a = b.p;
            }
        }
        return a;
    };
    BubbleSeries.prototype.vg = function (a, b, c, d) {
        var e = c.width;
        if (!this.by.bu.isEmpty) {
            e = this.by.bu.width;
        }
        else if (this.cb != null && !this.cb.sf.isEmpty) {
            e = this.cb.sf.width;
        }
        var f = DeviceUtils.c(e);
        var g = this.uh || ((function () {
            var $ret = new SizeScale();
            $ret.minimumValue = f / 10;
            $ret.maximumValue = f / 5;
            return $ret;
        })());
        if (g != null) {
            var h = g.minimumValue;
            var i = g.maximumValue;
            var j = g.logarithmBase;
            var k = this.ue(g);
            var l = k.b;
            var m = k.a;
            if (g.isLogarithmic) {
                for (var n = 0; n < b.count; n++) {
                    b._inner[n] = BubbleSeries.uu(l, m, h, i, j, b._inner[n]);
                }
            }
            else {
                for (var o = 0; o < b.count; o++) {
                    b._inner[o] = BubbleSeries.ut(l, m, h, i, b._inner[o]);
                }
            }
        }
        var p = 1;
        p = DeviceUtils.d();
        var q = this.uh == null;
        if (d) {
            var r = c.width / e;
            for (var s = 0; s < b.count; s++) {
                if (q) {
                    b._inner[s] = b._inner[s] / p;
                }
                b._inner[s] = b._inner[s] * r;
            }
        }
        for (var t = 0; t < a.count; t++) {
            var u = a._inner[t];
            if (q && !d) {
                u.width = Math.max(0, b._inner[t] / p);
                u.height = Math.max(0, b._inner[t] / p);
            }
            else {
                u.width = Math.max(0, b._inner[t]);
                u.height = Math.max(0, b._inner[t]);
            }
        }
    };
    BubbleSeries.prototype.vf = function (a) {
        var b = typeCast(BubbleSeriesView.$, this.bx);
        this.ug.b3 = false;
        if (b != null) {
            b.b3 = false;
        }
        var c = typeCast(CustomPaletteBrushScale.$, this.uf);
        var d = typeCast(ValueBrushScale.$, this.uf);
        var e = this.uf;
        var f = this.ud();
        var g = f.b;
        var h = f.a;
        var i = this.uf == null || !this.uf.isReady || (d != null && this.uy == null);
        if (i) {
            this.ug.dg();
            if (b != null) {
                b.dg();
            }
            return;
        }
        this.ug.b3 = true;
        if (b != null) {
            b.b3 = true;
        }
        var j = a.count;
        var k = this.ci;
        for (var l = 0; l < j; l++) {
            var m = a._inner[l];
            var n = typeCast(DataContext.$, m.content);
            if (n != null) {
                var o = null;
                var p = k.indexOf(n.item);
                if (c != null) {
                    o = c.getBrush1(p, k.count);
                }
                else if (d != null && this.ul != null) {
                    var q = this.ul.item(p);
                    o = d.getBrushByRange(q, g, h);
                }
                else if (e != null) {
                    o = e.getBrush(p);
                }
                else {
                    if (this.q2 == null) {
                        o = this.q0;
                    }
                    else {
                        o = this.q2;
                    }
                }
                var r = null;
                if (this.q3 == null) {
                    r = this.q1;
                }
                else {
                    r = this.q3;
                }
                if (this.uq && o != null) {
                    r = o;
                }
                if (r != null && !isNaN_(this.uw)) {
                    r = BrushUtil.l(r, this.uw);
                }
                if (o != null && !isNaN_(this.uv)) {
                    o = BrushUtil.l(o, this.uv);
                }
                n.itemBrush = o;
                n.actualItemBrush = o;
                n.outline = r;
            }
        }
    };
    Object.defineProperty(BubbleSeries.prototype, "actualMarkerBrush", {
        get: function () {
            return this.q0;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.$t = markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberPath:uy:vh', [2], 'FillScale:uf:vi', [BrushScale.$], 'FillScaleUseGlobalValues:up:vj', [0, false], 'LabelMemberPath:u3:vk', [2], 'MarkerBrushBrightness:uv:vl', [1, NaN], 'MarkerOutlineBrightness:uw:vm', [1, NaN], 'MarkerOutlineUsesFillScale:uq:vn', [0, false], 'RadiusMemberPath:u9:vo', [2, null], 'RadiusScale:uh:vp', [SizeScale.$], 'RadiusScaleUseGlobalValues:ur:vq', [0, false]]);
    return BubbleSeries;
}(ScatterBase));
export { BubbleSeries };
/**
 * @hidden
 */
var CustomPaletteBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomPaletteBrushScale, _super);
    function CustomPaletteBrushScale() {
        return _super.call(this) || this;
    }
    CustomPaletteBrushScale.prototype.getBrush1 = function (a, b) {
        if (this.brushes == null || this.brushes.count == 0) {
            return null;
        }
        if (this.brushSelectionMode == 0) {
            return _super.prototype.getBrush.call(this, a % this.brushes.count);
        }
        var c = BubbleSeries.ut(0, b - 1, 0, this.brushes.count - 1, a);
        return this.ab(c);
    };
    CustomPaletteBrushScale.prototype.get_isReady = function () {
        return this.brushes != null && this.brushes.count > 0;
    };
    CustomPaletteBrushScale.$t = markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
}(BrushScale));
export { CustomPaletteBrushScale };
/**
 * @hidden
 */
var BubbleSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeriesView, _super);
    function BubbleSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.df = null;
        _this.df = a;
        _this.cx = new ScatterTrendLineManager();
        return _this;
    }
    BubbleSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
            this.b1.p0 = Defaults.e;
        }
    };
    BubbleSeriesView.prototype.cu = function () {
        var _this = this;
        return new BubbleMarkerManager(function (a) { return _this.cy.item(a); }, function (a) { return _this.cw.rk.c.item(a); }, runOn(this, this.c9), runOn(this, this.cr), runOn(this, this.cz));
    };
    BubbleSeriesView.prototype.dh = function () {
        var a = this.cv;
        this.df.vg(a.n, a.o, this.bu, this == this.e.bx);
        this.aq();
    };
    BubbleSeriesView.prototype.di = function () {
        var a = this.cv;
        this.df.vf(a.n);
    };
    BubbleSeriesView.prototype.dg = function () {
        var e_2, _a;
        var a = this.cv;
        try {
            for (var _b = __values(fromEnum(a.n)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    BubbleSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a5.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.df.hs + "</span><br/><span>" + "(${item." + this.df.sx + "}, ${item." + this.df.s1 + "})</span>";
        if (!stringIsNullOrEmpty(this.df.u9)) {
            a += "<span>, Radius: ${item." + this.df.u9 + "}</span>";
        }
        a += "</div>";
        return a;
    };
    BubbleSeriesView.$t = markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
}(ScatterBaseView));
export { BubbleSeriesView };
