/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Base, Number_$type, typeCast, Array_$type, markType, TypeRegistrar } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { LinearCategorySnapper } from "./LinearCategorySnapper";
import { NumericYAxis } from "./NumericYAxis";
import { LabelPosition } from "./LabelPosition";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
var CategoryXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryXAxis, _super);
    function CategoryXAxis() {
        var _this = _super.call(this) || this;
        _this.mo = 1;
        _this.mn = 1;
        _this.mr = null;
        _this.me = 0;
        _this.mf = 0;
        _this.ks = new List$1(Number_$type, 0);
        _this.ab = CategoryXAxis.$;
        return _this;
    }
    CategoryXAxis.prototype.a3 = function () {
        return new CategoryXAxisView(this);
    };
    CategoryXAxis.prototype.hn = function (a) {
        _super.prototype.hn.call(this, a);
        this.mb = a;
    };
    Object.defineProperty(CategoryXAxis.prototype, "mq", {
        get: function () {
            return this.mo;
        },
        set: function (a) {
            this.mo = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryXAxis.prototype, "mp", {
        get: function () {
            return this.mn;
        },
        set: function (a) {
            this.mn = a;
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.au = function () {
        if (this.c2) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    CategoryXAxis.prototype.getCategorySize = function (a, b, c) {
        var d = this.j5(b, c);
        return d.width / (this.k9 * a.width);
    };
    CategoryXAxis.prototype.ky = function (a, b, c) {
        var d = this.k5(a, b, c);
        var e = 0;
        if (!isNaN_(this.k4)) {
            e = Math.min(this.k4, 1);
        }
        else {
            e = 0;
        }
        ;
        var f = 1 - 0.5 * d;
        var g = this.lb == 0 ? 1 : this.lb;
        var h = this.getCategorySize(a, b, c) * f / (g - (g - 1) * e);
        return h;
    };
    CategoryXAxis.prototype.getGroupCenter = function (a, b, c, d) {
        var e = 0.5;
        if (this.lb > 1) {
            var f = this.k5(b, c, d);
            var g = 0;
            if (!isNaN_(this.k4)) {
                g = Math.min(this.k4, 1);
            }
            var h = 1 - 0.5 * f;
            var i = h / (this.lb - (this.lb - 1) * g);
            var j = (h - i) / (this.lb - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    };
    CategoryXAxis.prototype.d0 = function () {
        return this.ml;
    };
    CategoryXAxis.prototype.mw = function (a) {
        var b = this.bh != null ? this.bh.r0 : Rect.empty;
        b = b.copy();
        var c = this.j7;
        var d = this.j4();
        var e = new Rect(0, 0, 0, 1, 1);
        var f = new ScalerParams(0, e, e, this.cf, d);
        var g = !b.isEmpty && !c.isEmpty && this.kl != null ? this.kl.indexOf(a) : -1;
        var h = g > -1 ? this.ef(g, f) : NaN;
        if (!isNaN_(h) && this.bh.ed) {
            if (!isNaN_(h)) {
                if (h < b.left + 0.1 * b.width) {
                    h = h + 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
                if (h > b.right - 0.1 * b.width) {
                    h = h - 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
            }
            this.bh.oj(b, false, true);
        }
    };
    CategoryXAxis.prototype.ef = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.mk(a, NumericScaler.ac, b.c, this.categoryMode);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.mk(a, b.e, b.d, this.categoryMode);
    };
    CategoryXAxis.prototype.ma = function (a) {
        if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
            return a.asArray();
        }
        return null;
    };
    CategoryXAxis.prototype.hh = function (a, b, c, d, e) {
        var f;
        var g = e.e;
        var h = e.d;
        var i = e.c;
        var j = e.a;
        var k = !i.isEmpty;
        var l = this.categoryMode == 0 ? this.k9 - 1 : this.k9;
        if (l < 0) {
            l = 0;
        }
        var m = i.left;
        var n = i.width;
        var o = g.left;
        var p = g.width;
        var q = h.left;
        var r = h.width;
        var s = 0;
        var t = 1;
        var u = this.ma(a);
        var v = false;
        if (u != null) {
            v = true;
        }
        var w;
        for (var x = 0; x < b.count; x++) {
            w = b.item(x);
            for (var y = c; y < d; y++) {
                if (v) {
                    f = u[y];
                }
                else {
                    f = a.item(y);
                }
                if (k) {
                    var z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        z = 1 - z;
                    }
                    z = m + n * (z - s) / t;
                    z = (z - q) / r;
                    var aa = q + r * (z - o) / p;
                    f[w] = aa;
                }
                else {
                    var ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        ab = 1 - ab;
                    }
                    ab = q + r * (ab - o) / p;
                    f[w] = ab;
                }
            }
        }
    };
    CategoryXAxis.prototype.eg = function (a, b, c) {
        if (!b.c.isEmpty) {
            var d = this.mk(a, NumericScaler.ac, b.c, c);
            d = (d - b.d.left) / b.d.width;
            d = b.d.left + b.d.width * (d - b.e.left) / b.e.width;
            return d;
        }
        return this.mk(a, b.e, b.d, c);
    };
    CategoryXAxis.prototype.mk = function (a, b, c, d) {
        var e = d == 0 ? this.k9 - 1 : this.k9;
        if (e < 0) {
            e = 0;
        }
        var f = e >= 1 ? (a) / (e) : e == 0 ? 0.5 : NaN;
        if (this.cg) {
            f = 1 - f;
        }
        return c.left + c.width * (f - b.left) / b.width;
    };
    CategoryXAxis.prototype.ei = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            c = (c * b.d.width) + b.d.left;
            c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
            return c;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    };
    CategoryXAxis.prototype.ej = function (a, b, c) {
        if (!b.c.isEmpty) {
            var d = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            d = (d * b.d.width) + b.d.left;
            d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
            return d;
        }
        return this.getUnscaledValue3(a, b.e, b.d, c);
    };
    CategoryXAxis.prototype.getUnscaledValue3 = function (a, b, c, d) {
        var e = b.left + (a - c.left) * b.width / c.width;
        if (this.cg) {
            e = 1 - e;
        }
        var f = d == 0 ? this.k9 - 1 : this.k9;
        if (f < 0) {
            f = 0;
        }
        return e * f;
    };
    CategoryXAxis.prototype.mx = function (a, b) {
        if (a == NaN || b == NaN || this.kl == null || this.kl.count == 0) {
            return;
        }
        var c = a / this.kl.count;
        var d = (b + 1) / this.kl.count;
        this.bh.sg = new Rect(0, c, this.bh.sg.y, d - c, this.bh.sg.height);
    };
    CategoryXAxis.prototype.h4 = function (a) {
        _super.prototype.h4.call(this, a);
        var b = this.bh != null ? this.bh.r0 : Rect.empty;
        var c = this.j7;
        var d = this.j2();
        var e = this.j1();
        var f = new ScalerParams(0, b, c, this.cf, d);
        var g = this.a4.ay();
        var h = this.a4.a1();
        var i = this.a4.az();
        var j = this.a4.a0();
        var k = this.a4.e();
        var l = this.a4.f();
        var m = this.a4.g();
        var n = this.kl;
        var o = this.mc();
        this.ig();
        this.hd(g);
        this.hd(h);
        this.hd(i);
        this.hd(j);
        this.c8.clear();
        this.c9.clear();
        this.ks.clear();
        this.a4.at(this, b, c);
        if (b.isEmpty || c.isEmpty) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
        }
        if (this.bq.count == 0 && this.bp.count == 0) {
            this.a4.y();
        }
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        if (this.itemsSource == null || o == null || n.count == 0) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
            this.a4.y();
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            var p = this.ei(e.left, f);
            var q = this.ei(e.right, f);
            var r = 0;
            var s = false;
            if (this.c1) {
                var t = Math.abs(q - p);
                r = Math.ceil(t) + 1;
                if (this.cf) {
                    if (Math.abs(q - Math.floor(q)) < Math.abs(p - Math.ceil(p))) {
                        s = true;
                    }
                }
                else {
                    if (Math.abs(q - Math.ceil(q)) < Math.abs(p - Math.floor(p))) {
                        s = true;
                    }
                }
            }
            if (this.cf) {
                p = Math.ceil(p);
                q = Math.floor(q);
            }
            else {
                p = Math.floor(p);
                q = Math.ceil(q);
            }
            if (this.c1) {
                if (Math.abs(q - p) < r) {
                    if (this.cf) {
                        if (s) {
                            q--;
                        }
                        else {
                            p++;
                        }
                    }
                    else {
                        if (s) {
                            q++;
                        }
                        else {
                            p--;
                        }
                    }
                }
            }
            var u = c.bottom;
            var v = u - c.top;
            if (this.ai != null) {
                var w = typeCast(NumericYAxis.$, this.ai);
                if (w != null) {
                    var x = this.h9(u, v, b, c, d, c.top, c.bottom);
                    u = x.p0;
                    v = x.p1;
                }
            }
            this.hl(g, u, c, k, true);
            this.a4.ao(v);
            var y = Math.min(p, q);
            var z = Math.max(p, q);
            var aa = e.width;
            if (this.c1) {
                var ab = this.ef(y, f);
                var ac = this.ef(z, f);
                aa = Math.abs(ac - ab);
            }
            var ad = new LinearCategorySnapper(1, y, z, aa, this.ml, this.categoryMode, this.eu());
            var ae = ad.g;
            ae = this.dy(ae, this.md(), b, c, d);
            if (ad.g != ae) {
                ad = new LinearCategorySnapper(1, y, z, aa, ae, this.categoryMode, this.eu());
            }
            var af = Math.floor((y - 0) / ad.g);
            var ag = Math.ceil((z - 0) / ad.g);
            this.mg = ad.g;
            if (!isNaN_(af) && !isNaN_(ag)) {
                var ah = truncate(af);
                var ai = truncate(ag);
                var aj = this.mj(0 + ah * ad.g, f);
                var ak = this.ef(ad.g, f);
                var al = Math.abs(ak - this.ef(0, f));
                this.a4.ap(ak);
                var am = truncate(Math.ceil(e.right));
                var an = truncate(Math.floor(e.left));
                var ao = this.mm;
                var ap = ao > 0 && ao < ad.g;
                var aq = c.right;
                var ar = this.ks;
                var as = ad.g;
                var at = truncate(as);
                var au = this.lb;
                var av = this.cf;
                var aw = this.categoryMode;
                this.mr = null;
                for (var ax = ah; ax <= ai; ++ax) {
                    var ay = this.mj(0 + (ax + 1) * ad.g, f);
                    if (aj <= aq) {
                        if (ax % 2 == 0) {
                            this.ii(h, aj, ay, c);
                        }
                        this.ih(i, aj, c, l, false);
                        ar.add(aj);
                    }
                    if (this.categoryMode != 0 && this.lb != 0 && this.cv) {
                        if (ap) {
                            var az = al * this.mm;
                            if (this.cf) {
                                var a0 = aj;
                                while (a0 - az > ay) {
                                    a0 -= az;
                                    if (Math.abs(a0 - ay) < 0.0001) {
                                        break;
                                    }
                                    this.ih(j, a0, c, m, false);
                                }
                            }
                            else {
                                var a1 = aj;
                                while (a1 + az < ay) {
                                    a1 += az;
                                    if (Math.abs(a1 - ay) < 0.0001) {
                                        break;
                                    }
                                    this.ih(j, a1, c, m, false);
                                }
                            }
                            this.mh = this.mm;
                        }
                        else {
                            for (var a2 = 0; a2 < truncate(ad.g); a2++) {
                                for (var a3 = 0; a3 < this.lb; a3++) {
                                    var a4 = this.getGroupCenter(a3, b, c, d);
                                    if (this.cf) {
                                        a4 = -a4;
                                    }
                                    var a5 = this.ef(a2 + ax * ad.g, f) + a4;
                                    this.ih(j, a5, c, m, false);
                                }
                            }
                            this.mh = 0.5;
                        }
                    }
                    var a6 = this.mi(ax * as, aj, aw == 0, f);
                    var a7 = truncate(Math.round(a6));
                    if (a7 >= an && a7 <= am) {
                        var a8 = 0;
                        if (as >= 1) {
                            a8 = ax * truncate(Math.floor(as));
                        }
                        else {
                            if ((ax * as) * 2 % 2 == 0) {
                                a8 = truncate(Math.floor(ax * as));
                            }
                            else {
                                a8 = -1;
                            }
                        }
                        if (o != null && a8 < n.count && a8 >= 0) {
                            var a9 = o.getItem(a8);
                            var ba = this.fv(a9);
                            this.mr = a9;
                            if (!isNaN_(a6) && !isInfinity(a6) && ba != null) {
                                if ((typeof ba === 'string') && Base.equalsStatic(ba, "")) {
                                }
                                else {
                                    this.c8.add1(ba);
                                    this.c9.add(new LabelPosition(a6));
                                }
                            }
                        }
                    }
                    aj = ay;
                }
            }
            this.mr = null;
            if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                    this.bh.lb();
                }
            }
            this.a4.au(this.c8, this.c9);
            this.ly();
        }
    };
    CategoryXAxis.prototype.c0 = function () {
        if (this.cn && this.c1) {
            this.bb = this.ba();
        }
        if (this.kl == null) {
            return false;
        }
        var a = this.kl.count;
        if (a != this.mp) {
            var b = new AxisRangeChangedEventArgs(0, 1, 1, this.mp, a);
            this.mp = a;
            this.hy(b);
            return true;
        }
        return false;
    };
    Object.defineProperty(CategoryXAxis.prototype, "ml", {
        get: function () {
            return this.c(CategoryXAxis.my);
        },
        set: function (a) {
            this.h(CategoryXAxis.my, a);
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.md = function () {
        return !isNaN_(this.ml);
    };
    Object.defineProperty(CategoryXAxis.prototype, "mg", {
        get: function () {
            return this.me;
        },
        set: function (a) {
            if (this.mg != a) {
                var b = this.me;
                this.me = a;
                this.hx("ActualInterval", b, this.mg);
            }
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.er = function () {
        return this.mg;
    };
    Object.defineProperty(CategoryXAxis.prototype, "mm", {
        get: function () {
            return this.c(CategoryXAxis.mz);
        },
        set: function (a) {
            this.h(CategoryXAxis.mz, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryXAxis.prototype, "mh", {
        get: function () {
            return this.mf;
        },
        set: function (a) {
            if (this.mh != a) {
                var b = this.mf;
                this.mf = a;
                this.hx("ActualMinorInterval", b, this.mh);
            }
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.ko = function (a) {
        if (a == null) {
            return false;
        }
        var b = this.bd();
        if (b == null) {
            return false;
        }
        return b.synchronizeHorizontally;
    };
    CategoryXAxis.prototype.get_a1 = function () {
        return 0;
    };
    Object.defineProperty(CategoryXAxis.prototype, "a1", {
        get: function () {
            return this.get_a1();
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.mc = function () {
        return this.kl;
    };
    CategoryXAxis.prototype.mj = function (a, b) {
        return this.ef(a, b);
    };
    CategoryXAxis.prototype.mi = function (a, b, c, d) {
        if (!c) {
            var e = this.mj(a + 1, d);
            return (b + e) / 2;
        }
        return b;
    };
    Object.defineProperty(CategoryXAxis.prototype, "isVertical", {
        get: function () {
            return this.cm;
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.j$c = function (a, b) {
        return this.ei.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$b = function (a, b) {
        return this.ef.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.hh.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$e = function (a, b, c, d) {
        this.hi.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$f = function (a, b, c, d) {
        this.hj.apply(this, arguments);
    };
    Object.defineProperty(CategoryXAxis.prototype, "j$a", {
        get: function () {
            return this.cf;
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.$t = markType(CategoryXAxis, 'CategoryXAxis', CategoryAxisBase.$);
    CategoryXAxis.my = DependencyProperty.i("Interval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        a.hx("Interval", b.oldValue, b.newValue);
        a.h3(false);
    }));
    CategoryXAxis.mz = DependencyProperty.i("MinorInterval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        (typeCast(CategoryXAxis.$, a)).hx("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryXAxis.$, a)).h3(false);
    }));
    return CategoryXAxis;
}(CategoryAxisBase));
export { CategoryXAxis };
/**
 * @hidden
 */
var CategoryXAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryXAxisView, _super);
    function CategoryXAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    CategoryXAxisView.prototype.ag = function () {
        _super.prototype.ag.call(this);
        this.a.fd = AxisDefaults.f;
    };
    CategoryXAxisView.$t = markType(CategoryXAxisView, 'CategoryXAxisView', CategoryAxisBaseView.$);
    return CategoryXAxisView;
}(CategoryAxisBaseView));
export { CategoryXAxisView };
