/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, markType, runOn, EnumUtil, typeCast, fromEnum, markDep } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { NotImplementedException } from "igniteui-react-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { truncate, intDivide, isNaN_ } from "igniteui-react-core";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { RadialFrame } from "./RadialFrame";
import { DependencyProperty } from "igniteui-react-core";
import { HighlightingInfo } from "./HighlightingInfo";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { RadialAxes } from "./RadialAxes";
import { Visibility_$type } from "igniteui-react-core";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { PropertyMetadata } from "igniteui-react-core";
import { round10N } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
/**
 * @hidden
 */
var RadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBucketCalculator, _super);
    function RadialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        _this.a = a;
        return _this;
    }
    RadialBucketCalculator.prototype.getBucket = function (a) {
        throw new NotImplementedException(0);
    };
    RadialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    RadialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    RadialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.cr.gk;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    RadialBucketCalculator.prototype.e = function (a) {
        var b = this.a.bv;
        var c = this.a.bu;
        var d = this.a.cr.q8;
        if (b.isEmpty || c.isEmpty || d == null || this.a.cr.ci == null || this.a.cr.ci.count == 0) {
            this.b = 0;
            return;
        }
        var e = Math.floor(d.mr(c, b));
        var f = Math.ceil(d.mq(c, b));
        if (d.cf) {
            f = Math.ceil(d.mr(c, b));
            e = Math.floor(d.mq(c, b));
        }
        if (f < e) {
            f = d.k9 + f;
        }
        var g = this.a.cr.rf;
        var h = g != null ? g.mu : 0.75;
        var i = Math.min(c.width, c.height) * 0.5 * (h) * 2 * Math.PI;
        var j = Math.floor((f - e + 1) * a / i);
        this.b = truncate(Math.max(1, j));
        this.c = truncate(Math.max(0, Math.floor(e / this.b) - 1));
        this.d = truncate(Math.ceil(f / this.b));
    };
    RadialBucketCalculator.prototype.cacheValues = function () {
    };
    RadialBucketCalculator.prototype.unCacheValues = function () {
    };
    RadialBucketCalculator.$t = markType(RadialBucketCalculator, 'RadialBucketCalculator', Base.$, [IBucketizer_$type]);
    return RadialBucketCalculator;
}(Base));
export { RadialBucketCalculator };
/**
 * @hidden
 */
var RadialBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBase, _super);
    function RadialBase() {
        var _this = _super.call(this) || this;
        _this.rm = null;
        _this.rn = null;
        _this.rp = false;
        _this.ro = false;
        _this.rd = null;
        _this.re = null;
        _this.assigningRadialStyle = null;
        _this.assigningRadialMarkerStyle = null;
        _this.rk = new RadialFrame(3);
        _this.rl = new RadialFrame(3);
        _this.ri = new RadialFrame(3);
        _this.rg = null;
        _this.rm = new RadialSeriesRenderManager();
        _this.rn = new SeriesRenderer$2(RadialFrame.$, RadialBaseView.$, 1, runOn(_this, _this.sa), runOn(_this, _this.sd), runOn(_this, _this.cs), runOn(_this, _this.mf), runOn(_this, _this.r9), function (a) { return _this.rh.cs.e(_this.gk); });
        return _this;
    }
    RadialBase.prototype.lo = function (a) {
        _super.prototype.lo.call(this, a);
        this.rh = a;
    };
    RadialBase.prototype.r9 = function () {
        if (this.cc.g) {
            this.cc.t();
        }
    };
    Object.defineProperty(RadialBase.prototype, "categoryAxis", {
        get: function () {
            return this.q8;
        },
        enumerable: false,
        configurable: true
    });
    RadialBase.prototype.ar = function () {
        return this.q8;
    };
    RadialBase.prototype.q5 = function (a, b) {
        return null;
    };
    RadialBase.prototype.cy = function (a, b, c, d) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var e = this.q8;
        var f = new ScalerParams(1, this.cb.r0, this.po, e.cf);
        f.c = this.getEffectiveViewport1(this.by);
        var g = this.rf;
        var h = new ScalerParams(1, this.cb.r0, this.po, g.cf);
        h.c = this.getEffectiveViewport1(this.by);
        a.clear();
        this.pz.cf(function (i) {
            if (i._visibility == 0) {
                var j = new SeriesPointOfInterest();
                var k = i.n;
                var l = i.o;
                if (k < _this.po.left || k > _this.po.right || l < _this.po.top || l > _this.po.bottom) {
                    return;
                }
                var m = void 0;
                var n = void 0;
                var o = _this.rg.g(k, l, _this.by.bv, _this.by.bu, m, n);
                m = o.p4;
                n = o.p5;
                j.b = m;
                j.c = n;
                if (b) {
                    if (c) {
                        j.d = _this.r4(j.c, d);
                    }
                    else {
                        var p = _this.gf(i);
                        if (!isNaN_(p)) {
                            j.d = _this.r4(p, d);
                        }
                        else {
                            j.d = _this.r4(j.c, d);
                        }
                    }
                }
                else {
                    j.d = e.f9(i.ak);
                }
                j.a = i.content;
                a.add(j);
            }
        });
        return true;
    };
    RadialBase.prototype.r4 = function (a, b) {
        if (b >= 0) {
            return round10N(a, b).toString();
        }
        else {
            return a.toString();
        }
    };
    RadialBase.prototype.get_d6 = function () {
        return true;
    };
    RadialBase.prototype.get_dt = function () {
        return true;
    };
    RadialBase.prototype.ra = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.h = 0;
        d.g = this.ci.count - 1;
        d.d = true;
        if (c != null && c.h == d.h && c.g == d.g) {
            return c;
        }
        return d;
    };
    RadialBase.prototype.rb = function (a, b, c) {
        var d = this.rh.cs.c;
        var e = this.rh.cs.d;
        var f = this.rh.cs.b;
        var g = this.rj();
        var h = this.ci.count;
        var i = this.q8;
        var j = -1;
        var k = -1;
        var l = this.g3(b);
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.h == j && c.g == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.b = this;
        m.h = j;
        m.g = k;
        return m;
    };
    RadialBase.prototype.rc = function (a, b, c) {
        var d = this.rh.cs.c;
        var e = this.rh.cs.d;
        var f = this.rh.cs.b;
        var g = this.rj();
        var h = this.ci.count;
        var i = this.q8;
        var j = -1;
        var k = -1;
        var l = this.g3(b);
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.h == j && c.g == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.e = true;
        m.b = this;
        m.h = j;
        m.g = k;
        return m;
    };
    RadialBase.prototype.av = function (a, b, c) {
        if (this.cz && this.eb(this.bk) && !c) {
            var d = this.rb(a, b, this.rd);
            this.rd = d;
            return d;
        }
        else {
            var e = this.ra(a, b, this.rd);
            this.rd = e;
            return e;
        }
    };
    RadialBase.prototype.aw = function (a, b, c) {
        if (this.eb(this.bk) && !c) {
            var d = this.rc(a, b, this.re);
            this.re = d;
            return d;
        }
        else {
            var e = this.ra(a, b, this.re);
            e.e = true;
            this.re = e;
            return e;
        }
    };
    RadialBase.prototype.ry = function () {
        return (this.assigningRadialStyle != null && this.rp) || (this.bk != 1);
    };
    RadialBase.prototype.rx = function () {
        return (this.assigningRadialMarkerStyle != null && this.ro) || (this.bk != 1);
    };
    RadialBase.prototype.sc = function (a) {
        if (this.assigningRadialStyle != null && this.rp) {
            this.assigningRadialStyle(this, a);
        }
    };
    RadialBase.prototype.sb = function (a) {
        if (this.assigningRadialMarkerStyle != null && this.ro) {
            this.assigningRadialMarkerStyle(this, a);
        }
    };
    RadialBase.prototype.r0 = function (a) {
        return a.cs.b;
    };
    RadialBase.prototype.r1 = function (a) {
        return a.cs.c;
    };
    RadialBase.prototype.ag = function () {
        return [this.q8, this.rf];
    };
    RadialBase.prototype.mu = function (a, b) {
        this.rh.cs.e(this.gk);
        this.l7(false);
    };
    RadialBase.prototype.mt = function (a, b) {
        this.rh.cs.e(this.gk);
        this.l7(false);
    };
    RadialBase.prototype.lt = function (a, b, c, d) {
        _super.prototype.lt.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.q8 != null) {
                        this.q8.by(this);
                    }
                    if (this.rf != null) {
                        this.rf.by(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.q8 != null) {
                        this.q8.cq(this);
                    }
                    if (this.rf != null) {
                        this.rf.cq(this);
                    }
                }
                this.rh.cs.e(this.gk);
                this.l7(false);
                break;
            case RadialBase.$$p[0]:
                if (this.q8 != null && this.rf != null) {
                    this.rg = new RadialAxes(this.rf, this.q8);
                }
                if (c != null) {
                    c.by(this);
                }
                if (d != null) {
                    d.cq(this);
                }
                this.rh.cs.e(this.gk);
                this.l7(false);
                break;
            case RadialBase.$$p[4]:
                if (this.q8 != null && this.rf != null) {
                    this.rg = new RadialAxes(this.rf, this.q8);
                }
                if (c != null) {
                    c.by(this);
                }
                if (d != null) {
                    d.cq(this);
                }
                this.rh.cs.e(this.gk);
                if (this.rf == null || !this.rf.cy()) {
                    this.l7(false);
                }
                break;
            case "SyncLink":
                if (this.b6 != null && this.cb != null) {
                    this.rh.cs.e(this.gk);
                    this.l7(false);
                }
                break;
            case "TransitionProgress":
                this.rl.c(this.gq, this.rk, this.ri);
                if (this.cu(this.by)) {
                    return;
                }
                if (this.gq == 1) {
                    this.sd(this.ri, this.rh);
                }
                else {
                    this.sd(this.rl, this.rh);
                }
                if (this.cb != null) {
                    this.cb.nd(this);
                }
                break;
            case RadialBase.$$p[1]:
                this.l7(false);
                this.le();
                break;
            case "VisibilityProxy":
                if (EnumUtil.getEnumValue(Visibility_$type, c) != 0 && EnumUtil.getEnumValue(Visibility_$type, d) == 0) {
                    this.rh.cs.e(this.gk);
                }
                break;
            case RadialBase.$$p[3]:
                this.rp = this.rw();
                this.l7(false);
                break;
            case RadialBase.$$p[2]:
                this.ro = this.rv();
                this.l7(false);
                break;
        }
    };
    RadialBase.prototype.rw = function () {
        return this.ru;
    };
    RadialBase.prototype.rv = function () {
        return this.rt;
    };
    RadialBase.prototype.rr = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.rq = function (a) {
        if (typeCast(CategoryAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.hk = function (a) {
        var b = this.g3(a);
        return b >= 0 && this.ci != null && b < this.ci.count ? this.ci.item(b) : null;
    };
    RadialBase.prototype.rz = function (a) {
        var b = this.by.bv;
        var c = this.by.bu;
        if (this.q8 != null && !b.isEmpty && !c.isEmpty && this.rg != null) {
            var d = this.rg.c(a);
            if (d < 0) {
                d += Math.PI * 2;
            }
            if (d > Math.PI * 2) {
                d -= Math.PI * 2;
            }
            return d;
        }
        return NaN;
    };
    RadialBase.prototype.fy = function (a) {
        var b = this.by.bv;
        var c = this.by.bu;
        var d = -1;
        if (this.q8 != null && !b.isEmpty && !c.isEmpty && this.rg != null) {
            var e = this.rg.c(a);
            if (e < 0) {
                e += Math.PI * 2;
            }
            if (e > Math.PI * 2) {
                e -= Math.PI * 2;
            }
            var f = this.q8.getUnscaledAngle(e);
            if (this.q8.categoryMode != 0) {
                f -= 0.5;
            }
            d = f;
        }
        return d;
    };
    RadialBase.prototype.g3 = function (a) {
        var b = truncate(Math.round(this.fy(a)));
        if (this.ci != null && b == this.ci.count) {
            b = 0;
        }
        return b;
    };
    RadialBase.prototype.ej = function (a) {
        return false;
    };
    RadialBase.prototype.rj = function () {
        var a = this.ri;
        if (this.cs()) {
            if (this.cc.g) {
                this.cc.t();
            }
            a = this.rl;
        }
        return a;
    };
    RadialBase.prototype.k5 = function () {
        _super.prototype.k5.call(this);
        if (this.q8 != null) {
            this.q8.h3(false);
        }
        if (this.rf != null) {
            this.rf.h3(false);
        }
    };
    RadialBase.prototype.e5 = function (a, b, c) {
        var d = true;
        var e = c;
        if (!_super.prototype.e5.call(this, a, b, c) || !c.o() || b.isEmpty || a.isEmpty || this.q8 == null || this.q8.itemsSource == null || this.rf == null || this.rg == null || this.ci == null || this.q8.bh == null || this.rf.bh == null || this.rf.ld == this.rf.lc) {
            e.cs.b = 0;
            d = false;
        }
        return d;
    };
    RadialBase.prototype.l8 = function (a) {
        var b;
        var c;
        var d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.e5(c, b, this.by)) {
            this.ko(true, this.by);
            return;
        }
        var e = new SeriesRenderingArguments(this, c, b, a, this.eo);
        var f = this.rn.g(e, this.rk, this.ri, this.rl, this.rh);
        this.rk = f.p1;
        this.ri = f.p2;
        this.rl = f.p3;
    };
    RadialBase.prototype.r2 = function () {
        var e_1, _a;
        var a = 0;
        try {
            for (var _b = __values(fromEnum(this.cb.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b == this) {
                    return a;
                }
                var c = typeCast(RadialBase.$, b);
                if (c != null && c.q8 == this.q8 && c.preferredCategoryMode(c.q8) == 2) {
                    a++;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    RadialBase.$t = markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
    RadialBase.$$p = markDep(DependencyProperty, PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:q8:se', [CategoryAngleAxis.$, null], 'ClipSeriesToBounds:rs:sf', [0, false], 'IsCustomRadialMarkerStyleAllowed:rt:sg', [0, false], 'IsCustomRadialStyleAllowed:ru:sh', [0, false], 'ValueAxis:rf:si', [NumericRadiusAxis.$, null]]);
    return RadialBase;
}(MarkerSeries));
export { RadialBase };
/**
 * @hidden
 */
var RadialBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBaseView, _super);
    function RadialBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cs = null;
        _this.cr = null;
        _this.ct = null;
        _this.cu = 0;
        _this.cv = null;
        _this.cr = a;
        _this.ct = new Pool$1(Marker.$);
        _this.ci(_this.ct);
        return _this;
    }
    RadialBaseView.prototype.cf = function (a) {
        this.ct.c(a);
    };
    RadialBaseView.$t = markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);
    return RadialBaseView;
}(MarkerSeriesView));
export { RadialBaseView };
