/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { ScatterItemSearchMode_$type } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "./HighlightingInfo";
import { ScatterFrame } from "./ScatterFrame";
import { Base, enumGetBox, Number_$type, typeCast, fromEnum, Point_$type, runOn, markType, markDep, PointUtil } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { GeometryUtil } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { PathGeometry } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { boxArray$1, arrayShallowClone } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
var ScatterBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterBase, _super);
    function ScatterBase() {
        var _this = _super.call(this) || this;
        _this.rk = null;
        _this.ry = null;
        _this.rz = null;
        _this.ub = null;
        _this.uc = null;
        _this.rt = 1;
        _this.q5 = null;
        _this.q6 = null;
        _this.rq = null;
        _this.rs = null;
        _this.ro = null;
        _this.r3 = false;
        _this.r2 = false;
        _this.rg = null;
        _this.rh = null;
        _this.assigningScatterStyle = null;
        _this.assigningScatterMarkerStyle = null;
        _this.rx = null;
        _this.rr = null;
        _this.rn = null;
        _this.ru = _this.rv();
        _this.rx = new ScatterSeriesRenderManager();
        _this.rr = new ScatterFrame();
        _this.uc = Rect.empty;
        _this.ub = Rect.empty;
        return _this;
    }
    ScatterBase.prototype.bv = function () {
        return new ScatterBaseView(this);
    };
    ScatterBase.prototype.kl = function () {
        _super.prototype.kl.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    ScatterBase.prototype.lo = function (a) {
        _super.prototype.lo.call(this, a);
        this.rl = a;
    };
    ScatterBase.prototype.get_d8 = function () {
        return true;
    };
    ScatterBase.prototype.ag = function () {
        return [this.xAxis, this.yAxis];
    };
    ScatterBase.prototype.hn = function (a, b) {
        var c = this.jf(b);
        if (c == ScatterBase.$$p[8]) {
            return this.ho(a, b, this.sx);
        }
        if (c == ScatterBase.$$p[10]) {
            return this.ho(a, b, this.s1);
        }
        return null;
    };
    ScatterBase.prototype.cy = function (a, b, c, d) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var e = this.xAxis;
        var f = new ScalerParams(1, this.cb.r0, this.po, e.cf);
        f.c = this.getEffectiveViewport1(this.by);
        var g = this.yAxis;
        var h = new ScalerParams(1, this.cb.r0, this.po, g.cf);
        h.c = this.getEffectiveViewport1(this.by);
        a.clear();
        this.pz.cf(function (i) {
            if (i._visibility == 0) {
                var j = new SeriesPointOfInterest();
                var k = i.n;
                var l = i.o;
                if (k < _this.po.left || k > _this.po.right || l < _this.po.top || l > _this.po.bottom) {
                    return;
                }
                j.b = e.ei(k, f);
                j.c = g.ei(l, h);
                j.a = i.content;
                a.add(j);
            }
        });
        return true;
    };
    ScatterBase.prototype.bp = function () {
        if (this.bq == 0) {
            if (this.sl <= 2000) {
                return 1;
            }
            else {
                return _super.prototype.bp.call(this);
            }
        }
        else {
            return _super.prototype.bp.call(this);
        }
    };
    ScatterBase.prototype.pm = function (a) {
        if (!this.hasMarkers || !this.p2()) {
            return Rect.empty;
        }
        var b = this.pz.by(this.o6(a));
        if (b != null) {
            return this.pz.cp(b);
        }
        return Rect.empty;
    };
    ScatterBase.prototype.er = function (a, b) {
        if (this.p3(a, b)) {
            return true;
        }
        return false;
    };
    Object.defineProperty(ScatterBase.prototype, "r0", {
        get: function () {
            return this.ry;
        },
        set: function (a) {
            if (this.ry != a) {
                var b = this.r0;
                this.ry = a;
                this.raisePropertyChanged("XColumn", b, this.r0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "r1", {
        get: function () {
            return this.rz;
        },
        set: function (a) {
            if (this.rz != a) {
                var b = this.r1;
                this.rz = a;
                this.raisePropertyChanged("YColumn", b, this.r1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "t8", {
        get: function () {
            return this.c(ScatterBase.tp);
        },
        set: function (a) {
            this.h(ScatterBase.tp, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "GetErrorBarsXAxis", {
        get: function () {
            return this.xAxis;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "GetErrorBarsYAxis", {
        get: function () {
            return this.yAxis;
        },
        enumerable: false,
        configurable: true
    });
    ScatterBase.prototype.k5 = function () {
        _super.prototype.k5.call(this);
        if (this.xAxis != null) {
            this.xAxis.h3(false);
        }
        if (this.yAxis != null) {
            this.yAxis.h3(false);
        }
    };
    ScatterBase.prototype.lt = function (a, b, c, d) {
        _super.prototype.lt.call(this, a, b, c, d);
        if (this.rl.cx.g$b(a, b, c, d)) {
            this.l7(false);
            this.le();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.r0);
                    c.deregisterColumn(this.r1);
                    this.r0 = null;
                    this.r1 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.r0 = this.cf(this.sx);
                    this.r1 = this.cf(this.s1);
                }
                if ((this.yAxis != null && !this.yAxis.cy()) || (this.xAxis != null && !this.xAxis.cy())) {
                    this.l7(false);
                }
                break;
            case ScatterBase.$$p[7]:
                if (c != null) {
                    c.by(this);
                }
                if (d != null) {
                    d.cq(this);
                }
                if ((this.xAxis != null && !this.xAxis.cy()) || (d == null && c != null)) {
                    this.l7(false);
                }
                this.le();
                break;
            case ScatterBase.$$p[9]:
                if (c != null) {
                    c.by(this);
                }
                if (d != null) {
                    d.cq(this);
                }
                if ((this.yAxis != null && !this.yAxis.cy()) || (d == null && c != null)) {
                    this.l7(false);
                }
                this.le();
                break;
            case ScatterBase.$$p[8]:
                if (this.ci != null) {
                    this.ci.deregisterColumn(this.r0);
                    this.r0 = this.cf(this.sx);
                }
                break;
            case "XColumn":
                this.rl.cx.g$i();
                if (this.xAxis != null && !this.xAxis.cy()) {
                    this.l7(false);
                }
                break;
            case ScatterBase.$$p[10]:
                if (this.ci != null) {
                    this.ci.deregisterColumn(this.r1);
                    this.r1 = this.cf(this.s1);
                }
                break;
            case "YColumn":
                this.rl.cx.g$i();
                if (this.yAxis != null && !this.yAxis.cy()) {
                    this.l7(false);
                }
                break;
            case ScatterBase.$$p[5]:
                this.l7(false);
                this.le();
                break;
            case ScatterBase.$$p[6]:
                this.l7(false);
                this.le();
                break;
            case "TransitionProgress":
                this.rs.c(this.gq, this.rq, this.ro);
                this.s3();
                try {
                    if (this.cu(this.by)) {
                        return;
                    }
                    if ((Math.round(this.gq * 100000) / 100000) == 1) {
                        this.tn(this.ro, this.rl);
                    }
                    else {
                        this.tn(this.rs, this.rl);
                    }
                    if (this.cb != null) {
                        this.cb.nd(this);
                    }
                }
                finally {
                    this.to();
                }
                break;
            case "TrendLineBrush":
                this.mk();
                break;
            case ScatterBase.$$p[0]:
                if (this.rm != null) {
                    this.rm.r = this;
                }
                this.l7(false);
                this.le();
                break;
            case "TrendLineType":
                this.le();
                break;
            case ScatterBase.$$p[2]:
                this.r3 = this.sb();
                this.l7(false);
                break;
            case ScatterBase.$$p[1]:
                this.r2 = this.sa();
                this.l7(false);
                break;
            case ScatterBase.$$p[3]:
                this.ru = this.rv();
                break;
        }
    };
    ScatterBase.prototype.sb = function () {
        return this.r7;
    };
    ScatterBase.prototype.sa = function () {
        return this.r6;
    };
    ScatterBase.prototype.r5 = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ScatterBase.prototype.r4 = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ScatterBase.prototype.to = function () {
        this.ub = Rect.empty;
        this.uc = Rect.empty;
    };
    ScatterBase.prototype.s3 = function () {
        var a = this.getViewInfo(this.ub, this.uc);
        this.ub = a.p0;
        this.uc = a.p1;
    };
    ScatterBase.prototype.r9 = function (a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.sx == a || this.s1 == a) {
            return true;
        }
        return false;
    };
    ScatterBase.prototype.kr = function (a, b, c, d) {
        var e = false;
        if (!this.r9(d, a)) {
            return;
        }
        this.rl.cx.g$e(a, b, c, d);
        if (this.xAxis != null && !this.xAxis.cy()) {
            e = true;
        }
        if (this.yAxis != null && !this.yAxis.cy()) {
            e = true;
        }
        if (e) {
            this.l7(true);
        }
    };
    ScatterBase.prototype.tf = function (a) {
        this.tg(a, null);
    };
    ScatterBase.prototype.tg = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = this.r0 != null ? this.r0.count : 0;
        var d = this.r1 != null ? this.r1.count : 0;
        var e = Math.min(c, d);
        if (e <= this.sl) {
            a.m.clear();
            var f = new List$1(OwnedPoint.$, 0);
            try {
                for (var _c = __values(fromEnum(a.u.values)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var g = _d.value;
                    f.add(g);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            var h_1 = this.ci;
            f.aa(function (i, j) {
                var k = h_1.indexOf(i.a);
                var l = h_1.indexOf(j.a);
                if (k < l) {
                    return -1;
                }
                if (k > l) {
                    return 1;
                }
                return 0;
            });
            if (b != null) {
                b.i = a.m;
            }
            try {
                for (var _e = __values(fromEnum(f)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var i = _f.value;
                    if (h_1.indexOf(i.a) >= 0) {
                        if (b != null) {
                            b.j(i.c);
                        }
                        else {
                            a.m.add({ $type: Point_$type, x: i.c.x, y: i.c.y });
                        }
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
    };
    ScatterBase.prototype.ap = function (a) {
        if (a != null && a == this.xAxis && this.r0 != null) {
            return new AxisRange(this.r0.minimum, this.r0.maximum);
        }
        if (a != null && a == this.yAxis && this.r1 != null) {
            return new AxisRange(this.r1.minimum, this.r1.maximum);
        }
        return null;
    };
    ScatterBase.prototype.hk = function (a) {
        var b = this.g3(a);
        if (this.ci != null && b >= 0 && b < this.ci.count) {
            return this.ci.item(b);
        }
        return null;
    };
    Object.defineProperty(ScatterBase.prototype, "ru", {
        get: function () {
            return this.rt;
        },
        set: function (a) {
            var b = this.rt;
            this.rt = a;
            if (b != this.rt) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ScatterItemSearchMode_$type, b), enumGetBox(ScatterItemSearchMode_$type, this.rt));
            }
        },
        enumerable: false,
        configurable: true
    });
    ScatterBase.prototype.rv = function () {
        if (this.rw != 0) {
            return this.rw;
        }
        return this.r8 ? 4 : 1;
    };
    ScatterBase.prototype.g3 = function (a) {
        var b = truncate(Math.round(this.fy(a)));
        return b;
    };
    ScatterBase.prototype.fy = function (a) {
        switch (this.ru) {
            case 1: return this.sh(a);
            case 3: return this.si(a);
            case 2: return this.sf(a);
            case 4: return this.sg(a);
        }
        return -1;
    };
    ScatterBase.prototype.sg = function (a) {
        return this.sj(a, false);
    };
    ScatterBase.prototype.sf = function (a) {
        var b = this.o6(a);
        var c = b.x;
        var d = b.y;
        if (this.ci == null || this.xAxis == null || this.yAxis == null || this.r0 == null || this.r1 == null) {
            return -1;
        }
        if (this.ci.count > this.sk) {
            return -1;
        }
        this.s6();
        var e = this.q5;
        var f = this.q6;
        if (e == null || f == null) {
            return -1;
        }
        var g = 1.7976931348623157E+308;
        var h = -1;
        for (var i = 0; i < this.r0.count; i++) {
            var j = e[i];
            var k = f[i];
            var l = (c - j) * (c - j) + (d - k) * (d - k);
            if (l < g) {
                g = l;
                h = i;
            }
        }
        return h;
    };
    ScatterBase.prototype.s6 = function () {
        var _this = this;
        var a = this.by.bv;
        var b = this.by.bu;
        var c = this.getEffectiveViewport();
        if (this.rk == null) {
            return;
        }
        var d = new ScalerParams(0, a, b, this.rk.d, c);
        var e = ((function () {
            var $ret = new ScalerParams(0, a, b, _this.rk.e, c);
            $ret.b = _this.f4();
            return $ret;
        })());
        if (this.q5 == null || this.q6 == null) {
            var f = arrayShallowClone(this.r0.asArray());
            var g = arrayShallowClone(this.r1.asArray());
            this.xAxis.hi(boxArray$1(f), 0, f.length, d);
            this.yAxis.hi(boxArray$1(g), 0, g.length, e);
            this.q5 = f;
            this.q6 = g;
        }
    };
    ScatterBase.prototype.get_r8 = function () {
        return false;
    };
    Object.defineProperty(ScatterBase.prototype, "r8", {
        get: function () {
            return this.get_r8();
        },
        enumerable: false,
        configurable: true
    });
    ScatterBase.prototype.sj = function (a, b) {
        if (!this.r8) {
            return -1;
        }
        var c = { $type: Point_$type, x: 0, y: 0 };
        var d = true;
        var e = this.rp();
        if (e == null) {
            return -1;
        }
        if (e.m == null) {
            return -1;
        }
        if (this.ci == null || this.ci.count > this.sk) {
            return -1;
        }
        this.s6();
        var f = this.q5;
        var g = this.q6;
        if (f == null || g == null) {
            return -1;
        }
        var h = this.o6(a);
        var i = 1.7976931348623157E+308;
        var j = -1;
        for (var k = 0; k < this.q5.length; k++) {
            var l = { $type: Point_$type, x: this.q5[k], y: this.q6[k] };
            if (k > 0) {
                if (!b || e.j.containsKey(this.ci.item(k)) || e.j.containsKey(this.ci.item(k - 1))) {
                    var m = GeometryUtil.d(h, c, l);
                    if (m < i) {
                        i = m;
                        j = k;
                    }
                }
            }
            c = l;
        }
        if (j >= 0) {
            var n = { $type: Point_$type, x: this.q5[j], y: this.q6[j] };
            var o = { $type: Point_$type, x: this.q5[j - 1], y: this.q6[j - 1] };
            if (!b || (e.j.containsKey(this.ci.item(j)) && e.j.containsKey(this.ci.item(j - 1)))) {
                var p = GeometryUtil.h(h, o, n);
                return (j - 1) + p;
            }
            else if (e.j.containsKey(this.ci.item(j))) {
                return j;
            }
            else {
                return j - 1;
            }
        }
        return -1;
    };
    ScatterBase.prototype.si = function (a) {
        return this.sj(a, true);
    };
    ScatterBase.prototype.sh = function (a) {
        var _this = this;
        var b = null;
        var c = 1.7976931348623157E+308;
        var d = this.o6(a);
        var e = d.x;
        var f = d.y;
        if (this.rl.cy.e > this.sk) {
            return -1;
        }
        this.rl.c5(function (g) {
            if (g._visibility == 0) {
                var h = _this.rl.cp(g);
                var i = h.left + h.width / 2;
                var j = h.top + h.height / 2;
                var k = (e - i) * (e - i) + (f - j) * (f - j);
                if (k < c) {
                    c = k;
                    b = g;
                }
            }
        });
        if (b != null) {
            return b.ak;
        }
        return -1;
    };
    ScatterBase.prototype.pb = function (a, b, c) {
        var _this = this;
        if (this.xAxis == null || this.yAxis == null || this.r0 == null || this.r1 == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.by.bv;
        var e = this.by.bu;
        var f = this.getEffectiveViewport();
        var g = new ScalerParams(0, d, e, this.xAxis.cf, f);
        var h = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.yAxis.cf, f);
            $ret.b = _this.f4();
            return $ret;
        })());
        if (b) {
            var i = this.fy(a);
            if (i == -1) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            var j = truncate(Math.floor(i));
            var k = truncate(Math.ceil(i));
            if (j < 0) {
                j = 0;
            }
            if (k < 0) {
                k = 0;
            }
            if (k > this.ci.count - 1) {
                k = this.ci.count - 1;
            }
            if (j > this.ci.count - 1) {
                j = this.ci.count - 1;
            }
            if (k == j) {
                var l = this.xAxis.ef(this.r0.item(j), g);
                var m = this.yAxis.ef(this.r1.item(j), h);
                return { $type: Point_$type, x: l, y: m };
            }
            var n = i - Math.floor(i);
            var o = this.xAxis.ef(this.r0.item(j), g);
            var p = this.yAxis.ef(this.r1.item(j), h);
            var q = this.xAxis.ef(this.r0.item(k), g);
            var r = this.yAxis.ef(this.r1.item(k), h);
            var s = q - o;
            var t = r - p;
            return { $type: Point_$type, x: o + s * n, y: p + t * n };
        }
        else {
            var u = this.g3(a);
            if (u == -1) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            var v = this.xAxis.ef(this.r0.item(u), g);
            var w = this.yAxis.ef(this.r1.item(u), h);
            return { $type: Point_$type, x: v, y: w };
        }
    };
    ScatterBase.prototype.ej = function (a) {
        var _this = this;
        var b = this.cb != null ? this.cb.r0 : Rect.empty;
        b = b.copy();
        var c = this.cb != null ? this.cb.sf : Rect.empty;
        var d = new Rect(0, 0, 0, 1, 1);
        var e = this.pi(this.by);
        var f = new ScalerParams(0, d, d, this.xAxis.cf, e);
        var g = ((function () {
            var $ret = new ScalerParams(0, d, d, _this.yAxis.cf, e);
            $ret.b = _this.f4();
            return $ret;
        })());
        var h = !b.isEmpty && !c.isEmpty && this.ci != null ? this.ci.indexOf(a) : -1;
        var i = this.xAxis != null && this.r0 != null && h < this.r0.count ? this.xAxis.ef(this.r0.item(h), f) : NaN;
        var j = this.yAxis != null && this.r1 != null && h < this.r1.count ? this.yAxis.ef(this.r1.item(h), g) : NaN;
        if (!isNaN_(i)) {
            if (i < b.left + 0.1 * b.width) {
                i = i + 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
            if (i > b.right - 0.1 * b.width) {
                i = i - 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
        }
        if (!isNaN_(j)) {
            if (j < b.top + 0.1 * b.height) {
                j = j + 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
            if (j > b.bottom - 0.1 * b.height) {
                j = j - 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
        }
        if (this.b6 != null) {
            this.b6.au(this.cb, b, true);
        }
        return h >= 0;
    };
    ScatterBase.prototype.mt = function (a, b) {
        this.l7(false);
    };
    ScatterBase.prototype.mu = function (a, b) {
        this.l7(false);
    };
    ScatterBase.prototype.rp = function () {
        var a = this.ro;
        if (this.cs()) {
            if (this.cc.g) {
                this.cc.t();
            }
            a = this.rs;
        }
        return a;
    };
    ScatterBase.prototype.s4 = function (a, b, c, d, e) {
        var _this = this;
        b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        var f = this.getEffectiveViewport1(a);
        var g = this.ci;
        var h;
        var i;
        var j = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.rk.d, f);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var k = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.rk.e, f);
            $ret.c = _this.getEffectiveViewport1(a);
            $ret.b = _this.f4();
            return $ret;
        })());
        var l = false;
        var m = 0;
        if (this.cb != null) {
            if (this.cb.ex()) {
                var n = this.cb.km(d, j);
                l = n.c;
                m = n.d;
            }
        }
        var _loop_1 = function (o) {
            h = this_1.r0.item(o);
            i = this_1.r1.item(o);
            var p = { $type: Point_$type, x: this_1.rk.a.ef(h, j), y: this_1.rk.b.ef(i, k) };
            if (l) {
                if (p.x < e.left || p.x > e.right) {
                    if (p.x + m >= e.left && p.x + m <= e.right) {
                        p = { $type: Point_$type, x: p.x + m, y: i };
                    }
                }
            }
            if (!isInfinity(p.x) && !isInfinity(p.y)) {
                var q_1 = g.item(o);
                if (!b.g.containsKey(q_1)) {
                    var r_1 = { $type: Point_$type, x: h, y: i };
                    var s_1 = { $type: Point_$type, x: p.x, y: p.y };
                    b.g.addItem(q_1, ((function () {
                        var $ret = new OwnedPoint();
                        $ret.a = q_1;
                        $ret.b = r_1;
                        $ret.c = s_1;
                        return $ret;
                    })()));
                }
            }
        };
        var this_1 = this;
        for (var o = 0; o < c; o++) {
            _loop_1(o);
        }
    };
    ScatterBase.prototype.tc = function (a, b) {
        var _this = this;
        this.q5 = null;
        this.q6 = null;
        a.j.clear();
        a.n.clear();
        a.h.clear();
        a.l.clear();
        a.i.clear();
        a.k.clear();
        var c = Math.min(this.r0 != null ? this.r0.count : 0, this.r1 != null ? this.r1.count : 0);
        var d = b.bv;
        var e = b.bu;
        var f = this.getEffectiveViewport1(b);
        var g = new ScalerParams(0, d, e, this.xAxis.cf, f);
        g.c = this.getEffectiveViewport1(b);
        var h = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.yAxis.cf, f);
            $ret.b = _this.f4();
            return $ret;
        })());
        h.c = this.getEffectiveViewport1(b);
        if (c < 1) {
            return;
        }
        this.rk = ((function () {
            var $ret = new ScatterAxisInfoCache();
            $ret.a = _this.xAxis;
            $ret.b = _this.yAxis;
            $ret.d = _this.xAxis.cf;
            $ret.e = _this.yAxis.cf;
            $ret.c = _this.ci;
            return $ret;
        })());
        var i = b;
        if (c <= this.sl) {
            this.s4(i, a, c, d, e);
        }
        if (this.p2()) {
            b.cv.l(a.j, this.sl, d, e, this.gk);
        }
        var j = ((function () {
            var $ret = new Clipper(0, e, false);
            $ret.i = a.n;
            return $ret;
        })());
        var k = this.pg(b);
        var l = this.xAxis.ei(k.left, g);
        var m = this.xAxis.ei(k.right, g);
        b.cx.h(a.n, this.trendLineType, this.r0, this.r1, this.trendLinePeriod, function (n) { return _this.xAxis.ef(n, g); }, function (n) { return _this.yAxis.ef(n, h); }, ((function () {
            var $ret = new TrendResolutionParams();
            $ret.b = _this.gk;
            $ret.f = e;
            $ret.g = d;
            return $ret;
        })()), j, l, m);
        this.ta(a, b);
    };
    ScatterBase.prototype.ko = function (a, b) {
        _super.prototype.ko.call(this, a, b);
        var c = b;
        c.c4(a);
    };
    ScatterBase.prototype.get_dt = function () {
        return true;
    };
    ScatterBase.prototype.re = function (a, b, c) {
        return null;
    };
    ScatterBase.prototype.rf = function (a, b, c) {
        var d = this.rp();
        var e = this.rl.by(this.o6(b));
        var f = -1;
        if (e == null) {
            if (a != null) {
                f = this.ci.indexOf(a);
            }
            else {
                return null;
            }
        }
        else {
            f = e.ak;
        }
        if (f == -1) {
            return null;
        }
        var g = new HighlightingInfo();
        g.b = this;
        g.h = f;
        g.g = f;
        g.d = false;
        g.e = true;
        if (c != null && c.h == g.h && c.g == g.g) {
            return c;
        }
        return g;
    };
    ScatterBase.prototype.pp = function () {
        if (this.p0 != 1 && this.p0 != 13) {
            var a = this.pz.cq();
            var b = (a.width / 2) + (this.p5 / 2);
            var c = (a.height / 2) + (this.p5 / 2);
            return new Thickness(1, b, c, b, c);
        }
        return new Thickness(1, 0, 0, 0, 0);
    };
    ScatterBase.prototype.rd = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.h = 0;
        d.g = this.ci.count - 1;
        d.d = true;
        if (c != null && c.h == d.h && c.g == d.g) {
            return c;
        }
        return d;
    };
    ScatterBase.prototype.av = function (a, b, c) {
        if (this.cz && this.eb(this.bk) && !c) {
            var d = this.re(a, b, this.rg);
            this.rg = d;
            return d;
        }
        else {
            var e = this.rd(a, b, this.rg);
            this.rg = e;
            return e;
        }
    };
    ScatterBase.prototype.aw = function (a, b, c) {
        if (this.eb(this.bk) && !c) {
            var d = this.rf(a, b, this.rh);
            this.rh = d;
            return d;
        }
        else {
            var e = this.rd(a, b, this.rh);
            e.e = true;
            this.rh = e;
            return e;
        }
    };
    ScatterBase.prototype.sd = function () {
        return (this.assigningScatterStyle != null && this.r3) || (this.bk != 1);
    };
    ScatterBase.prototype.sc = function () {
        return (this.assigningScatterMarkerStyle != null && this.r2) || (this.bk != 1);
    };
    ScatterBase.prototype.tn = function (a, b) {
        var _this = this;
        var c = b.bu;
        this.rk = ((function () {
            var $ret = new ScatterAxisInfoCache();
            $ret.a = _this.xAxis;
            $ret.b = _this.yAxis;
            $ret.d = _this.xAxis.cf;
            $ret.e = _this.yAxis.cf;
            return $ret;
        })());
        if (this.p2()) {
            b.cv.j(a.j, this.p4);
            if (this.sc()) {
                this.s5(b, a);
            }
        }
        b.cm();
        var d = ((function () {
            var $ret = new Clipper(1, NaN, c.bottom, NaN, c.top, false);
            $ret.i = b.cx.g$j.ak;
            return $ret;
        })());
        b.cx.g$h(a.n, d);
        this.tk(a, b);
    };
    ScatterBase.prototype.q8 = function (a, b) {
        return this.q9(a, b);
    };
    ScatterBase.prototype.q9 = function (a, b) {
        if (b < a || a < 0 || a > this.r0.count || b < 0 || b > this.r0.count) {
            return null;
        }
        var c = new Array((b - a) + 1);
        for (var d = a; d <= b; d++) {
            var e = d;
            c[d - a] = this.ci.item(d);
        }
        return c;
    };
    ScatterBase.prototype.s5 = function (a, b) {
        var _this = this;
        a.b3 = true;
        this.rx.aw(this, this.sc(), runOn(this, this.q8));
        var c = this.rx.d;
        var d = c != null;
        var e = this.getEffectiveViewport1(a);
        var f = this.ci == null ? 0 : this.ci.count;
        this.rl.cf(function (g) {
            if (g._visibility == 0) {
                var h = g.ak;
                var i = g.content;
                if (i == null) {
                    i = new DataContext();
                    g.content = i;
                }
                if (d) {
                    _this.s7(h, f, a.q);
                }
                _this.rx.ac(g, i);
            }
        });
    };
    ScatterBase.prototype.s8 = function (a, b, c) {
        var d = this.bk != 1;
        this.rx.ay(this.rx.b, a, b, false);
        this.rx.ab(this.fl);
        var e = this.rx.av;
        var f = null;
        var g = this.ci;
        if (d && this.cb != null) {
            f = this.cb.a3.getHighlightingInfo(this, g, e.o, e.n, false);
            e.b = f;
        }
        e.f = c;
        this.ti(e);
        this.rx.z(this, f, c, d, a < 0);
    };
    ScatterBase.prototype.s7 = function (a, b, c) {
        var d = this.bk != 1;
        this.rx.ay(this.rx.d, a, b, true);
        this.rx.aa(this.fl);
        var e = this.rx.au;
        var f = null;
        var g = this.ci;
        var h = null;
        if (d && this.cb != null) {
            f = this.cb.a3.getHighlightingInfo(this, g, e.o, e.n, true);
            if (this.cb.a3.isCrossSeriesHighlight(this)) {
                h = this.cb.a3.getHighlightingInfo(this, g, e.o, e.n, true);
            }
            e.b = f;
        }
        e.f = c;
        this.th(e);
        this.rx.y(this, f, c, d, e.m, this.cb.a3.totalHighlightingProgress);
    };
    ScatterBase.prototype.ti = function (a) {
        if (this.assigningScatterStyle != null && this.r3) {
            this.assigningScatterStyle(this, a);
        }
    };
    ScatterBase.prototype.th = function (a) {
        if (this.assigningScatterMarkerStyle != null && this.r2) {
            this.assigningScatterMarkerStyle(this, a);
        }
    };
    ScatterBase.prototype.ta = function (a, b) {
        var e_3, _a;
        var c = new ErrorBarsHelper(this, b);
        if (this.rm == null) {
            return;
        }
        var d = this.rm.u;
        var e = this.rm.v;
        var f = 0;
        var g = 0;
        var h = 0;
        var i = 0;
        try {
            for (var _b = __values(fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var j = _c.value;
                var k = a.j.item(j);
                if (d != null) {
                    switch (d.getCalculatorType()) {
                        case 1:
                            var l = this.td(k, c, d, h, i, true);
                            h = l.p3;
                            i = l.p4;
                            break;
                        case 0:
                            var m = this.tb(k, c, d, h, i, true);
                            h = m.p3;
                            i = m.p4;
                            break;
                        case 2:
                            var n = this.s9(k, c, d, j, h, i, true);
                            h = n.p4;
                            i = n.p5;
                            break;
                        case 3:
                            var o = this.te(c, d, f, h, i, true);
                            f = o.p2;
                            h = o.p3;
                            i = o.p4;
                            break;
                        case 4:
                            var p = this.tb(k, c, d, h, i, true);
                            h = p.p3;
                            i = p.p4;
                            break;
                    }
                    ;
                    var q = new OwnedPoint();
                    q.c = c.l(d, this.rk.a, k.c, f);
                    q.a = k.a;
                    a.h.addItem(j, q);
                    a.i.addItem(j, [h, i]);
                }
                if (e != null) {
                    switch (e.getCalculatorType()) {
                        case 1:
                            var r = this.td(k, c, e, h, i, false);
                            h = r.p3;
                            i = r.p4;
                            break;
                        case 0:
                            var s = this.tb(k, c, e, h, i, false);
                            h = s.p3;
                            i = s.p4;
                            break;
                        case 2:
                            var t = this.s9(k, c, e, j, h, i, false);
                            h = t.p4;
                            i = t.p5;
                            break;
                        case 3:
                            var u = this.te(c, e, g, h, i, false);
                            g = u.p2;
                            h = u.p3;
                            i = u.p4;
                            break;
                        case 4:
                            var v = this.tb(k, c, e, h, i, false);
                            h = v.p3;
                            i = v.p4;
                            break;
                    }
                    ;
                    var w = new OwnedPoint();
                    w.c = c.m(e, this.rk.b, k.c, g);
                    w.a = k.a;
                    a.l.addItem(j, w);
                    a.k.addItem(j, [h, i]);
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
    };
    ScatterBase.prototype.td = function (a, b, c, d, e, f) {
        if (f) {
            var g = void 0;
            var h = void 0, i = void 0;
            i = this.rk.a;
            if (this.rm.s == 0) {
                g = a.c.x;
                h = this.rk.a;
            }
            else {
                g = a.c.y;
                h = this.rk.b;
            }
            var j = b.f(g, c, h, i, d, e);
            d = j.p4;
            e = j.p5;
        }
        else {
            var k = void 0;
            var l = void 0, m = void 0;
            m = this.rk.b;
            if (this.rm.t == 0) {
                k = a.c.x;
                l = this.rk.a;
            }
            else {
                k = a.c.y;
                l = this.rk.b;
            }
            var n = b.f(k, c, l, m, d, e);
            d = n.p4;
            e = n.p5;
        }
        return {
            p3: d,
            p4: e
        };
    };
    ScatterBase.prototype.tb = function (a, b, c, d, e, f) {
        if (f) {
            var g = b.j(a.c.x, c, this.rk.a, d, e);
            d = g.p3;
            e = g.p4;
        }
        else {
            var h = b.j(a.c.y, c, this.rk.b, d, e);
            d = h.p3;
            e = h.p4;
        }
        return {
            p3: d,
            p4: e
        };
    };
    ScatterBase.prototype.s9 = function (a, b, c, d, e, f, g) {
        var h = c.getItemColumn();
        var i = this.ci.indexOf(d);
        if (h != null && i < h.count) {
            var j = h.item(i);
            if (g) {
                var k = b.h(a.c.x, j, this.rk.a, e, f);
                e = k.p3;
                f = k.p4;
            }
            else {
                var l = b.h(a.c.y, j, this.rk.b, e, f);
                e = l.p3;
                f = l.p4;
            }
        }
        else {
            e = NaN;
            f = NaN;
        }
        return {
            p4: e,
            p5: f
        };
    };
    ScatterBase.prototype.te = function (a, b, c, d, e, f) {
        var g = a.i(b, c);
        c = g.p1;
        if (f) {
            var h = a.k(c, b, this.rk.a, d, e);
            d = h.p3;
            e = h.p4;
        }
        else {
            var i = a.k(c, b, this.rk.b, d, e);
            d = i.p3;
            e = i.p4;
        }
        return {
            p2: c,
            p3: d,
            p4: e
        };
    };
    ScatterBase.prototype.tk = function (a, b) {
        if (!b.o() || this.rm == null) {
            b.c6();
            return;
        }
        this.tl(a, b);
        this.tm(a, b);
    };
    ScatterBase.prototype.tl = function (a, b) {
        var e_4, _a;
        b.c2();
        var c = new ErrorBarsHelper(this, b);
        var d = new PathGeometry();
        var e = this.rm.u;
        try {
            for (var _b = __values(fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                if (e != null && a.i.containsKey(f)) {
                    var g = a.i.item(f)[0];
                    var h = a.i.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        var i = a.h.item(f).c;
                        if (this.rm.o == 1 || this.rm.o == 2) {
                            c.d(d, i, g, true);
                        }
                        if (this.rm.o == 1 || this.rm.o == 3) {
                            c.d(d, i, h, false);
                        }
                    }
                }
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        b.c7(d);
    };
    ScatterBase.prototype.tm = function (a, b) {
        var e_5, _a;
        b.c3();
        var c = new ErrorBarsHelper(this, b);
        var d = new PathGeometry();
        var e = this.rm.v;
        try {
            for (var _b = __values(fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                if (e != null && a.k.containsKey(f)) {
                    var g = a.k.item(f)[0];
                    var h = a.k.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        var i = a.l.item(f).c;
                        if (this.rm.p == 1 || this.rm.p == 2) {
                            c.e(d, i, g, true);
                        }
                        if (this.rm.p == 1 || this.rm.p == 3) {
                            c.e(d, i, h, false);
                        }
                    }
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
    };
    ScatterBase.prototype.e5 = function (a, b, c) {
        var d = true;
        if (!_super.prototype.e5.call(this, a, b, c) || b.isEmpty || a.isEmpty || this.xAxis == null || this.yAxis == null || this.xAxis.bh == null || this.yAxis.bh == null || this.r0 == null || this.r1 == null || this.r0.count == 0 || this.r1.count == 0 || this.ci == null || this.ci.count != this.r0.count || this.ci.count != this.r1.count || this.xAxis.bh == null || this.yAxis.bh == null || this.xAxis.ld == this.xAxis.lc || this.yAxis.ld == this.yAxis.lc) {
            d = false;
        }
        return d;
    };
    ScatterBase.prototype.getViewInfo = function (a, b) {
        if (!this.ub.isEmpty && !this.uc.isEmpty) {
            a = this.ub;
            b = this.uc;
            return {
                p0: a,
                p1: b
            };
        }
        a = this.by.bu;
        b = this.by.bv;
        return {
            p0: a,
            p1: b
        };
    };
    ScatterBase.prototype.l8 = function (a) {
        this.s3();
        try {
            if (this.cu(this.by)) {
                return;
            }
            if (this.ci != null && this.ci.count > this.sl) {
                a = false;
            }
            if (this.ek(a) && !this.eo) {
                var b = this.rq;
                if (this.cs()) {
                    if (this.cc.g) {
                        this.cc.t();
                    }
                    this.rq = this.rs;
                    this.rs = b;
                }
                else {
                    this.rq = this.ro;
                    this.ro = b;
                }
                this.tc(this.ro, this.rl);
                this.mf();
            }
            else {
                if (!this.eo) {
                    this.tc(this.ro, this.rl);
                }
                this.tn(this.ro, this.rl);
            }
        }
        finally {
            this.to();
        }
    };
    ScatterBase.prototype.mk = function () {
        _super.prototype.mk.call(this);
        if (this.hc < 0) {
            return;
        }
        this.rl.da();
    };
    ScatterBase.prototype.l9 = function (a, b) {
        _super.prototype.l9.call(this, a, b);
        if (!this.ev) {
            this.by.a2(b);
            return;
        }
        this.by.a2(b);
        if (this.cu(this.bx)) {
            return;
        }
        var c = typeCast(ScatterBaseView.$, this.bx);
        if (!this.ep) {
            this.rr = new ScatterFrame();
            this.tc(this.rr, c);
        }
        this.ep = false;
        this.tn(this.rr, c);
        this.ev = false;
    };
    ScatterBase.prototype.l6 = function (a, b, c, d, e) {
        _super.prototype.l6.call(this, a, b, c, d, e);
        var f = this.a5.a$h.item(d);
        var g = f;
        f.a1(c);
        if (this.cu(g)) {
            return;
        }
        if (this.rn == null) {
            this.rn = new ScatterFrame();
        }
        this.tc(this.rn, g);
        this.tn(this.rn, g);
    };
    ScatterBase.prototype.tj = function (a, b) {
        var e_6, _a, e_7, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = __values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.h(e);
            }
        }
        catch (e_7_1) {
            e_7 = { error: e_7_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_7)
                    throw e_7.error;
            }
        }
    };
    ScatterBase.prototype.q7 = function (a, b, c, d, e) {
        var _this = this;
        if (c == null || c.length != this.rk.c.count) {
            c = new Array(this.rk.c.count);
            for (var f = 0; f < this.rk.c.count; f++) {
                c[f] = PointUtil.create();
            }
        }
        var g = this.getEffectiveViewport1(a);
        var h = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.xAxis.cf, g);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var i = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.yAxis.cf, g);
            $ret.c = _this.getEffectiveViewport1(a);
            $ret.b = _this.f4();
            return $ret;
        })());
        var j = this.pg(a);
        var k = this.rk.a.ei(j.left, h);
        var l = this.rk.a.ei(j.right, h);
        var m = this.rk.b.ei(j.bottom, i);
        var n = this.rk.b.ei(j.top, i);
        if (this.rk.d) {
            var o = k;
            k = l;
            l = o;
        }
        if (this.rk.e) {
            var p = m;
            m = n;
            n = p;
        }
        var q = this.rk;
        var r = q.a;
        var s = q.b;
        var t;
        var u;
        var v = this.r0;
        var w = this.r1;
        var x = false;
        var y = 0;
        var z = 0;
        if (this.cb != null) {
            if (this.cb.ex()) {
                var aa = this.cb.km(d, h);
                x = aa.c;
                y = aa.d;
                z = r.ei(0 + y, h);
                var ab = r.ei(0, h);
                z -= ab;
            }
        }
        for (var ac = 0; ac < this.rk.c.count; ac++) {
            t = v.item(ac);
            u = w.item(ac);
            if (x) {
                if (t >= k && t <= l && u >= m && u <= n) {
                    c[ac].x = r.ef(t, h);
                    c[ac].y = s.ef(u, i);
                }
                else {
                    if ((t + z) >= k && (t + z) <= l && u >= m && u <= n) {
                        c[ac].x = r.ef(t, h) + y;
                        c[ac].y = s.ef(u, i);
                    }
                    else {
                        c[ac].x = NaN;
                        c[ac].y = NaN;
                    }
                }
            }
            else {
                if (t >= k && t <= l && u >= m && u <= n) {
                    c[ac].x = r.ef(t, h);
                    c[ac].y = s.ef(u, i);
                }
                else {
                    c[ac].x = NaN;
                    c[ac].y = NaN;
                }
            }
        }
        return c;
    };
    ScatterBase.prototype.se = function (a, b) {
        var e_8, _a;
        if (b == null) {
            b = new List$1(Number_$type, 2, a.e);
        }
        else {
            b.clear();
        }
        var c = 0;
        var d = this.ci;
        try {
            for (var _b = __values(fromEnum(a.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                b.add(d.indexOf(e));
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        return b;
    };
    ScatterBase.prototype.ky = function (a) {
        _super.prototype.ky.call(this, a);
        this.a7.exportTrendlineData(this, a, this.rl.cx.g$j);
    };
    ScatterBase.prototype.f4 = function () {
        return Series.f5(this.r1, null);
    };
    ScatterBase.$t = markType(ScatterBase, 'ScatterBase', MarkerSeries.$, [ISupportsErrorBars_$type, ITrendLineSeries_$type]);
    ScatterBase.tp = DependencyProperty.i("ActualTrendLineBrush", Brush.$, ScatterBase.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    ScatterBase.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterBase, 'raisePropertyChanged', ['ErrorBarSettings:rm:tq', [ScatterErrorBarSettings.$, null], 'IsCustomScatterMarkerStyleAllowed:r6:tr', [0, false], 'IsCustomScatterStyleAllowed:r7:ts', [0, false], 'ItemSearchMode:rw:tt', [ScatterItemSearchMode_$type, enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:sk:tu', [1, 10000], 'MarkerCollisionAvoidance:rc:tv', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MaximumMarkers:sl:tw', [1, 400], 'XAxis::t4', [NumericXAxis.$, null], 'XMemberPath:sx:t5', [2, null], 'YAxis::t6', [NumericYAxis.$, null], 'YMemberPath:s1:t7', [2, null], 'TrendLineType::t2', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::t1', [1, 1.5], 'TrendLinePeriod::t0', [1, 7], 'TrendLineBrush::tx', [Brush.$, null], 'TrendLineZIndex:sm:t3', [1, 1001], 'TrendLineDashArray:t9:ty', [DoubleCollection.$], 'TrendLineDashCap:ua:tz', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return ScatterBase;
}(MarkerSeries));
export { ScatterBase };
/**
 * @hidden
 */
var ScatterSeriesRenderManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterSeriesRenderManager, _super);
    function ScatterSeriesRenderManager() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.au = null;
        _this.av = null;
        return _this;
    }
    ScatterSeriesRenderManager.prototype.c = function () {
        this.au = new AssigningScatterMarkerStyleEventArgs();
        return this.au;
    };
    ScatterSeriesRenderManager.prototype.a = function () {
        this.av = new AssigningScatterStyleEventArgs();
        return this.av;
    };
    ScatterSeriesRenderManager.prototype.aw = function (a, b, c) {
        this.w(a, b, c);
    };
    ScatterSeriesRenderManager.prototype.ax = function (a, b, c) {
        this.x(a, b, c);
    };
    ScatterSeriesRenderManager.prototype.ay = function (a, b, c, d) {
        if (b == -1) {
            a.c = false;
            a.o = 0;
            a.n = c - 1;
        }
        else {
            if (d) {
                a.o = b;
                a.n = b;
            }
            else {
                a.c = false;
                a.o = b;
                a.n = b;
            }
        }
    };
    ScatterSeriesRenderManager.$t = markType(ScatterSeriesRenderManager, 'ScatterSeriesRenderManager', SeriesRenderManager.$);
    return ScatterSeriesRenderManager;
}(SeriesRenderManager));
export { ScatterSeriesRenderManager };
/**
 * @hidden
 */
var ScatterBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterBaseView, _super);
    function ScatterBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cv = null;
        _this.ct = null;
        _this.cw = null;
        _this.c1 = null;
        _this.dc = null;
        _this.dd = null;
        _this.cx = null;
        _this.db = null;
        _this.cy = null;
        _this.cw = a;
        _this.cy = new HashPool$2(Base.$, Marker.$);
        _this.ch(_this.cy);
        _this.cx = new ScatterTrendLineManager();
        return _this;
    }
    ScatterBaseView.prototype.as = function () {
        _super.prototype.as.call(this);
        this.cv = this.cu();
        this.dc = new Path();
        this.dd = new Path();
        if (!this.q) {
            this.cw.sl = 2000;
        }
    };
    ScatterBaseView.prototype.de = function (a) {
        if (this.db == null) {
            this.db = new DataTemplateMeasureInfo();
            this.db.context = this.k.g();
        }
        this.db.width = a.width;
        this.db.height = a.height;
        this.db.data = a.content;
        var b = a.ah;
        if (b.measure != null) {
            b.measure(this.db);
        }
        return new Size(1, this.db.width, this.db.height);
    };
    ScatterBaseView.prototype.cu = function () {
        var _this = this;
        var a = new NumericMarkerManager(1, function (b) { return _this.cy.item(b); }, function (b) { return _this.cw.rk.c.item(b); }, runOn(this, this.c9), runOn(this, this.cr), runOn(this, this.cz), function () { return _this.cw.rc; });
        a.q = runOn(this, this.de);
        return a;
    };
    ScatterBaseView.prototype.c9 = function (a) {
        this.cw.tj(a, this.cy);
    };
    ScatterBaseView.prototype.c0 = function () {
        return this.b4;
    };
    ScatterBaseView.prototype.cs = function () {
        return this.ct;
    };
    ScatterBaseView.prototype.cr = function () {
        this.ct = this.cw.q7(this, this.cy, this.ct, this.bv, this.bu);
        return this.ct;
    };
    ScatterBaseView.prototype.cz = function () {
        this.c1 = this.cw.se(this.cy, this.c1);
        return this.c1;
    };
    ScatterBaseView.prototype.c2 = function () {
    };
    ScatterBaseView.prototype.c7 = function (a) {
    };
    ScatterBaseView.prototype.c3 = function () {
    };
    ScatterBaseView.prototype.c8 = function (a) {
    };
    ScatterBaseView.prototype.da = function () {
        if (this.cw.trendLineBrush != null) {
            this.cw.t8 = this.cw.trendLineBrush;
        }
        else {
            this.cw.t8 = this.cw.oo;
        }
    };
    ScatterBaseView.prototype.cf = function (a) {
        this.cy.f(a);
    };
    ScatterBaseView.prototype.c5 = function (a) {
        this.cy.g(a);
    };
    ScatterBaseView.prototype.c6 = function () {
    };
    ScatterBaseView.prototype.a5 = function (a, b) {
        _super.prototype.a5.call(this, a, b);
        if (a.d) {
            if (this.cw.trendLineType != 0 && !b) {
                var c = this.cx.g$j;
                c.ac = this.cw.trendLineThickness;
                c._stroke = this.cw.t8;
                c.ai = this.cw.t9;
                c.ad = this.cw.ua;
                a.u(c);
            }
        }
    };
    ScatterBaseView.prototype.c4 = function (a) {
        if (a) {
            this.c6();
            this.cy.clear();
        }
        this.cx.g$d();
        this.aq();
    };
    ScatterBaseView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a5.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cw.hs + "</span><br/><span>" + "x: </span><span class='ui-priority-primary'>${item." + this.cw.sx + "}</span><br/><span>" + "y: </span><span class='ui-priority-primary'>${item." + this.cw.s1 + "}</span></div>";
        return a;
    };
    ScatterBaseView.$t = markType(ScatterBaseView, 'ScatterBaseView', MarkerSeriesView.$);
    return ScatterBaseView;
}(MarkerSeriesView));
export { ScatterBaseView };
