/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { FastItemDateTimeColumn } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { DependencyProperty } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { typeCast, Number_$type, Date_$type, fromEnum, runOn, delegateRemove, delegateCombine, markType, markDep, TypeRegistrar } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { NumericScaler } from "./NumericScaler";
import { SeriesViewer } from "./SeriesViewer";
import { SortedListView$1 } from "./SortedListView$1";
import { ArrayExtension } from "igniteui-react-core";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_ } from "igniteui-react-core";
import { dateMinValue, dateSubtract, dateAdd, dateMaxValue, dateFromTicks } from "igniteui-react-core";
/**
 * @hidden
 */
var TimeAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TimeAxisBase, _super);
    function TimeAxisBase() {
        var _this = _super.call(this) || this;
        _this.ma = null;
        _this.mj = null;
        _this.me = false;
        _this.mm = dateMaxValue();
        _this.ml = dateMinValue();
        FastItemDateTimeColumn.o();
        return _this;
    }
    TimeAxisBase.prototype.ef = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.mr(a, NumericScaler.ac, b.c, Rect.empty);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.mr(a, b.e, b.d, b.c);
    };
    TimeAxisBase.prototype.ft = function (a, b) {
        var c = this.go(b);
        if (c == this.dateTimeMemberPath) {
            return this.fu(a, b, this.dateTimeMemberPath);
        }
        return _super.prototype.ft.call(this, a, b);
    };
    TimeAxisBase.prototype.mr = function (a, b, c, d) {
        var e;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            e = -1;
        }
        else {
            e = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        var f = 0;
        if (this.categoryMode == 2) {
            f = this.getGroupCenter(0, b, c, d);
        }
        if (this.cf) {
            e = 1 - e;
            f = -f;
        }
        return c.left + c.width * (e - b.left) / b.width - f;
    };
    TimeAxisBase.prototype.ms = function (a, b, c) {
        var d;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            d = -1;
        }
        else {
            d = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        var e = 0;
        if (this.cf) {
            d = 1 - d;
            e = -e;
        }
        return c.left + c.width * (d - b.left) / b.width - e;
    };
    TimeAxisBase.prototype.ei = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.d.left;
            var d = b.d.width;
            if (this.categoryMode != 0) {
                var e = this.getCategorySize(b.e, b.d, b.c);
                c += e / 2;
                d -= e;
            }
            var f = b.e.left + b.e.width * (a - c) / b.d.width;
            f = (f * b.d.width) + b.d.left;
            f = this.getUnscaledValue3(f, NumericScaler.ac, b.c, this.categoryMode);
            return f;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    };
    TimeAxisBase.prototype.getUnscaledValue3 = function (a, b, c, d) {
        var e = b.left + b.width * (a - c.left) / c.width;
        if (this.cf) {
            e = 1 - e;
        }
        return truncate(Math.floor(this.actualMinimumValue.getTime() + e * (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime())));
    };
    TimeAxisBase.prototype.i$h = function () {
        this.m7();
    };
    TimeAxisBase.prototype.m7 = function () {
        var a = this.bh != null ? this.bh.r0 : Rect.empty;
        var b = !a.isEmpty ? this.j7 : Rect.empty;
        var c = (new Date());
        var d = (new Date());
        var e = false;
        if (!a.isEmpty && !b.isEmpty && this.mb != null) {
            var f = typeCast(FastItemDateTimeColumn.$, this.mb);
            if (f != null) {
                if (this.mk == null) {
                    this.m8();
                }
            }
            else {
                this.mk = null;
            }
            if (this.mb.count > 0) {
                e = true;
                var g = this.mk == null ? 0 : this.mk._inner[0];
                var h = this.mk == null ? this.mb.count - 1 : this.mk._inner[this.mb.count - 1];
                c = this.mb.item(g);
                d = this.mb.item(h);
                this.mf = false;
                if (this.categoryMode == 2) {
                    var i = this.m5(c, d);
                    if (+c != +(dateMinValue())) {
                        c = dateSubtract(+c, +i);
                    }
                    d = dateAdd(+d, +i);
                }
            }
        }
        if (this.mi()) {
            e = true;
            c = this.minimumValue;
        }
        if (this.mh()) {
            e = true;
            d = this.maximumValue;
        }
        var j = +(this.actualMinimumValue) != +c || +(this.actualMaximumValue) != +d;
        if (e && j) {
            var k = this.actualMinimumValue;
            var l = this.actualMaximumValue;
            this.actualMinimumValue = c;
            this.actualMaximumValue = d;
            this.nc();
        }
    };
    TimeAxisBase.prototype.nc = function () {
    };
    Object.defineProperty(TimeAxisBase.prototype, "mb", {
        get: function () {
            return this.ma;
        },
        set: function (a) {
            if (this.ma != a) {
                var b = this.ma;
                this.ma = a;
                this.hx("DateTimeColumn", b, this.ma);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "mk", {
        get: function () {
            return this.mj;
        },
        set: function (a) {
            this.mj = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "i$b", {
        get: function () {
            if (this.mk == null) {
                var a = typeCast(FastItemDateTimeColumn.$, this.mb);
                if (a != null) {
                    this.m8();
                }
                else {
                    this.mk = null;
                }
            }
            return this.mk;
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.m8 = function () {
        if (this.mg) {
            this.mk = new List$1(Number_$type, 0);
            var a = this.mk;
            var b = this.mb.count;
            for (var c = 0; c < b; c++) {
                a.add(c);
            }
        }
        else {
            var d = typeCast(FastItemDateTimeColumn.$, this.mb);
            this.mk = d.h();
        }
    };
    TimeAxisBase.prototype.i$e = function (a, b, c, d) {
        return this.mu(a, b, c, d);
    };
    TimeAxisBase.prototype.mu = function (a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        var e = d;
        var f = new ScalerParams(0, a, b, this.cf, c);
        var g, h;
        if (this.cf) {
            h = this.ei(e.left, f);
            g = this.ei(e.right, f);
        }
        else {
            g = this.ei(e.left, f);
            h = this.ei(e.right, f);
        }
        var i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(g)));
        return this.mt(dateFromTicks(i));
    };
    TimeAxisBase.prototype.mt = function (a) {
        if (this.mb == null || this.mk.count != this.mb.count) {
            return -1;
        }
        var b = new SortedListView$1(Date_$type, this.mb, this.mk);
        var c = this.mv(a, b);
        if (c >= 0 && c < this.mk.count) {
            var d = this.mb.item(this.mk._inner[c]);
            if (d > a) {
                c--;
                if (c < 0) {
                    c = 0;
                }
            }
            return c;
        }
        return this.mk.count - 1;
    };
    TimeAxisBase.prototype.i$g = function (a, b, c, d) {
        return this.mx(a, b, c, d);
    };
    TimeAxisBase.prototype.mx = function (a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        var e = d;
        var f = new ScalerParams(0, a, b, this.cf, c);
        var g, h;
        if (this.cf) {
            h = this.ei(e.left, f);
            g = this.ei(e.right, f);
        }
        else {
            g = this.ei(e.left, f);
            h = this.ei(e.right, f);
        }
        var i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(h)));
        return this.mw(dateFromTicks(i));
    };
    TimeAxisBase.prototype.mw = function (a) {
        if (this.mb == null || this.mk.count != this.mb.count) {
            return -1;
        }
        var b = new SortedListView$1(Date_$type, this.mb, this.mk);
        var c = this.mv(a, b);
        if (c >= this.mk.count) {
            c = this.mk.count - 1;
        }
        if (c >= 0 && c < this.mk.count) {
            var d = this.mb.item(this.mk._inner[c]);
            if (d < a) {
                c++;
                if (c > this.mk.count - 1) {
                    c = this.mk.count - 1;
                }
            }
            return c;
        }
        return 0;
    };
    TimeAxisBase.prototype.i$d = function (a) {
        if (this.mb == null) {
            return NaN;
        }
        var b = this.ma.item(a);
        var c = b.getTime();
        var d = c;
        return d;
    };
    TimeAxisBase.prototype.i$c = function (a) {
        var b = this;
        if (b.i$b == null) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.mb, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.mv(d, c);
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            var diff1_ = d.getTime() - c.item(e - 1).getTime();
            var diff2_ = c.item(e).getTime() - d.getTime();
            var f = e - 1;
            var g = e;
            if (f < 0 && g >= 0) {
                return g;
            }
            if (g > b.i$b.count - 1 && f < b.i$b.count) {
                return f;
            }
            if (f < 0 && g < 0) {
                return -1;
            }
            if (f > b.i$b.count - 1 && g > b.i$b.count - 1) {
                return -1;
            }
            var h = diff1_ / (diff1_ + diff2_);
            if (isNaN_(h)) {
                h = 0;
            }
            return f + h;
        }
        if (e >= 0 && e < b.i$b.count) {
            return e;
        }
        var i = this.j2();
        if (e == b.i$b.count && this.bh != null && this.ef(a, new ScalerParams(0, this.bh.r0, this.j7, this.cf, i)) < (this.j7.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bh != null && Math.abs(this.ef(a, new ScalerParams(0, this.bh.r0, this.j7, this.cf, i)) - this.j7.left) < 2) {
            return 0;
        }
        return -1;
    };
    TimeAxisBase.prototype.mv = function (a, b) {
        var c = this;
        if (this.mb == null || c.i$b == null) {
            return -1;
        }
        var d = -1;
        var e = ArrayExtension.binarySearch$11(Date_$type, b, function (f) {
            if (a < f) {
                return -1;
            }
            if (a > f) {
                return 1;
            }
            return 0;
        });
        if (e >= 0) {
            d = e;
        }
        else {
            d = ~e;
        }
        while (d >= 0 && d < b.count && d - 1 >= 0 && +(b.item(d)) == +(b.item(d - 1))) {
            d--;
        }
        return d;
    };
    TimeAxisBase.prototype.i$f = function (a) {
        var b = this;
        if (b.i$b == null || this.mb == null || b.i$b.count != this.mb.count) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.mb, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.mv(d, c);
        var f = this.j2();
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            var g = +d - +(c.item(e - 1));
            var h = +(c.item(e)) - +d;
            if (g < h) {
                e = e - 1;
            }
        }
        if (e >= 0 && e < b.i$b.count) {
            return b.i$b._inner[e];
        }
        if (e == b.i$b.count && this.bh != null && this.ef(a, new ScalerParams(0, this.bh.r0, this.j7, this.cf, f)) < (this.j7.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bh != null && Math.abs(this.ef(a, new ScalerParams(0, this.bh.r0, this.j7, this.cf, f)) - this.j7.left) < 2) {
            return 0;
        }
        return -1;
    };
    TimeAxisBase.prototype.i$i = function () {
        this.mk = null;
        this.h2();
    };
    TimeAxisBase.prototype.get_mf = function () {
        return this.me;
    };
    TimeAxisBase.prototype.set_mf = function (a) {
        this.me = a;
    };
    Object.defineProperty(TimeAxisBase.prototype, "mf", {
        get: function () {
            return this.get_mf();
        },
        set: function (a) {
            this.set_mf(a);
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.ht = function (a) {
        _super.prototype.ht.call(this, a);
        this.dateTimeMemberPath = a;
    };
    TimeAxisBase.prototype.hw = function (a) {
        _super.prototype.hw.call(this, a);
        this.minimumValue = a;
    };
    TimeAxisBase.prototype.hv = function (a) {
        _super.prototype.hw.call(this, a);
        this.maximumValue = a;
    };
    TimeAxisBase.prototype.c0 = function () {
        if (this.cn && this.c1) {
            this.bb = this.ba();
        }
        var a = this.actualMinimumValue.getTime();
        var b = this.actualMaximumValue.getTime();
        this.m7();
        var c = !this.mi() ? this.actualMinimumValue.getTime() : this.minimumValue.getTime();
        var d = !this.mh() ? this.actualMaximumValue.getTime() : this.maximumValue.getTime();
        var e = new AxisRangeChangedEventArgs(0, a, c, b, d);
        this.hy(e);
        return true;
    };
    TimeAxisBase.prototype.mi = function () {
        if (+(this.minimumValue) == +(dateMinValue())) {
            return false;
        }
        return (this.minimumValue != null);
    };
    TimeAxisBase.prototype.mh = function () {
        if (+(this.maximumValue) == +(dateMaxValue())) {
            return false;
        }
        return (this.maximumValue != null);
    };
    Object.defineProperty(TimeAxisBase.prototype, "actualMinimumValue", {
        get: function () {
            return this.mm;
        },
        set: function (a) {
            var b = +(this.mm) != +a;
            if (b) {
                var c = this.mm;
                this.mm = a;
                this.hx("ActualMinimumValue", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.fy = function () {
        return this.actualMinimumValue;
    };
    Object.defineProperty(TimeAxisBase.prototype, "actualMaximumValue", {
        get: function () {
            return this.ml;
        },
        set: function (a) {
            var b = +(this.ml) != +a;
            if (b) {
                var c = this.ml;
                this.ml = a;
                this.hx("ActualMaximumValue", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.fx = function () {
        return this.maximumValue;
    };
    TimeAxisBase.prototype.m9 = function (a) {
        var e_1, _a;
        this.h4(a);
        if (this.kl == null) {
            return;
        }
        try {
            for (var _b = __values(fromEnum(this.c7())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.l7(a);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    TimeAxisBase.prototype.hr = function (a, b, c, d) {
        _super.prototype.hr.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.mb);
                    this.mb = null;
                    e.event = delegateRemove(e.event, runOn(this, this.m6));
                }
                var f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.mk = null;
                    this.mb = this.mc(this.dateTimeMemberPath);
                    f.event = delegateCombine(f.event, runOn(this, this.m6));
                }
                this.m9(false);
                break;
            case TimeAxisBase.$$p[0]:
                if (this.kl != null) {
                    this.kl.deregisterColumn(this.mb);
                    this.mb = this.mc(this.dateTimeMemberPath);
                    this.mk = null;
                }
                break;
            case TimeAxisBase.$$p[3]:
                this.cy();
                this.m9(false);
                break;
            case TimeAxisBase.$$p[2]:
                this.cy();
                this.m9(false);
                break;
            case "DateTimeColumn":
                this.m7();
                break;
        }
    };
    TimeAxisBase.prototype.m6 = function (a, b) {
        this.mk = null;
    };
    TimeAxisBase.prototype.mc = function (a) {
        return TimeAxisBase.md(a, this);
    };
    TimeAxisBase.md = function (a, b) {
        if (a == null) {
            return b.kl.registerColumnDateTime(null, null, false);
        }
        var c = null;
        var d = SeriesViewer.b8(a, b.coercionMethods);
        c = d.a;
        return b.kl.registerColumnDateTime(a, c, b.expectFunctions);
    };
    TimeAxisBase.prototype.au = function () {
        if (this.c2) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    TimeAxisBase.prototype.get_a1 = function () {
        return 0;
    };
    Object.defineProperty(TimeAxisBase.prototype, "a1", {
        get: function () {
            return this.get_a1();
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.h4 = function (a) {
        _super.prototype.h4.call(this, a);
        var b = this.a4.ay();
        var c = this.a4.a1();
        var d = this.a4.az();
        var e = this.a4.a0();
        var f = this.a4.e();
        var g = this.a4.f();
        var h = this.a4.g();
        this.ig();
        this.hd(b);
        this.hd(c);
        this.hd(d);
        this.hd(e);
        this.c8.clear();
        this.c9.clear();
        this.ks.clear();
        this.av.ad = this;
        var i = this.bh != null ? this.bh.r0 : Rect.empty;
        var j = !i.isEmpty ? this.j7 : Rect.empty;
        this.av.c5 = i;
        this.av.c4 = j;
        if (i.isEmpty || j.isEmpty) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
        }
        if (this.bq.count == 0) {
            this.av.ab.clear();
        }
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        this.m7();
    };
    TimeAxisBase.prototype.get_cc = function () {
        return true;
    };
    TimeAxisBase.prototype.startCursor = function () {
    };
    TimeAxisBase.prototype.resetCursor = function () {
    };
    TimeAxisBase.prototype.StartTimeCursor = function () {
        this.startCursor();
    };
    TimeAxisBase.prototype.ResetTimeCursor = function () {
        this.resetCursor();
    };
    TimeAxisBase.prototype.getCategorySize = function (a, b, c) {
        if (this.k9 == 0) {
            return 0;
        }
        var d = this.j5(b, c);
        return d.width / (this.k9 * a.width);
    };
    TimeAxisBase.prototype.getGroupCenter = function (a, b, c, d) {
        return this.getCategorySize(b, c, d) * 0.5;
    };
    TimeAxisBase.prototype.ky = function (a, b, c) {
        var d = this.k5(a, b, c);
        var e = 1 - 0.5 * d;
        var f = this.getCategorySize(a, b, c) * e;
        return f;
    };
    TimeAxisBase.prototype.get_ck = function () {
        return true;
    };
    TimeAxisBase.prototype.m5 = function (a, b) {
        return (0);
    };
    TimeAxisBase.prototype.preferredCategoryMode = function (a) {
        return this.ca ? 0 : 1;
    };
    Object.defineProperty(TimeAxisBase.prototype, "isVertical", {
        get: function () {
            return this.cm;
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.j$c = function (a, b) {
        return this.ei.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$b = function (a, b) {
        return this.ef.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$d = function (a, b, c, d, e) {
        this.hh.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$e = function (a, b, c, d) {
        this.hi.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$f = function (a, b, c, d) {
        this.hj.apply(this, arguments);
    };
    Object.defineProperty(TimeAxisBase.prototype, "j$a", {
        get: function () {
            return this.cf;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "i$a", {
        get: function () {
            return this.cc;
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.$t = markType(TimeAxisBase, 'TimeAxisBase', CategoryAxisBase.$, [ISortingAxis_$type, IDateTimeAxis_$type]);
    TimeAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, TimeAxisBase, 'hx', ['DateTimeMemberPath::nd', [2, null], 'IsDataPreSorted:mg:ne', [0, false], 'MaximumValue::nf', [3, null], 'MinimumValue::ng', [3, null]]);
    return TimeAxisBase;
}(CategoryAxisBase));
export { TimeAxisBase };
