import { __extends, __values } from "tslib";
import * as React from 'react';
import { XamDataLegend } from "./XamDataLegend";
import { arrayFindByName, ensureEnum, brushToString, stringToBrush, initializePropertiesFromCss, NamePatcher, isValidProp, toSpinal, getModifiedProps } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ReactRenderer } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { DataAbbreviationMode_$type } from './DataAbbreviationMode';
import { DataLegendUnitsMode_$type } from './DataLegendUnitsMode';
import { DataLegendSummaryType_$type } from './DataLegendSummaryType';
import { IgrDataLegendSummaryCalculationEventArgs } from './igr-data-legend-summary-calculation-event-args';
import { IgrDataLegendRowFormatEventArgs } from './igr-data-legend-row-format-event-args';
var DataLegendStylingDefaults = {};
/**
 * Represents data legend that displays information about each series including values and summaries.
 * THIS IS A COMMUNITY TECHNOLOGY PREVIEW, not for use in production.
*/
var IgrDataLegend = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDataLegend, _super);
    function IgrDataLegend(props) {
        var _this = _super.call(this, props) || this;
        _this._wrapper = null;
        _this._implementation = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._calculateSummaryValue = null;
        _this._calculateSummaryValue_wrapped = null;
        _this._formatHeaderRow = null;
        _this._formatHeaderRow_wrapped = null;
        _this._formatSeriesRow = null;
        _this._formatSeriesRow_wrapped = null;
        _this._formatSummaryRow = null;
        _this._formatSummaryRow_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._getMainRef = _this._getMainRef.bind(_this);
        _this._implementation = _this.createImplementation();
        if (document) {
            _this._container = document.createElement("div");
            _this._container.style.display = "block";
            _this._container.style.width = "100%";
            _this._container.style.height = "100%";
        }
        var root;
        root = _this._container;
        if (_this._container != null) {
            root = _this._container;
        }
        var ren = new ReactRenderer(root, document, true, DataLegendStylingDefaults);
        _this._wrapper = ren;
        var dataLegend = _this.i;
        _this._dataLegend = dataLegend;
        _this._dataLegend.externalObject = _this;
        dataLegend.provideContainer(ren);
        dataLegend.notifySizeChanged();
        if (props) {
            _this.initializeProperties();
        }
        ren.addSizeWatcher(function () {
            _this._dataLegend.notifySizeChanged();
        });
        return _this;
    }
    Object.defineProperty(IgrDataLegend.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._dataLegend.notifySizeChanged();
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._dataLegend.notifySizeChanged();
            }
        },
        enumerable: false,
        configurable: true
    });
    IgrDataLegend.prototype.desiredSizeChanged = function (width, height) {
        if (this.width == undefined || this.width == '') {
            this._elRef.style.width = width + "px";
        }
        if (this.height == undefined || this.height == '') {
            this._elRef.style.height = height + "px";
        }
        this._dataLegend.notifySizeChanged();
    };
    IgrDataLegend.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    IgrDataLegend.prototype.render = function () {
        var div = React.createElement("div", {
            className: "ig-data-legend igr-data-legend",
            ref: this._getMainRef
        });
        //}
        return div;
    };
    IgrDataLegend.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_1, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    IgrDataLegend.prototype.initializeProperties = function () {
        var e_2, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    // supports angular themes or custom properties set in CSS
    IgrDataLegend.prototype.updateStyle = function () {
        this._styling(this._elRef, this);
    };
    IgrDataLegend.prototype.componentWillUnmount = function () {
        this._dataLegend.destroy();
        this._wrapper.destroy();
    };
    IgrDataLegend.prototype.componentDidMount = function () {
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this._elRef.appendChild(this._container);
        this._dataLegend.notifySizeChanged();
        this.initializeContent();
    };
    IgrDataLegend.prototype.initializeContent = function () {
        this.updateStyle();
    };
    IgrDataLegend.prototype.createImplementation = function () {
        return new XamDataLegend();
    };
    Object.defineProperty(IgrDataLegend.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrDataLegend._staticStyling = function (container, component, parent) {
        var genericPrefix = "";
        var typeName = (component.i ? component.i : component).$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("DataLegend");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = (component.i ? component.i : component).$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, component, genericPrefix + "-", new Set(), false, additionalPrefixes);
    };
    Object.defineProperty(IgrDataLegend.prototype, "target", {
        /**
         * Gets or sets the target for the data legend.
        */
        get: function () {
            var ret = this.i.target;
            if (ret.externalObject != null) {
                ret = ret.externalObject;
            }
            return ret;
        },
        set: function (v) {
            if (v._implementation) {
                v = v._implementation;
            }
            this.i.target = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "actualAbbreviationMode", {
        /**
     * Gets actual mode for abbreviating numbers based on all numbers in the legend
    */
        get: function () {
            return this.i.al;
        },
        set: function (v) {
            this.i.al = ensureEnum(DataAbbreviationMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "formatAbbreviationMode", {
        /**
         * Gets or sets mode for abbreviating large numbers displayed in the legend
        */
        get: function () {
            return this.i.am;
        },
        set: function (v) {
            this.i.am = ensureEnum(DataAbbreviationMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "formatMaximumDigits", {
        /**
         * Gets or sets maximum digits for formating numbers displayed in the legend
        */
        get: function () {
            return this.i.bq;
        },
        set: function (v) {
            this.i.bq = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "formatMinimumDigits", {
        /**
         * Gets or sets minimum digits for formating numbers displayed in the legend
        */
        get: function () {
            return this.i.br;
        },
        set: function (v) {
            this.i.br = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "headerText", {
        /**
         * Gets or sets the HeaderText for the data legend.
        */
        get: function () {
            return this.i.b7;
        },
        set: function (v) {
            this.i.b7 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "headerTextColor", {
        /**
         * Gets or sets the header text color.
        */
        get: function () {
            return brushToString(this.i.et);
        },
        set: function (v) {
            this.i.et = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "headerTextFont", {
        /**
         * Gets or Sets the style to use for the header text.
        */
        get: function () {
            if (this.i.a5 == null) {
                return null;
            }
            return this.i.a5.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.a5 = fi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "summaryTextColor", {
        /**
         * Gets or sets the summary text color.
        */
        get: function () {
            return brushToString(this.i.ex);
        },
        set: function (v) {
            this.i.ex = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "summaryTextFont", {
        /**
         * Gets or Sets the style to use for the summary text.
        */
        get: function () {
            if (this.i.a9 == null) {
                return null;
            }
            return this.i.a9.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.a9 = fi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "summaryValueColor", {
        /**
         * Gets or sets the summary value color.
        */
        get: function () {
            return brushToString(this.i.ey);
        },
        set: function (v) {
            this.i.ey = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "summaryValueFont", {
        /**
         * Gets or Sets the style to use for the summary value.
        */
        get: function () {
            if (this.i.ba == null) {
                return null;
            }
            return this.i.ba.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.ba = fi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "summaryType", {
        /**
         * Gets or sets the SummaryType for the data legend.
        */
        get: function () {
            return this.i.au;
        },
        set: function (v) {
            this.i.au = ensureEnum(DataLegendSummaryType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "summaryValueFormat", {
        /**
         * Gets or sets the SummaryValueFormat for the data legend.
        */
        get: function () {
            return this.i.cz;
        },
        set: function (v) {
            this.i.cz = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "summaryValueFormatSpecifiers", {
        /**
         * Gets or sets the format specifiers to use with the SummaryValueFormat string.
        */
        get: function () {
            return this.i.ai;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.ai = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "summaryText", {
        /**
         * Gets or sets the SummaryText for the data legend.
        */
        get: function () {
            return this.i.cs;
        },
        set: function (v) {
            this.i.cs = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "rowMarginBottom", {
        get: function () {
            return this.i.e7 ? this.i.e7.b : NaN;
        },
        set: function (v) {
            this.ensureRowMargin();
            this.i.e7.b = +v;
            this.i.e7 = this.i.e7;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "rowMarginLeft", {
        get: function () {
            return this.i.e7 ? this.i.e7.c : NaN;
        },
        set: function (v) {
            this.ensureRowMargin();
            this.i.e7.c = +v;
            this.i.e7 = this.i.e7;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "rowMarginRight", {
        get: function () {
            return this.i.e7 ? this.i.e7.d : NaN;
        },
        set: function (v) {
            this.ensureRowMargin();
            this.i.e7.d = +v;
            this.i.e7 = this.i.e7;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "rowMarginTop", {
        get: function () {
            return this.i.e7 ? this.i.e7.e : NaN;
        },
        set: function (v) {
            this.ensureRowMargin();
            this.i.e7.e = +v;
            this.i.e7 = this.i.e7;
        },
        enumerable: false,
        configurable: true
    });
    IgrDataLegend.prototype.ensureRowMargin = function () {
        if (this.i.e7) {
            return;
        }
        this.i.e7 = new Thickness(2);
    };
    Object.defineProperty(IgrDataLegend.prototype, "columnSpacing", {
        /**
         * Gets or sets the ColumnMargin for the data legend.
        */
        get: function () {
            return this.i.bn;
        },
        set: function (v) {
            this.i.bn = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "badgeMarginBottom", {
        get: function () {
            return this.i.e6 ? this.i.e6.b : NaN;
        },
        set: function (v) {
            this.ensureBadgeMargin();
            this.i.e6.b = +v;
            this.i.e6 = this.i.e6;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "badgeMarginLeft", {
        get: function () {
            return this.i.e6 ? this.i.e6.c : NaN;
        },
        set: function (v) {
            this.ensureBadgeMargin();
            this.i.e6.c = +v;
            this.i.e6 = this.i.e6;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "badgeMarginRight", {
        get: function () {
            return this.i.e6 ? this.i.e6.d : NaN;
        },
        set: function (v) {
            this.ensureBadgeMargin();
            this.i.e6.d = +v;
            this.i.e6 = this.i.e6;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "badgeMarginTop", {
        get: function () {
            return this.i.e6 ? this.i.e6.e : NaN;
        },
        set: function (v) {
            this.ensureBadgeMargin();
            this.i.e6.e = +v;
            this.i.e6 = this.i.e6;
        },
        enumerable: false,
        configurable: true
    });
    IgrDataLegend.prototype.ensureBadgeMargin = function () {
        if (this.i.e6) {
            return;
        }
        this.i.e6 = new Thickness(2);
    };
    Object.defineProperty(IgrDataLegend.prototype, "seriesTitleMarginBottom", {
        get: function () {
            return this.i.e8 ? this.i.e8.b : NaN;
        },
        set: function (v) {
            this.ensureSeriesTitleMargin();
            this.i.e8.b = +v;
            this.i.e8 = this.i.e8;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesTitleMarginLeft", {
        get: function () {
            return this.i.e8 ? this.i.e8.c : NaN;
        },
        set: function (v) {
            this.ensureSeriesTitleMargin();
            this.i.e8.c = +v;
            this.i.e8 = this.i.e8;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesTitleMarginRight", {
        get: function () {
            return this.i.e8 ? this.i.e8.d : NaN;
        },
        set: function (v) {
            this.ensureSeriesTitleMargin();
            this.i.e8.d = +v;
            this.i.e8 = this.i.e8;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesTitleMarginTop", {
        get: function () {
            return this.i.e8 ? this.i.e8.e : NaN;
        },
        set: function (v) {
            this.ensureSeriesTitleMargin();
            this.i.e8.e = +v;
            this.i.e8 = this.i.e8;
        },
        enumerable: false,
        configurable: true
    });
    IgrDataLegend.prototype.ensureSeriesTitleMargin = function () {
        if (this.i.e8) {
            return;
        }
        this.i.e8 = new Thickness(2);
    };
    Object.defineProperty(IgrDataLegend.prototype, "seriesValueMarginBottom", {
        get: function () {
            return this.i.e9 ? this.i.e9.b : NaN;
        },
        set: function (v) {
            this.ensureSeriesValueMargin();
            this.i.e9.b = +v;
            this.i.e9 = this.i.e9;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesValueMarginLeft", {
        get: function () {
            return this.i.e9 ? this.i.e9.c : NaN;
        },
        set: function (v) {
            this.ensureSeriesValueMargin();
            this.i.e9.c = +v;
            this.i.e9 = this.i.e9;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesValueMarginRight", {
        get: function () {
            return this.i.e9 ? this.i.e9.d : NaN;
        },
        set: function (v) {
            this.ensureSeriesValueMargin();
            this.i.e9.d = +v;
            this.i.e9 = this.i.e9;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesValueMarginTop", {
        get: function () {
            return this.i.e9 ? this.i.e9.e : NaN;
        },
        set: function (v) {
            this.ensureSeriesValueMargin();
            this.i.e9.e = +v;
            this.i.e9 = this.i.e9;
        },
        enumerable: false,
        configurable: true
    });
    IgrDataLegend.prototype.ensureSeriesValueMargin = function () {
        if (this.i.e9) {
            return;
        }
        this.i.e9 = new Thickness(2);
    };
    Object.defineProperty(IgrDataLegend.prototype, "targetCursorPositionX", {
        /**
         * Gets or sets the TargetCursorPositionX for the data legend.
        */
        get: function () {
            return this.i.targetCursorPositionX;
        },
        set: function (v) {
            this.i.targetCursorPositionX = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "targetCursorPositionY", {
        /**
         * Gets or sets the TargetCursorPositionY for the data legend.
        */
        get: function () {
            return this.i.targetCursorPositionY;
        },
        set: function (v) {
            this.i.targetCursorPositionY = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "targetAxisValue", {
        /**
         * Gets or sets the TargetAxisValue for the data legend.
        */
        get: function () {
            return this.i.bu;
        },
        set: function (v) {
            this.i.bu = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesUnitsMode", {
        /**
         * Gets or sets the UnitsMode for the data legend.
        */
        get: function () {
            return this.i.av;
        },
        set: function (v) {
            this.i.av = ensureEnum(DataLegendUnitsMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesUnitsText", {
        /**
         * Gets or sets the units text for the data legend.
        */
        get: function () {
            return this.i.cn;
        },
        set: function (v) {
            this.i.cn = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesUnitsColor", {
        /**
         * Gets or sets the units text color.
        */
        get: function () {
            return brushToString(this.i.ev);
        },
        set: function (v) {
            this.i.ev = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesUnitsFont", {
        /**
         * Gets or Sets the style to use for the units text.
        */
        get: function () {
            if (this.i.a7 == null) {
                return null;
            }
            return this.i.a7.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.a7 = fi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesValueColor", {
        /**
         * Gets or sets the units text color.
        */
        get: function () {
            return brushToString(this.i.ew);
        },
        set: function (v) {
            this.i.ew = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesValueFont", {
        /**
         * Gets or Sets the style to use for the units text.
        */
        get: function () {
            if (this.i.a8 == null) {
                return null;
            }
            return this.i.a8.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.a8 = fi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesTitleColor", {
        /**
         * Gets or sets the display text color.
        */
        get: function () {
            return brushToString(this.i.eu);
        },
        set: function (v) {
            this.i.eu = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "seriesTitleFont", {
        /**
         * Gets or Sets the style to use for the display text.
        */
        get: function () {
            if (this.i.a6 == null) {
                return null;
            }
            return this.i.a6.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.a6 = fi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control to appear blurry.
        */
        get: function () {
            return this.i.bo;
        },
        set: function (v) {
            this.i.bo = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "actualPixelScalingRatio", {
        /**
         * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control to appear blurry.
        */
        get: function () {
            return this.i.bm;
        },
        set: function (v) {
            this.i.bm = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgrDataLegend.prototype.findByName = function (name) {
        if (this.summaryValueFormatSpecifiers != null && arrayFindByName(this.summaryValueFormatSpecifiers, name)) {
            return arrayFindByName(this.summaryValueFormatSpecifiers, name);
        }
        return null;
    };
    Object.defineProperty(IgrDataLegend.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgrDataLegend.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrDataLegend.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("DataLegend");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Notifies the legend about changes to size

*/
    IgrDataLegend.prototype.notifySizeChanged = function () {
        this.i.notifySizeChanged();
    };
    /**
     * Forces any pending refresh to the legend to be finished.
    
    */
    IgrDataLegend.prototype.flush = function () {
        this.i.de();
    };
    IgrDataLegend.prototype.getAbbreviatedValue = function (value, mode, minDigits, maxDigits) {
        var iv = this.i.b6(value, (mode == null ? null : mode), minDigits, maxDigits);
        return (iv);
    };
    IgrDataLegend.prototype.getAbbreviatedSymbol = function (value, mode, minDigits, maxDigits) {
        var iv = this.i.b5(value, (mode == null ? null : mode), minDigits, maxDigits);
        return (iv);
    };
    IgrDataLegend.prototype.getAbbreviatedString = function (value, mode, minDigits, maxDigits) {
        var iv = this.i.b4(value, (mode == null ? null : mode), minDigits, maxDigits);
        return (iv);
    };
    Object.defineProperty(IgrDataLegend.prototype, "calculateSummaryValue", {
        /**
         * Event raised when calculating summary value.
        */
        get: function () {
            return this._calculateSummaryValue;
        },
        set: function (ev) {
            var _this = this;
            if (this._calculateSummaryValue_wrapped !== null) {
                this.i.calculateSummaryValue = delegateRemove(this.i.calculateSummaryValue, this._calculateSummaryValue_wrapped);
                this._calculateSummaryValue_wrapped = null;
                this._calculateSummaryValue = null;
            }
            this._calculateSummaryValue = ev;
            this._calculateSummaryValue_wrapped = function (o, e) {
                var outerArgs = new IgrDataLegendSummaryCalculationEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeCalculateSummaryValue) {
                    _this.beforeCalculateSummaryValue(_this, outerArgs);
                }
                if (_this._calculateSummaryValue) {
                    _this._calculateSummaryValue(_this, outerArgs);
                }
            };
            this.i.calculateSummaryValue = delegateCombine(this.i.calculateSummaryValue, this._calculateSummaryValue_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "formatHeaderRow", {
        /**
         * Event raised when the Header row is formatted and styled.
        */
        get: function () {
            return this._formatHeaderRow;
        },
        set: function (ev) {
            var _this = this;
            if (this._formatHeaderRow_wrapped !== null) {
                this.i.formatHeaderRow = delegateRemove(this.i.formatHeaderRow, this._formatHeaderRow_wrapped);
                this._formatHeaderRow_wrapped = null;
                this._formatHeaderRow = null;
            }
            this._formatHeaderRow = ev;
            this._formatHeaderRow_wrapped = function (o, e) {
                var outerArgs = new IgrDataLegendRowFormatEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeFormatHeaderRow) {
                    _this.beforeFormatHeaderRow(_this, outerArgs);
                }
                if (_this._formatHeaderRow) {
                    _this._formatHeaderRow(_this, outerArgs);
                }
            };
            this.i.formatHeaderRow = delegateCombine(this.i.formatHeaderRow, this._formatHeaderRow_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "formatSeriesRow", {
        /**
         * Event raised when the series row is formatted and styled.
        */
        get: function () {
            return this._formatSeriesRow;
        },
        set: function (ev) {
            var _this = this;
            if (this._formatSeriesRow_wrapped !== null) {
                this.i.formatSeriesRow = delegateRemove(this.i.formatSeriesRow, this._formatSeriesRow_wrapped);
                this._formatSeriesRow_wrapped = null;
                this._formatSeriesRow = null;
            }
            this._formatSeriesRow = ev;
            this._formatSeriesRow_wrapped = function (o, e) {
                var outerArgs = new IgrDataLegendRowFormatEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeFormatSeriesRow) {
                    _this.beforeFormatSeriesRow(_this, outerArgs);
                }
                if (_this._formatSeriesRow) {
                    _this._formatSeriesRow(_this, outerArgs);
                }
            };
            this.i.formatSeriesRow = delegateCombine(this.i.formatSeriesRow, this._formatSeriesRow_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegend.prototype, "formatSummaryRow", {
        /**
         * Event raised when the summary row is formatted and styled.
        */
        get: function () {
            return this._formatSummaryRow;
        },
        set: function (ev) {
            var _this = this;
            if (this._formatSummaryRow_wrapped !== null) {
                this.i.formatSummaryRow = delegateRemove(this.i.formatSummaryRow, this._formatSummaryRow_wrapped);
                this._formatSummaryRow_wrapped = null;
                this._formatSummaryRow = null;
            }
            this._formatSummaryRow = ev;
            this._formatSummaryRow_wrapped = function (o, e) {
                var outerArgs = new IgrDataLegendRowFormatEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeFormatSummaryRow) {
                    _this.beforeFormatSummaryRow(_this, outerArgs);
                }
                if (_this._formatSummaryRow) {
                    _this._formatSummaryRow(_this, outerArgs);
                }
            };
            this.i.formatSummaryRow = delegateCombine(this.i.formatSummaryRow, this._formatSummaryRow_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    return IgrDataLegend;
}(React.Component));
export { IgrDataLegend };
