import { __extends } from "tslib";
import { IgrAnnotationLayer } from "./igr-annotation-layer";
import { SummaryToolTipLayer } from "./SummaryToolTipLayer";
import { ensureBool } from "igniteui-react-core";
/**
 * Represents an annotation layer that displays grouped tooltips with summaries for series.
 * THIS IS A COMMUNITY TECHNOLOGY PREVIEW, not for use in production.
*/
var IgrSummaryToolTipLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSummaryToolTipLayer, _super);
    function IgrSummaryToolTipLayer(props) {
        return _super.call(this, props) || this;
    }
    IgrSummaryToolTipLayer.prototype.createImplementation = function () {
        return new SummaryToolTipLayer();
    };
    Object.defineProperty(IgrSummaryToolTipLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSummaryToolTipLayer.prototype, "isAnnotationHoverLayer", {
        /**
         * Gets whether the series is an annotation layer displayed only when hovering over the chart.
        */
        get: function () {
            return this.i.c7;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSummaryToolTipLayer.prototype, "isDefaultTooltipBehaviorDisabled", {
        /**
         * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
        */
        get: function () {
            return this.i.dg;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSummaryToolTipLayer.prototype, "useInterpolation", {
        /**
         * Gets or sets whether to use value interpolation when drawing the tooltips.
        */
        get: function () {
            return this.i.qy;
        },
        set: function (v) {
            this.i.qy = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    IgrSummaryToolTipLayer.prototype.hideToolTips = function () {
        this.i.k4();
    };
    return IgrSummaryToolTipLayer;
}(IgrAnnotationLayer));
export { IgrSummaryToolTipLayer };
