import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-react-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private s8;
    get s9(): IAnchoredCategorySeriesInteractionManager;
    s4: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    ip(): string;
    protected bv(): SeriesView;
    lo(a: SeriesView): void;
    tc: boolean;
    constructor();
    tk: string;
    hn(a: any, b: string): any;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private ta;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get t2(): Brush;
    set t2(a: Brush);
    static readonly tr: DependencyProperty;
    trendLineThickness: number;
    t4: PenLineCap;
    t3: DoubleCollection;
    trendLinePeriod: number;
    te: number;
    ej(a: any): boolean;
    protected s1(a: number, b: number, c: Axis): any[];
    protected lt(a: any, b: string, c: any, d: any): void;
    ap(a: Axis): AxisRange;
    protected kr(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected sb(): number;
    td(a: CategorySeriesView): number;
    tp(a: PointCollection, b: number, c: CategorySeriesView): void;
    s2(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    s3(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    ko(a: boolean, b: SeriesView): void;
    sr(a: CategoryFrame, b: CategorySeriesView): void;
    su(a: CategoryFrame, b: CategorySeriesView): void;
    s5: CategoryFrame;
    l6(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    tm(a: CategoryFrame, b: CategorySeriesView): void;
    protected mk(): void;
    hq(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected tg: string;
    abstract tn(a: Axis): void;
    abstract to(a: Axis): void;
    protected ky(a: any): void;
    s6: CategorySeriesMarkerCollisionAvoidance;
    hk(a: Point): any;
    s7: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    f4(): number;
    protected get_tf(): number;
    protected get tf(): number;
    aq(a: Rect): AxisRange;
    private tq;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c0: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c1;
    get c2(): ITrendLineManager;
    set c2(a: ITrendLineManager);
    get c3(): boolean;
    c7(): void;
    c5(): void;
    c4(): void;
    cs(): CategoryBucketCalculator;
    c6(): void;
    c8(): void;
    c9(a: number): Rect;
    protected a5(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
