import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Point, Type, IList$1 } from "igniteui-react-core";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-react-core";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "igniteui-react-core";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { Geometry } from "igniteui-react-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { NumericAxisRenderer } from "./NumericAxisRenderer";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { GeometryGroup } from "igniteui-react-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
/**
 * @hidden
 */
export declare class AngleAxisLabelPanel extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    c9: AngleAxisLabelPanelView;
    constructor();
    da: boolean;
    dg: (arg1: number) => Point;
    at(a: number, b: Rect): boolean;
    de: number;
    db: number;
    dd: number;
    dc: number;
    a5(): List$1<Rect>;
    private df;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
}
/**
 * @hidden
 */
export declare class CategoryAngleAxis extends CategoryAxisBase implements IAngleScaler {
    static $t: Type;
    a3(): AxisView;
    hn(a: AxisView): void;
    mb: CategoryAngleAxisView;
    protected get_b7(): boolean;
    private mg;
    constructor();
    au(): AxisLabelPanelBase;
    md: CategoryAxisRenderer;
    private mh;
    private mv;
    private ml;
    private mc;
    private na;
    private mp;
    private ma;
    getMinMaxAngle(a: Rect, b: number, c: number): {
        p1: number;
        p2: number;
    };
    ac(): void;
    private me;
    get mf(): NumericRadiusAxis;
    set mf(a: NumericRadiusAxis);
    aj(): Axis;
    mw: number;
    private mm;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    ky(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    ms(a: number): number;
    protected h4(a: boolean): void;
    mr(a: Rect, b: Rect): number;
    mq(a: Rect, b: Rect): number;
    getScaledAngle(a: number): number;
    getUnscaledAngle(a: number): number;
    ef(a: number, b: ScalerParams): number;
    ei(a: number, b: ScalerParams): number;
    protected hr(a: any, b: string, c: any, d: any): void;
    private m4;
    m6(a: NumericRadiusAxis): void;
    static readonly m7: DependencyProperty;
    get mt(): number;
    set mt(a: number);
    private mj;
    get mn(): number;
    set mn(a: number);
    er(): number;
    static readonly m8: DependencyProperty;
    get mu(): number;
    set mu(a: number);
    private mk;
    get mo(): number;
    set mo(a: number);
    protected mi(): boolean;
    protected get_a1(): AxisOrientation;
    get a1(): AxisOrientation;
    c0(): boolean;
    private mx;
    get my(): number;
    set my(a: number);
    jz(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    get isVertical(): boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$a(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class NumericAngleAxis extends NumericAxisBase implements IAngleScaler {
    static $t: Type;
    a3(): AxisView;
    hn(a: AxisView): void;
    mn: NumericAngleAxisView;
    mq: PolarAxisRenderingManager;
    protected get_b7(): boolean;
    constructor();
    au(): AxisLabelPanelBase;
    private mu;
    private mw;
    private mr;
    private ms;
    kj(): NumericAxisRenderer;
    private m3;
    ef(a: number, b: ScalerParams): number;
    getScaledAngle1(a: number, b: boolean, c: boolean): number;
    getScaledAngle(a: number): number;
    ei(a: number, b: ScalerParams): number;
    getUnscaledAngle(a: number): number;
    mx: number;
    private mt;
    protected hr(a: any, b: string, c: any, d: any): void;
    private mz;
    kn(): NumericAxisRenderingParameters;
    km(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    getMinMaxAngle(a: Rect, b: number, c: number): {
        p1: number;
        p2: number;
    };
    protected h4(a: boolean): void;
    private mo;
    get mp(): NumericRadiusAxis;
    set mp(a: NumericRadiusAxis);
    aj(): Axis;
    m1(a: NumericRadiusAxis): void;
    protected ij(a: Rect, b: Rect): void;
    protected get_a1(): AxisOrientation;
    get a1(): AxisOrientation;
    jz(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class NumericRadiusAxis extends NumericAxisBase {
    static $t: Type;
    a3(): AxisView;
    hn(a: AxisView): void;
    mp: NumericRadiusAxisView;
    protected get_cj(): boolean;
    ee(): number;
    private my;
    private mx;
    private mq;
    constructor();
    au(): AxisLabelPanelBase;
    mr: boolean;
    private mv;
    private ms;
    kj(): NumericAxisRenderer;
    ef(a: number, b: ScalerParams): number;
    m1(a: number, b: boolean, c: boolean, d: number, e: number): number;
    m0(a: number): number;
    m2(a: number): number;
    ei(a: number, b: ScalerParams): number;
    m4: number;
    mu: number;
    m3: number;
    mt: number;
    protected hr(a: any, b: string, c: any, d: any): void;
    protected mw: number;
    m9(a: Axis): void;
    private mn;
    get mo(): Axis;
    set mo(a: Axis);
    aj(): Axis;
    kn(): NumericAxisRenderingParameters;
    km(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    private na;
    private m5;
    mz(): number;
    mc(a: AxisRangeChangedEventArgs): void;
    protected h4(a: boolean): void;
    protected ij(a: Rect, b: Rect): void;
    m8(a: GeometryGroup, b: Rect, c: Rect, d: Rect, e: Rect): void;
    protected get_a1(): AxisOrientation;
    get a1(): AxisOrientation;
    jz(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AngleAxisLabelPanelView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected ax: AngleAxisLabelPanel;
    constructor(a: AngleAxisLabelPanel);
    am(): void;
    ay(a: List$1<Rect>, b: List$1<boolean>): void;
    o(): number;
    p(): number;
    q(): number;
    r(): number;
}
/**
 * @hidden
 */
export declare class CategoryAngleAxisView extends CategoryAxisBaseView {
    static $t: Type;
    protected bg: CategoryAngleAxis;
    constructor(a: CategoryAngleAxis);
    ag(): void;
}
/**
 * @hidden
 */
export declare class NumericAngleAxisView extends NumericAxisBaseView {
    static $t: Type;
    protected bg: NumericAngleAxis;
    constructor(a: NumericAngleAxis);
    ag(): void;
}
/**
 * @hidden
 */
export declare class NumericRadiusAxisView extends NumericAxisBaseView {
    static $t: Type;
    protected bg: NumericRadiusAxis;
    constructor(a: NumericRadiusAxis);
    ag(): void;
}
