import { Base, INotifyPropertyChanged, IEnumerable, Type, PropertyChangedEventArgs } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { IDomainChartWidget } from "./IDomainChartWidget";
import { XamDataChart } from "./XamDataChart";
import { DataSeriesAdapterImplementation } from "igniteui-react-core";
import { DataSeriesType } from "igniteui-react-core";
import { IDataSeriesAdapterRule } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { IAnnotationLayerProxy } from "./IAnnotationLayerProxy";
import { Color } from "igniteui-react-core";
import { DomainType } from "./DomainType";
import { BrushCollection } from "igniteui-react-core";
import { IChartLegend } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { UnknownValuePlotting } from "igniteui-react-core";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { MarkerTypeCollection } from "./MarkerTypeCollection";
import { MarkerAutomaticBehavior } from "./MarkerAutomaticBehavior";
import { TrendLineType } from "igniteui-react-core";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
import { SeriesHighlightingMode } from "./SeriesHighlightingMode";
import { SeriesHighlightingBehavior } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode } from "./LegendHighlightingMode";
import { LegendItemBadgeShape } from "./LegendItemBadgeShape";
import { LegendItemBadgeMode } from "./LegendItemBadgeMode";
import { ToolTipType } from "./ToolTipType";
import { CrosshairsDisplayMode } from "./CrosshairsDisplayMode";
import { Series } from "./Series";
import { DataSeries } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ObservableColorCollection } from "igniteui-react-core";
import { DataSeriesMarker } from "igniteui-react-core";
import { ChartSeriesEventArgs } from "./ChartSeriesEventArgs";
import { DomainChartSeriesPointerEventArgs } from "./DomainChartSeriesPointerEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
/**
 * @hidden
 */
export declare abstract class DomainChart extends Base implements INotifyPropertyChanged {
    static $t: Type;
    protected ff: any;
    provideContainer(a: any): void;
    destroy(): void;
    private jo;
    protected jp(): void;
    protected jl(a: XamDataChart): void;
    protected ji(): void;
    protected jr(a: Series, b: number): void;
    protected kb(a: string, b: any, c: any): void;
    private fe;
    get tooltipTemplate(): any;
    set tooltipTemplate(a: any);
    private c1;
    get tooltipTemplates(): List$1<any>;
    set tooltipTemplates(a: List$1<any>);
    private dq;
    get eg(): number;
    set eg(a: number);
    private fd;
    private get toolTip();
    private set toolTip(value);
    private d3;
    get et(): number;
    set et(a: number);
    private d4;
    get eu(): number;
    set eu(a: number);
    private d5;
    get ev(): number;
    set ev(a: number);
    private d2;
    get es(): number;
    set es(a: number);
    private dy;
    get eo(): number;
    set eo(a: number);
    private d0;
    get eq(): number;
    set eq(a: number);
    private dz;
    get ep(): number;
    set ep(a: number);
    private dx;
    get en(): number;
    set en(a: number);
    private ld;
    get ls(): Brush;
    set ls(a: Brush);
    private le;
    get lt(): Brush;
    set lt(a: Brush);
    private dm;
    protected get_ed(): number;
    protected set_ed(a: number): void;
    get ed(): number;
    set ed(a: number);
    private d6;
    get ew(): number;
    set ew(a: number);
    private dw;
    get em(): number;
    set em(a: number);
    private dk;
    get eb(): number;
    set eb(a: number);
    private e5;
    get fb(): number;
    set fb(a: number);
    private br;
    get bs(): (time: number) => number;
    set bs(a: (time: number) => number);
    protected jm(a: XamDataChart): void;
    protected js(a: Series, b: number): void;
    protected jj(): void;
    private jt;
    ey: (arg1: HTMLElement) => any[];
    private kz;
    private fh;
    private cv;
    private ez;
    protected kc(a: string, b: any, c: any): void;
    private an;
    get ao(): IDomainChartWidget;
    set ao(a: IDomainChartWidget);
    private ft;
    get h8(): string;
    set h8(a: string);
    private fv;
    get ik(): string;
    set ik(a: string);
    private bp;
    get dataChart(): XamDataChart;
    set dataChart(a: XamDataChart);
    ac: DataSeriesAdapterImplementation;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    constructor();
    protected jn(): void;
    protected abstract get c7(): List$1<DataSeriesType>;
    protected abstract get c6(): List$1<IDataSeriesAdapterRule>;
    protected c5: List$1<MarkerType>;
    protected cr(a: DataSeriesType): boolean;
    notifyResized(): void;
    j1(): void;
    i8(): void;
    jg(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected kh(a: string): void;
    protected abstract i9(a: (arg1: Axis) => void, b: boolean): void;
    protected ja(a: (arg1: Series) => void): void;
    protected jb(a: (arg1: Series, arg2: number) => void): void;
    protected je(a: (arg1: Series) => void): void;
    protected jf(a: (arg1: Series, arg2: number) => void): void;
    protected jc(a: (arg1: Series) => void): void;
    protected jd(a: (arg1: Series, arg2: number) => void): void;
    kq(): void;
    protected j3(a: (arg1: XamDataChart) => void): void;
    protected j4(a: (arg1: XamDataChart) => void, b: boolean): void;
    protected j5(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    protected cs(a: DataSeries): boolean;
    protected ck(): boolean;
    private static readonly fn;
    private e4;
    protected g1(a: DataSeries): string;
    private static fm;
    protected g2(a: DataSeries, b: DataSeriesType): string;
    protected abstract ab(a: DataSeries): DataSeriesType;
    protected abstract bb(a: DataSeries, b: DataSeriesType): Series;
    g0(): string;
    private cp;
    protected kt(): void;
    protected bc(seriesType_: DataSeriesType): Series;
    private a6;
    private a8;
    private a9;
    private ba;
    private a7;
    private aj;
    protected get ak(): IAnnotationLayerProxy;
    private get ci();
    private cj;
    private k0;
    protected cl(): boolean;
    protected cm(): boolean;
    protected c3(a: string, b: boolean): List$1<Series>;
    protected ky(a: Series, b: Series, c: DataSeries): void;
    protected abstract ks(a: DataSeries): void;
    protected abstract kr(a: DataSeries): void;
    protected kv(): void;
    private kw;
    protected kx(a: Series): void;
    protected abstract ku(): void;
    private j6;
    protected i6(): void;
    protected ln(a: number): Brush;
    protected lq(a: number): Brush;
    protected lo(a: number): Brush;
    protected lp(a: number): Brush;
    protected lu(a: number): Color;
    protected bt(a: Color): ObservableColorCollection;
    protected o(a: Color): BrushCollection;
    protected c0: List$1<Color>;
    protected get c2(): List$1<Color>;
    fg(): any;
    ju(a: string, b: string): void;
    jv(a: string, b: string, c: Series): void;
    a1(a: DataSeriesMarker): MarkerType;
    j0(source_: any, a: number, b: any, c: any): void;
    jw(source_: any): void;
    jx(source_: any, a: number, b: any): void;
    jy(source_: any, a: number, b: any): void;
    seriesAdded: (sender: any, args: ChartSeriesEventArgs) => void;
    ki(a: Series): void;
    seriesRemoved: (sender: any, args: ChartSeriesEventArgs) => void;
    ko(a: Series): void;
    seriesPointerEnter: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    kk(a: Series, b: any): void;
    seriesPointerLeave: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    kl(a: Series, b: any): void;
    seriesPointerMove: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    km(a: Series, b: any): void;
    seriesPointerDown: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    kj(a: Series, b: any): void;
    seriesPointerUp: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    kn(a: Series, b: any): void;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    kg(a: any, b: CalloutStyleUpdatingEventArgs): void;
    private c4;
    ke(a: () => void): void;
    private bu;
    kf(a: () => void, b: boolean): {
        p1?: boolean;
    };
    protected get_ct(): boolean;
    protected get ct(): boolean;
    protected jk(a: XamDataChart): void;
    protected s(a: BrushCollection): BrushCollection;
    protected lr(a: Brush): Brush;
    protected jq(a: Series, b: number): void;
    protected abstract i4(): void;
    protected get cc(): boolean;
    private bx;
    protected i7(): void;
    protected jh(): void;
    protected kp(a: XamDataChart): void;
    protected i3(a: Series, b: number): void;
    protected abstract i2(a: Series, b: number): void;
    protected a3(a: Series, b: number): MarkerType;
    protected a2(a: Series): MarkerType;
    protected df(): IEnumerable;
    protected get_cn(): boolean;
    protected get cn(): boolean;
    protected dg(): IEnumerable;
    protected ka(a: string, b: any, c: any): void;
    private j8;
    abstract get ai(): DomainType;
    private db;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    private c9;
    get actualItemsSource(): IEnumerable;
    set actualItemsSource(a: IEnumerable);
    private b;
    get d(): string[];
    set d(a: string[]);
    private a;
    get c(): string[];
    set c(a: string[]);
    private g;
    get n(): BrushCollection;
    set n(a: BrushCollection);
    private j;
    get r(): BrushCollection;
    set r(a: BrushCollection);
    private e;
    get l(): BrushCollection;
    set l(a: BrushCollection);
    private f;
    get m(): BrushCollection;
    set m(a: BrushCollection);
    private al;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    private b3;
    protected get_co(): boolean;
    protected set_co(a: boolean): void;
    get co(): boolean;
    set co(a: boolean);
    private b5;
    protected get_cu(): boolean;
    protected set_cu(a: boolean): void;
    get cu(): boolean;
    set cu(a: boolean);
    private b8;
    protected get_cy(): boolean;
    protected set_cy(a: boolean): void;
    get cy(): boolean;
    set cy(a: boolean);
    private b9;
    protected get_cz(): boolean;
    protected set_cz(a: boolean): void;
    get cz(): boolean;
    set cz(a: boolean);
    private b4;
    protected get_cq(): boolean;
    protected set_cq(a: boolean): void;
    get cq(): boolean;
    set cq(a: boolean);
    private lv;
    get lx(): Rect;
    set lx(a: Rect);
    get lw(): Rect;
    private fu;
    get ic(): string;
    set ic(a: string);
    private fs;
    get h1(): string;
    set h1(a: string);
    private k2;
    get k4(): HorizontalAlignment;
    set k4(a: HorizontalAlignment);
    private k1;
    get k3(): HorizontalAlignment;
    set k3(a: HorizontalAlignment);
    private bn;
    get bo(): UnknownValuePlotting;
    set bo(a: UnknownValuePlotting);
    private dv;
    protected get_el(): number;
    protected set_el(a: number): void;
    get el(): number;
    set el(a: number);
    private d1;
    get er(): number;
    set er(a: number);
    private bh;
    get bi(): SeriesOutlineMode;
    set bi(a: SeriesOutlineMode);
    private az;
    get a0(): MarkerOutlineMode;
    set a0(a: MarkerOutlineMode);
    private ax;
    get ay(): MarkerFillMode;
    set ay(a: MarkerFillMode);
    private dn;
    get ee(): number;
    set ee(a: number);
    private dp;
    get ef(): number;
    set ef(a: number);
    private a4;
    get a5(): MarkerTypeCollection;
    set a5(a: MarkerTypeCollection);
    private av;
    get aw(): MarkerAutomaticBehavior;
    set aw(a: MarkerAutomaticBehavior);
    private h;
    get p(): BrushCollection;
    set p(a: BrushCollection);
    private i;
    get q(): BrushCollection;
    set q(a: BrushCollection);
    private e3;
    get fa(): number;
    set fa(a: number);
    private dh;
    get d8(): number;
    set d8(a: number);
    private bw;
    get cb(): boolean;
    set cb(a: boolean);
    private k;
    get t(): BrushCollection;
    set t(a: BrushCollection);
    private bl;
    get bm(): TrendLineType;
    set bm(a: TrendLineType);
    private d7;
    get ex(): number;
    set ex(a: number);
    private bv;
    get ca(): boolean;
    set ca(a: boolean);
    private ds;
    get ei(): number;
    set ei(a: number);
    private du;
    get ek(): number;
    set ek(a: number);
    private dt;
    get ej(): number;
    set ej(a: number);
    private dr;
    get eh(): number;
    set eh(a: number);
    protected j9(): void;
    private x;
    get y(): ComputedPlotAreaMarginMode;
    set y(a: ComputedPlotAreaMarginMode);
    private bf;
    get bg(): SeriesHighlightingMode;
    set bg(a: SeriesHighlightingMode);
    private bd;
    get be(): SeriesHighlightingBehavior;
    set be(a: SeriesHighlightingBehavior);
    private ap;
    get aq(): LegendHighlightingMode;
    set aq(a: LegendHighlightingMode);
    private at;
    get au(): LegendItemBadgeShape;
    set au(a: LegendItemBadgeShape);
    private ar;
    get as(): LegendItemBadgeMode;
    set as(a: LegendItemBadgeMode);
    private b6;
    get cw(): boolean;
    set cw(a: boolean);
    private di;
    get d9(): number;
    set d9(a: number);
    private dj;
    get ea(): number;
    set ea(a: number);
    private e6;
    get fc(): number;
    set fc(a: number);
    private bj;
    get bk(): ToolTipType;
    set bk(a: ToolTipType);
    private z;
    get aa(): CrosshairsDisplayMode;
    set aa(a: CrosshairsDisplayMode);
    private b1;
    get cg(): boolean;
    set cg(a: boolean);
    private la;
    get lk(): Brush;
    set lk(a: Brush);
    private dl;
    get ec(): number;
    set ec(a: number);
    private k9;
    get lj(): Brush;
    set lj(a: Brush);
    private b0;
    get cf(): boolean;
    set cf(a: boolean);
    private k5;
    get lf(): Brush;
    set lf(a: Brush);
    private k7;
    get lh(): Brush;
    set lh(a: Brush);
    private k6;
    get lg(): Brush;
    set lg(a: Brush);
    private k8;
    get li(): Brush;
    set li(a: Brush);
    private e0;
    get e7(): number;
    set e7(a: number);
    private e1;
    get e8(): number;
    set e8(a: number);
    private b7;
    get cx(): boolean;
    set cx(a: boolean);
    private b2;
    get ch(): boolean;
    set ch(a: boolean);
    private lb;
    get ll(): Brush;
    set ll(a: Brush);
    private lc;
    get lm(): Brush;
    set lm(a: Brush);
    private e2;
    get e9(): number;
    set e9(a: number);
    private bz;
    get ce(): boolean;
    set ce(a: boolean);
    private by;
    get cd(): boolean;
    set cd(a: boolean);
    private da;
    get calloutsItemsSource(): IEnumerable;
    set calloutsItemsSource(a: IEnumerable);
    private fq;
    get gd(): string;
    set gd(a: string);
    private fr;
    get gf(): string;
    set gf(a: string);
    private fp;
    get f9(): string;
    set f9(a: string);
    private fo;
    get f6(): string;
    set f6(a: string);
}
