import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    get position(): number;
    set position(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _dataSource;
    get dataSource(): FinancialCalculationDataSource;
    set dataSource(a: FinancialCalculationDataSource);
    private _supportingCalculations;
    get supportingCalculations(): FinancialCalculationSupportingCalculations;
    set supportingCalculations(a: FinancialCalculationSupportingCalculations);
    private _basedOn;
    get basedOn(): IList$1<string>;
    set basedOn(a: IList$1<string>);
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    lo(a: SeriesView): void;
    qg: FinancialSeriesView;
    protected get_dk(): boolean;
    ag(): Axis[];
    hn(a: any, b: string): any;
    protected rz(): number;
    private rx;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    constructor();
    s5: Brush;
    oy(): Brush;
    oz(): Brush;
    kl(): void;
    pz: CategoryAxisBase;
    ql: NumericYAxis;
    sf: string;
    get qv(): IFastItemColumn$1<number>;
    set qv(a: IFastItemColumn$1<number>);
    private qq;
    r6: string;
    get qt(): IFastItemColumn$1<number>;
    set qt(a: IFastItemColumn$1<number>);
    private qo;
    sb: string;
    get qu(): IFastItemColumn$1<number>;
    set qu(a: IFastItemColumn$1<number>);
    private qp;
    r3: string;
    get qs(): IFastItemColumn$1<number>;
    set qs(a: IFastItemColumn$1<number>);
    private qn;
    sj: string;
    get qx(): IFastItemColumn$1<number>;
    set qx(a: IFastItemColumn$1<number>);
    private qr;
    q5: boolean;
    protected q0: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    q7(): boolean;
    protected sr(a: AssigningCategoryStyleEventArgs): void;
    protected p8: CategorySeriesRenderManager;
    protected sp(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    rp(a: Point): number;
    g9(a: Point, b: boolean): number;
    g7(a: Point, b: boolean): number;
    fw(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    pb(a: Point, b: boolean, c: boolean): Point;
    ga(a: Point, b: boolean, c: boolean): number;
    f6(a: Point, b: boolean, c: boolean): number;
    f8(a: Point, b: boolean, c: boolean): number;
    rr(a: Point, b: boolean, c: boolean): number;
    rs(a: Point, b: boolean, c: boolean): number;
    rt(a: Point, b: boolean, c: boolean): number;
    o7(a: Point, b: boolean, c: boolean): Point;
    o9(a: Point, b: boolean, c: boolean): Point;
    s7(a: Point, b: boolean, c: boolean): Point;
    s6(a: Point, b: boolean, c: boolean): Point;
    s8(a: Point, b: boolean, c: boolean): Point;
    k5(): void;
    protected mu(a: Rect, b: Rect): void;
    protected mt(a: Rect, b: Rect): void;
    protected ra: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected rb: Dictionary$2<string, string>;
    private qw;
    private so;
    private qz;
    protected lt(a: any, b: string, c: any, d: any): void;
    q2(a: any): boolean;
    q1(a: any): boolean;
    protected ps(a: number, b: number, c: Axis): any[];
    protected rw(a: SeriesView): number;
    protected ry(a: SeriesView): number;
    pr(a: number, b: number): any[];
    private qj;
    protected get_dt(): boolean;
    km(): void;
    av(a: any, b: Point, c: boolean): HighlightingInfo;
    r0(a: Point): number;
    protected qi(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected qh(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected q3(): boolean;
    fy(a: Point): number;
    g3(a: Point): number;
    protected get_d5(): boolean;
    ar(): CategoryAxisBase;
    g5(a: Point): number;
    hk(a: Point): any;
    p3: CategoryFrame;
    p5: CategoryFrame;
    p1: CategoryFrame;
    p2(): CategoryFrame;
    protected rq(a: Rect, b: Rect, c: Rect): number;
    qa: CategoryTransitionInMode;
    q6: boolean;
    protected em(): boolean;
    protected p9(): CategoryTransitionInMode;
    protected b7(): TransitionInSpeedType;
    ss(a: CategoryFrame, b: FinancialSeriesView): void;
    sq(a: CategoryFrame, b: FinancialSeriesView): void;
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    qb: CategoryTransitionSourceFramePreparer;
    ru(a: FinancialSeriesView): number;
    protected kp(): void;
    l8(a: boolean): void;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected q8(a: IList$1<string>): boolean;
    get q9(): boolean;
    protected q4(): boolean;
    protected sn(a: FinancialEventArgs): void;
    protected get rh(): IEnumerable$1<number>;
    private _re;
    private re;
    protected get rg(): IEnumerable$1<number>;
    private _rd;
    private rd;
    protected get rf(): IEnumerable$1<number>;
    private _rc;
    private rc;
    rj(a: IList$1<number>): IList$1<number>;
    private qy;
    protected ri(): IList$1<string>;
    private rn;
    getOpenColumnAsArray(): number[];
    private rl;
    getHighColumnAsArray(): number[];
    private rm;
    getLowColumnAsArray(): number[];
    private rk;
    getCloseColumnAsArray(): number[];
    private ro;
    getVolumeColumnAsArray(): number[];
    protected kr(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected qc(a: number, b: number): FinancialCalculationDataSource;
    rv(a: number): number;
    protected qd(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    get categoryAxis(): CategoryAxisBase;
    private p4;
    l9(a: Rect, b: RenderSurface): void;
    private p0;
    l6(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    an(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private p6;
    get p7(): CategoryMode;
    set p7(a: CategoryMode);
    protected get_dz(): boolean;
    mc(a: Brush, b: Brush): void;
    private st;
    private qk;
    private qm;
    hm(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    get openColumn(): IList$1<number>;
    set openColumn(a: IList$1<number>);
    private _closeColumn;
    get closeColumn(): IList$1<number>;
    set closeColumn(a: IList$1<number>);
    private _highColumn;
    get highColumn(): IList$1<number>;
    set highColumn(a: IList$1<number>);
    private _lowColumn;
    get lowColumn(): IList$1<number>;
    set lowColumn(a: IList$1<number>);
    private _volumeColumn;
    get volumeColumn(): IList$1<number>;
    set volumeColumn(a: IList$1<number>);
    private _indicatorColumn;
    get indicatorColumn(): IList$1<number>;
    set indicatorColumn(a: IList$1<number>);
    private _typicalColumn;
    get typicalColumn(): CalculatedColumn;
    set typicalColumn(a: CalculatedColumn);
    private _trueRange;
    get trueRange(): CalculatedColumn;
    set trueRange(a: CalculatedColumn);
    private _trueLow;
    get trueLow(): CalculatedColumn;
    set trueLow(a: CalculatedColumn);
    private _period;
    get period(): number;
    set period(a: number);
    private _shortPeriod;
    get shortPeriod(): number;
    set shortPeriod(a: number);
    private _longPeriod;
    get longPeriod(): number;
    set longPeriod(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _calculateFrom;
    get calculateFrom(): number;
    set calculateFrom(a: number);
    private _calculateCount;
    get calculateCount(): number;
    set calculateCount(a: number);
    private _multiplier;
    get multiplier(): number;
    set multiplier(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
    private _specifiesRange;
    get specifiesRange(): boolean;
    set specifiesRange(a: boolean);
    private _series;
    get series(): FinancialSeries;
    set series(a: FinancialSeries);
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    bz: FinancialSeries;
    bx: FinancialBucketCalculator;
    b1: number;
    b0(a: CategoryFrame): boolean;
    b2(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract by(): FinancialBucketCalculator;
    as(): void;
    getDefaultTooltipTemplate(): string;
    protected af(): void;
}
