import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IndicatorDisplayType } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { SeriesView } from "./SeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { Axis } from "./Axis";
import { Point, IList$1, Type } from "igniteui-react-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-react-core";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Clipper } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { LegendItemBadgeShape } from "./LegendItemBadgeShape";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class FinancialIndicator extends FinancialSeries implements ITrendLineSeries {
    static $t: Type;
    protected get_dl(): boolean;
    protected bv(): SeriesView;
    lo(a: SeriesView): void;
    ta: FinancialIndicatorView;
    constructor();
    tn(a: boolean): void;
    protected tf(a: Point, b: Point, c: boolean): boolean;
    protected bp(): SeriesHitTestMode;
    pk(a: Point): Rect;
    er(a: Point, b: boolean): boolean;
    protected kr(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    tc: IndicatorDisplayType;
    protected get_tb(): IndicatorDisplayType;
    get tb(): IndicatorDisplayType;
    ti: number;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get t0(): Brush;
    set t0(a: Brush);
    static readonly tq: DependencyProperty;
    trendLineThickness: number;
    t2: PenLineCap;
    t1: DoubleCollection;
    trendLinePeriod: number;
    protected tk(): number;
    tj: number;
    private _indicatorColumn;
    get indicatorColumn(): List$1<number>;
    set indicatorColumn(a: List$1<number>);
    protected s9: AxisRange;
    protected abstract td(a: number, b: number): boolean;
    protected abstract tg(a: number, b: number): IList$1<string>;
    protected lt(a: any, b: string, c: any, d: any): void;
    ga(a: Point, b: boolean, c: boolean): number;
    g9(a: Point, b: boolean): number;
    g7(a: Point, b: boolean): number;
    protected get_e4(): boolean;
    private te;
    private tp;
    ap(a: Axis): AxisRange;
    ej(a: any): boolean;
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    sq(a: CategoryFrame, b: FinancialSeriesView): void;
    ko(a: boolean, b: SeriesView): void;
    protected p9(): CategoryTransitionInMode;
    ss(a: CategoryFrame, b: FinancialSeriesView): void;
    protected mk(): void;
    protected to(): void;
    protected ky(a: any): void;
    protected a9(a: LegendItemBadgeShape): LegendItemBadgeShape;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
    static $t: Type;
    constructor(a: FinancialSeriesView);
    protected f: FinancialIndicatorView;
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class FinancialIndicatorView extends FinancialSeriesView {
    static $t: Type;
    b3: FinancialIndicator;
    constructor(a: FinancialIndicator);
    protected by(): FinancialBucketCalculator;
    as(): void;
    private readonly b6;
    private cg;
    private b9;
    cu: Path;
    cq: Path;
    cv: Path;
    cr: Path;
    cw: Path;
    cs: Path;
    ct: Path;
    cp: Path;
    private b4;
    get b5(): ITrendLineManager;
    set b5(a: ITrendLineManager);
    get b7(): boolean;
    b8(a: boolean): void;
    ce(): void;
    cc(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: Clipper): void;
    ca(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number, f: Clipper): void;
    cb(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number): void;
    cf(): void;
    private cm;
    private co;
    private cn;
    private cl;
    private ci;
    private ck;
    private cj;
    private ch;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected a5(a: RenderingContext, b: boolean): void;
    al(a: any): void;
    cd(): void;
}
