import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { TrendLineType } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { PriceDisplayType } from "./PriceDisplayType";
import { SeriesView } from "./SeriesView";
import { Type, Point } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { ITrendLineManager } from "./ITrendLineManager";
import { Axis } from "./Axis";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { Pool$1 } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { GeometryGroup } from "igniteui-react-core";
import { LegendItemBadgeShape } from "./LegendItemBadgeShape";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class FinancialPriceSeries extends FinancialSeries implements ITrendLineSeries {
    static $t: Type;
    protected get_dn(): boolean;
    protected bv(): SeriesView;
    lo(a: SeriesView): void;
    ta: FinancialPriceSeriesView;
    constructor();
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get tu(): Brush;
    set tu(a: Brush);
    static readonly tk: DependencyProperty;
    trendLineThickness: number;
    tx: PenLineCap;
    tw: DoubleCollection;
    trendLinePeriod: number;
    te: number;
    protected kr(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    tb: PriceDisplayType;
    protected bp(): SeriesHitTestMode;
    pk(a: Point): Rect;
    private s9;
    ak(a: Point): Rect[];
    er(a: Point, b: boolean): boolean;
    protected eu(a: Point, b: boolean): boolean;
    protected lt(a: any, b: string, c: any, d: any): void;
    private tj;
    ap(a: Axis): AxisRange;
    aq(a: Rect): AxisRange;
    f4(): number;
    ej(a: any): boolean;
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    sq(a: CategoryFrame, b: FinancialSeriesView): void;
    ko(a: boolean, b: SeriesView): void;
    protected mt(a: Rect, b: Rect): void;
    pp(): Thickness;
    protected get_cz(): boolean;
    ss(a: CategoryFrame, b: FinancialSeriesView): void;
    f3(): number;
    private ti;
    private tc;
    private th;
    hq(a: any, b: Point): any;
    protected mk(): void;
    protected ky(a: any): void;
    tv: Brush;
    oz(): Brush;
    mc(a: Brush, b: Brush): void;
    protected a9(a: LegendItemBadgeShape): LegendItemBadgeShape;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialPriceSeriesView extends FinancialSeriesView {
    static $t: Type;
    protected b3: FinancialPriceSeries;
    constructor(a: FinancialPriceSeries);
    b6: Pool$1<Path>;
    co(): Path;
    protected b9: List$1<Path>;
    ce(a: Path): void;
    cg(a: Path): void;
    cf(a: Path): void;
    protected by(): FinancialBucketCalculator;
    as(): void;
    private cn;
    private cm;
    private b4;
    get b5(): ITrendLineManager;
    set b5(a: ITrendLineManager);
    get b7(): boolean;
    ch(): void;
    cb(): void;
    ca(): void;
    ck(): GeometryGroup;
    cj(): GeometryGroup;
    ci(): void;
    protected bb(): void;
    protected bc(): void;
    protected ac(a: number): any;
    private cl;
    protected ab(a: number): any;
    protected a6(a: RenderingContext, b: boolean): void;
    protected a5(a: RenderingContext, b: boolean): void;
    al(a: any): void;
    cc(): void;
    b8: boolean;
    cd(): void;
}
