import { MarkerSeries } from "./MarkerSeries";
import { Point, Type } from "igniteui-react-core";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Axis } from "./Axis";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { OwnedPoint } from "./OwnedPoint";
import { HashPool$2 } from "igniteui-react-core";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { AssigningPolarStyleEventArgs } from "./AssigningPolarStyleEventArgs";
import { AssigningPolarMarkerStyleEventArgs } from "./AssigningPolarMarkerStyleEventArgs";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-react-core";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class PolarBase extends MarkerSeries {
    static $t: Type;
    protected bv(): SeriesView;
    lo(a: SeriesView): void;
    rl: PolarBaseView;
    private rm;
    kl(): void;
    protected get_d2(): boolean;
    cy(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    constructor();
    private tc;
    private te;
    private q8;
    rk: PolarAxisInfoCache;
    private uc;
    private ub;
    ry: SeriesRenderer$2<PolarFrame, PolarBaseView>;
    sx: string;
    s7: string;
    protected get r2(): IFastItemColumn$1<number>;
    protected set r2(a: IFastItemColumn$1<number>);
    private r0;
    protected get r3(): IFastItemColumn$1<number>;
    protected set r3(a: IFastItemColumn$1<number>);
    private r1;
    rh: NumericAngleAxis;
    ri: NumericRadiusAxis;
    sh: boolean;
    sr: number;
    rz: TrendLineType;
    t6: Brush;
    get t5(): Brush;
    set t5(a: Brush);
    static readonly tm: DependencyProperty;
    sp: number;
    t8: PenLineCap;
    t7: DoubleCollection;
    ss: number;
    st: number;
    r8: boolean;
    rq: PolarFrame;
    rs: PolarFrame;
    ro: PolarFrame;
    rp(): PolarFrame;
    rj: PolarAxes;
    k5(): void;
    protected kr(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected mt(a: Rect, b: Rect): void;
    protected mu(a: Rect, b: Rect): void;
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    l8(a: boolean): void;
    private ua;
    ap(a: Axis): AxisRange;
    ej(a: any): boolean;
    hk(a: Point): any;
    g3(a: Point): number;
    fy(a: Point): number;
    protected sl(a: Point): number;
    protected sk(a: Point): number;
    private r9;
    private si;
    private so;
    protected sn(a: Point): number;
    protected sm(a: Point): number;
    pb(a: Point, b: boolean, c: boolean): Point;
    ag(): Axis[];
    hn(a: any, b: string): any;
    protected lt(a: any, b: string, c: any, d: any): void;
    private ru;
    get rv(): ScatterItemSearchMode;
    set rv(a: ScatterItemSearchMode);
    protected rw(): ScatterItemSearchMode;
    protected get_sc(): boolean;
    protected get sc(): boolean;
    protected se(): boolean;
    protected sd(): boolean;
    rx: ScatterItemSearchMode;
    sq: number;
    r7(a: any): boolean;
    r6(a: any): boolean;
    ko(a: boolean, b: SeriesView): void;
    private q9;
    tb(a: PolarFrame, b: number, c: Rect, d: Rect): void;
    th(a: PolarFrame, b: PolarBaseView): void;
    sb: boolean;
    sa: boolean;
    protected r5: boolean;
    protected r4: boolean;
    protected get_dt(): boolean;
    private rf;
    private rg;
    protected rd(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected re(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected rc(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    av(a: any, b: Point, c: boolean): HighlightingInfo;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningPolarStyle: (sender: any, args: AssigningPolarStyleEventArgs) => void;
    assigningPolarMarkerStyle: (sender: any, args: AssigningPolarMarkerStyleEventArgs) => void;
    protected sg(): boolean;
    protected sf(): boolean;
    tl(a: PolarFrame, b: PolarBaseView): void;
    q6(a: number, b: number): any[];
    protected q7(a: number, b: number): any[];
    protected rt: PolarSeriesRenderManager;
    td(a: PolarBaseView, b: PolarFrame): void;
    protected tg(a: number, b: number, c: boolean): void;
    protected tf(a: number, b: number, c: boolean): void;
    protected tj(a: AssigningPolarStyleEventArgs): void;
    protected ti(a: AssigningPolarMarkerStyleEventArgs): void;
    private ta;
    protected mk(): void;
    rr: PolarFrame;
    l9(a: Rect, b: RenderSurface): void;
    private rn;
    l6(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    tk(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    q5(a: HashPool$2<any, Marker>, b: Rect, c: Rect): Point[];
    sj(a: HashPool$2<any, Marker>): List$1<number>;
    t9(a: number): Point;
    protected ky(a: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PolarSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    au: AssigningPolarMarkerStyleEventArgs;
    av: AssigningPolarStyleEventArgs;
    aw(a: PolarBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ax(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ay(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class PolarBaseView extends MarkerSeriesView {
    static $t: Type;
    protected cu: PolarBase;
    ct: MarkerManagerBase;
    constructor(a: PolarBase);
    cv: PolarTrendLineManager;
    as(): void;
    cz(a: (arg1: Marker) => void): void;
    protected cs(): MarkerManagerBase;
    protected c0(a: IDictionary$2<any, OwnedPoint>): void;
    protected cr(): Point[];
    protected cx(): List$1<number>;
    cy(a: Rect, b: Rect, c: Rect, d: Rect): void;
    c1(): void;
    cw: HashPool$2<any, Marker>;
    cf(a: (arg1: Marker) => void): void;
    protected a5(a: RenderingContext, b: boolean): void;
    protected c2(): Rect;
    getDefaultTooltipTemplate(): string;
}
