import { Base, Type, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { RadialFrame } from "./RadialFrame";
import { HighlightingInfo } from "./HighlightingInfo";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { AssigningRadialStyleEventArgs } from "./AssigningRadialStyleEventArgs";
import { AssigningRadialMarkerStyleEventArgs } from "./AssigningRadialMarkerStyleEventArgs";
import { RadialAxes } from "./RadialAxes";
import { Pool$1 } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class RadialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: RadialBaseView;
    constructor(a: RadialBaseView);
    c: number;
    d: number;
    b: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class RadialBase extends MarkerSeries implements IHasCategoryModePreference {
    static $t: Type;
    lo(a: SeriesView): void;
    rh: RadialBaseView;
    constructor();
    private r9;
    get categoryAxis(): CategoryAxisBase;
    ar(): CategoryAxisBase;
    q5(a: number, b: number): any[];
    protected rm: RadialSeriesRenderManager;
    cy(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    private r4;
    rn: SeriesRenderer$2<RadialFrame, RadialBaseView>;
    protected get_d6(): boolean;
    ru: boolean;
    rt: boolean;
    protected rp: boolean;
    protected ro: boolean;
    protected get_dt(): boolean;
    private rd;
    private re;
    protected ra(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected rb(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected rc(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    av(a: any, b: Point, c: boolean): HighlightingInfo;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningRadialStyle: (sender: any, args: AssigningRadialStyleEventArgs) => void;
    assigningRadialMarkerStyle: (sender: any, args: AssigningRadialMarkerStyleEventArgs) => void;
    protected ry(): boolean;
    protected rx(): boolean;
    protected sc(a: AssigningRadialStyleEventArgs): void;
    protected sb(a: AssigningRadialMarkerStyleEventArgs): void;
    r0(a: SeriesView): number;
    r1(a: SeriesView): number;
    q8: CategoryAngleAxis;
    rf: NumericRadiusAxis;
    ag(): Axis[];
    rs: boolean;
    protected mu(a: Rect, b: Rect): void;
    protected mt(a: Rect, b: Rect): void;
    abstract preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected lt(a: any, b: string, c: any, d: any): void;
    protected rw(): boolean;
    protected rv(): boolean;
    rr(a: any): boolean;
    rq(a: any): boolean;
    hk(a: Point): any;
    rz(a: Point): number;
    fy(a: Point): number;
    g3(a: Point): number;
    ej(a: any): boolean;
    rk: RadialFrame;
    rl: RadialFrame;
    ri: RadialFrame;
    rj(): RadialFrame;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    abstract sa(a: RadialFrame, b: RadialBaseView): void;
    abstract sd(a: RadialFrame, b: RadialBaseView): void;
    rg: RadialAxes;
    k5(): void;
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    l8(a: boolean): void;
    r2(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RadialBaseView extends MarkerSeriesView {
    static $t: Type;
    cs: RadialBucketCalculator;
    cr: RadialBase;
    constructor(a: RadialBase);
    ct: Pool$1<Marker>;
    cf(a: (arg1: Marker) => void): void;
    cu: number;
    cv: Point;
}
