import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "./HighlightingInfo";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-react-core";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-react-core";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected bv(): SeriesView;
    kl(): void;
    lo(a: SeriesView): void;
    rl: ScatterBaseView;
    protected get_d8(): boolean;
    ag(): Axis[];
    hn(a: any, b: string): any;
    cy(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    protected bp(): SeriesHitTestMode;
    pm(a: Point): Rect;
    er(a: Point, b: boolean): boolean;
    constructor();
    rk: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    sx: string;
    get r0(): IFastItemColumn$1<number>;
    set r0(a: IFastItemColumn$1<number>);
    private ry;
    s1: string;
    get r1(): IFastItemColumn$1<number>;
    set r1(a: IFastItemColumn$1<number>);
    private rz;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get t8(): Brush;
    set t8(a: Brush);
    static readonly tp: DependencyProperty;
    trendLineThickness: number;
    ua: PenLineCap;
    t9: DoubleCollection;
    trendLinePeriod: number;
    rc: CollisionAvoidanceType;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    sm: number;
    sl: number;
    rw: ScatterItemSearchMode;
    sk: number;
    k5(): void;
    rm: ScatterErrorBarSettings;
    protected lt(a: any, b: string, c: any, d: any): void;
    protected sb(): boolean;
    protected sa(): boolean;
    r5(a: any): boolean;
    r4(a: any): boolean;
    private to;
    private ub;
    private uc;
    private s3;
    protected r9(a: string, b: FastItemsSourceEventAction): boolean;
    protected kr(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    tf(a: ScatterFrame): void;
    tg(a: ScatterFrame, b: Clipper): void;
    ap(a: Axis): AxisRange;
    hk(a: Point): any;
    private rt;
    get ru(): ScatterItemSearchMode;
    set ru(a: ScatterItemSearchMode);
    protected rv(): ScatterItemSearchMode;
    g3(a: Point): number;
    fy(a: Point): number;
    protected sg(a: Point): number;
    private q5;
    private q6;
    protected sf(a: Point): number;
    private s6;
    protected get_r8(): boolean;
    protected get r8(): boolean;
    private sj;
    protected si(a: Point): number;
    protected sh(a: Point): number;
    pb(a: Point, b: boolean, c: boolean): Point;
    ej(a: any): boolean;
    protected mt(a: Rect, b: Rect): void;
    protected mu(a: Rect, b: Rect): void;
    rq: ScatterFrame;
    rs: ScatterFrame;
    ro: ScatterFrame;
    rp(): ScatterFrame;
    s4(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    tc(a: ScatterFrame, b: ScatterBaseView): void;
    ko(a: boolean, b: SeriesView): void;
    r7: boolean;
    r6: boolean;
    protected r3: boolean;
    protected r2: boolean;
    protected get_dt(): boolean;
    private rg;
    private rh;
    protected re(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected rf(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    pp(): Thickness;
    protected rd(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    av(a: any, b: Point, c: boolean): HighlightingInfo;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    protected sd(): boolean;
    protected sc(): boolean;
    tn(a: ScatterFrame, b: ScatterBaseView): void;
    q8(a: number, b: number): any[];
    protected q9(a: number, b: number): any[];
    protected rx: ScatterSeriesRenderManager;
    s5(a: ScatterBaseView, b: ScatterFrame): void;
    protected s8(a: number, b: number, c: boolean): void;
    protected s7(a: number, b: number, c: boolean): void;
    protected ti(a: AssigningScatterStyleEventArgs): void;
    protected th(a: AssigningScatterMarkerStyleEventArgs): void;
    ta(a: ScatterFrame, b: ScatterBaseView): void;
    td(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    tb(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    s9(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    te(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    tk(a: ScatterFrame, b: ScatterBaseView): void;
    private tl;
    private tm;
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    l8(a: boolean): void;
    protected mk(): void;
    rr: ScatterFrame;
    l9(a: Rect, b: RenderSurface): void;
    private rn;
    l6(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    tj(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    q7(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    se(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected ky(a: any): void;
    f4(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    au: AssigningScatterMarkerStyleEventArgs;
    av: AssigningScatterStyleEventArgs;
    aw(a: ScatterBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ax(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ay(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    cv: MarkerManagerBase;
    protected ct: Point[];
    protected cw: ScatterBase;
    protected c1: List$1<number>;
    constructor(a: ScatterBase);
    private dc;
    private dd;
    cx: ScatterTrendLineManager;
    as(): void;
    private db;
    de(a: Marker): Size;
    protected cu(): MarkerManagerBase;
    protected c9(a: IDictionary$2<any, OwnedPoint>): void;
    c0(): List$1<Marker>;
    cs(): Point[];
    protected cr(): Point[];
    protected cz(): List$1<number>;
    c2(): void;
    c7(a: PathGeometry): void;
    c3(): void;
    c8(a: PathGeometry): void;
    da(): void;
    cy: HashPool$2<any, Marker>;
    cf(a: (arg1: Marker) => void): void;
    c5(a: (arg1: Marker) => void): void;
    c6(): void;
    protected a5(a: RenderingContext, b: boolean): void;
    c4(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
