import { Control } from "igniteui-react-core";
import { INotifyPropertyChanged, Type, Base, Point, EventArgs, PropertyChangedEventArgs, IEnumerable, IEnumerable$1, IList$1 } from "igniteui-react-core";
import { ILegendOwner } from "igniteui-react-core";
import { IInternalLegendOwner } from "igniteui-react-core";
import { IDataLegendTarget } from "igniteui-react-core";
import { ISeriesViewerWidget } from "./ISeriesViewerWidget";
import { SRProvider } from "igniteui-react-core";
import { SeriesViewerScrollbarMode } from "./SeriesViewerScrollbarMode";
import { DoubleAnimator } from "igniteui-react-core";
import { BrushCollection } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { DependencyObject } from "igniteui-react-core";
import { MarkerAutomaticBehavior } from "./MarkerAutomaticBehavior";
import { IChartLegend } from "igniteui-react-core";
import { SeriesHighlightingMode } from "./SeriesHighlightingMode";
import { SeriesViewerHorizontalScrollbarPosition } from "./SeriesViewerHorizontalScrollbarPosition";
import { SeriesViewerVerticalScrollbarPosition } from "./SeriesViewerVerticalScrollbarPosition";
import { Brush } from "igniteui-react-core";
import { SeriesHighlightingBehavior } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode } from "./LegendHighlightingMode";
import { LegendItemBadgeShape } from "./LegendItemBadgeShape";
import { LegendItemBadgeMode } from "./LegendItemBadgeMode";
import { Rect } from "igniteui-react-core";
import { ChartHitTestMode } from "./ChartHitTestMode";
import { InteractionState } from "igniteui-react-core";
import { WindowResponse } from "./WindowResponse";
import { Visibility } from "igniteui-react-core";
import { IOverviewPlusDetailPane } from "igniteui-react-core";
import { SeriesViewerComponentsFromView } from "./SeriesViewerComponentsFromView";
import { ZoomCoercionMode } from "./ZoomCoercionMode";
import { ModifierKeys } from "igniteui-react-core";
import { DataTemplate } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { CanvasRenderScheduler } from "igniteui-react-core";
import { SyncSettings } from "./SyncSettings";
import { SeriesViewerComponentsForView } from "./SeriesViewerComponentsForView";
import { Dictionary$2 } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { IDataLegend } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
import { NotifyCollectionChangedEventArgs } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { FrameworkElement } from "igniteui-react-core";
import { EventProxy } from "igniteui-react-core";
import { MouseEventArgs } from "igniteui-react-core";
import { MouseButtonEventArgs } from "igniteui-react-core";
import { Tuple$2 } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesViewerManipulationEventArgs } from "./SeriesViewerManipulationEventArgs";
import { Key } from "igniteui-react-core";
import { CultureInfo } from "igniteui-react-core";
import { RectChangedEventArgs } from "igniteui-react-core";
import { RefreshCompletedEventArgs } from "./RefreshCompletedEventArgs";
import { Thickness } from "igniteui-react-core";
import { AxisTitlePosition } from "./AxisTitlePosition";
import { FontInfo } from "igniteui-react-core";
import { IFastItemsSource } from "igniteui-react-core";
import { CoercionInfo } from "./CoercionInfo";
import { IDataLegendSeries } from "igniteui-react-core";
import { ChartContentType } from "./ChartContentType";
import { ISchedulableRender } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Line } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { ITileZoomTile } from "./ITileZoomTile";
import { IExecutionContext } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { PathGeometry } from "igniteui-react-core";
import { Geometry } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { LabelPanelsArrangeState } from "./LabelPanelsArrangeState";
import { DataTemplateRenderInfo } from "igniteui-react-core";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { IProvidesViewport } from "./IProvidesViewport";
import { ActualLegendItemBadgeShape } from "./ActualLegendItemBadgeShape";
import { StandardLegendItems } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { PointerTooltipStyle } from "./PointerTooltipStyle";
import { DefaultPaletteInfo } from "./DefaultPaletteInfo";
import { AxisRange } from "./AxisRange";
import { AxisAnnotationCollection } from "./AxisAnnotationCollection";
import { VerticalAlignment } from "igniteui-react-core";
import { Canvas } from "igniteui-react-core";
import { IFastItemsSourceProvider } from "igniteui-react-core";
import { AxisExtentType } from "./AxisExtentType";
import { DoubleCollection } from "igniteui-react-core";
import { LabelPosition } from "./LabelPosition";
import { BindingFormatter } from "igniteui-react-core";
import { LabelFontHeuristics } from "./LabelFontHeuristics";
import { AxisOrientation } from "./AxisOrientation";
import { Pool$1 } from "igniteui-react-core";
import { AxisComponentsFromView } from "./AxisComponentsFromView";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { GeometryCollection } from "igniteui-react-core";
import { PathRenderingInfo } from "./PathRenderingInfo";
import { RenderRequestedEventArgs } from "./RenderRequestedEventArgs";
import { CategoryMode } from "./CategoryMode";
import { GridMode } from "./GridMode";
import { Panel } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { TickmarkValues } from "./TickmarkValues";
import { ICategoryScaler } from "./ICategoryScaler";
import { FastItemsSourceEventArgs } from "igniteui-react-core";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { AxisRenderingParametersBase } from "./AxisRenderingParametersBase";
import { HighlightingState } from "./HighlightingState";
import { Marker } from "./Marker";
import { Polyline } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { AutoMarginsAndAngleUpdateMode } from "./AutoMarginsAndAngleUpdateMode";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
import { ILegendSeries } from "igniteui-react-core";
import { ILegendSeriesInternal } from "igniteui-react-core";
import { ILegendTemplateProvider } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { SeriesVisibleRangeMode } from "./SeriesVisibleRangeMode";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { SeriesComponentsFromView } from "./SeriesComponentsFromView";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { ISortingAxis } from "./ISortingAxis";
import { MarkerType } from "./MarkerType";
import { Style } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class SeriesViewer extends Control implements INotifyPropertyChanged, ILegendOwner, IInternalLegendOwner, IDataLegendTarget {
    static $t: Type;
    private _widget;
    get widget(): ISeriesViewerWidget;
    set widget(a: ISeriesViewerWidget);
    cm: SeriesViewerView;
    static staticInit(): void;
    private cy;
    private get cz();
    private a4;
    get a5(): ISeriesViewerInteractionManager;
    get d8(): boolean;
    constructor();
    private ce;
    k7(): void;
    private m3;
    protected get_eo(): boolean;
    get eo(): boolean;
    k8(): void;
    get series(): SeriesCollection;
    private bl;
    private nw;
    la(): void;
    protected lu(): void;
    private _skipDataCleanup;
    get skipDataCleanup(): boolean;
    set skipDataCleanup(a: boolean);
    protected nq(a: any): void;
    private nx;
    ld(a: number, b: number, c: boolean, d: boolean): {
        p0?: number;
        p1?: number;
    };
    dv(): boolean;
    get ez(): boolean;
    protected get d4(): boolean;
    protected get dn(): boolean;
    protected get dm(): boolean;
    get dl(): boolean;
    get a3(): IHighlightingManager;
    get a6(): ISeriesViewerScrollbarManager;
    private k1;
    cn: DoubleAnimator;
    co: DoubleAnimator;
    private k6;
    oa(a: number): void;
    k5(): void;
    q9(a: number): Brush;
    rf(a: number): Brush;
    rd(a: number): Brush;
    re(a: number): Brush;
    private q8;
    ag: BrushCollection;
    aj: BrushCollection;
    ah: BrushCollection;
    ai: BrushCollection;
    ba: MarkerAutomaticBehavior;
    ap: ChartContentManager;
    get rr(): Point;
    set rr(a: Point);
    private rq;
    get d7(): boolean;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    static readonly pq: DependencyProperty;
    get dj(): boolean;
    set dj(a: boolean);
    plotAreaMouseLeftButtonDown: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseLeftButtonUp: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaClicked: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseEnter: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseLeave: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseOver: (sender: any, e: PlotAreaMouseEventArgs) => void;
    mk(a: Point, b: boolean): void;
    private bb;
    private bf;
    ml(a: Point, b: boolean, c: boolean): void;
    static readonly ow: DependencyProperty;
    get ef(): boolean;
    set ef(a: boolean);
    static readonly pm: DependencyProperty;
    get ey(): boolean;
    set ey(a: boolean);
    static readonly p8: DependencyProperty;
    get br(): SeriesHighlightingMode;
    set br(a: SeriesHighlightingMode);
    static readonly o6: DependencyProperty;
    get bx(): SeriesViewerScrollbarMode;
    set bx(a: SeriesViewerScrollbarMode);
    protected bv: SeriesViewerScrollbarMode;
    static readonly pd: DependencyProperty;
    get by(): SeriesViewerScrollbarMode;
    set by(a: SeriesViewerScrollbarMode);
    protected bw: SeriesViewerScrollbarMode;
    static readonly ql: DependencyProperty;
    get bu(): SeriesViewerHorizontalScrollbarPosition;
    set bu(a: SeriesViewerHorizontalScrollbarPosition);
    static readonly pf: DependencyProperty;
    get bz(): SeriesViewerVerticalScrollbarPosition;
    set bz(a: SeriesViewerVerticalScrollbarPosition);
    static readonly qn: DependencyProperty;
    get rg(): Brush;
    set rg(a: Brush);
    static readonly o9: DependencyProperty;
    get rh(): Brush;
    set rh(a: Brush);
    static readonly pe: DependencyProperty;
    get ga(): number;
    set ga(a: number);
    static readonly ph: DependencyProperty;
    get f9(): number;
    set f9(a: number);
    static readonly pc: DependencyProperty;
    get f6(): number;
    set f6(a: number);
    static readonly o8: DependencyProperty;
    get f7(): number;
    set f7(a: number);
    static readonly pa: DependencyProperty;
    get f8(): number;
    set f8(a: number);
    static readonly pb: DependencyProperty;
    get gc(): number;
    set gc(a: number);
    static readonly pj: DependencyProperty;
    get gb(): number;
    set gb(a: number);
    static readonly pi: DependencyProperty;
    get dw(): boolean;
    set dw(a: boolean);
    static readonly ic: string;
    static readonly pg: DependencyProperty;
    get ro(): Brush;
    set ro(a: Brush);
    static readonly qi: DependencyProperty;
    get rp(): Brush;
    set rp(a: Brush);
    static readonly qm: DependencyProperty;
    get gu(): number;
    set gu(a: number);
    static readonly qp: DependencyProperty;
    get gt(): number;
    set gt(a: number);
    static readonly qk: DependencyProperty;
    get gr(): number;
    set gr(a: number);
    static readonly qh: DependencyProperty;
    get gx(): number;
    set gx(a: number);
    static readonly qs: DependencyProperty;
    get gs(): number;
    set gs(a: number);
    static readonly qj: DependencyProperty;
    get gw(): number;
    set gw(a: number);
    static readonly qr: DependencyProperty;
    get gv(): number;
    set gv(a: number);
    static readonly qq: DependencyProperty;
    get e7(): boolean;
    set e7(a: boolean);
    static readonly j9: string;
    static readonly qo: DependencyProperty;
    private bq;
    private bn;
    get bo(): SeriesHighlightingBehavior;
    get bp(): SeriesHighlightingBehavior;
    set bp(a: SeriesHighlightingBehavior);
    static readonly o5: DependencyProperty;
    get a7(): LegendHighlightingMode;
    set a7(a: LegendHighlightingMode);
    static readonly pn: DependencyProperty;
    get a9(): LegendItemBadgeShape;
    set a9(a: LegendItemBadgeShape);
    static readonly pp: DependencyProperty;
    get a8(): LegendItemBadgeMode;
    set a8(a: LegendItemBadgeMode);
    static readonly po: DependencyProperty;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected nb(a: string, b: any, c: any): void;
    mb(): void;
    mc(a: IEnumerable): void;
    mn(a: Series, b: any, c: any): void;
    mr(a: Series, b: any, c: any): void;
    mo(a: Series, b: any, c: any): void;
    mp(a: Series, b: any, c: any): void;
    mq(a: Series, b: any, c: any): void;
    km(a: Rect, b: ScalerParams): Tuple$2<boolean, number>;
    get el(): boolean;
    private c8;
    lt(): void;
    ms(a: Series, b: any, c: any): void;
    mt(a: Series, b: any, c: any): void;
    seriesCursorMouseMove: (sender: any, e: ChartCursorEventArgs) => void;
    ne(a: Series, b: any): void;
    seriesMouseLeftButtonDown: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    ni(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseLeftButtonUp: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    nj(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseMove: (sender: any, e: ChartMouseEventArgs) => void;
    n1(a: Point): void;
    n2(a: Point): void;
    nk(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseEnter: (sender: any, e: ChartMouseEventArgs) => void;
    ng(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseLeave: (sender: any, e: ChartMouseEventArgs) => void;
    nh(a: Series, b: any, c: MouseEventArgs): void;
    private c3;
    ls(): void;
    private rz;
    protected get_sf(): Rect;
    get sf(): Rect;
    private rx;
    get r4(): Rect;
    set r4(a: Rect);
    r9(a: Rect, b: Rect, c: Rect): Rect;
    private c1;
    private rw;
    protected get_r3(): Rect;
    get r3(): Rect;
    r7(a: Rect, b: Rect, c: Rect): Rect;
    protected r2(a: Rect): Rect;
    r8(): Rect;
    protected n6(a: Axis): void;
    sg: Rect;
    e6: boolean;
    dg: boolean;
    eu: boolean;
    ha: number;
    private g2;
    get g5(): number;
    set g5(a: number);
    g8: number;
    g9: number;
    protected em: boolean;
    protected di: boolean;
    m6(a: Rect, b: Rect): void;
    private bs;
    bt(): SeriesViewerComponentsForView;
    private c6;
    ks(a: Point, b: boolean): void;
    eb: boolean;
    private ar;
    get at(): ChartHitTestMode;
    set at(a: ChartHitTestMode);
    nm(): void;
    protected au(): ChartHitTestMode;
    private aq;
    get as(): ChartHitTestMode;
    set as(a: ChartHitTestMode);
    ec: boolean;
    seriesAnimating: (series: Series) => void;
    nd(a: Series): void;
    abstract eh(): boolean;
    abstract ei(): boolean;
    eg(): boolean;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    get cd(): InteractionState;
    set cd(a: InteractionState);
    private c4;
    private b9;
    me(a: Point): void;
    mf(a: Point, b: boolean): void;
    es(a: Point, b: number): boolean;
    l4(a: Point): void;
    er(a: Key): boolean;
    private da;
    dr: boolean;
    private c2;
    get dk(): boolean;
    set dk(a: boolean);
    protected get_d9(): boolean;
    get d9(): boolean;
    l6(a: Point): void;
    get du(): boolean;
    jz: string;
    mj(a: Point): void;
    l7(a: Point, b: boolean): void;
    l5(a: Point): void;
    get et(): boolean;
    set et(a: boolean);
    private m1;
    mi(a: Point): void;
    m2(a: Point, b: number, c: number, d: number): void;
    mh(a: number): void;
    my(a: Point, b: number, c: number, d: number): void;
    md(a: Point): void;
    mg(a: number): void;
    l8(a: Point): void;
    mx(a: Point, b: number, c: number, d: number): void;
    ma(a: Size): void;
    k4(): void;
    lx(a: Point, b: boolean): void;
    cb(a: boolean): InteractionState;
    viewerManipulationStarting: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    viewerManipulationEnding: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    private de;
    m0(): void;
    mz(): void;
    n3(): void;
    kz(): void;
    ku(): void;
    kt(): void;
    m4(): void;
    np(): void;
    nn(): void;
    lw(a: Point, b: boolean): void;
    ex(): boolean;
    private db;
    get e1(): boolean;
    set e1(a: boolean);
    lv(a: Point, b: boolean, c: boolean): void;
    og(a: any, b: PropertyUpdatedEventArgs): void;
    of(a: SyncLink, b: SyncLink): void;
    kv(a: Point): void;
    oi(a: Rect, b: boolean): void;
    oj(a: Rect, b: boolean, c: boolean): void;
    m5(a: Rect, b: boolean): void;
    get ed(): boolean;
    private _fa;
    fa(): IEnumerable$1<SeriesViewer>;
    ru(a: Point): Point;
    rs(a: Point): Point;
    se(a: Rect): Rect;
    windowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private nl;
    mw(a: Rect, b: Rect): void;
    sizeChanged: (sender: any, e: RectChangedEventArgs) => void;
    mu(a: Size, b: Size): void;
    dz: boolean;
    ev(a: Rect, b: Rect): boolean;
    actualWindowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private m9;
    nv(): void;
    gridAreaRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private na;
    protected get_ea(): boolean;
    get ea(): boolean;
    mm(a: Rect, b: Rect): void;
    b3: WindowResponse;
    lc(): void;
    dt: boolean;
    g0: number;
    private _syncChannel;
    get syncChannel(): string;
    set syncChannel(a: string);
    private b0;
    get actualSyncLink(): SyncLink;
    set actualSyncLink(a: SyncLink);
    e2: boolean;
    lb(): void;
    sl: Visibility;
    private dd;
    l2(): void;
    l0(): void;
    l1(): void;
    get cf(): IOverviewPlusDetailPane;
    protected oc(a: boolean): void;
    sk: Visibility;
    dy: boolean;
    e5: boolean;
    private b4;
    get b5(): ZoomCoercionMode;
    set b5(a: ZoomCoercionMode);
    b6(): ZoomCoercionMode;
    b7: ZoomCoercionMode;
    rj: Brush;
    q6: Brush;
    ri: Brush;
    dq(): boolean;
    dh(): boolean;
    sh: Rect;
    kr(): void;
    private g4;
    private notifyCrosshairUpdate;
    protected oh(a: number, b: number): void;
    f4(): number;
    f5(): number;
    protected m7(a: any, b: string, c: any, d: any): void;
    get d5(): boolean;
    protected get eq(): boolean;
    bk: Series;
    ob(a: Point): void;
    private kl;
    oe(): void;
    protected lp(): void;
    od(): void;
    private dc;
    protected e3: boolean;
    ca: InteractionState;
    cc: InteractionState;
    q2: ModifierKeys;
    q3: ModifierKeys;
    private ry;
    get sa(): Rect;
    set sa(a: Rect);
    fc: Date;
    e8: boolean;
    protected n5(): void;
    kn(a: Rect, b: Rect): void;
    protected lq(a: Rect, b: Rect): void;
    gy: number;
    gz: number;
    private sd;
    refreshCompleted: (sender: any, e: RefreshCompletedEventArgs) => void;
    nc(): void;
    protected abstract cl(): SeriesViewerView;
    protected mv(a: SeriesViewerView): void;
    static sc: Rect;
    ok: DataTemplate;
    ot: DataTemplate;
    oq: DataTemplate;
    or: DataTemplate;
    ol: DataTemplate;
    oo: DataTemplate;
    om: DataTemplate;
    os: DataTemplate;
    op: DataTemplate;
    on: DataTemplate;
    jp: string;
    q1: HorizontalAlignment;
    q0: HorizontalAlignment;
    private hg;
    get jw(): string;
    set jw(a: string);
    private hf;
    get jk(): string;
    set jk(a: string);
    private q5;
    get rn(): Brush;
    set rn(a: Brush);
    private q4;
    get rm(): Brush;
    set rm(a: Brush);
    private fv;
    get gp(): number;
    set gp(a: number);
    private ft;
    get gn(): number;
    set gn(a: number);
    private fu;
    get go(): number;
    set go(a: number);
    private fs;
    get gm(): number;
    set gm(a: number);
    private fr;
    get gl(): number;
    set gl(a: number);
    private fp;
    get gj(): number;
    set gj(a: number);
    private fq;
    get gk(): number;
    set gk(a: number);
    private fo;
    get gi(): number;
    set gi(a: number);
    jd: string;
    si(): Thickness;
    sj(): Thickness;
    an(a: Axis): AxisTitlePosition;
    ao(a: Axis): AxisTitlePosition;
    abstract getFontInfo(): FontInfo;
    getFontHeight(): number;
    protected get_ep(): boolean;
    get ep(): boolean;
    lz(): void;
    abstract getFontBrush(): Brush;
    abstract q7(): Brush;
    hd: any;
    provideContainer(a: any): void;
    ly(a: number, b: number): void;
    notifyContainerResized(): void;
    r5(): Rect;
    k0(): void;
    rt(): Point;
    cq(): FontInfo;
    cp(): FontInfo;
    ra(): Brush;
    rb(): Brush;
    kp(a: Series): void;
    nr(a: Series): void;
    al: CanvasRenderScheduler;
    am: CanvasRenderScheduler;
    ak: CanvasRenderScheduler;
    private c9;
    get en(): boolean;
    set en(a: boolean);
    private c0;
    get df(): boolean;
    set df(a: boolean);
    private _syncSettings;
    get syncSettings(): SyncSettings;
    set syncSettings(a: SyncSettings);
    ko(a: any): void;
    nt(a: any): void;
    lm(source_: any, a: number, b: any, c: any): void;
    le(source_: any): void;
    lk(source_: any, a: number, b: any): void;
    ll(source_: any, a: number, b: any): void;
    destroyed: boolean;
    protected hb: any;
    protected e9: Dictionary$2<string, any>;
    ek: boolean;
    destroy(): void;
    protected ky(): void;
    n0(source_: any): void;
    nu(): void;
    nz(a: string, source_: any): void;
    ns(a: string, b: boolean): void;
    protected ny(a: Series, b: any): void;
    protected n8(a: any): void;
    protected n9(): void;
    private fw;
    get gq(): number;
    set gq(a: number);
    private fl;
    get ge(): number;
    set ge(a: number);
    private fn;
    get gh(): number;
    set gh(a: number);
    private fj;
    get f3(): number;
    set f3(a: number);
    private fi;
    get f2(): number;
    set f2(a: number);
    private fh;
    get f1(): number;
    set f1(a: number);
    ew(): boolean;
    private c5;
    get d1(): boolean;
    set d1(a: boolean);
    private fm;
    get gf(): number;
    set gf(a: number);
    private fk;
    get gd(): number;
    set gd(a: number);
    static b8(a: string, b: any): CoercionInfo;
    private he;
    get iv(): string;
    set iv(a: string);
    private fe;
    get fy(): number;
    set fy(a: number);
    private fd;
    get fx(): number;
    set fx(a: number);
    private rv;
    get r0(): Rect;
    set r0(a: Rect);
    r6(): Rect;
    dx: boolean;
    private k9;
    sb(): Rect;
    protected r1(): Rect;
    hc(a: number, b: number): any;
    private ff;
    get fz(): number;
    set fz(a: number);
    private fg;
    get f0(): number;
    set f0(a: number);
    lo(): void;
    ln(): void;
    flush(): void;
    k3(a: boolean, b: boolean, c: boolean): void;
    e4(): boolean;
    private ou;
    private av;
    protected no(a: DependencyObject, b: (arg1: boolean) => void): void;
    protected n4(a: DependencyObject): void;
    kw(): void;
    d2: boolean;
    d3: boolean;
    d0: boolean;
    l9(): void;
    private c7;
    get ee(): boolean;
    kq(): void;
    ej(): boolean;
    private g3;
    g7(): number;
    ct(): FontInfo;
    cs(): FontInfo;
    n7(): void;
    protected dp: boolean;
    rl: Brush;
    rk: Brush;
    gg: number;
    d6: boolean;
    seriesDataUpdated: (sender: any, e: EventArgs) => void;
    nf(): void;
    private li;
    private lj;
    lh(a: Point): void;
    private fb;
    attachDataLegend(a: IDataLegend): void;
    detachDataLegend(a: IDataLegend): void;
    getDataLegendSeries(): IDataLegendSeries[];
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class SeriesViewerView extends Base implements ISchedulableRender {
    static $t: Type;
    constructor(a: SeriesViewer);
    l(): IExecutionContext;
    co(): void;
    p: SeriesViewer;
    c4(): void;
    e(): Series;
    private cn;
    a: CanvasRenderScheduler;
    n: IOverviewPlusDetailPane;
    private dn;
    private dm;
    em(): void;
    private ct;
    private cs;
    o: OverviewPlusDetailViewportHost;
    cb(a: number, b: number, c: RenderSurface): void;
    d5(): void;
    cd(): void;
    d7(): void;
    ck(): void;
    cc(): void;
    ce(): void;
    dy(a: Series): void;
    dc(): void;
    private er;
    aq(a: Series): boolean;
    protected g: SeriesCollection;
    protected b: AxisCollection;
    private ai;
    get au(): boolean;
    set au(a: boolean);
    bp(a: Series): void;
    dt(a: RenderingContext): void;
    bx(): void;
    bt(): void;
    cf(): void;
    ca(): void;
    dr(): void;
    protected fi: Rectangle;
    protected ff: Path;
    d8(): void;
    eg(a: Rect): void;
    bw(): void;
    df(): void;
    eo(a: number, b: number, c: number, d: number): void;
    protected fe: Line;
    protected fd: Line;
    ed(): void;
    cl(): void;
    eh(a: number, b: number, c: number, d: number): void;
    d9(): void;
    cg(): void;
    cj(): void;
    private e6;
    private e7;
    en(a: Rect, b: Rect): void;
    ec(): void;
    ep(a: Rect): void;
    dw(a: Axis): void;
    dx(a: Axis): void;
    bo(a: Axis): void;
    bl(a: Axis): void;
    private h;
    i(): SeriesViewerComponentsFromView;
    static aw(a: Series): List$1<Series>;
    d2(): void;
    j: SeriesViewerViewManager;
    protected w: RenderingContext;
    z: RenderingContext;
    y: RenderingContext;
    x: RenderingContext;
    an: boolean;
    ao: boolean;
    protected bi: any;
    c0(a: any): void;
    private al;
    protected cy(a: Point, b: boolean): void;
    protected cz(a: Point, b: boolean): void;
    protected c3(a: Point): void;
    protected cx(a: Point, b: boolean, c: boolean): void;
    du(a: RenderingContext): void;
    protected get_ap(): boolean;
    get ap(): boolean;
    k: EventProxy;
    ef(): void;
    a9: number;
    f(a: Point, b: boolean, c: DataContext, d: boolean): {
        ret: Series;
        p2: DataContext;
    };
    bd(): number;
    bc(): number;
    a8: number;
    a7: number;
    private e9;
    private aj;
    cu(): void;
    c1(a: number, b: number): void;
    private fg;
    private fh;
    b6(a: Rectangle): void;
    b9(a: Rectangle): void;
    b8(): void;
    d3(): void;
    private a1;
    private az;
    private a0;
    private ay;
    private ak;
    private aa;
    private b2;
    private ek;
    v(): FontInfo;
    u(): FontInfo;
    private e5;
    private e4;
    private bf;
    private a2;
    private be;
    fm(): Thickness;
    fl(): Thickness;
    protected dv(a: Rect): void;
    cq(): void;
    private fa;
    protected d0(): void;
    isValid(): boolean;
    preRender(): void;
    protected ds(): void;
    protected ab: boolean;
    protected d1(): void;
    c2(): void;
    cw(): void;
    fb(): Rect;
    e8(): Point;
    private d6;
    ee(): void;
    dp(): void;
    protected as(a: Point): boolean;
    c8(a: Point, b: boolean, c: boolean): void;
    protected c7(a: Point): void;
    protected c6(a: Point): void;
    protected c9(a: Point): void;
    d4(): void;
    get ez(): ModifierKeys;
    eq(a: Rect): void;
    cr(a: boolean): void;
    bk(a: boolean): void;
    protected el(): void;
    private af;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    undirty(a: boolean): void;
    get index(): number;
    postRender(): void;
    b7(): void;
    protected ae: boolean;
    ch(): void;
    ea(): void;
    bv(a: boolean): void;
    bm(a: any): void;
    ei(a: number): void;
    ej(a: number): void;
    bn(a: any): void;
    dz(a: any): void;
    da(a: Brush): void;
    bu(a: Point): void;
    av: boolean;
    m(a: boolean): InteractionState;
    c5(): void;
    private et;
    private es;
    bb(a: TextBlock, b: FontInfo): number;
    ba(a: string, b: FontInfo): number;
    dj(): void;
    private eu;
    di(): void;
    de(): void;
    c(a: Axis): AxisTitlePosition;
    d(a: Axis): AxisTitlePosition;
    dk(): void;
    dl(): void;
    t(): FontInfo;
    e3(): Brush;
    q(): FontInfo;
    e0(): Brush;
    s(): FontInfo;
    r(): FontInfo;
    e2(): Brush;
    e1(): Brush;
    get a4(): number;
    get a5(): number;
    get a6(): number;
    get a3(): number;
    get ew(): TextBlock;
    get ev(): TextBlock;
    fc(): Rect;
    fk(): Thickness;
    fj(): Thickness;
    private ad;
    private ac;
    dd(a: any, b: any): void;
    dh(a: any, b: any): void;
    ey(): HorizontalAlignment;
    ex(): HorizontalAlignment;
    private ag;
    bq(): void;
    am(): boolean;
    b5(): void;
    cp(): void;
    at(a: Point): boolean;
    dq(): void;
    private ax;
    b3(a: Dictionary$2<any, ITileZoomTile>, b: List$1<ITileZoomTile>, c: number): void;
    bh(a: Rect, b: ITileZoomTile, c: number): any;
    b0(): void;
    b1(a: ITileZoomTile): void;
    cm(): void;
    ar: boolean;
    private bg;
    by(): void;
    br(): void;
    bz(a: number): void;
    bs(): void;
    private ah;
    ci(): void;
    eb(): void;
    dg(): void;
    cv(): void;
    db(): void;
    b4(a: any): void;
    bj(a: number, b: number): any;
}
/**
 * @hidden
 */
export declare class OverviewPlusDetailViewportHost extends Base implements IProvidesViewport {
    static $t: Type;
    constructor(a: SeriesViewerView);
    a: SeriesViewerView;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    getEffectiveViewport(): Rect;
}
/**
 * @hidden
 */
export declare class LegendTemplates extends Base {
    static $t: Type;
    private static readonly z;
    private static readonly ae;
    private static readonly ad;
    private static readonly ah;
    private static readonly ab;
    private static readonly y;
    private static readonly aa;
    private static readonly ac;
    static af(a: Series): DataTemplate;
    static a(a: DataTemplateRenderInfo): RenderingContext;
    static v(a: DataContext): void;
    private static b;
    private static c;
    static u(a: DataTemplateRenderInfo, b: number, c: Brush, d: Brush, e: number, f: number, g: number, h: number): void;
    static s(a: DataTemplateRenderInfo): void;
    static r(a: DataTemplateRenderInfo, b: number, c: number): void;
    static t(a: DataTemplateRenderInfo, b?: number): void;
    static j(a: DataTemplateRenderInfo): void;
    static n(a: DataTemplateRenderInfo): void;
    static o(a: DataTemplateRenderInfo): void;
    static q(a: DataTemplateRenderInfo): void;
    static p(a: DataTemplateRenderInfo): void;
    static i(a: DataTemplateRenderInfo): void;
    static l(a: DataTemplateRenderInfo): void;
    static m(a: DataTemplateRenderInfo): void;
    static k(a: DataTemplateRenderInfo): void;
    static g(a: DataTemplateRenderInfo): void;
    private static readonly w;
    private static readonly x;
    static resolveLegendItemTemplate(a: StandardLegendItems): DataTemplate;
    static e(a: DataTemplateRenderInfo): void;
    static f(a: DataTemplateMeasureInfo): void;
    static d(a: DataTemplateMeasureInfo): void;
    static h(a: DataTemplateMeasureInfo): void;
}
/**
 * @hidden
 */
export declare class SeriesViewerViewManager extends Base {
    static $t: Type;
    ae: DomRenderer;
    protected af: DomWrapper;
    protected aj: DomWrapper;
    protected ai: DomWrapper;
    protected ag: DomWrapper;
    ak: DomWrapper;
    t: RenderingContext;
    w: RenderingContext;
    v: RenderingContext;
    u: RenderingContext;
    x: RenderingContext;
    f: EventProxy;
    private j;
    constructor(a: SeriesViewerView);
    protected ah: DomWrapper;
    bi(): void;
    bf(a: any): void;
    static bx(a: DomRenderer, b: () => void): void;
    private bh;
    a9(): void;
    g(): IOverviewPlusDetailPane;
    bl(): void;
    bm(): void;
    b2(): Brush;
    private ab;
    private aa;
    private ac;
    ay(a: number, b: number, c: number): void;
    b7(): Point;
    y(): boolean;
    bb(a: boolean): void;
    a7(a: BrushCollection, b: BrushCollection, c: Brush, d: FontInfo, e: Brush): {
        p0: BrushCollection;
        p1: BrushCollection;
        p2: Brush;
        p3: FontInfo;
        p4: Brush;
    };
    e(): DefaultPaletteInfo;
    a6(a: number, b: number[], c: Brush, d: Brush, e: number, f: boolean): {
        p0: number;
        p1: number[];
        p2: Brush;
        p3: Brush;
        p4: number;
        p5: boolean;
    };
    ax(): void;
    bt(x_: number): void;
    private ad;
    bu(y_: number): void;
    at(a: any): void;
    a8(): void;
    bn(): void;
    au(a: any): void;
    bj(a: any): void;
    bc(): void;
    private l;
    p(): FontInfo;
    private b9;
    cd(): Thickness;
    private aq;
    as(): string;
    private ap;
    ar(): string;
    private b8;
    cc(): Thickness;
    private bz;
    b4(): Brush;
    private by;
    b3(): Brush;
    private k;
    o(): FontInfo;
    private a;
    c(): AxisTitlePosition;
    private b;
    d(): AxisTitlePosition;
    private n;
    r(): FontInfo;
    private b1;
    b6(): Brush;
    private m;
    q(): FontInfo;
    private b0;
    b5(): Brush;
    private ca;
    ce(): Thickness;
    private cb;
    cf(): Thickness;
    bo(): void;
    private bw;
    private bq;
    private bp;
    private br;
    private bs;
    a5(a: number, b: number): void;
    private h;
    i(): PointerTooltipStyle;
    ba(a: boolean): void;
    private z;
    an(a: Rect, b: ITileZoomTile, c: number): any;
    a2(a: ITileZoomTile): void;
    a1(): void;
    bk(a: List$1<ITileZoomTile>): void;
    private al;
    az(): void;
    av(): void;
    private am;
    a0(a: number): void;
    aw(): void;
    private s;
    bd(): void;
    bv(a: boolean): void;
    a3(): void;
    a4(): void;
    bg(): void;
    be(): void;
    ao(a: number, b: number): any;
}
/**
 * @hidden
 */
export declare class AutoRangeCalculator extends Base {
    static $t: Type;
    static a(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
}
/**
 * @hidden
 */
export interface IAxisAnnotationManager {
    owner: Axis;
    onAutoAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAutoAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAddAnnotations(a: Axis): void;
    arrangeAnnotations(a: Axis, b: AxisLabelPanelBaseView, c: List$1<FrameworkElement>, d: List$1<Rect>, e: boolean, f: number, g: number, h: number, i: number, j: number): void;
}
/**
 * @hidden
 */
export declare let IAxisAnnotationManager_$type: Type;
/**
 * @hidden
 */
export declare class AxisLabelSettings extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private aa;
    get textStyle(): string;
    set textStyle(a: string);
    private ax;
    get textColor(): Brush;
    set textColor(a: Brush);
    get location(): AxisLabelsLocation;
    set location(a: AxisLabelsLocation);
    private b;
    get visibility(): Visibility;
    set visibility(a: Visibility);
    private a2;
    get showFirstLabel(): boolean;
    set showFirstLabel(a: boolean);
    private h;
    c: AxisLabelsLocation;
    a: Axis;
    registerAxis(a: Axis): void;
    unregisterAxis(a: Axis): void;
    get angle(): number;
    set angle(a: number);
    private m;
    get extent(): number;
    set extent(a: number);
    private o;
    set margin(a: number);
    get leftMargin(): number;
    set leftMargin(a: number);
    private p;
    get rightMargin(): number;
    set rightMargin(a: number);
    private q;
    get topMargin(): number;
    set topMargin(a: number);
    private r;
    get bottomMargin(): number;
    set bottomMargin(a: number);
    private n;
    private au;
    get horizontalAlignment(): HorizontalAlignment;
    set horizontalAlignment(a: HorizontalAlignment);
    private az;
    get verticalAlignment(): VerticalAlignment;
    set verticalAlignment(a: VerticalAlignment);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    ar(a: string, b: any, c: any): void;
    protected aq(a: any, b: string, c: any, d: any): void;
    j(): boolean;
    k(): boolean;
    static readonly extentPropertyDefault: number;
    get i(): boolean;
    private f;
    g(a: DomRenderer): FontInfo;
}
/**
 * @hidden
 */
export declare class TitleSettings extends AxisLabelSettings {
    static $t: Type;
    constructor();
    private a4;
    get position(): AxisTitlePosition;
    set position(a: AxisTitlePosition);
    protected aq(a: any, b: string, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare abstract class Axis extends Control implements INotifyPropertyChanged {
    static $t: Type;
    a3(): AxisView;
    a4: AxisView;
    hn(a: AxisView): void;
    ha(): void;
    private bs;
    get bt(): SRProvider;
    private a8;
    get a9(): IAxisVisualDataManager;
    ee(): number;
    fy(): any;
    fx(): any;
    protected get_b9(): boolean;
    get b9(): boolean;
    protected get_ch(): boolean;
    get ch(): boolean;
    protected get_b7(): boolean;
    get b7(): boolean;
    protected get_cj(): boolean;
    get cj(): boolean;
    protected get_cm(): boolean;
    get cm(): boolean;
    protected get_ck(): boolean;
    get ck(): boolean;
    protected get_cc(): boolean;
    get cc(): boolean;
    protected get_ci(): boolean;
    get ci(): boolean;
    protected get_ca(): boolean;
    get ca(): boolean;
    protected get_cb(): boolean;
    get cb(): boolean;
    aj(): Axis;
    constructor();
    private a6;
    get a7(): IAxisAnnotationManager;
    get b8(): boolean;
    private g8;
    private g9;
    private g6;
    private g7;
    provideRenderer(a: DomRenderer): void;
    at: (item: any) => string;
    hk(a: Rect, b: Rect): void;
    abstract au(): AxisLabelPanelBase;
    ac(): void;
    il: Canvas;
    get bn(): IFastItemsSourceProvider;
    set bn(a: IFastItemsSourceProvider);
    private bm;
    get bh(): SeriesViewer;
    set bh(a: SeriesViewer);
    private bg;
    get bf(): XamDataChart;
    set bf(a: XamDataChart);
    readonly br: (sender: any, e: RectChangedEventArgs) => void;
    private bx;
    get c2(): boolean;
    set c2(a: boolean);
    private dh;
    get e2(): number;
    set e2(a: number);
    private db;
    get dt(): number;
    set dt(a: number);
    private dn;
    get e8(): number;
    set e8(a: number);
    private dk;
    get e5(): number;
    set e5(a: number);
    private ar;
    get as(): AxisExtentType;
    set as(a: AxisExtentType);
    private dg;
    get e1(): number;
    set e1(a: number);
    ds: number;
    private dm;
    get e7(): number;
    set e7(a: number);
    private dj;
    get e4(): number;
    set e4(a: number);
    private bj;
    private bi;
    get bl(): FontInfo;
    set bl(a: FontInfo);
    private fz;
    get gt(): string;
    set gt(a: string);
    private di;
    get e3(): number;
    set e3(a: number);
    du: number;
    private dp;
    get e9(): number;
    set e9(a: number);
    private dl;
    get e6(): number;
    set e6(a: number);
    private fk;
    get fp(): number;
    set fp(a: number);
    private fj;
    get fo(): number;
    set fo(a: number);
    private fi;
    get fn(): number;
    set fn(a: number);
    fl: number;
    private kd;
    get kg(): VerticalAlignment;
    set kg(a: VerticalAlignment);
    private dr;
    get fb(): number;
    set fb(a: number);
    private dq;
    get fa(): number;
    set fa(a: number);
    ib(): void;
    private h0;
    private h1;
    im: TextBlock;
    g2: string;
    jt: Brush;
    jp: Brush;
    fc: number;
    jx: DoubleCollection;
    js: Brush;
    jq: Brush;
    jn: Brush;
    en: number;
    jv: DoubleCollection;
    jr: Brush;
    jo: Brush;
    eq: number;
    jw: DoubleCollection;
    ju: Brush;
    fe: number;
    jy: DoubleCollection;
    fd: number;
    dv: number;
    private ie;
    cd: boolean;
    cf: boolean;
    cg: boolean;
    cr: boolean;
    private bv;
    private dc;
    get b2(): boolean;
    get b5(): boolean;
    ia(a: number): void;
    h5(): void;
    eb(): number;
    es(): number;
    cs: boolean;
    ct: boolean;
    cu: boolean;
    get c1(): boolean;
    set c1(a: boolean);
    static readonly jk: DependencyProperty;
    fm: number;
    bz: boolean;
    ay: AxisLabelSettings;
    d1(): number;
    jl(): HorizontalAlignment;
    ke(): VerticalAlignment;
    jm(): HorizontalAlignment;
    kf(): VerticalAlignment;
    d3(): number;
    d5(): number;
    d4(): number;
    d2(): number;
    d8(): number;
    ea(): number;
    d9(): number;
    d7(): number;
    az(): AxisLabelsLocation;
    a0(): AxisLabelsLocation;
    ai: Axis;
    fr: any;
    rangeChanged: (sender: any, e: AxisRangeChangedEventArgs) => void;
    protected hy(a: AxisRangeChangedEventArgs): void;
    be: TitleSettings;
    d6(): number;
    d0(): number;
    get am(): AxisAnnotationCollection;
    private ak;
    get an(): AxisAnnotationCollection;
    private al;
    private j0;
    get j7(): Rect;
    set j7(a: Rect);
    j6: Rect;
    ig(): void;
    c4(a: Rect, b: Rect, c: AxisView): boolean;
    cl(): boolean;
    c8: List$1<any>;
    c9: List$1<LabelPosition>;
    av: AxisLabelPanelBase;
    protected ij(a: Rect, b: Rect): void;
    private bw;
    get cn(): boolean;
    set cn(a: boolean);
    protected j4(): Rect;
    protected ik(a: Rect, b: Rect): void;
    hz(): void;
    a5: ContentInfo;
    fh: DomRenderer;
    ah: BindingFormatter;
    protected hr(a: any, b: string, c: any, d: any): void;
    hp(): void;
    hq(): void;
    private _coercionMethods;
    get coercionMethods(): any;
    set coercionMethods(a: any);
    private bu;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    get expectFunctions(): boolean;
    set expectFunctions(a: boolean);
    cv: boolean;
    private h7;
    c3: boolean;
    protected hm(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected hl(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    protected ii(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected ih(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    private ce;
    protected h9(a: number, b: number, c: Rect, d: Rect, e: Rect, f: number, g: number): {
        p0: number;
        p1: number;
    };
    dw(a: number, b: number, c: number, d: PathRenderingInfo): number;
    hd(a: GeometryCollection): void;
    protected hc(): void;
    h2(): void;
    h3(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    bb: LabelFontHeuristics;
    static ep: number;
    ev(): number;
    ez(): number;
    ex(): number;
    ey(): number;
    ew(): number;
    et(): number;
    dy(a: number, b: boolean, c: Rect, d: Rect, e: Rect): number;
    private em;
    private ed;
    cw(a: number, b: Rect, c: Rect, d: Rect): boolean;
    protected ec(a: number, b: Rect, c: Rect, d: Rect): number;
    eu(): number;
    protected get cx(): boolean;
    co: boolean;
    hf(a: boolean): void;
    private de;
    private b0;
    h6(): void;
    protected b4(): boolean;
    dx(a: number, b: ScalerParams): number;
    protected h8(): void;
    private df;
    ba(): LabelFontHeuristics;
    bk(): FontInfo;
    private hg;
    cp: boolean;
    cy(): boolean;
    cz(a: boolean): boolean;
    c0(): boolean;
    protected h4(a: boolean): void;
    id(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected hx(a: string, b: any, c: any): void;
    da: List$1<Series>;
    cq(a: Series): boolean;
    by(a: Series): boolean;
    fw: any;
    gc: string;
    ag: any[];
    ft(a: any, b: string): any;
    private c6;
    protected go(a: string): string;
    private c5;
    protected fu(a: any, b: string, c: string): any;
    fv(a: any): any;
    f9(a: number): string;
    er(): number;
    ef(a: number, b: ScalerParams): number;
    eg(a: number, b: ScalerParams, c: CategoryMode): number;
    j3(a: Rect): Rect;
    j2(): Rect;
    j1(): Rect;
    protected j5(a: Rect, b: Rect): Rect;
    eh(a: number, b: Rect, c: Rect): number;
    hi(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    hh(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    ei(a: number, b: ScalerParams): number;
    ej(a: number, b: ScalerParams, c: CategoryMode): number;
    ek(a: number, b: Rect, c: Rect): number;
    hj(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    e0(a: number): number;
    abstract get a1(): AxisOrientation;
    kc: Size;
    ho(a: Size): void;
    ic(): void;
    ao: AxisComponentsForView;
    ap(): AxisComponentsForView;
    dz: number;
    private dd;
    get eo(): number;
    set eo(a: number);
    b6(): boolean;
    el(): number;
    protected hb(): void;
    he(a: AxisRangeChangedEventArgs): void;
    bq: Pool$1<TextBlock>;
    bp: Pool$1<TextBlock>;
    bo: Pool$1<Rectangle>;
    get j8(): Path;
    get j9(): Path;
    get kb(): Path;
    get ka(): Path;
    bd(): SyncSettings;
    aq(): AxisComponentsFromView;
    private aw;
    get ax(): AxisLabelSettings;
    hs(a: RenderingContext, b: RenderingContext): void;
    b3(): boolean;
    fs(): any;
    private _c7;
    c7(): IEnumerable$1<Series>;
    ht(a: string): void;
    hw(a: any): void;
    hv(a: any): void;
    fg: CultureInfo;
    jz(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisCollection extends ObservableCollection$1<Axis> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class AxisLabelManager extends Base {
    static $t: Type;
    e: List$1<any>;
    f: List$1<LabelPosition>;
    b: AxisLabelPanelBase;
    a: Axis;
    c: (arg1: number) => void;
    constructor();
    n(a: Rect, b: Rect): void;
    i(a: any, b: LabelPosition): void;
    t(): void;
    static j(a: FrameworkElement, b: AxisLabelSettings): void;
    private static k;
    private static l;
    static m(a: FrameworkElement, b: TitleSettings): void;
    h(a: FrameworkElement): void;
    r(a: number): void;
    o(a: number): void;
    u(a: number): FrameworkElement;
    s(a: number): void;
    get d(): boolean;
    q(): void;
    p(): void;
    g(): void;
}
/**
 * @hidden
 */
export declare abstract class AxisLabelPanelBase extends Panel {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    af: AxisLabelPanelBaseView;
    cx: Rect;
    b8(): void;
    cp(): void;
    co(): void;
    constructor();
    bw: number;
    ad: Axis;
    private ak;
    get az(): boolean;
    set az(a: boolean);
    private a3;
    get a9(): List$1<any>;
    set a9(a: List$1<any>);
    ba: List$1<LabelPosition>;
    c4: Rect;
    private cw;
    get c5(): Rect;
    set c5(a: Rect);
    private cv;
    get c1(): Rect;
    set c1(a: Rect);
    c2: Rect;
    private bc;
    get bg(): number;
    set bg(a: number);
    bx: () => boolean;
    bb: List$1<FrameworkElement>;
    a8: List$1<Rect>;
    ag: AxisLabelSettings;
    bn(): number;
    ao: boolean;
    c3: Rect;
    cl(): void;
    ar: boolean;
    av: boolean;
    aw: boolean;
    ax: boolean;
    bz: any;
    al: boolean;
    protected an(a: List$1<Rect>, b: List$1<boolean>): boolean;
    protected by(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    a5(): List$1<Rect>;
    b6(): void;
    b2(a: Size): void;
    get ap(): boolean;
    bl(): number;
    bq(): number;
    at(a: number, b: Rect): boolean;
    bk(a: any): number;
    bv(a: any): number;
    bm(a: any): number;
    bj(a: any): number;
    aq(): boolean;
    protected ct(a: Rect, b: Rect): void;
    protected cd(a: Rect, b: Rect): void;
    a7(): List$1<Rect>;
    a6(a: List$1<Rect>): List$1<Rect>;
    protected cy(a: number, b: Rect, c: Thickness): Rect;
    protected as(a: List$1<Rect>, b: List$1<number>, c: Thickness): boolean;
    protected a4(a: List$1<Rect>): List$1<number>;
    bp(a: number, b: Size): number;
    bo(a: number, b: Size): number;
    bt(): number;
    br(): number;
    bs(): number;
    bu(): number;
    c6(a: Size): Size;
    protected get am(): boolean;
    c0(): Rect;
    protected b5(a: Size): void;
    protected b4(a: Size): void;
    protected b9(): void;
    protected a2(): IEnumerable$1<number>;
    get ah(): AxisLabelsLocation;
    cs(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cc(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cm(a: FrameworkElement, b: number): void;
    protected get_au(): boolean;
    get au(): boolean;
    ac(a: Rect, b: number): Point[];
    cz(a: Rect, b: number): Rect;
    cn(a: FrameworkElement): void;
    cb(a: FrameworkElement, b: number): void;
    c8(a: Size): Size;
    static readonly cu: DependencyProperty;
    get bh(): number;
    set bh(a: number);
    bd: number;
    aj(a: TitleSettings): AxisTitlePosition;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
    private _a0;
    a0(): IEnumerable$1<any>;
    b1(a: number, b: TextBlock, c: number, d: number, e: number): string;
    b7(a: any): void;
    cg(a: FrameworkElement): void;
    private _a1;
    a1(): IEnumerable$1<any>;
    protected be: number;
    protected bf: number;
    ca(): void;
    cr(): void;
    ce(): void;
    bi(a: Rect): number;
    c7: Size;
    ci(): void;
    cq(): void;
    cf(): void;
    cj(a: RenderingContext): void;
    b3(): void;
    ck(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryAxisBase extends Axis implements ICategoryScaler {
    static $t: Type;
    a3(): AxisView;
    protected get_cb(): boolean;
    hn(a: AxisView): void;
    kh: CategoryAxisBaseView;
    protected ec(a: number, b: Rect, c: Rect, d: Rect): number;
    constructor();
    c4(a: Rect, b: Rect, c: AxisView): boolean;
    lv(): void;
    lu(): void;
    ks: List$1<number>;
    protected get_b9(): boolean;
    l8(a: Point, b: boolean, c: number): Rect;
    l9(a: Point, b: boolean, c: number, d: boolean): Rect;
    kl: IFastItemsSource;
    private kk;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    static readonly l3: DependencyProperty;
    private k7;
    k9: number;
    get la(): number;
    set la(a: number);
    get categoryMode(): CategoryMode;
    set categoryMode(a: CategoryMode);
    private ki;
    kv: number;
    protected k5(a: Rect, b: Rect, c: Rect): number;
    k2: number;
    ku: number;
    k3: number;
    k4: number;
    kp: boolean;
    get lb(): number;
    set lb(a: number);
    private k8;
    ei(a: number, b: ScalerParams): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    ky(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    k6(a: number): number;
    private _kr;
    private kr;
    private kn;
    ko(a: SeriesViewer): boolean;
    private _kq;
    private kq;
    private km;
    lz(a: boolean): void;
    protected hr(a: any, b: string, c: any, d: any): void;
    protected ln(): void;
    lp(a: any, b: FastItemsSourceEventArgs): void;
    protected lw(a: FastItemsSourceEventArgs): void;
    private l0;
    cq(a: Series): boolean;
    by(a: Series): boolean;
    private lx;
    lm(): void;
    ly(): void;
    lo(a: NotifyCollectionChangedEventArgs): void;
    lt(a: number, b: any, c: any): void;
    lq(): void;
    lr(a: number, b: any): void;
    ls(a: number, b: any): void;
    kz(a: Rect, b: Rect, c: Rect, d: number): number;
    k0(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    getSeriesOffset(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    get isVertical(): boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$a(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalAxisLabelPanelBase extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    c9: HorizontalAxisLabelPanelBaseView;
    dl: number;
    di: number;
    dk: number;
    dj: number;
    b6(): void;
    db(): boolean;
    dc(): boolean;
    aq(): boolean;
    a5(): List$1<Rect>;
    dn(a: List$1<Rect>, b: List$1<boolean>, c: number): void;
    private dm;
    private dp;
    protected dq(a: List$1<Rect>, b: List$1<boolean>): void;
    protected dr(): void;
    protected get_au(): boolean;
    cm(a: FrameworkElement, b: number): void;
    protected dd(): boolean;
    protected da(): boolean;
    protected by(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    c0(): Rect;
    dh(): number;
    de(): number;
    dg(): number;
    df(): number;
    protected b9(): void;
    a6(a: List$1<Rect>): List$1<Rect>;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanel extends HorizontalAxisLabelPanelBase {
    static $t: Type;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
}
/**
 * @hidden
 */
export declare abstract class NumericAxisBase extends Axis {
    static $t: Type;
    a3(): AxisView;
    hn(a: AxisView): void;
    dx(a: number, b: ScalerParams): number;
    ki: NumericAxisBaseView;
    protected get_ch(): boolean;
    constructor();
    ll: number;
    get ld(): number;
    set ld(a: number);
    private k7;
    lj: number;
    fy(): any;
    get lg(): number;
    set lg(a: number);
    private la;
    lk: number;
    get lc(): number;
    set lc(a: number);
    private k6;
    fx(): any;
    li: number;
    private k9;
    get lf(): number;
    set lf(a: number);
    lh: number;
    private k5;
    get lb(): number;
    set lb(a: number);
    er(): number;
    lm: number;
    private k8;
    get le(): number;
    set le(a: number);
    ln: number;
    k2: boolean;
    private kt;
    get kw(): boolean;
    set kw(a: boolean);
    ky: boolean;
    private ku;
    get kx(): boolean;
    set kx(a: boolean);
    get k3(): boolean;
    lp: number;
    lq: number;
    kl: NumericAxisRenderer;
    protected k4: boolean;
    protected h4(a: boolean): void;
    hw(a: any): void;
    hv(a: any): void;
    protected hr(a: any, b: string, c: any, d: any): void;
    protected mb(): void;
    kh(): AxisRange;
    l9(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
    c0(): boolean;
    mc(a: AxisRangeChangedEventArgs): void;
    cq(a: Series): boolean;
    by(a: Series): boolean;
    kk(a: AxisLabelManager): NumericAxisRenderer;
    kj(): NumericAxisRenderer;
    kn(): NumericAxisRenderingParameters;
    ma(): void;
    ko(): NumericScaler;
    km(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    lo(a: number): number;
    kz(): boolean;
    get k1(): boolean;
    get k0(): boolean;
    private md;
    static readonly mm: DependencyProperty;
    get kr(): TickmarkValues;
    set kr(a: TickmarkValues);
    private kp;
    get kq(): TickmarkValues;
    set kq(a: TickmarkValues);
    private ks;
    get kv(): boolean;
    set kv(a: boolean);
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class NumericScaler extends DependencyObject {
    static $t: Type;
    static readonly ac: Rect;
    abstract t(a: NumericAxisBase, b: number, c: number, d: number, e: number): {
        p3: number;
        p4: number;
    };
    l: number;
    k: number;
    protected o: number;
    protected n: number;
    y(a: number): void;
    x(a: number): void;
    protected w(a: string, b: any, c: any): void;
    private z;
    protected m: number;
    abstract q(a: number, b: ScalerParams): number;
    abstract p(a: number, b: ScalerParams): number;
    j(a: IList$1<number>, b: number, c: number, d: ScalerParams): IList$1<number>;
    v(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    u(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisRendererBase extends Base {
    static $t: Type;
    constructor(a: AxisLabelManager);
    u: () => void;
    o: (viewportRect: Rect, windowRect: Rect) => boolean;
    v: () => void;
    m: (p: AxisRenderingParametersBase, value: number) => number;
    l: (p: AxisRenderingParametersBase, geometry: GeometryCollection, startValue: number, endValue: number) => void;
    k: (p: AxisRenderingParametersBase, geometry: GeometryCollection, value: number) => void;
    q: (p: AxisRenderingParametersBase, value: number) => boolean;
    n: (p: AxisRenderingParametersBase, value: number) => boolean;
    j: (p: AxisRenderingParametersBase) => void;
    e: (p: AxisRenderingParametersBase) => void;
    p: (p: AxisRenderingParametersBase, position: number, isLastLabel: boolean) => boolean;
    h: (p: AxisRenderingParametersBase, value: number) => LabelPosition;
    t: (p: AxisRenderingParametersBase, value: number) => number;
    b: AxisLabelManager;
    g: (item: any) => any;
    d: (viewportRect: Rect, windowRect: Rect, effectiveViewportRect: Rect, contentViewport: Rect) => AxisRenderingParametersBase;
    r: (p: AxisRenderingParametersBase, value: number, absoluteIndex: number, interval: number) => number;
    a: (p: AxisRenderingParametersBase, value: number, absolueIndex: number, interval: number) => number;
    f: (index: number, window: Rect, viewport: Rect, effectiveViewport: Rect) => number;
    i: (index: number) => number;
    c(a: boolean, b: Rect, c: Rect, d: Rect, e: Rect): AxisRenderingParametersBase;
    private aa;
    private ab;
    protected x(a: Rect, b: Rect): void;
    private z;
    private s;
    private y;
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
}
/**
 * @hidden
 */
export declare class NumericAxisRenderer extends AxisRendererBase {
    static $t: Type;
    constructor(a: AxisLabelManager);
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
    private ac;
    private ad;
    private ae;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanel extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    c9: VerticalAxisLabelPanelView;
    di: number;
    df: number;
    dh: number;
    dg: number;
    b6(): void;
    bq(): number;
    db(): number;
    dd(): number;
    de(): number;
    dc(): number;
    a5(): List$1<Rect>;
    private dj;
    private dk;
    cm(a: FrameworkElement, b: number): void;
    protected da(): boolean;
    c0(): Rect;
    aj(a: TitleSettings): AxisTitlePosition;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
    protected b9(): void;
}
/**
 * @hidden
 */
export interface IHasCategoryAxis {
    readonly categoryAxis: CategoryAxisBase;
    getOffsetValue(): number;
    getCategoryWidth(): number;
}
/**
 * @hidden
 */
export declare let IHasCategoryAxis_$type: Type;
/**
 * @hidden
 */
export interface IHasCategoryModePreference extends IHasCategoryAxis {
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
}
/**
 * @hidden
 */
export declare let IHasCategoryModePreference_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerScrollbarManager {
    executionContext: IExecutionContext;
    animator: DoubleAnimator;
    owner: SeriesViewer;
    onHorizontalScrollbarModeChanged(a: SeriesViewerScrollbarMode): void;
    onVerticalScrollbarModeChanged(a: SeriesViewerScrollbarMode): void;
    updateScrollbars(a: SeriesViewer, b: Rect, c: Rect, d: Rect, e: Rect): void;
    updateBarDimensions(a: SeriesViewer, b: number, c: number, d: number, e: boolean, f: number, g: number, h: number, i: number, j: number, k: boolean, l: number, m: number): void;
    updateBarAppearance(a: SeriesViewer, b: Brush, c: Brush, d: Brush, e: Brush, f: number, g: number, h: number, i: number): void;
    onCrosshairMoved(a: Point): void;
    shouldHandleInteraction(a: Point, b: boolean): boolean;
    onScrollbarDrag(a: Point, b: boolean): void;
    onScrollbarDragComplete(a: Point, b: boolean): void;
    onScrollbarDragCancel(): void;
    updateVerticalScrollbarPosition(a: SeriesViewerVerticalScrollbarPosition): void;
    updateHorizontalScrollbarPosition(a: SeriesViewerHorizontalScrollbarPosition): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerScrollbarManager_$type: Type;
/**
 * @hidden
 */
export interface IHighlightingManager {
    startHighlight(a: HighlightingInfo): void;
    endHighlight(a: HighlightingInfo): void;
    clear(): void;
    getHighlightingInfo(a: Series, b: IFastItemsSource, c: number, d: number, e: boolean): HighlightingInfo;
    tick(a: number): boolean;
    inProgress: boolean;
    maxHighlightingProgress: number;
    totalHighlightingProgress: number;
    sumHighlightingProgress: number;
    maxMarkerHighlightingProgress: number;
    sumMarkerHighlightingProgress: number;
    readonly dirtySeries: List$1<Series>;
    readonly allDirty: boolean;
    isCrossSeriesHighlight(a: Series): boolean;
    executionContext: IExecutionContext;
    ensureAnimator: () => void;
    highlightingBehavior: SeriesHighlightingBehavior;
}
/**
 * @hidden
 */
export declare let IHighlightingManager_$type: Type;
/**
 * @hidden
 */
export declare class HighlightingInfo extends Base {
    static $t: Type;
    constructor();
    i: number;
    h: number;
    g: number;
    a: HighlightingState;
    f: number;
    e: boolean;
    d: boolean;
    c: boolean;
    b: Series;
}
/**
 * @hidden
 */
export interface ISeriesInteractionManager {
    a$j(a: Series, b: Point, c: number, d: Axis, e: ScalerParams, f: number, g: number, h: (arg1: Point) => number): number;
    a$m(a: Series, b: IList$1<number>, c: Point, d: Axis, e: ScalerParams, f: number, g: (arg1: Point) => number, h: boolean, i: boolean): number;
    a$l(a: Series, b: number, c: IList$1<number>, d: number, e: number, f: number, g: number, h: number, i: boolean): number;
    a$o(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$d(a: Series, b: Point, c: boolean): boolean;
    a$a(a: Series, b: CategoryAxisBase, c: List$1<number[]>, d: number, e: number, f: Point, g: boolean): number[][];
    a$e(a: Series, b: Point, c: boolean, d: PathGeometry): boolean;
    a$f(a: Series, b: Point, c: PathGeometry): boolean;
    a$n(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$k(a: Series, b: Point, c: Axis): number;
    a$g(a: Series, b: Point, c: boolean): boolean;
    a$al(a: Series, b: Point, c: boolean, d: boolean, e: number, f: Axis, g: Axis, h: (arg1: Point, arg2: boolean, arg3: boolean) => number, i: (arg1: Point, arg2: boolean) => number, j: (arg1: Point, arg2: boolean) => number): Point;
    a$v(a: Series, b: any, c: Point, d: boolean, e: boolean, f: boolean, g: boolean, h: boolean, i: boolean): void;
    a$s(): void;
    a$ak(a: Series, b: HighlightingInfo, c: Brush): Brush;
    a$i(a: Series, b: HighlightingInfo, c: number, d: number, e: number, f: number, g: boolean): number;
    a$y(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$ai(a: Series, b: Point): void;
    a$ab(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$z(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$w(a: Series, b: Point, c: any, d: any): void;
    a$aa(a: Series, b: Point, c: any, d: any): void;
    a$x(a: Series, b: Point, c: any, d: any): void;
    a$ac(a: Series, b: Point, c: any, d: any): void;
    a$ad(a: Series, b: Point, c: any, d: any): void;
    a$q(a: Series): string;
    a$r(a: Series): string;
    readonly a$b: boolean;
    readonly a$p: any;
    a$aj(a: Series, b: any): void;
    a$ah(a: Series, b: Point, c: (arg1: any) => void): void;
    a$u(a: Series): void;
    a$ag(a: Series): void;
    readonly a$c: boolean;
    readonly a$h: Dictionary$2<string, SeriesView>;
    a$t(a: Series, b: Rect, c: Rect, d: string, e: number): void;
    a$ae(a: Series, b: SeriesViewer): void;
    a$af(a: Series, b: string, c: SeriesViewer): void;
}
/**
 * @hidden
 */
export declare let ISeriesInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerInteractionManager {
    f$a(a: SeriesViewer): ChartHitTestMode;
    f$ag(a: SeriesViewer): void;
    f$q(a: SeriesViewer, b: Point): void;
    f$ae(a: SeriesViewer, b: Point): void;
    f$r(a: SeriesViewer, b: Point, c: boolean): void;
    f$p(a: SeriesViewer, b: Point): void;
    f$al(a: SeriesViewer): void;
    f$ad(a: SeriesViewer, b: Point): void;
    f$am(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$ac(a: SeriesViewer, b: number): void;
    f$ai(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$z(a: SeriesViewer, b: Point): void;
    f$ab(a: SeriesViewer, b: number): void;
    f$s(a: SeriesViewer, b: Point): void;
    f$y(a: SeriesViewer, b: Point): void;
    f$ah(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$n(a: SeriesViewer, b: Point, c: boolean): void;
    f$ak(a: SeriesViewer): void;
    f$aj(a: SeriesViewer): void;
    f$ap(a: SeriesViewer): void;
    f$k(a: SeriesViewer): void;
    f$h(a: SeriesViewer): void;
    f$m(a: SeriesViewer, b: Point, c: boolean): void;
    f$l(a: SeriesViewer, b: Point, c: boolean, d: boolean): void;
    f$an(a: SeriesViewer): void;
    f$af(a: SeriesViewer): void;
    f$e(a: SeriesViewer, b: Key): boolean;
    f$f(a: SeriesViewer, b: Point, c: number): boolean;
    f$o(a: SeriesViewer, b: Point): void;
    f$j(a: SeriesViewer): void;
    f$i(a: SeriesViewer): void;
    readonly f$b: IHighlightingManager;
    readonly f$c: ISeriesViewerScrollbarManager;
    f$ao(a: SeriesViewer, b: Point): void;
    f$d(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: DataContext, g: boolean): {
        ret: Series;
        p5: DataContext;
    };
    f$g(a: SeriesViewer, b: Point): boolean;
    f$w(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: boolean): void;
    f$v(a: SeriesViewer, b: Point): void;
    f$u(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$x(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$t(a: SeriesViewer, b: Point, c: boolean): void;
    f$aa(a: SeriesViewer, b: boolean): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface IDataChartVisualDataManager {
    exportVisualData(a: XamDataChart): any;
}
/**
 * @hidden
 */
export declare let IDataChartVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface IAxisVisualDataManager {
    exportVisualData(a: Axis): any;
}
/**
 * @hidden
 */
export declare let IAxisVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesVisualDataManager {
    exportVisualData(a: Series, b: Rect): any;
    exportMarkerVisualData(a: MarkerSeries, b: any): void;
    getMarkerVisualData(a: Series, b: Marker, c: DataTemplate): any;
    copyVisualData(a: any, b: any): void;
    exportTrendlineData(a: Series, b: any, c: Polyline): void;
    exportStackedVisualData(a: Series, b: Rect): any;
    createFragmentVisualData(a: Series, b: Rect, c: string, d: string): any;
    addSubSeriesVisualData(a: any, b: any): void;
    exportRectangleData(a: any, b: Rectangle, c: string, d: string[]): void;
    exportMarkerVisualDataFromMarker(a: Series, b: any, c: ContentControl): void;
    exportPathData(a: any, b: Path, c: string, d: string[]): void;
    exportPolylineData(a: any, b: Polyline, c: string, d: string[]): void;
    exportPolygonData(a: any, b: Polygon, c: string, d: string[]): void;
    exportSeriesPixelsData(a: any, b: number[], c: number, d: number): void;
    addPointerTooltipData(a: any, b: any, c: number, d: number, e: List$1<string>): void;
    exportPointerTooltipData(a: Polygon, b: Polyline, c: Rectangle, d: Rect): any;
    exportCalloutData(a: number, b: number, c: number, d: number, e: any, f: Rectangle, g: TextBlock, h: FontInfo, i: Line, j: string, k: string[]): void;
}
/**
 * @hidden
 */
export declare let ISeriesVisualDataManager_$type: Type;
/**
 * @hidden
 */
export declare class XamDataChart extends SeriesViewer {
    static $t: Type;
    static t3: number;
    static t2: number;
    private _xsr;
    private get XSRP();
    private ss;
    get st(): IDataChartVisualDataManager;
    static staticInit(): void;
    static ue(a: Series): number;
    constructor();
    protected m7(a: any, b: string, c: any, d: any): void;
    lz(): void;
    protected lq(a: Rect, b: Rect): void;
    protected lu(): void;
    vh(): void;
    private vc;
    private v7;
    private v8;
    s7: boolean;
    f4(): number;
    f5(): number;
    protected n5(): void;
    uc: number;
    ud: number;
    private tm;
    get ty(): number;
    set ty(a: number);
    private tn;
    get tz(): number;
    set tz(a: number);
    eh(): boolean;
    ei(): boolean;
    s4: boolean;
    tg: boolean;
    s5: boolean;
    s8: boolean;
    sr: GridMode;
    s1: boolean;
    tc: boolean;
    t1: number;
    t0: number;
    get sz(): boolean;
    protected get_ep(): boolean;
    get s0(): boolean;
    te: boolean;
    tb: boolean;
    td: boolean;
    tf: boolean;
    sm: AutoMarginsAndAngleUpdateMode;
    s6: boolean;
    ta: boolean;
    s9: boolean;
    private to;
    private tp;
    private t5;
    private t6;
    protected get_eo(): boolean;
    vg(): void;
    vf(): void;
    ve(a: AxisLabelPanelBase, b: Rect, c: Rect, d: Rect): void;
    private ub;
    private t4;
    private vb;
    v6: Brush;
    v4: Brush;
    v5: Brush;
    get axes(): AxisCollection;
    private sn;
    private u8;
    private u9;
    axisRangeChanged: (sender: any, e: ChartAxisRangeChangedEventArgs) => void;
    private va;
    private static vd;
    of(a: SyncLink, b: SyncLink): void;
    private sv;
    getFontInfo(): FontInfo;
    vi(): void;
    getFontBrush(): Brush;
    protected ky(): void;
    q7(): Brush;
    ew(): boolean;
    protected n9(): void;
    dv(): boolean;
    private s3;
    protected cl(): SeriesViewerView;
    protected mv(a: SeriesViewerView): void;
    su: XamDataChartView;
    nn(): void;
    private sy;
    static uh: string;
    private tj;
    get tv(): number;
    set tv(a: number);
    static uj: string;
    private tl;
    get tx(): number;
    set tx(a: number);
    static ui: string;
    private tk;
    get tw(): number;
    set tw(a: number);
    static ug: string;
    private ti;
    get tu(): number;
    set tu(a: number);
    sp: ComputedPlotAreaMarginMode;
    private tr;
    get t8(): number;
    set t8(a: number);
    private tt;
    get ua(): number;
    set ua(a: number);
    private ts;
    get t9(): number;
    set t9(a: number);
    private tq;
    get t7(): number;
    set t7(a: number);
    protected r2(a: Rect): Rect;
    r8(): Rect;
    uf(): any;
    uu(): string;
    m4(): void;
    np(): void;
    th(a: Axis): List$1<Axis>;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class LabelPanelArranger extends Base {
    static $t: Type;
    static e(a: List$1<AxisLabelPanelBase>, b: Rect): Rect;
    private static a;
    static b(a: AxisLabelPanelBase): AxisLabelsLocation;
    private static c;
    static d(a: List$1<AxisLabelPanelBase>, b: LabelPanelsArrangeState, c: Rect, d: (arg1: AxisLabelPanelBase, arg2: Rect) => void): void;
}
/**
 * @hidden
 */
export declare class ChartContentManager extends DependencyObject {
    static $t: Type;
    private l;
    private r;
    private t;
    private get u();
    private set u(value);
    constructor(a: SeriesViewer);
    k(a: ChartContentType, b: DependencyObject, c: (arg1: boolean) => void): ContentInfo;
    ad(a: ChartContentType, b: DependencyObject): void;
    private m;
    private v;
    aa(a: DomRenderer): void;
    z(): void;
    ac(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: boolean): void;
    private q;
    private j;
    y(): void;
    private w;
    private _s;
    private s;
    x(a: Size): void;
    o: boolean;
    n: boolean;
    p: boolean;
    ae(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: Rect): void;
    ab(a: Axis, b: ContentInfo): void;
}
/**
 * @hidden
 */
export declare class ContentInfo extends Base {
    static $t: Type;
    h: DependencyObject;
    a: (arg1: boolean) => void;
    b: boolean;
    c: boolean;
    i: Rect;
    get d(): boolean;
    g(): void;
    f(): void;
    e: boolean;
}
/**
 * @hidden
 */
export declare abstract class Series extends Control implements INotifyPropertyChanged, IProvidesViewport, ILegendSeries, ILegendSeriesInternal, ILegendOwner, ILegendTemplateProvider, IDataLegendSeries {
    static $t: Type;
    by: SeriesView;
    private static g0;
    hf: number;
    pf: Rect;
    private gy;
    get gz(): DomRenderer;
    set gz(a: DomRenderer);
    provideRenderer(a: DomRenderer): void;
    jg(): string;
    constructor();
    mo(a: MarkerOutlineMode): void;
    mn(a: MarkerFillMode): void;
    mp(a: number): void;
    private static readonly oi;
    protected kg(a: any, b: PropertyChangedEventArgs): void;
    private ck;
    get cl(): SRProvider;
    private a6;
    get a7(): ISeriesVisualDataManager;
    protected get e8(): Dictionary$2<string, SeriesView>;
    private a4;
    get a5(): ISeriesInteractionManager;
    get dv(): boolean;
    cc: DoubleAnimator;
    lo(a: SeriesView): void;
    lm(): void;
    ln(): void;
    bw(): SeriesView;
    protected bv(): SeriesView;
    my: Canvas;
    e2(): boolean;
    hn(a: any, b: string): any;
    onLegendItemOver(a: any): void;
    onLegendItemPointerUp(a: any): void;
    onLegendItemPointerDown(a: any): void;
    onLegendItemEnter(a: any): void;
    onLegendItemLeave(a: any): void;
    private e7;
    protected jf(a: string): string;
    private e6;
    protected ho(a: any, b: string, c: string): any;
    fy(a: Point): number;
    g5(a: Point): number;
    protected get_d5(): boolean;
    get d5(): boolean;
    ar(): CategoryAxisBase;
    g3(a: Point): number;
    pp(): Thickness;
    hk(a: Point): any;
    protected hp(a: Series, b: Point): any;
    protected ax(a: Series, b: any, c: Point, d: boolean): HighlightingInfo;
    protected ay(a: Series, b: any, c: Point, d: boolean): HighlightingInfo;
    g2(): number;
    g6(): number;
    hb(): number;
    get container(): ILegendOwner;
    get hasSubItems(): boolean;
    protected c0(): boolean;
    forSubItems(a: (arg1: any) => void): void;
    protected k0(a: (arg1: any) => void): void;
    k1(a: (arg1: Series) => boolean): void;
    je(): string;
    oy(): Brush;
    oz(): Brush;
    resolveLegendIndex(): number;
    bf(): Series;
    protected get_c8(): boolean;
    get c8(): boolean;
    protected get_c5(): boolean;
    get c5(): boolean;
    protected get_c4(): boolean;
    get c4(): boolean;
    protected get_c7(): boolean;
    get c7(): boolean;
    protected get_c6(): boolean;
    get c6(): boolean;
    protected get_isVertical(): boolean;
    get isVertical(): boolean;
    protected get_dq(): boolean;
    get dq(): boolean;
    protected get_da(): boolean;
    get da(): boolean;
    protected get_c9(): boolean;
    get c9(): boolean;
    protected get_dx(): boolean;
    get dx(): boolean;
    protected get_dw(): boolean;
    get dw(): boolean;
    protected get_ec(): boolean;
    get ec(): boolean;
    protected get_dd(): boolean;
    get dd(): boolean;
    protected get_db(): boolean;
    get db(): boolean;
    protected get_eg(): boolean;
    get eg(): boolean;
    protected get_d4(): boolean;
    get d4(): boolean;
    protected get_d3(): boolean;
    get d3(): boolean;
    protected get_d1(): boolean;
    get d1(): boolean;
    protected get_d0(): boolean;
    get d0(): boolean;
    protected get_ee(): boolean;
    get ee(): boolean;
    protected get_ed(): boolean;
    get ed(): boolean;
    protected get_ea(): boolean;
    get ea(): boolean;
    protected get_d2(): boolean;
    get d2(): boolean;
    protected get_d8(): boolean;
    get d8(): boolean;
    protected get_d6(): boolean;
    get d6(): boolean;
    protected get_isStacked(): boolean;
    get isStacked(): boolean;
    protected get_dk(): boolean;
    get dk(): boolean;
    protected get_d7(): boolean;
    get d7(): boolean;
    protected get_dc(): boolean;
    get dc(): boolean;
    protected get_dr(): boolean;
    get dr(): boolean;
    protected get_d9(): boolean;
    get d9(): boolean;
    protected get_ef(): boolean;
    get ef(): boolean;
    be(): Series;
    protected get_c1(): boolean;
    get c1(): boolean;
    protected get_dn(): boolean;
    get dn(): boolean;
    protected get_dm(): boolean;
    get dm(): boolean;
    protected get_dl(): boolean;
    get dl(): boolean;
    protected get_dp(): boolean;
    get dp(): boolean;
    protected get_df(): boolean;
    get df(): boolean;
    protected get_dg(): boolean;
    get dg(): boolean;
    fw(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    protected fx(a: Point, b: number, c: Axis, d: ScalerParams, e: number, f: number, g: (arg1: Point) => number): number;
    protected get_e4(): boolean;
    get e4(): boolean;
    protected gc(a: IList$1<number>, b: Point, c: Axis, d: ScalerParams, e: number, f: (arg1: Point) => number, g: boolean, h: boolean): number;
    f2(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    ha(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    f1(a: boolean): number;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    protected eq(a: Point, b: boolean): boolean;
    aj(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    protected es(a: Point, b: boolean, c: PathGeometry): boolean;
    protected et(a: Point, b: PathGeometry): boolean;
    g8(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    f0(a: Point, b: Axis): number;
    g9(a: Point, b: boolean): number;
    g7(a: Point, b: boolean): number;
    ga(a: Point, b: boolean, c: boolean): number;
    pb(a: Point, b: boolean, c: boolean): Point;
    pk(a: Point): Rect;
    ak(a: Point): Rect[];
    pl(a: Point): Rect;
    al(a: Point): Rect[];
    pm(a: Point): Rect;
    pn(a: Point): Rect;
    protected eu(a: Point, b: boolean): boolean;
    protected pd(a: Point, b: boolean, c: boolean, d: number, e: Axis, f: Axis, g: (arg1: Point, arg2: boolean, arg3: boolean) => number, h: (arg1: Point, arg2: boolean) => number, i: (arg1: Point, arg2: boolean) => number): Point;
    f6(a: Point, b: boolean, c: boolean): number;
    o7(a: Point, b: boolean, c: boolean): Point;
    f8(a: Point, b: boolean, c: boolean): number;
    o9(a: Point, b: boolean, c: boolean): Point;
    pc(a: Point, b: boolean, c: boolean): Point;
    gb(a: Point, b: boolean, c: boolean): number;
    o8(a: Point, b: boolean, c: boolean): Point;
    f7(a: Point, b: boolean, c: boolean): number;
    pa(a: Point, b: boolean, c: boolean): Point;
    f9(a: Point, b: boolean, c: boolean): number;
    g4(a: Point): number;
    f3(): number;
    fz(a: Point): number;
    hl(a: Point): any;
    cy(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    gf(a: Marker): number;
    ip(): string;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected raisePropertyChanged(a: string, b: any, c: any): void;
    protected get_hasMarkers(): boolean;
    get hasMarkers(): boolean;
    k4(): void;
    ov(): Brush;
    ow(): Brush;
    m2(): DataTemplate;
    fv(): number;
    pe(a: Point): Point;
    o6(a: Point): Point;
    hq(a: any, b: Point): any;
    ej(a: any): boolean;
    ap(a: Axis): AxisRange;
    aq(a: Rect): AxisRange;
    protected ao(a: AxisRange, b: NumericAxisBase, c: Rect): AxisRange;
    protected kx(): void;
    l7(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    private ku;
    l8(a: boolean): void;
    protected ew: boolean;
    protected kk(): void;
    protected kp(): void;
    bx: SeriesView;
    l9(a: Rect, b: RenderSurface): void;
    l6(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    getEffectiveViewport1(a: SeriesView): Rect;
    pg(a: SeriesView): Rect;
    pj(a: Rect): Rect;
    pi(a: SeriesView): Rect;
    getEffectiveViewport(): Rect;
    l1(): void;
    protected get_cz(): boolean;
    get cz(): boolean;
    protected get_c2(): boolean;
    get c2(): boolean;
    private l2;
    l3(a: string): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    ko(a: boolean, b: SeriesView): void;
    protected ct(): boolean;
    cu(a: SeriesView): boolean;
    lp(a: Rect, b: Rect): void;
    protected mu(a: Rect, b: Rect): void;
    protected mt(a: Rect, b: Rect): void;
    as: ContentInfo;
    private cp;
    get ev(): boolean;
    set ev(a: boolean);
    protected kz(a: Series): void;
    protected lf(): void;
    k9(): void;
    le(): void;
    protected get_du(): boolean;
    get du(): boolean;
    protected get_isUsableInLegend(): boolean;
    get isUsableInLegend(): boolean;
    protected lk(): void;
    lg(): void;
    protected lq(): void;
    lr(): void;
    protected eo: boolean;
    protected ep: boolean;
    protected ei(): boolean;
    protected ls(a: boolean): void;
    private cq;
    protected get ex(): boolean;
    protected set ex(a: boolean);
    protected get ey(): boolean;
    protected v(): void;
    protected w(a: Visibility, b: Visibility): void;
    protected lj(): void;
    protected lt(a: any, b: string, c: any, d: any): void;
    protected mj(): void;
    mr(a: Point): void;
    kw(): void;
    protected get_dt(): boolean;
    protected get dt(): boolean;
    cv: boolean;
    protected kt(a: Series): void;
    get b6(): SyncLink;
    set b6(a: SyncLink);
    private b5;
    get cb(): SeriesViewer;
    set cb(a: SeriesViewer);
    private ca;
    get b9(): XamDataChart;
    set b9(a: XamDataChart);
    readonly fc: (sender: any, e: NotifyCollectionChangedEventArgs) => void;
    readonly bd: (sender: any, e: PropertyUpdatedEventArgs) => void;
    readonly cj: (sender: any, e: RectChangedEventArgs) => void;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    static readonly no: DependencyProperty;
    ci: IFastItemsSource;
    gv: (sender: any, e: FastItemsSourceEventArgs) => void;
    protected kr(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    static readonly nu: DependencyProperty;
    get mx(): Control;
    set mx(a: Control);
    private mv;
    hr(): any;
    protected mw(): Control;
    get a0(): IChartLegend;
    set a0(a: IChartLegend);
    private az;
    pq: Visibility;
    get legendItemBadgeTemplate(): DataTemplate;
    set legendItemBadgeTemplate(a: DataTemplate);
    static readonly nr: DependencyProperty;
    mz: DataTemplate;
    private m1;
    oq: Brush;
    op: Brush;
    b4: StandardLegendItems;
    b3: StandardLegendItems;
    ba: LegendItemBadgeShape;
    a8: LegendItemBadgeMode;
    get legendItemTemplate(): DataTemplate;
    set legendItemTemplate(a: DataTemplate);
    static readonly ns: DependencyProperty;
    get m0(): DataTemplate;
    set m0(a: DataTemplate);
    static readonly nf: DependencyProperty;
    get hc(): number;
    set hc(a: number);
    static readonly nj: DependencyProperty;
    ms(): void;
    kv(): void;
    protected mk(): void;
    cd: (time: number) => number;
    ce: (time: number) => number;
    cx: boolean;
    hd: number;
    gq: number;
    cs(): boolean;
    mf(): void;
    gk: number;
    private fh;
    protected get fr(): number;
    protected set fr(a: number);
    gu: number;
    private fe;
    protected get fo(): number;
    protected set fo(a: number);
    gr: number;
    private ff;
    protected get fp(): number;
    protected set fp(a: number);
    gs: number;
    private fg;
    protected get fq(): number;
    protected set fq(a: number);
    gt: number;
    hs: any;
    j7: string;
    os: Brush;
    oo: Brush;
    ot: Brush;
    ou: Brush;
    ox: Brush;
    or: Brush;
    gi: number;
    gp: number;
    fn: number;
    ft: number;
    o2: PenLineCap;
    o1: DoubleCollection;
    toolTip: any;
    private bj;
    get bk(): SeriesHighlightingMode;
    set bk(a: SeriesHighlightingMode);
    protected bl(): SeriesHighlightingMode;
    protected eb(a: SeriesHighlightingMode): boolean;
    private fd;
    get fl(): number;
    set fl(a: number);
    gg: number;
    c3: boolean;
    de: boolean;
    ds: boolean;
    di: boolean;
    protected get_dj(): boolean;
    get dj(): boolean;
    gm: number;
    o0: Color;
    e3: boolean;
    gn: number;
    go: number;
    fs: number;
    fk: number;
    mh(): void;
    gh: number;
    fm: number;
    mi(): void;
    protected gl(): number;
    private co;
    get dh(): boolean;
    set dh(a: boolean);
    en: boolean;
    private bz;
    get b0(): SeriesVisibleRangeMode;
    set b0(a: SeriesVisibleRangeMode);
    b1(): SeriesVisibleRangeMode;
    b2: SeriesVisibleRangeMode;
    private br;
    get bs(): SeriesOutlineMode;
    set bs(a: SeriesOutlineMode);
    bu(): SeriesOutlineMode;
    bt: SeriesOutlineMode;
    au(a: any): DataContext;
    he: number;
    b8: TransitionInSpeedType;
    protected b7(): TransitionInSpeedType;
    hi: any;
    l5(): void;
    ma(): void;
    l4(): void;
    kl(): void;
    k5(): void;
    private static _fa;
    static fa(a: (arg1: number) => number, b: number, c: number): IEnumerable$1<number>;
    static e9(a: (arg1: number) => number, b: number): IEnumerable$1<number>;
    o4: PenLineCap;
    o3: PenLineCap;
    private bg;
    bh(): SeriesComponentsForView;
    mb(a: Canvas): void;
    gd(): number;
    ge(): number;
    private cr;
    protected get_ez(): boolean;
    protected set_ez(a: boolean): void;
    protected get ez(): boolean;
    protected set ez(a: boolean);
    get el(): boolean;
    eh: boolean;
    km(): void;
    av(a: any, b: Point, c: boolean): HighlightingInfo;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    ll(a: Point, b: any, c: any, d: boolean): void;
    me(a: Point): void;
    private ki;
    private kn;
    kh(a: IChartLegend, b: IChartLegend): void;
    private kj;
    l0(a: IFastItemsSourceProvider): void;
    lz(a: IFastItemsSourceProvider): void;
    protected a1(): IChartLegend;
    protected em(): boolean;
    ek(a: boolean): boolean;
    protected ks(a: Axis): void;
    protected ly(a: Axis): void;
    bi(): SeriesComponentsFromView;
    mm(a: Canvas): void;
    md(a: Point, b: (arg1: any) => void): void;
    protected get_e1(): boolean;
    get e1(): boolean;
    lu(a: RenderingContext, b: RenderingContext): void;
    lw(a: Rect): void;
    k3(a: NotifyCollectionChangedEventArgs): void;
    lc(a: number, b: any, c: any): void;
    k8(): void;
    la(a: number, b: any): void;
    lb(a: number, b: any): void;
    mg(): void;
    hu: any;
    gx: (arg1: any) => any;
    er(a: Point, b: boolean): boolean;
    protected _coercionMethods: any;
    protected get_coercionMethods(): any;
    protected set_coercionMethods(a: any): void;
    get coercionMethods(): any;
    set coercionMethods(a: any);
    private cn;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    get expectFunctions(): boolean;
    set expectFunctions(a: boolean);
    at(a: Point, b: boolean): DataContext;
    private bn;
    get bq(): SeriesHitTestMode;
    set bq(a: SeriesHitTestMode);
    protected bp(): SeriesHitTestMode;
    private bm;
    get bo(): SeriesHitTestMode;
    set bo(a: SeriesHitTestMode);
    protected cf(a: string): IFastItemColumn$1<number>;
    protected cg(a: string): IFastItemColumn$1<number>;
    protected ch(a: string): IFastItemColumn$1<any>;
    protected get po(): Rect;
    protected get_dz(): boolean;
    get dz(): boolean;
    protected get_dy(): boolean;
    get dy(): boolean;
    mc(a: Brush, b: Brush): void;
    cm: (arg1: SeriesViewer) => void;
    protected kq(a: any, b: any): void;
    hj(): any;
    protected ky(a: any): void;
    private o5;
    k6(a: Point): void;
    protected li(a: Point): void;
    k7(): void;
    ld(): void;
    an(a: Axis): Axis;
    ag(): Axis[];
    f4(): number;
    static f5(a: IList$1<number>, b: ISortingAxis): number;
    lh(): void;
    private fi;
    get fu(): number;
    set fu(a: number);
    private fj;
    get gj(): number;
    set gj(a: number);
    protected mq(): void;
    hm(a: any): any;
    get h8(): string;
    get hx(): string;
    get hy(): string;
    get h6(): string;
    get id(): string;
    get ic(): string;
    get ia(): string;
    protected ml(): void;
    am(): ActualLegendItemBadgeShape;
    protected a9(a: LegendItemBadgeShape): LegendItemBadgeShape;
    private bb;
    getDataLegendBadge(): DataTemplate;
    private a3;
    getDataLegendBadgeContext(): any;
    getDataLegendSeriesTitle(): string;
    getDataLegendSeriesUnit(): string;
    getDataLegendValueFromCursorPosition(a: number, b: number): number;
    getDataLegendValueFromTargetAxisValue(a: any): number;
    getDataLegendAxisLabelFromCursorPosition(a: number, b: number): any;
    getDataLegendAxisLabelFromTargetAxisValue(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class MarkerSeries extends Series {
    static $t: Type;
    pz: MarkerSeriesView;
    constructor();
    pp(): Thickness;
    lo(a: SeriesView): void;
    protected get_hasMarkers(): boolean;
    ov(): Brush;
    ow(): Brush;
    m2(): DataTemplate;
    p0: MarkerType;
    private pv;
    get pw(): MarkerOutlineMode;
    set pw(a: MarkerOutlineMode);
    py(): MarkerOutlineMode;
    mo(a: MarkerOutlineMode): void;
    px: MarkerOutlineMode;
    private pr;
    get ps(): MarkerFillMode;
    set ps(a: MarkerFillMode);
    pu(): MarkerFillMode;
    mn(a: MarkerFillMode): void;
    mp(a: number): void;
    pt: MarkerFillMode;
    qm: DataTemplate;
    p5: number;
    fv(): number;
    qk: DataTemplate;
    ql: DataTemplate;
    private static qj;
    static get qn(): DataTemplate;
    get q2(): Brush;
    set q2(a: Brush);
    static readonly qr: DependencyProperty;
    q0: Brush;
    q3: Brush;
    q1: Brush;
    q4: Style;
    p4: boolean;
    p2(): boolean;
    protected lj(): void;
    protected lt(a: any, b: string, c: any, d: any): void;
    static p9(a: MarkerType): string;
    static p1(a: Series, b: MarkerType): MarkerType;
    protected mk(): void;
    protected ky(a: any): void;
    protected p3(a: Point, b: boolean): boolean;
    at(a: Point, b: boolean): DataContext;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SyncLink extends FrameworkElement implements INotifyPropertyChanged, IFastItemsSourceProvider {
    static $t: Type;
    constructor();
    ak: string;
    protected aq(a: any, b: string, c: any, d: any): void;
    releaseFastItemsSource(a: IEnumerable): IFastItemsSource;
    static aj: (arg1: IEnumerable) => IFastItemsSource;
    private static af;
    getFastItemsSource(a: IEnumerable): IFastItemsSource;
    ag(a: IEnumerable): IFastItemsSource;
    private ah;
    av: Rect;
    private aw;
    private ax;
    private ab;
    private ac;
    get ai(): IList$1<SeriesViewer>;
    private ad;
    al(a: SeriesViewer): void;
    as(a: SeriesViewer): void;
    private ao;
    private am;
    an(a: SeriesViewer, b: Point): void;
    ap(a: SeriesViewer, b: Rect): void;
    at(a: SeriesViewer, b: Rect): void;
    au(a: SeriesViewer, b: Rect, c: boolean): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected ar(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class SyncLinkManager extends Base {
    static $t: Type;
    private static b;
    static instance(): SyncLinkManager;
    private d;
    get e(): number;
    constructor();
    getLink(a: string): SyncLink;
    releaseLink(a: SyncLink): void;
}
/**
 * @hidden
 */
export declare class SyncManager extends Base {
    static $t: Type;
    static e(a: SeriesViewer): void;
    static c(a: SeriesViewer): void;
    static b(a: SeriesViewer, b: string, c: string): void;
    static d(a: DependencyObject, b: SyncSettings): void;
    static a(a: DependencyObject): SyncSettings;
}
/**
 * @hidden
 */
export declare class ChartCollection extends ObservableCollection$1<SeriesViewer> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class SeriesCollection extends ObservableCollection$1<Series> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class PlotAreaMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    get chartPosition(): Point;
    set chartPosition(a: Point);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private _isDuringManipulation;
    get isDuringManipulation(): boolean;
    set isDuringManipulation(a: boolean);
    private _viewer;
    get viewer(): SeriesViewer;
    set viewer(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class PlotAreaMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    get chartPosition(): Point;
    set chartPosition(a: Point);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private _manipulationOccurred;
    get manipulationOccurred(): boolean;
    set manipulationOccurred(a: boolean);
    private _viewer;
    get viewer(): SeriesViewer;
    set viewer(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class ChartCursorEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any);
    toString(): string;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _seriesViewer;
    get seriesViewer(): SeriesViewer;
    set seriesViewer(a: SeriesViewer);
    get chart(): XamDataChart;
}
/**
 * @hidden
 */
export declare class DataChartMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseButtonEventArgs);
    toString(): string;
    protected g: MouseButtonEventArgs;
    get handled(): boolean;
    set handled(a: boolean);
    getPosition(a: UIElement): Point;
    get originalSource(): any;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class ChartMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseEventArgs);
    toString(): string;
    private f;
    getPosition(a: UIElement): Point;
    get originalSource(): any;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class AxisComponentsForView extends Base {
    static $t: Type;
    a: AxisLabelPanelBase;
}
/**
 * @hidden
 */
export declare class AxisLabelPanelBaseView extends Base {
    static $t: Type;
    protected a: AxisLabelPanelBase;
    av: Path;
    constructor(a: AxisLabelPanelBase);
    aa(a: FrameworkElement, b: Rect, c: number, d: number, e: number, f: number): void;
    z(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number): void;
    ad(a: FrameworkElement): void;
    ag(a: any): void;
    ah(a: any, b: Size): void;
    ai(a: FrameworkElement, b: number): void;
    aq(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number, i: number): void;
    x(a: TextBlock, b: number, c: number, d: number): string;
    ae(): void;
    g(): IEnumerable$1<any>;
    l(a: any): number;
    n(a: any): number;
    am(): void;
    m(a: any): number;
    w(a: any): number;
    ac(): void;
    aj(): void;
    protected e: RenderingContext;
    f(): RenderingContext;
    ak(a: RenderingContext): void;
    y(): void;
    protected al(): void;
    private au;
    protected ao(a: TextBlock): void;
    an(): void;
    d(): FontInfo;
    as(): Brush;
    private c;
    af(): void;
    private h;
    private ar;
    private i;
    j(): number;
    k(): number;
    protected ap(): void;
    ab(a: Size): void;
    protected aw(): Thickness;
    v(): number;
    s(): number;
    t(): number;
    u(): number;
    at(): GeometryCollection;
    b(): PathRenderingInfo;
    r(): number;
    p(): number;
    q(): number;
    o(): number;
}
/**
 * @hidden
 */
export declare class AxisView extends Base implements ISchedulableRender {
    static $t: Type;
    protected a: Axis;
    constructor(a: Axis);
    ag(): void;
    ai(a: any): void;
    a7: Path;
    a8: Path;
    ba: Path;
    a9: Path;
    ax(): TextBlock;
    aq(a: TextBlock): void;
    as(a: TextBlock): void;
    ar(a: TextBlock): void;
    bc(): Rectangle;
    p(a: Rectangle): void;
    r(a: Rectangle): void;
    q(a: Rectangle): void;
    aj(): void;
    m(): boolean;
    get index(): number;
    ad(): void;
    ab(): void;
    x(): void;
    av(a: Visibility): void;
    an(): void;
    w(a: AxisLabelSettings): void;
    private b;
    c(): AxisComponentsFromView;
    z(a: GeometryCollection): void;
    ay(): GeometryCollection;
    e(): PathRenderingInfo;
    a1(): GeometryCollection;
    az(): GeometryCollection;
    f(): PathRenderingInfo;
    a0(): GeometryCollection;
    g(): PathRenderingInfo;
    protected get d(): AxisLabelPanelBase;
    at(a: Axis, b: Rect, c: Rect): void;
    y(): void;
    ap(a: number): void;
    au(a: List$1<any>, b: List$1<LabelPosition>): void;
    ao(a: number): void;
    v(): void;
    private h;
    o(a: number): string;
    n(dataItem_: any): any;
    protected k: RenderingContext;
    j: RenderingContext;
    af(a: RenderingContext, b: RenderingContext): void;
    private _isDirty;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    protected ae(): void;
    undirty(a: boolean): void;
    private bb;
    protected al(a: boolean): void;
    postRender(): void;
    private a5;
    protected am(): void;
    ac(): void;
    aa(a: SeriesViewer): void;
    u(a: SeriesViewer): void;
    i(): FontInfo;
    l(): boolean;
    ak(): void;
    t(): void;
    aw(): void;
    s(a: AxisLabelSettings, b: string): void;
    preRender(): void;
    isValid(): boolean;
    a2(a: TextBlock): Point;
    a3(): Point;
    a6(): Rect;
    a4(a: TextBlock): Point;
    bd(a: TextBlock): Thickness;
    ah(): void;
}
/**
 * @hidden
 */
export declare class CategoryAxisBaseView extends AxisView {
    static $t: Type;
    protected be: CategoryAxisBase;
    constructor(a: CategoryAxisBase);
    o(a: number): string;
    bf(a: List$1<any>): number;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanelBaseView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected ax: HorizontalAxisLabelPanelBase;
    constructor(a: HorizontalAxisLabelPanelBase);
    az(): void;
    ay(): boolean;
    a0(a: List$1<Rect>): void;
}
/**
 * @hidden
 */
export declare class NumericAxisBaseView extends AxisView {
    static $t: Type;
    protected be: NumericAxisBase;
    constructor(a: NumericAxisBase);
    bf(): void;
    o(a: number): string;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanelView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected ax: VerticalAxisLabelPanel;
    constructor(a: VerticalAxisLabelPanel);
    ay(): void;
    d(): FontInfo;
    protected aw(): Thickness;
    as(): Brush;
    az(a: List$1<Rect>, b: number): void;
}
/**
 * @hidden
 */
export declare class XamDataChartView extends SeriesViewerView {
    static $t: Type;
    constructor(a: XamDataChart);
    protected fn: XamDataChart;
    fr(a: any): void;
    protected ds(): void;
    d4(): void;
    fw: Brush;
    fs: Brush;
    ft: Brush;
    fv: Brush;
    fu: Brush;
    fp: number;
    fq: number;
    protected d1(): void;
    fo: FontInfo;
}
/**
 * @hidden
 */
export declare class SeriesView extends Base implements ISchedulableRender, IProvidesViewport {
    static $t: Type;
    protected e: Series;
    s: boolean;
    constructor(a: Series);
    getDefaultTooltipTemplate(): string;
    ap(): void;
    j(): IExecutionContext;
    private h;
    protected get i(): IExecutionContext;
    d: DataContext;
    as(): void;
    getEffectiveViewport(): Rect;
    az(): void;
    aj(): void;
    get w(): DomRenderer;
    private _isDirty;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    protected get_index(): number;
    get index(): number;
    protected aq(): void;
    undirty(a: boolean): void;
    private bw;
    au(): void;
    private bn;
    bq(): Brush;
    v: number;
    private u;
    protected a4(a: boolean): void;
    private br;
    protected bd(a: any, b: number, c: boolean): void;
    protected bg(a: any, b: number, c: boolean): void;
    protected aa(a: number, b: boolean): any;
    protected ab(a: number): any;
    protected ac(a: number): any;
    protected be(a: any, b: number): void;
    protected bh(a: any, b: number): void;
    protected bf(a: any, b: number): void;
    protected bi(a: any, b: number): void;
    protected ba(a: boolean): void;
    protected bb(): void;
    protected bc(): void;
    private bm;
    protected bp(a: number): Brush;
    protected bo(): Brush;
    protected a6(a: RenderingContext, b: boolean): void;
    protected a5(a: RenderingContext, b: boolean): void;
    ax(): void;
    am(): void;
    an(): void;
    private f;
    g(): SeriesComponentsFromView;
    a9(a: Canvas): void;
    t(): boolean;
    aw(): void;
    av(): void;
    a7(): void;
    ah(): void;
    a8(): void;
    ai(): void;
    c(a: any): DataContext;
    protected k: RenderingContext;
    protected l: RenderingContext;
    ar(a: RenderingContext, b: RenderingContext): void;
    private bs;
    get bu(): Rect;
    set bu(a: Rect);
    bt: Rect;
    protected get_bv(): Rect;
    get bv(): Rect;
    private m;
    get q(): boolean;
    set q(a: boolean);
    ak(a: SeriesViewer): void;
    a: CanvasRenderScheduler;
    ag(a: SeriesViewer): void;
    postRender(): void;
    protected a0(): void;
    b(a: number): DataContext;
    a2(a: RenderSurface): void;
    al(a: any): void;
    bj(): void;
    at(): void;
    ay(): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    o(): boolean;
    protected r: boolean;
    bk(): void;
    a3(): void;
    protected af(): void;
    ao(): void;
    preRender(): void;
    isValid(): boolean;
    n: boolean;
    p: boolean;
    a1(a: RenderSurface): void;
    ad: string;
    bl(type_: StandardLegendItems): DataTemplate;
}
/**
 * @hidden
 */
export declare abstract class MarkerSeriesView extends SeriesView {
    static $t: Type;
    protected b1: MarkerSeries;
    private b5;
    private b7;
    private b6;
    constructor(a: MarkerSeries);
    as(): void;
    cg(): void;
    cq(): Size;
    cn(a: boolean): void;
    protected b4: List$1<Marker>;
    b0(): Marker;
    abstract cf(a: (arg1: Marker) => void): void;
    cj(a: Marker): void;
    cl(a: Marker): void;
    ck(a: Marker): void;
    b2(): boolean;
    ce(): void;
    b8(): void;
    cp(a: Marker): Rect;
    cb(a: string): void;
    cc(): void;
    b9(): void;
    cd(): void;
    ca(): void;
    cm(): void;
    b3: boolean;
    protected bh(a: any, b: number): void;
    private bx;
    protected bi(a: any, b: number): void;
    b(a: number): DataContext;
    private co;
    protected a5(a: RenderingContext, b: boolean): void;
    ch(a: HashPool$2<any, Marker>): void;
    ci(a: Pool$1<Marker>): void;
    by(a: Point): Marker;
    private bz;
}
/**
 * @hidden
 */
export declare class ChartAxisRangeChangedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Axis, c: number, d: number, e: number, f: number);
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
    private _axis;
    get axis(): Axis;
    set axis(a: Axis);
    private _oldMinimumValue;
    get oldMinimumValue(): number;
    set oldMinimumValue(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _oldMaximumValue;
    get oldMaximumValue(): number;
    set oldMaximumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
}
