import { EventArgs, Base, Type, Point, IList$1, IEnumerable, IEnumerator$1, IEnumerator, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { DataTemplate } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { Style } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { Series } from "./Series";
import { List$1 } from "igniteui-react-core";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategorySeries } from "./CategorySeries";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { NumericAxisBase } from "./NumericAxisBase";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { Rect } from "igniteui-react-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { SeriesViewer } from "./SeriesViewer";
import { PointCollection } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { IChartLegend } from "igniteui-react-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { RenderSurface } from "./RenderSurface";
import { Path } from "igniteui-react-core";
import { CategoryMode } from "./CategoryMode";
import { DependencyObject } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Pool$1 } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { IScaler } from "./IScaler";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { NumericXAxis } from "./NumericXAxis";
import { CategoryYAxis } from "./CategoryYAxis";
import { AnchoredCategoryBucketCalculator } from "./AnchoredCategoryBucketCalculator";
import { SplineSeriesBase } from "./SplineSeriesBase";
import { CollisionAvoider } from "./CollisionAvoider";
import { ICategoryScaler } from "./ICategoryScaler";
import { IBucketizer } from "./IBucketizer";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { IBarSeries } from "./IBarSeries";
import { Color } from "igniteui-react-core";
import { LegendItemBadgeShape } from "./LegendItemBadgeShape";
import { LegendItemBadgeMode } from "./LegendItemBadgeMode";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { DomRenderer } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ValuesHolder } from "./ValuesHolder";
import { PreparationParams } from "./PreparationParams";
import { RenderingContext } from "igniteui-react-core";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { Canvas } from "igniteui-react-core";
import { Panel } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class StackedSeriesCreatedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: StackedFragmentSeries);
    c: StackedFragmentSeries;
    get brush(): Brush;
    set brush(a: Brush);
    get legendItemTemplate(): DataTemplate;
    set legendItemTemplate(a: DataTemplate);
    get legendItemBadgeTemplate(): DataTemplate;
    set legendItemBadgeTemplate(a: DataTemplate);
    get legendItemVisibility(): Visibility;
    set legendItemVisibility(a: Visibility);
    get outline(): Brush;
    set outline(a: Brush);
    get dashArray(): DoubleCollection;
    set dashArray(a: DoubleCollection);
    get dashCap(): PenLineCap;
    set dashCap(a: PenLineCap);
    get index(): number;
    get thickness(): number;
    set thickness(a: number);
    get title(): any;
    set title(a: any);
    get markerBrush(): Brush;
    set markerBrush(a: Brush);
    get markerOutline(): Brush;
    set markerOutline(a: Brush);
    get markerStyle(): Style;
    set markerStyle(a: Style);
    get markerTemplate(): DataTemplate;
    set markerTemplate(a: DataTemplate);
    get markerType(): MarkerType;
    set markerType(a: MarkerType);
    get markerThickness(): number;
    set markerThickness(a: number);
    get startCap(): PenLineCap;
    set startCap(a: PenLineCap);
    get endCap(): PenLineCap;
    set endCap(a: PenLineCap);
}
/**
 * @hidden
 */
export declare abstract class FragmentBase extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    constructor();
    up: CategoryLineRasterizer;
    private _logicalSeriesLink;
    get logicalSeriesLink(): StackedFragmentSeries;
    set logicalSeriesLink(a: StackedFragmentSeries);
    private ur;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    protected get_dj(): boolean;
    protected get_dq(): boolean;
    je(): string;
    g2(): number;
    g6(): number;
    resolveLegendIndex(): number;
    bf(): Series;
    rb(): CategoryAxisBase;
    uo(): CategoryFramePreparer;
    rw(): NumericAxisBase;
    ut(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    sr(a: CategoryFrame, b: CategorySeriesView): void;
    pb(a: Point, b: boolean, c: boolean): Point;
    ag(): Axis[];
    private uu;
    uw(a: PointCollection, b: List$1<number[]>, c: CategorySeriesView): void;
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    td(a: CategorySeriesView): number;
    ap(a: Axis): AxisRange;
    uv(): number;
    ux(a: IChartLegend): void;
    protected lt(a: any, b: string, c: any, d: any): void;
    l9(a: Rect, b: RenderSurface): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragment extends FragmentBase {
    static $t: Type;
    constructor();
    protected bv(): SeriesView;
    uy: AreaFragmentView;
    lo(a: SeriesView): void;
    protected get_da(): boolean;
    protected get_c9(): boolean;
    protected u0(a: Point, b: boolean): boolean;
    er(a: Point, b: boolean): boolean;
    private uz;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    ko(a: boolean, b: SeriesView): void;
    su(a: CategoryFrame, b: CategorySeriesView): void;
    mh(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class ColumnFragment extends FragmentBase {
    static $t: Type;
    protected get_dd(): boolean;
    protected get_dy(): boolean;
    constructor();
    protected bv(): SeriesView;
    uz: ColumnFragmentView;
    lo(a: SeriesView): void;
    u2: number;
    u3: number;
    get fragmentXAxis(): CategoryAxisBase;
    get fragmentYAxis(): NumericAxisBase;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    rb(): CategoryAxisBase;
    rw(): NumericAxisBase;
    protected get_cz(): boolean;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    ko(a: boolean, b: SeriesView): void;
    ap(a: Axis): AxisRange;
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    e2(): boolean;
    sc(a: SeriesView): number;
    sd(a: SeriesView): number;
    se(a: SeriesView): number;
    pk(a: Point): Rect;
    er(a: Point, b: boolean): boolean;
    protected eu(a: Point, b: boolean): boolean;
    protected u8(a: Rect, b: number): Rect;
    hq(a: any, b: Point): any;
    hk(a: Point): any;
    g5(a: Point): number;
    g3(a: Point): number;
    ut(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    private u1;
    l6(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    sr(a: CategoryFrame, b: CategorySeriesView): void;
    su(a: CategoryFrame, b: CategorySeriesView): void;
    protected lt(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BarFragment extends ColumnFragment {
    static $t: Type;
    constructor();
    protected get_db(): boolean;
    protected get_dy(): boolean;
    protected get_dd(): boolean;
    get barFragmentXAxis(): NumericXAxis;
    get barFragmentYAxis(): CategoryYAxis;
    rb(): CategoryAxisBase;
    protected get_isVertical(): boolean;
    fy(a: Point): number;
    rw(): NumericAxisBase;
    protected u8(a: Rect, b: number): Rect;
    pk(a: Point): Rect;
    er(a: Point, b: boolean): boolean;
    ut(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    hk(a: Point): any;
    g5(a: Point): number;
    td(a: CategorySeriesView): number;
    protected lt(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class LineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class SplineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class StackedBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class StackedBarBucketCalculator extends StackedBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    g(a: number): void;
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class StackedColumnBucketCalculator extends StackedBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class FragmentBaseValueList extends Base implements IList$1<number> {
    static $t: Type;
    private a;
    constructor(a: FragmentBase);
    indexOf(a: number): number;
    insert(a: number, b: number): void;
    removeAt(a: number): void;
    item(a: number, b?: number): number;
    add(a: number): void;
    clear(): void;
    contains(a: number): boolean;
    copyTo(a: number[], b: number): void;
    get count(): number;
    get isReadOnly(): boolean;
    remove(a: number): boolean;
    getEnumerator(): IEnumerator$1<number>;
    getEnumeratorObject(): IEnumerator;
}
/**
 * @hidden
 */
export declare class LineFragment extends FragmentBase {
    static $t: Type;
    protected get_dx(): boolean;
    constructor();
    protected bv(): SeriesView;
    uy: LineFragmentView;
    lo(a: SeriesView): void;
    protected u0(a: Point, b: boolean): boolean;
    protected get_da(): boolean;
    er(a: Point, b: boolean): boolean;
    private uz;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    ko(a: boolean, b: SeriesView): void;
    su(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare abstract class SplineFragmentBase extends SplineSeriesBase {
    static $t: Type;
    private _logicalSeriesLink;
    get logicalSeriesLink(): StackedFragmentSeries;
    set logicalSeriesLink(a: StackedFragmentSeries);
    u8: CategoryLineRasterizer;
    constructor();
    private va;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    protected get_dj(): boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected get_dq(): boolean;
    je(): string;
    pb(a: Point, b: boolean, c: boolean): Point;
    ag(): Axis[];
    private vc;
    g2(): number;
    resolveLegendIndex(): number;
    g6(): number;
    bf(): Series;
    uu(a: CategoryFrame, b: number[], c: CollisionAvoider, d: number, e: number, f: CategorySeriesView, g: number): boolean;
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    ap(a: Axis): AxisRange;
    vd(a: CategoryFrame, b: Rect, c: Rect, d: CategoryAxisBase, e: NumericYAxis, f: CategorySeriesView): void;
    sr(a: CategoryFrame, b: CategorySeriesView): void;
    uo(a: CategorySeriesView): number[][];
    up(a: CategorySeriesView): number[][];
    u3(a: CategorySeriesView): void;
    protected lt(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineAreaFragment extends SplineFragmentBase {
    static $t: Type;
    constructor();
    protected bv(): SeriesView;
    lo(a: SeriesView): void;
    private ve;
    ac(): void;
    protected get_da(): boolean;
    protected get_c9(): boolean;
    protected get_ec(): boolean;
    protected vg(a: Point, b: boolean): boolean;
    er(a: Point, b: boolean): boolean;
    private vf;
    vi: PointCollection;
    ko(a: boolean, b: SeriesView): void;
    su(a: CategoryFrame, b: CategorySeriesView): void;
    l9(a: Rect, b: RenderSurface): void;
    vh(a: PointCollection, b: List$1<number[]>, c: CategorySeriesView): void;
    td(a: CategorySeriesView): number;
    mh(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineFragment extends SplineFragmentBase {
    static $t: Type;
    protected get_ec(): boolean;
    constructor();
    protected bv(): SeriesView;
    ve: SplineFragmentView;
    lo(a: SeriesView): void;
    protected vg(a: Point, b: boolean): boolean;
    protected get_da(): boolean;
    er(a: Point, b: boolean): boolean;
    private vf;
    ko(a: boolean, b: SeriesView): void;
    su(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineFragmentBaseValueList extends Base implements IList$1<number> {
    static $t: Type;
    private a;
    constructor(a: SplineFragmentBase);
    indexOf(a: number): number;
    insert(a: number, b: number): void;
    removeAt(a: number): void;
    item(a: number, b?: number): number;
    add(a: number): void;
    clear(): void;
    contains(a: number): boolean;
    copyTo(a: number[], b: number): void;
    get count(): number;
    get isReadOnly(): boolean;
    remove(a: number): boolean;
    getEnumerator(): IEnumerator$1<number>;
    getEnumeratorObject(): IEnumerator;
}
/**
 * @hidden
 */
export declare abstract class StackedSeriesBase extends CategorySeries implements IIsCategoryBased {
    static $t: Type;
    constructor();
    k9(): void;
    protected get_dt(): boolean;
    getHostReferenceValue(): number;
    protected bv(): SeriesView;
    ta: StackedSeriesView;
    lo(a: SeriesView): void;
    lp(a: Rect, b: Rect): void;
    private _series;
    get series(): StackedSeriesCollection;
    set series(a: StackedSeriesCollection);
    hb(): number;
    k1(a: (arg1: Series) => boolean): void;
    tb: boolean;
    td: boolean;
    protected get_isStacked(): boolean;
    seriesCreated: (sender: any, e: StackedSeriesCreatedEventArgs) => void;
    t0: Visibility;
    tj: number;
    ti: number;
    s1: number[];
    s2: number[];
    s9: StackedSeriesManager;
    s6: StackedSeriesCollection;
    get s5(): StackedSeriesCollection;
    private tp;
    private tv;
    private tu;
    me(a: Point): void;
    ri(a: CategorySeriesView): CategoryFramePreparer;
    sr(a: CategoryFrame, b: CategorySeriesView): void;
    ko(a: boolean, b: SeriesView): void;
    tq(): void;
    tw(): void;
    protected get_tc(): boolean;
    get tc(): boolean;
    ej(a: any): boolean;
    ap(a: Axis): AxisRange;
    p2(): boolean;
    protected kr(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    s4(): CategorySeriesView;
    tg(): number;
    th(): number;
    tl(a: StackedFragmentSeries): number;
    tk(a: Point): number;
    te(a: AnchoredCategorySeries, b: Rect, c: Rect, d: SeriesView): boolean;
    private tf;
    tr(): void;
    su(a: CategoryFrame, b: CategorySeriesView): void;
    tt(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView): void;
    aq(a: Rect): AxisRange;
    protected ts(): void;
    protected lt(a: any, b: string, c: any, d: any): void;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    protected em(): boolean;
    protected get_dj(): boolean;
    l9(a: Rect, b: RenderSurface): void;
    s3: CategoryFrame;
    l6(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    hj(): any;
    get mayContainUnknowns(): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalStackedSeriesBase extends StackedSeriesBase {
    static $t: Type;
    xAxis: CategoryAxisBase;
    yAxis: NumericYAxis;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    ag(): Axis[];
    r6(): boolean;
    mh(): void;
    protected lt(a: any, b: string, c: any, d: any): void;
    t4(a: any): boolean;
    t3(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedAreaSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected get_c9(): boolean;
    constructor();
    ac(): void;
    protected bv(): SeriesView;
    t9: StackedAreaSeriesView;
    lo(a: SeriesView): void;
    ap(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare abstract class VerticalStackedSeriesBase extends StackedSeriesBase {
    static $t: Type;
    xAxis: NumericXAxis;
    yAxis: CategoryYAxis;
    rb(): CategoryAxisBase;
    rw(): NumericAxisBase;
    aq(a: Rect): AxisRange;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    protected get_isVertical(): boolean;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    r6(): boolean;
    protected lt(a: any, b: string, c: any, d: any): void;
    t4(a: any): boolean;
    t3(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedBarSeries extends VerticalStackedSeriesBase implements IBarSeries {
    static $t: Type;
    protected get_db(): boolean;
    protected get_dy(): boolean;
    constructor();
    ac(): void;
    protected bv(): SeriesView;
    t9: StackedBarSeriesView;
    lo(a: SeriesView): void;
    ua: number;
    ub: number;
    s4(): CategorySeriesView;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    sf(): number;
    tg(): number;
    th(): number;
    ap(a: Axis): AxisRange;
    ej(a: any): boolean;
    e5(a: Rect, b: Rect, c: SeriesView): boolean;
    protected kr(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    g3(a: Point): number;
    hk(a: Point): any;
    tw(): void;
    tk(a: Point): number;
    te(a: AnchoredCategorySeries, b: Rect, c: Rect, d: SeriesView): boolean;
    f3(): number;
    tt(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView): void;
    protected lt(a: any, b: string, c: any, d: any): void;
    getPreferredCategoryMode(): CategoryMode;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedColumnSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected get_dd(): boolean;
    protected get_dy(): boolean;
    constructor();
    protected bv(): SeriesView;
    t9: StackedColumnSeriesView;
    lo(a: SeriesView): void;
    ua: number;
    ub: number;
    s4(): CategorySeriesView;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    ap(a: Axis): AxisRange;
    f3(): number;
    tt(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView): void;
    protected lt(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSplineAreaSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    ua: boolean;
    protected get_c9(): boolean;
    protected get_ec(): boolean;
    constructor();
    ac(): void;
    protected bv(): SeriesView;
    t9: StackedSplineAreaSeriesView;
    lo(a: SeriesView): void;
    ap(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected lt(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSplineSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    ua: boolean;
    protected get_ec(): boolean;
    constructor();
    ac(): void;
    protected bv(): SeriesView;
    t9: StackedSplineSeriesView;
    lo(a: SeriesView): void;
    ap(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedFragmentSeries extends DependencyObject implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    itemsSource: IEnumerable;
    hx: Brush;
    hs: Brush;
    h6: DoubleCollection;
    h5: DoubleCollection;
    ia: PenLineCap;
    h7: PenLineCap;
    ag: boolean;
    private y;
    aa: boolean;
    bi: number;
    az: number;
    h4: Color;
    h3: Color;
    an: boolean;
    private z;
    ae: boolean;
    bj: number;
    a0: number;
    bk: number;
    a1: number;
    ib: PenLineCap;
    h8: PenLineCap;
    ah: boolean;
    ab: boolean;
    fi: DataTemplate;
    ff: DataTemplate;
    fj: DataTemplate;
    fg: DataTemplate;
    iw: Visibility;
    iu: Visibility;
    p: LegendItemBadgeShape;
    n: LegendItemBadgeMode;
    o: LegendItemBadgeShape;
    m: LegendItemBadgeMode;
    hy: Brush;
    ht: Brush;
    hz: Brush;
    hu: Brush;
    it: Style;
    is: Style;
    fk: DataTemplate;
    fh: DataTemplate;
    r: MarkerType;
    q: MarkerType;
    dk: string;
    bf: number;
    aw: number;
    h0: Brush;
    hv: Brush;
    h1: Brush;
    hw: Brush;
    a3: number;
    as: number;
    bd: number;
    au: number;
    u: SeriesOutlineMode;
    t: SeriesOutlineMode;
    bc: number;
    at: number;
    bg: number;
    ax: number;
    ac: boolean;
    ai: boolean;
    bh: number;
    ay: number;
    ic: PenLineCap;
    h9: PenLineCap;
    bl: number;
    a2: number;
    be: number;
    av: number;
    bv: any;
    bw: any;
    bs: any;
    am: boolean;
    ad: boolean;
    d4: string;
    ix: Visibility;
    iv: Visibility;
    private _parentSeries;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    br: number;
    w: SeriesViewer;
    x: IFastItemColumn$1<number>;
    private _visualSeriesLink;
    get visualSeriesLink(): AnchoredCategorySeries;
    set visualSeriesLink(a: AnchoredCategorySeries);
    ap: List$1<number>;
    aq: List$1<number>;
    ao: List$1<number[]>;
    aj: boolean;
    bn(a: Point): number;
    bt(a: Point): any;
    bq(a: Point, b: boolean): number;
    bp(a: Point, b: boolean): number;
    ba(a: Point, b: boolean, c: boolean): number;
    ij(a: Point, b: boolean, c: boolean): Point;
    io(a: Point): Rect;
    j(a: Point): Rect[];
    ip(a: Point): Rect;
    k(a: Point): Rect[];
    iq(a: Point): Rect;
    ir(a: Point): Rect;
    a6(a: Point, b: boolean, c: boolean): number;
    ie(a: Point, b: boolean, c: boolean): Point;
    a8(a: Point, b: boolean, c: boolean): number;
    ih(a: Point, b: boolean, c: boolean): Point;
    ik(a: Point, b: boolean, c: boolean): Point;
    bb(a: Point, b: boolean, c: boolean): number;
    ig(a: Point, b: boolean, c: boolean): Point;
    a7(a: Point, b: boolean, c: boolean): number;
    ii(a: Point, b: boolean, c: boolean): Point;
    a9(a: Point, b: boolean, c: boolean): number;
    bo(a: Point): number;
    a5(): number;
    a4(a: Point): number;
    bu(a: Point): any;
    af(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    il(a: Point): Point;
    id(a: Point): Point;
    ak(a: any): boolean;
    im(): Rect;
    d8(): void;
    ec(a: Point): void;
    al(a: Point, b: boolean): boolean;
    d7(a: Point): void;
    bm: DomRenderer;
    provideRenderer(a: DomRenderer): void;
    h2: Brush;
    fe(): void;
    ew(): void;
    ey(): void;
    ee(): void;
    ef(): void;
    ei(): void;
    e2(): void;
    et(): void;
    eg(): void;
    ej(): void;
    e5(): void;
    e6(): void;
    fd(): void;
    e7(): void;
    e8(): void;
    eh(): void;
    ek(): void;
    ep(): void;
    eq(): void;
    er(): void;
    eo(): void;
    en(): void;
    es(): void;
    eu(): void;
    ev(): void;
    ez(): void;
    e0(): void;
    e1(): void;
    em(): void;
    ed(): void;
    el(): void;
    e3(): void;
    e4(): void;
    e9(): void;
    fa(): void;
    ex(): void;
    fb(): void;
    fc(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected eb(a: string, b: any, c: any): void;
    protected d9(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSeriesCollection extends ObservableCollection$1<StackedFragmentSeries> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class StackedSeriesFramePreparer extends CategoryFramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    protected j(a: PreparationParams): ValuesHolder;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    da: AreaFragment;
    as(): void;
    constructor(a: AreaFragment);
    dg: Path;
    di: Path;
    dh: Path;
    dj: Path;
    dc: Path;
    de: Path;
    dd: Path;
    df: Path;
    db(): void;
    cs(): CategoryBucketCalculator;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class ColumnFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    da: ColumnFragment;
    as(): void;
    constructor(a: ColumnFragment);
    protected de: List$1<Rectangle>;
    db: Pool$1<Rectangle>;
    dc: List$1<number>;
    dd: List$1<number>;
    private dk;
    private df;
    private dh;
    private dg;
    protected be(a: any, b: number): void;
    di(a: Rectangle, b: number, c: number): void;
    protected bf(a: any, b: number): void;
    protected ac(a: number): any;
    private dj;
    protected ab(a: number): any;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
    getDefaultTooltipTemplate(): string;
}
/**
 * @hidden
 */
export declare class LineFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    da: LineFragment;
    constructor(a: LineFragment);
    dg: Path;
    df: Path;
    dh: Path;
    dd: Path;
    dc: Path;
    de: Path;
    db(): void;
    cs(): CategoryBucketCalculator;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class SplineAreaFragmentView extends SplineSeriesBaseView {
    static $t: Type;
    private db;
    as(): void;
    constructor(a: SplineAreaFragment);
    dh: Path;
    dj: Path;
    di: Path;
    dk: Path;
    dd: Path;
    df: Path;
    de: Path;
    dg: Path;
    dc(): void;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class SplineFragmentView extends SplineSeriesBaseView {
    static $t: Type;
    db: SplineFragment;
    constructor(a: SplineFragment);
    cs(): CategoryBucketCalculator;
    dh: Path;
    dg: Path;
    di: Path;
    de: Path;
    dd: Path;
    df: Path;
    dc(): void;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class StackedSeriesView extends CategorySeriesView {
    static $t: Type;
    c0: StackedSeriesBase;
    private readonly c1;
    get c2(): Canvas;
    private readonly c3;
    get c4(): Panel;
    constructor(a: StackedSeriesBase);
    cs(): CategoryBucketCalculator;
    ap(): void;
    ar(a: RenderingContext, b: RenderingContext): void;
    protected af(): void;
}
/**
 * @hidden
 */
export declare class StackedBarSeriesView extends StackedSeriesView {
    static $t: Type;
    c5: StackedBarSeries;
    constructor(a: StackedBarSeries);
    cs(): CategoryBucketCalculator;
    as(): void;
}
/**
 * @hidden
 */
export declare class StackedColumnSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedColumnSeries);
    cs(): CategoryBucketCalculator;
    as(): void;
}
/**
 * @hidden
 */
export declare class StackedAreaSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedAreaSeries);
    as(): void;
}
/**
 * @hidden
 */
export declare class StackedSplineAreaSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedSplineAreaSeries);
    as(): void;
}
/**
 * @hidden
 */
export declare class StackedSplineSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedSplineSeries);
    as(): void;
}
/**
 * @hidden
 */
export declare class StackedSeriesManager extends Base {
    static $t: Type;
    constructor(a: StackedSeriesBase);
    b: StackedSeriesBase;
    f: ObservableCollection$1<AnchoredCategorySeries>;
    c: StackedSeriesCollection;
    e: ObservableCollection$1<AnchoredCategorySeries>;
    d: ObservableCollection$1<AnchoredCategorySeries>;
    j: Canvas;
    k: Panel;
    a(a: StackedFragmentSeries): AnchoredCategorySeries;
    private i;
    h(): void;
    private g;
}
