import { DomainChart } from "./DomainChart";
import { IEnumerable$1, Type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { VerticalAlignment } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { YAxisLabelLocation } from "./YAxisLabelLocation";
import { XAxisLabelLocation } from "./XAxisLabelLocation";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { DataSeries } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
/**
 * @hidden
 */
export declare abstract class XYChart extends DomainChart {
    static $t: Type;
    provideContainer(a: any): void;
    protected jp(): void;
    protected kb(a: string, b: any, c: any): void;
    private l4;
    get l6(): (item: any) => string;
    set l6(a: (item: any) => string);
    private l5;
    get l7(): (item: any) => string;
    set l7(a: (item: any) => string);
    private ml;
    get nn(): number;
    set nn(a: number);
    private mn;
    get np(): number;
    set np(a: number);
    private mm;
    get no(): number;
    set no(a: number);
    private mk;
    get nm(): number;
    set nm(a: number);
    private m2;
    get n4(): number;
    set n4(a: number);
    private m4;
    get n6(): number;
    set n6(a: number);
    private m3;
    get n5(): number;
    set n5(a: number);
    private m1;
    get n3(): number;
    set n3(a: number);
    private rv;
    get sb(): Brush;
    set sb(a: Brush);
    private r2;
    get si(): Brush;
    set si(a: Brush);
    private rt;
    get r9(): Brush;
    set r9(a: Brush);
    private ru;
    get sa(): Brush;
    set sa(a: Brush);
    private mw;
    get ny(): number;
    set ny(a: number);
    private nd;
    get of(): number;
    set of(a: number);
    private mv;
    get nx(): number;
    set nx(a: number);
    private nc;
    get oe(): number;
    set oe(a: number);
    private my;
    get n0(): number;
    set n0(a: number);
    private nf;
    get oh(): number;
    set oh(a: number);
    private mx;
    get nz(): number;
    set nz(a: number);
    private ne;
    get og(): number;
    set og(a: number);
    private mu;
    get nw(): number;
    set nw(a: number);
    private nb;
    get od(): number;
    set od(a: number);
    private r1;
    get sh(): Brush;
    set sh(a: Brush);
    private r8;
    get so(): Brush;
    set so(a: Brush);
    protected kc(a: string, b: any, c: any): void;
    private on;
    get pb(): string;
    set pb(a: string);
    private or;
    get qg(): string;
    set qg(a: string);
    private op;
    get pz(): string;
    set pz(a: string);
    private ot;
    get q4(): string;
    set q4(a: string);
    private ra;
    private rc;
    protected ks(a: DataSeries): void;
    protected abstract l2(): Axis;
    protected abstract l3(): Axis;
    protected rd(a: (arg1: Axis) => void): void;
    protected re(a: (arg1: Axis) => void, b: string): void;
    protected rj(a: (arg1: Axis) => void, b: boolean): void;
    protected ri(a: (arg1: Axis) => void): void;
    protected i9(a: (arg1: Axis) => void, b: boolean): void;
    protected rh(a: (arg1: TitleSettings) => void): void;
    protected rm(a: (arg1: TitleSettings) => void): void;
    protected rk(a: (arg1: AxisLabelSettings) => void): void;
    protected rf(a: (arg1: AxisLabelSettings) => void): void;
    ng(a: number): number;
    ni(a: number): number;
    nh(a: number): number;
    nj(a: number): number;
    protected kp(a: XamDataChart): void;
    static ow(a: CategoryAxisBase, b: IEnumerable$1<DataSeries>): string;
    protected jk(a: XamDataChart): void;
    protected q9(a: Axis): void;
    protected rb(a: Axis): void;
    protected jh(): void;
    protected q7(a: Axis, b: (arg1: AxisLabelSettings) => void): void;
    protected q8(a: Axis, b: (arg1: TitleSettings) => void): void;
    protected ka(a: string, b: any, c: any): void;
    rl(): void;
    rg(): void;
    l9(a: YAxisLabelLocation): AxisLabelsLocation;
    l8(a: XAxisLabelLocation): AxisLabelsLocation;
    private oi;
    get ok(): any;
    set ok(a: any);
    private oj;
    get ol(): any;
    set ol(a: any);
    private rw;
    get sc(): Brush;
    set sc(a: Brush);
    private r3;
    get sj(): Brush;
    set sj(a: Brush);
    private mo;
    get nq(): number;
    set nq(a: number);
    private m5;
    get n7(): number;
    set n7(a: number);
    private mp;
    get nr(): number;
    set nr(a: number);
    private m6;
    get n8(): number;
    set n8(a: number);
    private ry;
    get se(): Brush;
    set se(a: Brush);
    private r5;
    get sl(): Brush;
    set sl(a: Brush);
    private rz;
    get sf(): Brush;
    set sf(a: Brush);
    private r6;
    get sm(): Brush;
    set sm(a: Brush);
    private mq;
    get ns(): number;
    set ns(a: number);
    private m7;
    get n9(): number;
    set n9(a: number);
    private mr;
    get nt(): number;
    set nt(a: number);
    private m8;
    get oa(): number;
    set oa(a: number);
    private r0;
    get sg(): Brush;
    set sg(a: Brush);
    private r7;
    get sn(): Brush;
    set sn(a: Brush);
    private ms;
    get nu(): number;
    set nu(a: number);
    private m9;
    get ob(): number;
    set ob(a: number);
    private oo;
    get pq(): string;
    set pq(a: string);
    private os;
    get qv(): string;
    set qv(a: string);
    private rx;
    get sd(): Brush;
    set sd(a: Brush);
    private r4;
    get sk(): Brush;
    set sk(a: Brush);
    private mj;
    get nl(): number;
    set nl(a: number);
    private m0;
    get n2(): number;
    set n2(a: number);
    private mi;
    get nk(): number;
    set nk(a: number);
    private mz;
    get n1(): number;
    set n1(a: number);
    private mt;
    get nv(): number;
    set nv(a: number);
    private na;
    get oc(): number;
    set oc(a: number);
    private me;
    get mg(): boolean;
    set mg(a: boolean);
    private mf;
    get mh(): boolean;
    set mh(a: boolean);
    private ro;
    get rr(): HorizontalAlignment;
    set rr(a: HorizontalAlignment);
    private sr;
    get su(): VerticalAlignment;
    set su(a: VerticalAlignment);
    private rn;
    get rq(): HorizontalAlignment;
    set rq(a: HorizontalAlignment);
    private rp;
    protected get_rs(): HorizontalAlignment;
    protected set_rs(a: HorizontalAlignment): void;
    get rs(): HorizontalAlignment;
    set rs(a: HorizontalAlignment);
    private sp;
    get ss(): VerticalAlignment;
    set ss(a: VerticalAlignment);
    private sq;
    get st(): VerticalAlignment;
    set st(a: VerticalAlignment);
    private sv;
    get sx(): Visibility;
    set sx(a: Visibility);
    private sw;
    get sy(): Visibility;
    set sy(a: Visibility);
    private mc;
    protected get_md(): YAxisLabelLocation;
    protected set_md(a: YAxisLabelLocation): void;
    get md(): YAxisLabelLocation;
    set md(a: YAxisLabelLocation);
    private ma;
    protected get_mb(): XAxisLabelLocation;
    protected set_mb(a: XAxisLabelLocation): void;
    get mb(): XAxisLabelLocation;
    set mb(a: XAxisLabelLocation);
    private om;
    get o2(): string;
    set o2(a: string);
    private ly;
    get l0(): any[];
    set l0(a: any[]);
    private oq;
    get p7(): string;
    set p7(a: string);
    private lz;
    get l1(): any[];
    set l1(a: any[]);
}
