import { Control } from "igniteui-react-core";
import { INotifyPropertyChanged, Base, PropertyChangedEventArgs, Point, Type } from "igniteui-react-core";
import { IDataLegend } from "igniteui-react-core";
import { IOnDemandRender } from "igniteui-react-core";
import { DataAbbreviationMode } from "./DataAbbreviationMode";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { DataLegendSummaryType } from "./DataLegendSummaryType";
import { BindingFormatter } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { DataLegendUnitsMode } from "./DataLegendUnitsMode";
import { Rect } from "igniteui-react-core";
import { DataLegendSummaryCalculationEventArgs } from "./DataLegendSummaryCalculationEventArgs";
import { DataLegendRowFormatEventArgs } from "./DataLegendRowFormatEventArgs";
import { IDataLegendSeries } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { FrameworkElement } from "igniteui-react-core";
import { IDataLegendSummaryCalculation } from "./IDataLegendSummaryCalculation";
import { DataLegendSummaryResult } from "./DataLegendSummaryResult";
import { DataTemplate } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class XamDataLegend extends Control implements INotifyPropertyChanged, IDataLegend, IOnDemandRender {
    static $t: Type;
    calculateSummaryValue: (sender: any, args: DataLegendSummaryCalculationEventArgs) => void;
    formatHeaderRow: (sender: any, args: DataLegendRowFormatEventArgs) => void;
    formatSeriesRow: (sender: any, args: DataLegendRowFormatEventArgs) => void;
    formatSummaryRow: (sender: any, args: DataLegendRowFormatEventArgs) => void;
    private dp;
    private dn;
    private dl;
    private ap;
    private dm;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected dt(a: string, b: any, c: any): void;
    private dq;
    private dr;
    notifyCursorPositionChanged(a: Point): void;
    notifySizeChanged(): void;
    notifyVisualPropertiesChanged(a: IDataLegendSeries): void;
    notifySeriesCollectionChanged(): void;
    al: DataAbbreviationMode;
    am: DataAbbreviationMode;
    bq: number;
    br: number;
    b7: string;
    et: Brush;
    private az;
    get a5(): FontInfo;
    set a5(a: FontInfo);
    ex: Brush;
    private a3;
    get a9(): FontInfo;
    set a9(a: FontInfo);
    ey: Brush;
    private a4;
    get ba(): FontInfo;
    set ba(a: FontInfo);
    au: DataLegendSummaryType;
    cz: string;
    ai: any[];
    aj: BindingFormatter;
    cs: string;
    e7: Thickness;
    bn: number;
    e6: Thickness;
    e8: Thickness;
    e9: Thickness;
    private bg;
    protected get bk(): number;
    protected set bk(a: number);
    private bh;
    protected get bl(): number;
    protected set bl(a: number);
    targetCursorPositionX: number;
    targetCursorPositionY: number;
    bu: any;
    target: any;
    av: DataLegendUnitsMode;
    cn: string;
    ev: Brush;
    private a1;
    get a7(): FontInfo;
    set a7(a: FontInfo);
    ew: Brush;
    private a2;
    get a8(): FontInfo;
    set a8(a: FontInfo);
    eu: Brush;
    private a0;
    get a6(): FontInfo;
    set a6(a: FontInfo);
    private bj;
    get bo(): number;
    set bo(a: number);
    private bi;
    get bm(): number;
    set bm(a: number);
    constructor();
    ax: DataLegendView;
    aw(): DataLegendView;
    ez: Rect;
    destroy(): void;
    private _externalObject;
    get externalObject(): any;
    set externalObject(a: any);
    de(): void;
    onAttachedToUI(): void;
    onDetachedFromUI(): void;
    provideContainer(a: any): void;
    private bb;
    dv(): void;
    private bc;
    get shouldOnDemandRender(): boolean;
    set shouldOnDemandRender(a: boolean);
    doRender(a: RenderingContext, b: number): void;
    ensureUpdated(): void;
    private dd;
    getDesiredSize(): Size;
    private d2;
    dc(): void;
    private dg;
    private dw;
    private dy;
    private d1;
    private d0;
    private dz;
    private dx;
    private an;
    private ao;
    private ag;
    private df;
    private c9;
    private e1;
    private e0;
    private e4;
    private e3;
    private e2;
    private dh;
    private c8;
    private ak;
    b6(a: number, b?: DataAbbreviationMode, c?: number, d?: number): string;
    b5(a: number, b?: DataAbbreviationMode, c?: number, d?: number): string;
    b4(a: number, b?: DataAbbreviationMode, c?: number, d?: number): string;
    private cf;
    private ah;
    private ay;
    private c7;
    private bt;
    private bf;
    private bp;
    private be;
    private bd;
    private d3;
    private ce;
    private bv;
    private c6;
    private ds;
    private cd;
    private cc;
    private da;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class DataLegendSummaryCalculationCustom extends Base implements IDataLegendSummaryCalculation {
    static $t: Type;
    private readonly b;
    private readonly a;
    constructor(a: XamDataLegend, b: (sender: any, args: DataLegendSummaryCalculationEventArgs) => void);
    calculate(a: number[]): DataLegendSummaryResult;
}
/**
 * @hidden
 */
export declare class DataLegendContent extends Base {
    static $t: Type;
    private a;
    get b(): List$1<DataLegendRowInfo>;
    d: number;
    c: number;
    f(): void;
    e(a: DataLegendRowInfo): void;
}
/**
 * @hidden
 */
export declare class DataLegendRowInfo extends Base {
    static $t: Type;
    constructor(a: DataLegendView, b: boolean, c: boolean);
    m: number;
    h: boolean;
    e: boolean;
    g: boolean;
    d: boolean;
    f: boolean;
    i: number;
    o: string;
    q: string;
    p: string;
    s: Brush;
    t: Brush;
    u: Brush;
    a: FontInfo;
    c: FontInfo;
    b: FontInfo;
    r: DataTemplate;
    l: number;
    k: number;
    ad: Thickness;
    ac: Thickness;
    ae: Thickness;
    ag: Thickness;
    af: Thickness;
    j: number;
    z: Size;
    ab: Size;
    aa: Size;
    w: Rect;
    y: Rect;
    v: Rect;
    x: Rect;
    n: any;
}
/**
 * @hidden
 */
export declare class DataLegendView extends Base {
    static $t: Type;
    constructor(a: XamDataLegend);
    ai(): void;
    v: List$1<TextBlock>;
    x: List$1<TextBlock>;
    w: List$1<TextBlock>;
    u: List$1<ContentControl>;
    n: Pool$1<TextBlock>;
    p: Pool$1<TextBlock>;
    o: Pool$1<TextBlock>;
    m: Pool$1<ContentControl>;
    a7(): TextBlock;
    ax(a: TextBlock): void;
    az(a: TextBlock): void;
    ay(a: TextBlock): void;
    a9(): TextBlock;
    a3(a: TextBlock): void;
    a5(a: TextBlock): void;
    a4(a: TextBlock): void;
    a8(): TextBlock;
    a0(a: TextBlock): void;
    a2(a: TextBlock): void;
    a1(a: TextBlock): void;
    a6(): ContentControl;
    am(a: ContentControl): void;
    ao(a: ContentControl): void;
    an(a: ContentControl): void;
    a: XamDataLegend;
    al(): void;
    ar(): void;
    private ab;
    aa: DomRenderer;
    q: RenderingContext;
    private b;
    private ae;
    private y;
    aq(a: any): void;
    private ak;
    private aj;
    private au;
    av(a: RenderingContext, b: number): void;
    private ad;
    private ac;
    s(): boolean;
    bf(a: string, b: FontInfo): Size;
    private t;
    private z;
    aw(a: FrameworkElement, b: number, c: number): void;
    ah(a: DataLegendContent): void;
    ag(a: TextBlock, b: FontInfo): void;
    private e;
    j(): FontInfo;
    private g;
    l(): FontInfo;
    be(): Brush;
    bc(): Brush;
    bd(): Brush;
    private f;
    k(): FontInfo;
    bb(): Brush;
    private d;
    i(): FontInfo;
    ba(): Brush;
    private c;
    h(): FontInfo;
    r: (arg1: number, arg2: number) => void;
    af(a: number, b: number): void;
    at(a: number): void;
    ap(): void;
    as(): void;
}
