import { DataLegendRowFormatEventArgs as DataLegendRowFormatEventArgs_internal } from "./DataLegendRowFormatEventArgs";
/**
 * Represents event argument for StylingDataRow, StylingSummaryRow, and StylingHeaderRow events.
*/
export declare class IgrDataLegendRowFormatEventArgs {
    protected createImplementation(): DataLegendRowFormatEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): DataLegendRowFormatEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets whether the legend badge is visible in the Data Legend
    */
    get isBadgeVisible(): boolean;
    set isBadgeVisible(v: boolean);
    /**
     * Gets or sets whether the whole row is visible in the Data Legend
    */
    get isRowVisible(): boolean;
    set isRowVisible(v: boolean);
    /**
     * Gets actual value of series that will be formatted in row of Data Legend
    */
    get actualValue(): number;
    set actualValue(v: number);
    /**
     * Gets or sets label text displayed in row of Data Legend
    */
    get titleText(): string;
    set titleText(v: string);
    /**
     * Gets or sets value text displayed in row of Data Legend
    */
    get valueText(): string;
    set valueText(v: string);
    /**
     * Gets or sets unit text displayed in row of Data Legend
    */
    get unitsText(): string;
    set unitsText(v: string);
    /**
     * Gets index of series in added to the chart's series collection.
    */
    get seriesIndex(): number;
    set seriesIndex(v: number);
    /**
     * Gets or sets color of label text
    */
    get titleTextColor(): string;
    set titleTextColor(v: string);
    /**
     * Gets or sets color of value text
    */
    get unitsTextColor(): string;
    set unitsTextColor(v: string);
    /**
     * Gets or sets color of unit text
    */
    get valueTextColor(): string;
    set valueTextColor(v: string);
    /**
     * Gets or Sets the style to use for the units text.
    */
    get unitsTextFont(): string;
    set unitsTextFont(v: string);
    /**
     * Gets or Sets the style to use for the Value text.
    */
    get valueTextFont(): string;
    set valueTextFont(v: string);
    /**
     * Gets or Sets the style to use for the Title text.
    */
    get titleTextFont(): string;
    set titleTextFont(v: string);
}
