import { IgrAnnotationLayer, IIgrAnnotationLayerProps } from "./igr-annotation-layer";
import { SummaryToolTipLayer } from "./SummaryToolTipLayer";
/**
 * Represents an annotation layer that displays grouped tooltips with summaries for series.
 * THIS IS A COMMUNITY TECHNOLOGY PREVIEW, not for use in production.
*/
export declare class IgrSummaryToolTipLayer extends IgrAnnotationLayer<IIgrSummaryToolTipLayerProps> {
    protected createImplementation(): SummaryToolTipLayer;
    /**
                                 * @hidden
                                 */
    get i(): SummaryToolTipLayer;
    constructor(props: IIgrSummaryToolTipLayerProps);
    /**
     * Gets whether the series is an annotation layer displayed only when hovering over the chart.
    */
    get isAnnotationHoverLayer(): boolean;
    /**
     * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
    */
    get isDefaultTooltipBehaviorDisabled(): boolean;
    /**
     * Gets or sets whether to use value interpolation when drawing the tooltips.
    */
    get useInterpolation(): boolean;
    set useInterpolation(v: boolean);
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    hideToolTips(): void;
}
export interface IIgrSummaryToolTipLayerProps extends IIgrAnnotationLayerProps {
    /**
     * Gets or sets whether to use value interpolation when drawing the tooltips.
    */
    useInterpolation?: boolean | string;
}
